      subroutine modifyHMdependentcouplings(mh2)
      implicit none
      double precision mh2
#include "couplingandmasses.h"

*** higgs mass dependent couplings
      CHPhiPhi = -im*elc*mh2/sqrt(mw2)/2.d0/sw
      CHHH     = -im*elc*mh2/sqrt(mw2)*1.5d0/sw
      CHChiChi = -im*elc*mh2/sqrt(mw2)*0.5d0/sw
****
      return
      end
****
      subroutine get_counterterms(mh2)
      implicit none

**** external parameters
      integer imode
      common/imode/imode

      double precision mass(5)
      common/amasses/mass
***
      integer ifirst,k
      double precision mh2
      double complex cmh2

#include "ctsdefs.h"
#include "looptools.h"

      common/ifirstCTS/ifirst
      data ifirst/0/

      double complex Dr,Drt
      common/deltaerre/Dr,Drt

      double precision me2loc,mm2loc
      common/m2fermionmassesevent/me2loc,mm2loc

      double complex SigW,SigZZ,SigAZ,SigH,SigfL,SigfR
      external SigW,SigZZ,SigAZ,SigH,SigfL,SigfR
      double complex dSigfL,dSigfR,dSigfS,gp,gm
      external dSigfL,dSigfR,dSigfS
      double complex dSigW,dSigZZ,dSigAZ,dSigH,dSigAA
      external  dSigW,dSigZZ,dSigAZ,dSigH,dSigAA
      double complex SigWin0,tmp
      external SigWin0

      integer ionlytop,omt
      common/onlytop/ionlytop,omt
c      data ionlytop,omt /0,1/
      
      double complex dMW2t,dMZ2t,dZZZt,dZZAt,dZAZt,dsost,dZAAt,dZet,dZHt
      common/ctsfortoploop/ dMW2t,dMZ2t,dZZZt,dZZAt,dZAZt,dsost,dZAAt,
     .                      dZet,dZHt

#include "couplingandmasses.h"

      if (ifirst.eq.0) then

         do k = 1,2
c            print*,' print in counterterms:'
c            print*,' THINK ABOUT Delta_r!!!'
c            print*,' already removed QED contribution from [d]Sigf[LRS]'
         enddo

         me2loc = mass(1)*mass(1)
         mm2loc = mass(3)*mass(3)

         ifirst = 1
      endif

      ionlytop = 0
      omt = 1 - ionlytop

      cmh2 = cmplx(mh2)

cc the input momentum must be always real
cc following 4.9 4.10 of NPB 724 (2005)
      dMW2 =  SigW(mw2r,mh2)  + (mw2-mw2r) * dSigW(mw2r,mh2)
! erratum NPB 854 (2012) !!!
c      print*,'ERRATUM COMMENTED'
      dMW2 = dMW2 + alpho4pi*4.d0*(mw2r-mw2) !!!

      dMZ2 =  SigZZ(mz2r,mh2) + (mz2-mz2r) * dSigZZ(mz2r,mh2)
      dZZA =  2.d0*SigAZ(0.d0)/mz2 ! notice the complex mass in the denominator
      dZAZ = -2.d0*SigAZ(mz2r)/mz2r + (mz2/mz2r - 1.d0)*dZZA

      dZW  = -dSigW(mw2r,mh2)
      dZZZ = -dSigZZ(mz2r,mh2)
      dZAA = -dSigAA(0.d0)

*** 4.17
      dZeeL = -SigfL(me2loc,me2loc)
     .-me2loc*(dSigfL(me2loc,me2loc)+dSigfR(me2loc,me2loc) 
     .         + 2.d0*dSigfS(me2loc,me2loc))

      dZeeR = -SigfR(me2loc,me2loc)
     .-me2loc*(dSigfR(me2loc,me2loc)+dSigfL(me2loc,me2loc) 
     .         + 2.d0*dSigfS(me2loc,me2loc))

      dZmmL = -SigfL(mm2loc,mm2loc)
     .-mm2loc*(dSigfL(mm2loc,mm2loc)+dSigfR(mm2loc,mm2loc) 
     .         + 2.d0*dSigfS(mm2loc,mm2loc))

      dZmmR = -SigfR(mm2loc,mm2loc)
     .-mm2loc*(dSigfR(mm2loc,mm2loc)+dSigfL(mm2loc,mm2loc) 
     .         + 2.d0*dSigfS(mm2loc,mm2loc))

*** 4.20 with Whiggs = 0.d0!!
      dMH2 =  SigH(mh2,mh2)
      dZH  = -dSigH(mh2,mh2)

      dZe  = -0.5d0*dZAA-sw/cw*0.5d0*dZZA

*** \Delta r from Denner PhD thesis
** 8.3, 8.5 and 8.14
c      Dr=dSigAA(0.d0)-cw2/sw2*(dMZ2/mz2-dMW2/mw2)
c      Dr=Dr+(SigWin0(0.d0,mh2)-SigW(mw2r,mh2))/mw2
c      Dr=Dr+2.d0*cw/sw*SigAZ(0.d0)/mz2
c      Dr=Dr+alpho4pi/sw2*(6.d0+0.5d0*(7.d0-4.d0*sw2)/sw2*log(cw2))

! with this choice Dr is UV finite and numerically almost the same as in Horace...
! notice this is in complex mass scheme and it coincides with the one in prophecy
      Dr =      dSigAA(0.d0)
      Dr = Dr - cw2/sw2*(dMZ2/mz2-dMW2/mw2)  ! this is -2*ds/s
      Dr = Dr + (SigWin0(0.d0,mh2)-dMW2)/mw2
      Dr = Dr + 2.d0*cw/sw*SigAZ(0.d0)/mz2
      Dr = Dr + alpho4pi/sw2*(6.d0+0.5d0*(7.d0-4.d0*sw2)/sw2*log(cw2))

      if (abs(1.d0/alpha-1.d0/alpha0).lt.1d-2)  then
         Dr = czero
      endif

c      Dr = dReal(Dr)
c      print*,'DELTAR ',Dr,' subtracted in Gmu scheme'

      dZe = dZe - 0.5d0*Dr

c      print*,dZe
c      stop

* UV TEST **********************
c      dVHZZ = czero
c      dHZA  = czero
c      dcwoc = czero
c      dswos = czero
c      dgvee = czero
c      dgaee = czero
c      dgvmm = czero
c      dgamm = czero      
c      gvg   = czero
c      dMZ2  = czero
c      dMW2  = czero
c      dZZZ  = czero
c      dZAZ  = czero
c      dZZA  = czero
c      dZW   = czero
c      dZe   = czero
c      dZH   = czero
c      dMH2  = czero
c      dZAA  = czero
c      dZeeR = czero
c      dZeeL = czero
c      dZmmR = czero
c      dZmmL = czero
***************************************

      dcwoc =  0.5d0*(dMW2/mw2-dMZ2/mz2)
      dswos = -cw2/sw2*dcwoc

      dgpogp = sw/cw*(dZe+dswos/cw2)
      dgmogm = -0.5d0/cw/sw*(dZe+(sw2-cw2)/cw2*dswos)+dgpogp

      dgpogp = dgpogp*cw/sw
      dgmogm = dgmogm/(-0.5d0+sw2)*cw*sw

      gp = sw/cw
      gm = (-0.5d0+sw2)/sw/cw

      dgpee  = dgpogp + 0.5d0 * dZZZ + 0.5d0*(dZeeR+conjg(dZeeR))
      dgpee  = gp * dgpee
      dgpee  = dgpee  + 0.5d0*dZAZ
      dgmee  = dgmogm + 0.5d0 * dZZZ + 0.5d0*(dZeeL+conjg(dZeeL))
      dgmee  = gm * dgmee
      dgmee  = dgmee  + 0.5d0*dZAZ

      dgpmm  = dgpogp + 0.5d0 * dZZZ + 0.5d0*(dZmmR+conjg(dZmmR))
      dgpmm  = gp * dgpmm
      dgpmm  = dgpmm  + 0.5d0*dZAZ
      dgmmm  = dgmogm + 0.5d0 * dZZZ + 0.5d0*(dZmmL+conjg(dZmmL))
      dgmmm  = gm * dgmmm
      dgmmm  = dgmmm  + 0.5d0*dZAZ

      dgvee = 0.5d0 * sw * (dgpee + dgmee)
      dgaee = 0.5d0 * sw * (dgmee - dgpee)

      dgvmm = 0.5d0 * sw * (dgpmm + dgmmm)
      dgamm = 0.5d0 * sw * (dgmmm - dgpmm)

* UV test
c      dgvee = czero
c      dgaee = czero
c      dgvmm = czero
c      dgamm = czero      
**

*******

** to be overwritten below
      dVHZZ = dZe+(2.d0*sw2/cw2-1.d0)*dswos + 0.5d0*dMW2/mw2
     .       +0.5d0*dZH + dZZZ
      dHZA = 0.5d0*dZZA

**
*######### only top / bottom among fermions for H vertex if ionlytop = 1.
      ionlytop = 0
c      print*,'ALL FERMIONS IN H VERTEX -- BE CONSISTENT!'
      omt = 1 - ionlytop

      dZZZt = -dSigZZ(mz2r,mh2)
      dZHt  =  dZH
      dMW2t =  SigW(mw2r,mh2)  + (mw2-mw2r) * dSigW(mw2r,mh2)
      dMW2t =  dMW2t + alpho4pi*4.d0*(mw2r-mw2) 
      dMZ2t =  SigZZ(mz2r,mh2) + (mz2-mz2r) * dSigZZ(mz2r,mh2)
      dsost = -cw2/sw2 * 0.5d0*(dMW2t/mw2-dMZ2t/mz2)
      dZZAt =  2.d0*SigAZ(0.d0)/mz2
      dZAAt =  -dSigAA(0.d0)
      dZet  = -0.5d0*dZAAt-sw/cw*0.5d0*dZZAt

      Drt = Dr
      dZet  = dZet - 0.5d0*Drt

      dVHZZ = dZet+(2.d0*sw2/cw2-1.d0)*dsost + 0.5d0*dMW2t/mw2
     .       +0.5d0*dZHt + dZZZt
      dHZA = 0.5d0*dZZAt * (sw2 + cw2) 

      ionlytop = 0
      omt = 1 - ionlytop
*#############################################################
c      call CTSdebug
      return
      end
*****************************************************************************
      subroutine CTSandSelf(ctsself)
c      implicit none
      implicit double complex (Z)
      double precision ctsself
      double complex   born
      integer          i,ifirst,idpart,helid
      double complex   coverZZ,coverZA
      double complex   P123412s34s,P142314s23s,P12s34s1423,P123414s23s
      double complex   P12sP34s,P14sP23s
      double precision m1s, m2s, m3s, m4s, m5s, mh2
      double complex   cm1s,cm2s,cm3s,cm4s,cm5s,cmh2
      double complex   cp1p2s,cp1p4s,cp3p4s,cp2p3s

      common/commonCTSself/cm3s,m3s,coverZZ,me2,mm2,me4,mm4,
     .     coverZA,ifirst
      data ifirst /1/

      double complex SELFZZ12,SELFZZ34,SELFZZ14,SELFZZ23
      double complex SELFZA12,SELFZA34,SELFZA14,SELFZA23
      double precision K12,K34,K14,K23

#include "invariants.h"

**** parametri esterni
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision mass(5)
      common/amasses/mass ! common used also to force pXs = m^2
      double precision me2,mm2,me4,mm4,pis
***
      double precision dot
      double complex epsfun,SigZZ,SigAZ
      external dot,epsfun,SigZZ,SigAZ

#include "looptools.h"

#include "ctsdefs.h"
      
#include "couplingandmasses.h"

      if (ifirst.eq.1) then

         me2 = mass(1)*mass(1)
         mm2 = mass(3)*mass(3)
         me4 = me2*me2
         mm4 = mm2*mm2

         m3s  = zmass*zmass
         cm3s = m3s - im * zmass * zwidth * zwonoff

         coverZZ = (32.d0,0.d0)* g*conjg(g) 
     .                         * g*conjg(g) 
     .                         * CHZZ*conjg(CHZZ)
         coverZA = coverZZ 

* UV test
c         coverZA = 0.d0
         
         ifirst = 0
      endif

      mh2  = masshiggs*masshiggs

      K12 = p1p2s
      K34 = p3p4s
      K14 = p1p4s
      K23 = p2p3s

      P123412s34s = P12*P34*P12s*P34s
      P142314s23s = P14*P23*P14s*P23s
      P12s34s1423 = P12s*P34s*P14*P23
      P123414s23s = P12*P34*P14s*P23s

      P12sP34s = P12s*P34s
      P14sP23s = P14s*P23s

**** SELFZZxy = Pxy * (SigZZxy + dC1ZZ*Kxy-dC2ZZ) ! comment in the pippo files

      SELFZZ12 =P12*( SigZZ(K12,mh2)+(dZZZ*K12 - mz2*dZZZ - dMZ2))
      SELFZZ34 =P34*( SigZZ(K34,mh2)+(dZZZ*K34 - mz2*dZZZ - dMZ2))

      if (idpart.eq.0) then
         include 'form/cts-self-ZZ-eemm.f'
      else
         SELFZZ14=P14*(SigZZ(K14,mh2) + (dZZZ*K14 - mz2*dZZZ - dMZ2))
         SELFZZ23=P23*(SigZZ(K23,mh2) + (dZZZ*K23 - mz2*dZZZ - dMZ2))
         include 'form/cts-self-ZZ-eeee.f'
      endif

      ctsself =  2.d0 * dReal(coverZZ * born ) ! "born" is the variable used in the pippo files...

*** SELFZAxy = Pxyg * (SigAZxy + dC1AZ*Kxy-dC2AZ)
      SELFZA12=P12g*(SigAZ(K12)+0.5d0*((dZAZ+dZZA)*K12-mz2*dZZA))
      SELFZA34=P34g*(SigAZ(K34)+0.5d0*((dZAZ+dZZA)*K34-mz2*dZZA))

      if (idpart.eq.0) then
         include 'form/cts-self-ZA-eemm.f'
      else
         SELFZA14=P14g * (SigAZ(K14)+0.5d0*((dZAZ+dZZA)*K14-mz2*dZZA))
         SELFZA23=P23g * (SigAZ(K23)+0.5d0*((dZAZ+dZZA)*K23-mz2*dZZA))
         include 'form/cts-self-ZA-eeee.f'
      endif

      ctsself = ctsself + 2.d0 * dReal(coverZA * born)

      return
      end
***********************************************************
      subroutine CTSdebug

      double complex dMW2t,dMZ2t,dZZZt,dZZAt,dZAZt,dsost,dZAAt,dZet,dZHt
      common/ctsfortoploop/ dMW2t,dMZ2t,dZZZt,dZZAt,dZAZt,dsost,dZAAt,
     .                      dZet,dZHt
#include "ctsdefs.h"

#include "couplingandmasses.h"

      print*,'dZe ',dZe
      print*,'dZZZ ', dZZZ
      print*,'dZW ', dZW
      print*,'dZAA ', dZAA
      print*,'dMW2 ', dMW2
      print*,'dMZ2 ', dMZ2
      print*,'dZAZ ', dZAZ
      print*,'dZZA ', dZZA
      print*,'dZeeL ',dZeeL
      print*,'dZeeR ', dZeeR
      print*,'dZmmL ', dZmmL
      print*,'dZmmR ', dZmmR
      print*,'dZH ', dZH
      print*,'dMH2 ', dMH2
      print*,'dswos ',dswos
      print*,'dsw ',dswos*sw
      print*,'dcwoc ', dcwoc
      print*,'dgpogp ', dgpogp
      print*,'dgmogm ', dgmogm
      print*,'dgvee ',dgvee
      print*,'dgdaee ', dgaee
      print*,'dgvmm', dgvmm
      print*,'dgamm ', dgamm
      print*,'dgpee ',dgpee
      print*,'dgmee ', dgmee
      print*,'dgpmm ', dgpmm
      print*,'dgmmm ', dgmmm
      print*,'dVHZZ ', dVHZZ
      print*,'dHZA ', dHZA
      print*,'dMW2t ' ,dMW2t
      print*,'dMZ2t ' ,dMZ2t
      print*,'dZZZt ' ,dZZZt
      print*,'dZZAt ' ,dZZAt
      print*,'dZAZt ' ,dZAZt
      print*,'dsost ' ,dsost
      print*,'dst ' ,dsost*sw
      print*,'dZAAt' ,dZAAt
      print*,'dZet' ,dZet
      print*,'dZHt ' ,dZHt      

      return
      end
***********************************************************
*******************************************************************************************
      subroutine QEDcts(bornin,ctsQED)
*** "bornin" is the born matrix element as calculated by me, it's an input!!
      implicit none
      
c      implicit double complex (Z)

      double precision bornin,ctsQED
      double complex   cselfen,tmp,selfenF
      integer          i,id,ifirst,iret,idpart
      integer*8          id1,id2
      double complex   cover
      double complex   B1lt,dB0lt,dB1lt
      double precision m1s, m2s, m3s
      double precision p3s, p4s, p5s, p1s, p2s

      common/commonforQEDcts/cover,selfenF,
     .    me2,mm2,me4,mm4,id1,id2,ifirst
      data ifirst /1/
      common/selfenargs/m1s, m2s, m3s, p1s, p2s, p3s, p4s

**** external parameters
      double precision me2,mm2,me4,mm4
      double precision mass(5)
      common/amasses/mass ! common used also to force pXs = m^2
***
#include "couplingandmasses.h"

#include "looptools.h"

      if (ifirst.eq.1) then

         cover = (1,0.d0)/16.d0/pi2*elc2
         cover = cover * rescaleQED

         me2 = mass(1)*mass(1)
         mm2 = mass(3)*mass(3)
         me4 = me2*me2
         mm4 = me2*mm2

         m1s = 0.d0 !mass(5)*mass(5)

! the B functions do not depend on energy, so the following can be calculated just once!
         id1   = Bget(me2,me2,m1s)
         B1lt  = Bval(bb1,id1)
         dB0lt = Bval(dbb0,id1)
         dB1lt = Bval(dbb1,id1)

c         print*,me2,me2,m1s
c         print*,db0lt,db1lt
c         print*,1.d0/me2+0.5d0/me2*log(me2/getlambda())
c         print*,1.d0/me2*(3.d0/2.d0 - 0.5d0 * log(me2/getlambda())) 
         
         tmp   = B1lt + 0.5d0 + 2.d0*me2*dB1lt + 4.d0*me2*dB0lt
         selfenF = 2.d0 * tmp * cover

         id2   = Bget(mm2,mm2,m1s)
         B1lt  = Bval(bb1,id2)
         dB0lt = Bval(dbb0,id2)
         dB1lt = Bval(dbb1,id2)

c         print*,mm2,mm2,m1s
c         print*,db0lt,db1lt
c         print*,1.d0/mm2*(3.d0/2.d0 - 0.5d0 * log(mm2/getlambda())) 
        
         tmp = B1lt + 0.5d0 + 2.d0*mm2*dB1lt + 4.d0*mm2*dB0lt
         tmp = 2.d0 * tmp * cover
         selfenF = selfenF + tmp
         
         ifirst = 0
         
** UV test
c         ifirst = 1
      endif

c      print*,'cts ',rescaleQED

      ctsQED = 2.d0 * dReal(bornin * selfenF)

      return
      end
**************************************************
      function SigAA(q2)
*** B.1
      implicit none
      double complex   SigAA,SigAAtmp,cq2
      double precision q2

      double precision Qd2,Qu2

      integer k

      integer ionlytop,omt,lon
      common/onlytop/ionlytop,omt

      double complex m2gend(3),m2genu(3)

#include "couplingandmasses.h"

#include "looptools.h"

      cq2   = cone * q2
      SigAA = (0.d0,0.d0)

** UV test
c      goto 111

** leptonic contribution
      SigAAtmp  = (0.d0,0.d0)
      m2gend(1) = cme2
      m2gend(2) = cmm2
      m2gend(3) = cmtau2
      do k = 1,3
         SigAAtmp = SigAAtmp + q2/3.d0
     .   -(q2   + omt * m2gend(k)*2.d0) * B0C(cq2,m2gend(k),m2gend(k))
     .   + 2.d0 * omt * m2gend(k)       * B0C(czero,m2gend(k),m2gend(k))
      enddo
      SigAAtmp = SigAAtmp*4.d0/3.d0
      SigAA    = SigAA+SigAAtmp

** UV test
c      goto 111

** W contribution
      SigAAtmp   = (3.d0*q2+4.d0*mw2)*B0C(cq2,mw2,mw2)
     .            - 4.d0*mw2*B0C(czero,mw2,mw2)
      SigAA    = SigAA+SigAAtmp

*** quark contribution
 111  m2genu(1) = cmup2
      m2genu(2) = cmc2
      m2genu(3) = mtop2
      m2gend(1) = cmdown2
      m2gend(2) = cms2
      m2gend(3) = cmb2
      Qd2       = 1.d0/9.d0 ! down charge squared
      Qu2       = 4.d0/9.d0 ! up charge squared

** down quark contribution
      SigAAtmp   = (0.d0,0.d0)
      do k = 1,2
         SigAAtmp = SigAAtmp + q2/3.d0
     .     -  (q2 + omt * m2gend(k)*2.d0)*B0C(cq2,m2gend(k),m2gend(k))
     .     + 2.d0 * omt * m2gend(k)      *B0C(czero,m2gend(k),m2gend(k))
      enddo
** bottom
      k = 3
      SigAAtmp = SigAAtmp + q2/3.d0
     .     -  (q2 + m2gend(k)*2.d0)*B0C(cq2,m2gend(k),m2gend(k))
     .     + 2.d0 * m2gend(k)      *B0C(czero,m2gend(k),m2gend(k))
*
      SigAAtmp = Qd2 * SigAAtmp * 4.d0  ! that's 2*2 ! Nc = 3, it cancels 1/3
      SigAA    = SigAA+SigAAtmp !* (1.d0 - ionlytop)


** up quark contribution
      SigAAtmp   = (0.d0,0.d0)
      do k = 1,2
         SigAAtmp = SigAAtmp + q2/3.d0
     .     -(q2+ omt * m2genu(k)*2.d0)*B0C(cq2,m2genu(k),m2genu(k))
     .     + 2.d0 * omt * m2genu(k) * B0C(czero,m2genu(k),m2genu(k))
      enddo
* TOP
      k = 3
      SigAAtmp = SigAAtmp + q2/3.d0
     .     -(q2+ m2genu(k)*2.d0) * B0C(cq2,m2genu(k),m2genu(k))
     .     + 2.d0 * m2genu(k)    * B0C(czero,m2genu(k),m2genu(k))
**

      SigAAtmp = Qu2 * SigAAtmp * 4.d0 ! that's 2*2 ! Nc = 3, it cancels 1/3
      SigAA    = SigAA+SigAAtmp

*** rescaling by -alpha/4.d0/pi
      SigAA = -SigAA*alpho4pi

      return
      end
**************************************************
      function dSigAA(q2)
*** derivative of B.1
      implicit none
      integer k
      double complex dSigAA,dSigAAtmp,cq2
      double precision mh2,q2
      double precision Qd2,Qu2
      double complex gfm,gfp

      double complex m2gend(3),m2genu(3)

      integer ionlytop,omt
      common/onlytop/ionlytop,omt

#include "couplingandmasses.h"

#include "looptools.h"

      cq2    = cone * q2
      dSigAA = (0.d0,0.d0)

** UV test
c      goto 111

** leptonic contribution
      dSigAAtmp = (0.d0,0.d0)
      m2gend(1) = cme2
      m2gend(2) = cmm2
      m2gend(3) = cmtau2
      do k = 1,3
         dSigAAtmp = dSigAAtmp + 1.d0/3.d0
     .     -(q2+ omt * m2gend(k)*2.d0) * DB0C(cq2,m2gend(k),m2gend(k))
     .     -(1.d0)                     * B0C(cq2,m2gend(k),m2gend(k))
      enddo
      dSigAAtmp = 2.d0 * dSigAAtmp*2.d0/3.d0
      dSigAA    = dSigAA+dSigAAtmp

** UV test
c      goto 111

** W contribution
      dSigAAtmp   = (3.d0*q2+4.d0*mw2)*DB0C(cq2,mw2,mw2)
     .             +(3.d0)            * B0C(cq2,mw2,mw2)
      dSigAA    = dSigAA+dSigAAtmp

*** quark contribution
 111  m2genu(1) = cmup2
      m2genu(2) = cmc2
      m2genu(3) = mtop2
      m2gend(1) = cmdown2
      m2gend(2) = cms2
      m2gend(3) = cmb2
      Qd2       = 1.d0/9.d0 ! down charge squared
      Qu2       = 4.d0/9.d0 ! up charge squared

** down quark contribution
      dSigAAtmp   = (0.d0,0.d0)
      do k = 1,2
         dSigAAtmp = dSigAAtmp + 1.d0/3.d0
     .     -(q2+ omt * m2gend(k)*2.d0) * DB0C(cq2,m2gend(k),m2gend(k))
     .     -(1.d0)                     * B0C(cq2,m2gend(k),m2gend(k))
      enddo
* bottom 
      k = 3
      dSigAAtmp = dSigAAtmp + 1.d0/3.d0
     .     -(q2+ m2gend(k)*2.d0) * DB0C(cq2,m2gend(k),m2gend(k))
     .     -(1.d0)               * B0C(cq2,m2gend(k),m2gend(k))
**
      dSigAAtmp = Qd2 * dSigAAtmp * 4.d0  ! that's 2*2 ! Nc = 3, it cancels 1/3
      dSigAA    = dSigAA+dSigAAtmp
** up quark contribution
      dSigAAtmp   = (0.d0,0.d0)
      do k = 1,2
         dSigAAtmp = dSigAAtmp + 1.d0/3.d0
     .     -(q2+ omt * m2genu(k)*2.d0) * DB0C(cq2,m2genu(k),m2genu(k))
     .     -(1.d0)                     * B0C(cq2,m2genu(k),m2genu(k))
      enddo

** TOP 
      k = 3
      dSigAAtmp = dSigAAtmp + 1.d0/3.d0
     .     -(q2 + m2genu(k)*2.d0) * DB0C(cq2,m2genu(k),m2genu(k))
     .     -(1.d0)                * B0C(cq2,m2genu(k),m2genu(k))
**
      dSigAAtmp = Qu2 * dSigAAtmp * 4.d0 ! that's 2*2 ! Nc = 3, it cancels 1/3
      dSigAA    = dSigAA+dSigAAtmp

*** rescaling by -alpha/4.d0/pi
      dSigAA = -dSigAA*alpho4pi

      return
      end
**************************************************
      function SigAZ(q2)
*** B.2
      implicit none
      integer k
      double complex SigAZ,SigAZtmp,cq2
      double precision mh2,q2

      double complex gfpgfm
      double precision qf

      integer ionlytop,omt
      common/onlytop/ionlytop,omt

      double complex m2gend(3),m2genu(3)

#include "couplingandmasses.h"

#include "looptools.h"

      cq2   = cone * q2
      SigAZ = (0.d0,0.d0)

** UV test
c      goto 111

** leptonic contribution
      SigAZtmp  = (0.d0,0.d0)
      m2gend(1) = cme2
      m2gend(2) = cmm2
      m2gend(3) = cmtau2
      qf        = -1.d0
      gfpgfm    = -sw/cw*qf
     .            + (-0.5d0-sw2*qf)/cw/sw
      do k = 1,3
         SigAZtmp = SigAZtmp + q2/3.d0
     .     -(q2+ omt * m2gend(k)*2.d0) * B0C(cq2,m2gend(k),m2gend(k))
     .     + 2.d0 * omt * m2gend(k)    * B0C(czero,m2gend(k),m2gend(k))
      enddo
      SigAZtmp = - qf * SigAZtmp*2.d0/3.d0 * gfpgfm 
      SigAZ    = SigAZ+SigAZtmp


** UV test
c      goto 111

** W contribution
      SigAZtmp   = q2/3.d0
     .    +((9.d0*cw2+0.5d0)*q2 + (12.d0*cw2+4.d0)*mw2)*B0C(cq2,mw2,mw2)
     .    - (12.d0*cw2-2.d0)*mw2*B0C(czero,mw2,mw2)
      SigAZtmp = -SigAZtmp / 3.d0 / sw / cw
      SigAZ    =  SigAZ+SigAZtmp

*** down quark contribution
 111  SigAZtmp  = (0.d0,0.d0)
      m2gend(1) = cmdown2
      m2gend(2) = cms2
      m2gend(3) = cmb2
      qf        = -1.d0/3.d0
      gfpgfm    = -sw/cw*qf + (-0.5d0-sw2*qf)/cw/sw
      do k = 1,2
         SigAZtmp = SigAZtmp + q2/3.d0
     .     -(q2+ omt * m2gend(k)*2.d0) * B0C(cq2,m2gend(k),m2gend(k))
     .     + 2.d0 * omt * m2gend(k)    * B0C(czero,m2gend(k),m2gend(k))
      enddo
** bottom
      k = 3
      SigAZtmp = SigAZtmp + q2/3.d0
     .     -(q2+ m2gend(k)*2.d0) * B0C(cq2,m2gend(k),m2gend(k))
     .     + 2.d0 * m2gend(k)    * B0C(czero,m2gend(k),m2gend(k))
**
      SigAZtmp = - qf * SigAZtmp*2.d0/3.d0 * gfpgfm * 3.d0  !! 3 is Nc !!!!
      SigAZ    = SigAZ+SigAZtmp

** up quark contribution
      SigAZtmp  = (0.d0,0.d0)

      m2genu(1) = cmup2
      m2genu(2) = cmc2
      m2genu(3) = mtop2
      qf        = 2.d0/3.d0
      gfpgfm    = -sw/cw*qf + (0.5d0-sw2*qf)/cw/sw
      do k = 1,2
         SigAZtmp = SigAZtmp + q2/3.d0
     .     -(q2+ omt * m2genu(k)*2.d0) * B0C(cq2,m2genu(k),m2genu(k))
     .     + 2.d0 * omt * m2genu(k)    * B0C(czero,m2genu(k),m2genu(k))
      enddo

** TOP
      k = 3
      SigAZtmp = SigAZtmp + q2/3.d0
     .     -(q2 +  m2genu(k)*2.d0) * B0C(cq2,m2genu(k),m2genu(k))
     .     + 2.d0 * m2genu(k)      * B0C(czero,m2genu(k),m2genu(k))
**
      SigAZtmp = - qf * SigAZtmp*2.d0/3.d0 * gfpgfm * 3.d0 !! 3 is Nc !!!!
      SigAZ    = SigAZ+SigAZtmp

*** rescaling by -alpha/4.d0/pi
      SigAZ = -SigAZ*alpho4pi

      return
      end
**************************************************
      function dSigAZ(q2)
*** derivative of B.2
      implicit none
      integer k
      double complex dSigAZ,dSigAZtmp,cq2,gfp,gfm,gfpgfm
      double precision mh2,q2,qf

      double complex m2gend(3),m2genu(3)

      integer ionlytop,omt
      common/onlytop/ionlytop,omt

#include "couplingandmasses.h"

#include "looptools.h"

      cq2   = cone * q2
      dSigAZ = (0.d0,0.d0)

** leptonic contribution
      dSigAZtmp  = (0.d0,0.d0)
      m2gend(1) = cme2
      m2gend(2) = cmm2
      m2gend(3) = cmtau2
      qf        = -1.d0
      gfpgfm    = -sw/cw*qf
     .            + (-0.5d0-sw2*qf)/cw/sw
      do k = 1,3
         dSigAZtmp = dSigAZtmp + 1.d0/3.d0
     .     -(q2+ omt* m2gend(k)*2.d0)*DB0C(cq2,m2gend(k),m2gend(k))
     .     -(1.d0)             * B0C(cq2,m2gend(k),m2gend(k))
      enddo
      dSigAZtmp = - qf * dSigAZtmp*2.d0/3.d0 * gfpgfm
      dSigAZ    = dSigAZ+dSigAZtmp

*** down quark contribution
      dSigAZtmp  = (0.d0,0.d0)
      m2gend(1) = cmdown2
      m2gend(2) = cms2
      m2gend(3) = cmb2
      qf        = -1.d0/3.d0
      gfpgfm    = -sw/cw*qf 
     .            + (-0.5d0-sw2*qf)/cw/sw
      do k = 1,2
         dSigAZtmp = dSigAZtmp + 1.d0/3.d0
     .     -(q2+omt * m2gend(k)*2.d0) * DB0C(cq2,m2gend(k),m2gend(k))
     .     -(1.d0)              * B0C(cq2,m2gend(k),m2gend(k))
      enddo
* bottom
      k = 3
      dSigAZtmp = dSigAZtmp + 1.d0/3.d0
     .     -(q2+m2gend(k)*2.d0) * DB0C(cq2,m2gend(k),m2gend(k))
     .     -(1.d0)              * B0C(cq2,m2gend(k),m2gend(k))
***
      dSigAZtmp = - qf * dSigAZtmp*2.d0/3.d0 * gfpgfm * 3.d0 !! 3 is Nc !!!!
      dSigAZ    = dSigAZ+dSigAZtmp

** up quark contribution
      dSigAZtmp  = (0.d0,0.d0)

      m2genu(1) = cmup2
      m2genu(2) = cmc2
      m2genu(3) = mtop2
      qf        = 2.d0/3.d0
      gfpgfm    = -sw/cw*qf 
     .           + (0.5d0-sw2*qf)/cw/sw
      do k = 1,2
         dSigAZtmp = dSigAZtmp + 1.d0/3.d0
     .     -(q2+omt*m2genu(k)*2.d0) * DB0C(cq2,m2genu(k),m2genu(k))
     .     -(1.d0)              * B0C(cq2,m2genu(k),m2genu(k))
      enddo
      k = 3
      dSigAZtmp = dSigAZtmp + 1.d0/3.d0
     .     -(q2+m2genu(k)*2.d0) * DB0C(cq2,m2genu(k),m2genu(k))
     .     -(1.d0)              * B0C(cq2,m2genu(k),m2genu(k))


      dSigAZtmp = - qf * dSigAZtmp*2.d0/3.d0 * gfpgfm * 3.d0 !! 3 is Nc !!!!
      dSigAZ    = dSigAZ+dSigAZtmp

** W contribution
      dSigAZtmp   = 1.d0/3.d0
     .   +((9.d0*cw2+0.5d0)*q2 + (12.d0*cw2+4.d0)*mw2)*DB0C(cq2,mw2,mw2)
     .   +((9.d0*cw2+0.5d0)*1.d0                     )* B0C(cq2,mw2,mw2)

      dSigAZtmp = -dSigAZtmp / 3.d0 / sw/cw
      dSigAZ    = dSigAZ+dSigAZtmp

*** rescaling by -alpha/4.d0/pi
      dSigAZ = -dSigAZ*alpho4pi

      return
      end
**********************************************************************************
      function SigZZ(q2,mh2)
*** B.3
      implicit none
      double complex SigZZ,SigZZtmp,cq2
      double precision mh2,q2,qf
      integer k
      double complex cmh2
      double complex gfpgfm
      integer ionlytop,omt
      common/onlytop/ionlytop,omt

      double complex m2gend(3),m2genu(3)

#include "couplingandmasses.h"
#include "looptools.h"

      cq2  = cone * q2
      cmh2 = cmplx(mh2)

      SigZZ = (0.d0,0.d0)

** leptonic down contribution
      SigZZtmp  = (0.d0,0.d0)
      m2gend(1) = cme2
      m2gend(2) = cmm2
      m2gend(3) = cmtau2
      qf        = -1.d0
      gfpgfm = (-sw/cw*qf)**2
     .        +((-0.5d0-sw2*qf)/cw/sw)**2
      do k = 1,3
         SigZZtmp = SigZZtmp + 
     .     gfpgfm * (q2/3.d0
     .      -(q2 + omt * m2gend(k)*2.d0)*B0C(cq2,m2gend(k),m2gend(k))
     .     +2.d0 * omt * m2gend(k) * B0C(czero,m2gend(k),m2gend(k)))
     .     + omt * 
     .        3.d0/4.d0/cw2/sw2*m2gend(k)*B0C(cq2,m2gend(k),m2gend(k))
      enddo
      SigZZtmp = SigZZtmp*2.d0/3.d0
      SigZZ    = SigZZ+SigZZtmp
      
** leptonic up contribution
      qf     = 0.d0
      gfpgfm = (-sw/cw*qf)**2
     .        +((+0.5d0-sw2*qf)/cw/sw)**2
      SigZZtmp = gfpgfm * (q2/3.d0 - q2*B0C(cq2,czero,czero))
      SigZZtmp = SigZZtmp*2.d0/3.d0 * 3.d0    ! 3 is for 3 neutrinos!
      SigZZ    = SigZZ+SigZZtmp

** UV test
c      goto 111

** W contribution
      SigZZtmp= (  (18d0*cw2*cw2+2.d0*cw2-0.5d0)*q2
     .      +(24.d0*cw2*cw2+16.d0*cw2-10.d0)*mw2  ) * B0C(cq2,mw2,mw2)
     .      -(24.d0*cw2*cw2-8.d0*cw2+2.d0)*mw2      * B0C(czero,mw2,mw2)
     .      + (4.d0*cw2 - 1.d0) * q2/3.d0
      SigZZtmp = SigZZtmp/6.d0/sw2/cw2
      SigZZ    = SigZZ+SigZZtmp

*** higgs contribution
      SigZZtmp=  -q2*2.d0/3.d0
     .          +( 2d0*cmh2-10.d0*mz2-q2 ) * B0C(cq2,mz2,cmh2)
     .          -2.d0*mz2* B0C(czero,mz2,mz2)
     .          -2.d0*cmh2* B0C(czero,cmh2,cmh2)
     .        -(mz2-cmh2)**2/q2* (B0C(cq2,mz2,cmh2)-B0C(czero,mz2,cmh2)) 
      SigZZtmp = SigZZtmp/12.d0/sw2/cw2
      SigZZ    = SigZZ+SigZZtmp

*** down quark contribution
 111  SigZZtmp  = (0.d0,0.d0)
      m2gend(1) = cmdown2
      m2gend(2) = cms2
      m2gend(3) = cmb2
      qf        = -1.d0/3.d0
      gfpgfm = (-sw/cw*qf)**2
     .        +((-0.5d0-sw2*qf)/cw/sw)**2
      do k = 1,2
         SigZZtmp = SigZZtmp + 
     .     gfpgfm * (q2/3.d0
     .      -(q2+ omt * m2gend(k)*2.d0)* B0C(cq2,m2gend(k),m2gend(k))
     .     + 2.d0 * omt * m2gend(k)    * B0C(czero,m2gend(k),m2gend(k)))
     .     + omt * 
     .        3.d0/4.d0/cw2/sw2*m2gend(k)*B0C(cq2,m2gend(k),m2gend(k))
      enddo
*** bottom 
      k = 3
      SigZZtmp = SigZZtmp + 
     .     gfpgfm * (q2/3.d0
     .     -(q2+ m2gend(k)*2.d0)* B0C(cq2,m2gend(k),m2gend(k))
     .     + 2.d0 * m2gend(k)    * B0C(czero,m2gend(k),m2gend(k)))
     .     + 3.d0/4.d0/cw2/sw2*m2gend(k)*B0C(cq2,m2gend(k),m2gend(k))
****
      SigZZtmp = SigZZtmp*2.d0/3.d0 * 3.d0  ! 3 is the color factor
      SigZZ    = SigZZ+SigZZtmp

*** up quark contribution
      SigZZtmp  = (0.d0,0.d0)
      m2genu(1) = cmup2
      m2genu(2) = cmc2
      m2genu(3) = mtop2
      qf        = 2.d0/3.d0
      gfpgfm = (-sw/cw*qf)**2
     .         +((+0.5d0-sw2*qf)/cw/sw)**2
      do k = 1,2
         SigZZtmp = SigZZtmp + 
     .     gfpgfm * (q2/3.d0
     .      -(q2+ omt * m2genu(k)*2.d0)
     .       *B0C(cq2,m2genu(k),m2genu(k))
     .     + 2.d0 * omt * m2genu(k) * B0C(czero,m2genu(k),m2genu(k)))
     .     + omt * 
     .        3.d0/4.d0/cw2/sw2*m2genu(k)*B0C(cq2,m2genu(k),m2genu(k))
      enddo
      SigZZtmp = SigZZtmp 
* TOP
      k = 3
      SigZZtmp = SigZZtmp + 
     .     gfpgfm * (q2/3.d0
     .      -(q2+ m2genu(k)*2.d0)
     .       *B0C(cq2,m2genu(k),m2genu(k))
     .     + 2.d0 * m2genu(k) * B0C(czero,m2genu(k),m2genu(k)))
     .     +  
     .     3.d0/4.d0/cw2/sw2*m2genu(k)*B0C(cq2,m2genu(k),m2genu(k))
**
      SigZZtmp = SigZZtmp*2.d0/3.d0 * 3.d0 ! 3 is the color factor
      SigZZ    = SigZZ+SigZZtmp

*** rescaling by -alpha/4.d0/pi
      SigZZ = -SigZZ*alpho4pi

      return
      end
**********************************************************************************
      function dSigZZ(q2,mh2)
*** derivative of B.3
      implicit none
      integer k
      double complex dSigZZ,dSigZZtmp,cq2
      double precision mh2,q2,qf
      double complex cmh2,gfpgfm

      double complex m2gend(3),m2genu(3)

      integer ionlytop,omt
      common/onlytop/ionlytop,omt

#include "couplingandmasses.h"

#include "looptools.h"

      cq2   = cone * q2
      cmh2 = cmplx(mh2)

      dSigZZ = (0.d0,0.d0)

** leptonic down contribution
      dSigZZtmp  = (0.d0,0.d0)
      m2gend(1) = cme2
      m2gend(2) = cmm2
      m2gend(3) = cmtau2
      qf        = -1.d0
      gfpgfm = (-sw/cw*qf)**2
     .         +((-0.5d0-sw2*qf)/cw/sw)**2
      do k = 1,3
         dSigZZtmp = dSigZZtmp + 
     .     gfpgfm * (1.d0/3.d0
     .      -(q2+ omt * m2gend(k)*2.d0) * DB0C(cq2,m2gend(k),m2gend(k))
     .      -(1.d0)                     * B0C(cq2,m2gend(k),m2gend(k)))
     .     + omt *
     .       3.d0/4.d0/cw2/sw2*m2gend(k)*DB0C(cq2,m2gend(k),m2gend(k))
      enddo
      dSigZZtmp = dSigZZtmp*2.d0/3.d0
      dSigZZ    = dSigZZ+dSigZZtmp

** leptonic up contribution
      qf     = 0.d0
      gfpgfm = (-sw/cw*qf)**2
     .       +((+0.5d0-sw2*qf)/cw/sw)**2
      dSigZZtmp = gfpgfm * (1.d0/3.d0 - q2*DB0C(cq2,czero,czero)
     .                                     -B0C(cq2,czero,czero))
      dSigZZtmp = dSigZZtmp*2.d0/3.d0 * 3.d0  ! 3 is for 3 neutrinos!
      dSigZZ    = dSigZZ+dSigZZtmp

c      print*,'2  ',dSigZZtmp*alpho4pi

** UV test
c       goto 111

** W contribution
      dSigZZtmp= 
     .     (    (18d0*cw2*cw2+2.d0*cw2-0.5d0)*q2
     .         +(24.d0*cw2*cw2+16.d0*cw2-10.d0)*mw2  )
     .    * DB0C(cq2,mw2,mw2)
     .     +     (18d0*cw2*cw2+2.d0*cw2-0.5d0)*1.d0
     .    *  B0C(cq2,mw2,mw2)
     .         + (4.d0*cw2 - 1.d0) * 1.d0/3.d0
      dSigZZtmp = dSigZZtmp/6.d0/sw2/cw2
      dSigZZ    = dSigZZ+dSigZZtmp

*** higgs contribution
      dSigZZtmp=  -1.d0*2.d0/3.d0
     .          +( 2d0*cmh2-10.d0*mz2-q2 ) * DB0C(cq2,mz2,cmh2)
     .          +( -1.d0 )                 *  B0C(cq2,mz2,cmh2)
     .    -(mz2-cmh2)**2/q2*    (DB0C(cq2,mz2,cmh2)) 
     .    +(mz2-cmh2)**2/q2/q2* (B0C(cq2,mz2,cmh2)- B0C(czero,mz2,cmh2)) 
      dSigZZtmp = dSigZZtmp/12.d0/sw2/cw2
      dSigZZ    = dSigZZ+dSigZZtmp

*** down quark contribution
 111  dSigZZtmp  = (0.d0,0.d0)
      m2gend(1) = cmdown2
      m2gend(2) = cms2
      m2gend(3) = cmb2
      qf        = -1.d0/3.d0
      gfpgfm = (-sw/cw*qf)**2
     .       +((-0.5d0-sw2*qf)/cw/sw)**2
      do k = 1,2
         dSigZZtmp = dSigZZtmp + 
     .     gfpgfm * (1.d0/3.d0
     .      -(q2+ omt * m2gend(k)*2.d0)*DB0C(cq2,m2gend(k),m2gend(k))
     .      -(1.d0)             * B0C(cq2,m2gend(k),m2gend(k)))
     .     + omt * 
     .        3.d0/4.d0/cw2/sw2*m2gend(k)*DB0C(cq2,m2gend(k),m2gend(k))
      enddo
** bottom 
      k = 3
         dSigZZtmp = dSigZZtmp + 
     .     gfpgfm * (1.d0/3.d0
     .     -(q2+ m2gend(k)*2.d0)*DB0C(cq2,m2gend(k),m2gend(k))
     .     -(1.d0)             * B0C(cq2,m2gend(k),m2gend(k)))
     .     + 3.d0/4.d0/cw2/sw2*m2gend(k)*DB0C(cq2,m2gend(k),m2gend(k))
****
      dSigZZtmp = dSigZZtmp*2.d0/3.d0 * 3.d0  ! 3 is the color factor
      dSigZZ    = dSigZZ+dSigZZtmp

*** up quark contribution
      dSigZZtmp = (0.d0,0.d0)
      m2genu(1) = cmup2
      m2genu(2) = cmc2
      m2genu(3) = mtop2
      qf        = 2.d0/3.d0
      gfpgfm = (-sw/cw*qf)**2
     .     +((+0.5d0-sw2*qf)/cw/sw)**2
      do k = 1,2
         dSigZZtmp = dSigZZtmp + 
     .     gfpgfm * (1.d0/3.d0
     .      -(q2+omt * m2genu(k)*2.d0)*DB0C(cq2,m2genu(k),m2genu(k))
     .      -(1.d0) * B0C(cq2,m2genu(k),m2genu(k)))
     .     + omt *
     .        3.d0/4.d0/cw2/sw2*m2genu(k)*DB0C(cq2,m2genu(k),m2genu(k))
      enddo
      dSigZZtmp = dSigZZtmp

** TOP
      k = 3
      dSigZZtmp = dSigZZtmp + 
     .     gfpgfm * (1.d0/3.d0
     .      -(q2+ m2genu(k)*2.d0)*DB0C(cq2,m2genu(k),m2genu(k))
     .      -(1.d0) * B0C(cq2,m2genu(k),m2genu(k))) !* (1.d0 - ionlytop)
     .    +3.d0/4.d0/cw2/sw2*m2genu(k)*DB0C(cq2,m2genu(k),m2genu(k))
**
      dSigZZtmp = dSigZZtmp*2.d0/3.d0 * 3.d0 ! 3 is the color factor
      dSigZZ    = dSigZZ+dSigZZtmp

*** rescaling by -alpha/4.d0/pi
      dSigZZ = -dSigZZ*alpho4pi

      end
*********************************************************************************
      function SigW(q2,mh2)
*** B.4
      implicit none
      integer k
      double complex SigW,SigWtmp,cq2
      double precision mh2,q2
      double complex cmh2

      double complex m2gend(3),m2genu(3)

      integer ionlytop,omt
      common/onlytop/ionlytop,omt

#include "couplingandmasses.h"

#include "looptools.h"

      cq2   = cone * q2
      cmh2 = cmplx(mh2)

      SigW = (0.d0,0.d0)

** leptonic contribution
c      goto 111
      SigWtmp   = (0.d0,0.d0)
      m2gend(1) = cme2
      m2gend(2) = cmm2
      m2gend(3) = cmtau2
      m2genu    = czero
      do k = 1,3
         SigWtmp = SigWtmp + q2/3.d0
     .     -(q2- omt * m2gend(k)*0.5d0)*B0C(cq2,m2genu(k),m2gend(k))
     .     + omt * m2gend(k) * B0C(czero,m2gend(k),m2gend(k))
     .     + 0.5d0* omt *m2gend(k)**2/q2 * 
     .     (B0C(cq2,m2genu(k),m2gend(k))-B0C(czero,m2genu(k),m2gend(k)))
      enddo
      SigWtmp = SigWtmp/sw2/3.d0
      SigW    = SigW+SigWtmp

 111  continue
** UV test
c       goto 111

** photon contribution
      SigWtmp   = q2/3.d0
     .          + (2.d0*mw2+5.d0*q2)*B0C(cq2,mw2,czero)
     .          - 2.d0*mw2*B0C(czero,mw2,mw2)
     .          - mw2*mw2/q2*(B0C(cq2,mw2,czero)- B0C(czero,mw2,czero))
      SigWtmp = SigWtmp*2.d0/3.d0
      SigW    = SigW+SigWtmp

** Z contribution
      SigWtmp   = ((40.d0*cw2-1.d0)*q2+mw2*(16.d0*cw2+54.d0-10.d0/cw2))
     .            *B0C(cq2,mw2,mz2)
     .          - (16.d0*cw2+2.d0)
     .            * (mw2*B0C(czero,mw2,mw2) + mz2*B0C(czero,mz2,mz2))
     .          + (4.d0*cw2-1.d0)*q2*2.d0/3.d0
     .          - (8.d0*cw2+1.d0)*(mw2-mz2)**2/q2
     .            *(B0C(cq2,mw2,mz2) - B0C(czero,mw2,mz2))
      SigWtmp = SigWtmp/12.d0/sw2
      SigW    = SigW+SigWtmp

** higgs contribution
      SigWtmp   = (2.d0*cmh2-10.d0*mw2-q2)
     .            *B0C(cq2,mw2,cmh2)
     .         - 2.d0*(mw2*B0C(czero,mw2,mw2)+cmh2*B0C(czero,cmh2,cmh2))
     .           - (mw2-cmh2)**2/q2
     .            *(B0C(cq2,mw2,cmh2) - B0C(czero,mw2,cmh2))
     .           - 2.d0/3.d0*q2
      SigWtmp = SigWtmp/12.d0/sw2
      SigW    = SigW+SigWtmp

** quark contribution
c      goto 222
      SigWtmp   = (0.d0,0.d0)
      m2genu(1) = cmup2
      m2genu(2) = cmc2
      m2genu(3) = mtop2

      m2gend(1) = cmdown2
      m2gend(2) = cms2 
      m2gend(3) = cmb2

      do k = 1,2
         SigWtmp = SigWtmp + q2/3.d0
     .    -(q2- omt * (m2gend(k)+m2genu(k))*0.5d0)
     .      *B0C(cq2,m2genu(k),m2gend(k))
     .    + omt * m2gend(k) * B0C(czero,m2gend(k),m2gend(k))
     .    + omt * m2genu(k) * B0C(czero,m2genu(k),m2genu(k))
     .    + omt * 0.5d0*(m2genu(k)-m2gend(k))**2/q2 * 
     .    (B0C(cq2,m2genu(k),m2gend(k))-B0C(czero,m2genu(k),m2gend(k)))
      enddo
c      SigWtmp = SigWtmp

* TOP & bottom
      k = 3
      SigWtmp = SigWtmp + q2/3.d0
     .     -(q2-(m2gend(k) + m2genu(k))*0.5d0)
     .     *B0C(cq2,m2genu(k),m2gend(k))
     .     + m2gend(k) * B0C(czero,m2gend(k),m2gend(k))
     .     + m2genu(k) * B0C(czero,m2genu(k),m2genu(k))
     .     + 0.5d0*(m2genu(k)-m2gend(k))**2/q2 * 
     .     (B0C(cq2,m2genu(k),m2gend(k))-B0C(czero,m2genu(k),m2gend(k)))
**     
      SigWtmp = SigWtmp/sw2
      SigW    = SigW+SigWtmp

 222  continue

      SigW = -SigW*alpho4pi

      return
      end

*********************************************************************************
      function SigWin0(q2,mh2)
!! to be used only for q2 = 0!!!!!!!!!!!!!!!!
*** B.4
! for q2 = 0!!
      implicit none
      integer k
      double complex SigWin0,SigWtmp,cq2
      double precision mh2,q2
      double complex cmh2

      double complex m2gend(3),m2genu(3)

      integer ionlytop,omt
      common/onlytop/ionlytop,omt

#include "couplingandmasses.h"

#include "looptools.h"

      cq2  = cone * q2
      cmh2 = cmplx(mh2)

      SigWin0 = (0.d0,0.d0)

** leptonic contribution
      SigWtmp   = (0.d0,0.d0)
      m2gend(1) = cme2
      m2gend(2) = cmm2
      m2gend(3) = cmtau2
      m2genu    = czero
      do k = 1,3
         SigWtmp = SigWtmp + q2/3.d0
     .     -(-omt * m2gend(k)*0.5d0)*B0C(cq2,m2genu(k),m2gend(k))
     .     + omt * m2gend(k) * B0C(czero,m2gend(k),m2gend(k))
     .     + omt * 0.5d0*m2gend(k)**2 *
     .     (DB0C(cq2,m2genu(k),m2gend(k)))
      enddo
      SigWtmp = SigWtmp/sw2/3.d0
      SigWin0 = SigWin0+SigWtmp

** quark contribution
      SigWtmp   = (0.d0,0.d0)
      m2genu(1) = cmup2
      m2genu(2) = cmc2
      m2genu(3) = mtop2

      m2gend(1) = cmdown2
      m2gend(2) = cms2
      m2gend(3) = cmb2

      do k = 1,2
         SigWtmp = SigWtmp + q2/3.d0
     .  -(-omt*(m2gend(k)+m2genu(k))*0.5d0)*B0C(cq2,m2genu(k),m2gend(k))
     .  + omt * m2gend(k) * B0C(czero,m2gend(k),m2gend(k))
     .  + omt *  m2genu(k) * B0C(czero,m2genu(k),m2genu(k))
     .  + omt * 0.5d0*(m2genu(k)-m2gend(k))**2 * 
     .  DB0C(cq2,m2genu(k),m2gend(k))
      enddo

      k = 3
      SigWtmp = SigWtmp + q2/3.d0
     .     -(-(m2gend(k)+m2genu(k))*0.5d0)*B0C(cq2,m2genu(k),m2gend(k))
     .     +   m2gend(k) * B0C(czero,m2gend(k),m2gend(k))
     .     + m2genu(k) * B0C(czero,m2genu(k),m2genu(k))
     .     + 0.5d0*(m2genu(k)-m2gend(k))**2 * 
     .     (DB0C(cq2,m2genu(k),m2gend(k)))

      SigWtmp = SigWtmp/sw2
      SigWin0 = SigWin0+SigWtmp

** photon contribution
      SigWtmp   = 0.d0/3.d0
     .          + (2.d0*mw2+5.d0*q2)*B0C(cq2,mw2,czero)
     .          - 2.d0*mw2*B0C(czero,mw2,mw2)
     .          - mw2*mw2*(DB0C(cq2,mw2,czero))
      SigWtmp = SigWtmp*2.d0/3.d0
      SigWin0 = SigWin0+SigWtmp

** Z contribution
      SigWtmp   = ((40.d0*cw2-1.d0)*q2+mw2*(16.d0*cw2+54.d0-10.d0/cw2))
     .            *B0C(cq2,mw2,mz2)
     .          - (16.d0*cw2+2.d0)
     .            * (mw2*B0C(czero,mw2,mw2) + mz2*B0C(czero,mz2,mz2))
     .          + (4.d0*cw2-1.d0)*q2*2.d0/3.d0
     .          - (8.d0*cw2+1.d0)*(mw2-mz2)**2
     .            *(DB0C(cq2,mw2,mz2))
      SigWtmp = SigWtmp/12.d0/sw2
      SigWin0 = SigWin0+SigWtmp

** higgs contribution
      SigWtmp   = (2.d0*cmh2-10.d0*mw2-q2)
     .            *B0C(cq2,mw2,cmh2)
     .         - 2.d0*(mw2*B0C(czero,mw2,mw2)+cmh2*B0C(czero,cmh2,cmh2))
     .           - (mw2-cmh2)**2
     .            *(DB0C(cq2,mw2,cmh2))
     .           - 2.d0/3.d0*q2
      SigWtmp = SigWtmp/12.d0/sw2
      SigWin0 = SigWin0+SigWtmp

      SigWin0 = -SigWin0*alpho4pi

      return
      end
************************************************************************************
      function dSigW(q2,mh2)
*** derivative of B.4
      implicit none
      integer k
      double complex dSigW,dSigWtmp,cq2
      double precision mh2,q2
      double complex cmh2

      integer ionlytop,omt
      common/onlytop/ionlytop,omt

      double complex m2gend(3),m2genu(3)

#include "couplingandmasses.h"

#include "looptools.h"

      cq2   = cone * q2
      cmh2 = cmplx(mh2)

      dSigW = (0.d0,0.d0)

** leptonic contribution
      dSigWtmp   = (0.d0,0.d0)
      m2gend(1) = cme2
      m2gend(2) = cmm2
      m2gend(3) = cmtau2
      m2genu    = czero

      do k = 1,3
         dSigWtmp = dSigWtmp + 1.d0/3.d0
     .     -(q2- omt * m2gend(k)*0.5d0) * DB0C(cq2,m2genu(k),m2gend(k))
     .     -(1.d0)                      * B0C(cq2,m2genu(k),m2gend(k))
     .     + omt * 0.5d0*m2gend(k)**2/q2 * DB0C(cq2,m2genu(k),m2gend(k))
     .     - omt * 0.5d0*m2gend(k)**2/q2/q2 * 
     .     (B0C(cq2,m2genu(k),m2gend(k))-B0C(czero,m2genu(k),m2gend(k)))
      enddo
      dSigWtmp = dSigWtmp/sw2/3.d0
      dSigW    = dSigW+dSigWtmp

** UV test
c       goto 111


** photon contribution
      dSigWtmp   = 1.d0/3.d0
     .        + (2.d0*mw2+5.d0*q2) * DB0C(cq2,mw2,czero)
     .        + (5.d0)             * B0C(cq2,mw2,czero)
     .        - mw2*mw2/q2*DB0C(cq2,mw2,czero)
     .        + mw2*mw2/q2/q2*(B0C(cq2,mw2,czero)- B0C(czero,mw2,czero))
      dSigWtmp = dSigWtmp*2.d0/3.d0
      dSigW    = dSigW+dSigWtmp
      
** Z contribution
      dSigWtmp   = ((40.d0*cw2-1.d0)*q2+mw2*(16.d0*cw2+54.d0-10.d0/cw2))
     .            *DB0C(cq2,mw2,mz2)
     .          +  (40.d0*cw2-1.d0)*1.d0
     .            *B0C(cq2,mw2,mz2)
     .          + (4.d0*cw2-1.d0)*2.d0/3.d0
     .          - (8.d0*cw2+1.d0)*(mw2-mz2)**2/q2
     .            *DB0C(cq2,mw2,mz2)
     .          + (8.d0*cw2+1.d0)*(mw2-mz2)**2/q2/q2
     .            *(B0C(cq2,mw2,mz2) - B0C(czero,mw2,mz2))

      dSigWtmp = dSigWtmp/12.d0/sw2
      dSigW    = dSigW+dSigWtmp

** higgs contribution
      dSigWtmp   = (2.d0*cmh2-10.d0*mw2-q2)
     .            *DB0C(cq2,mw2,cmh2)
     .            +(-1.d0)
     .            *B0C(cq2,mw2,cmh2)
     .           - (mw2-cmh2)**2/q2
     .            *DB0C(cq2,mw2,cmh2)
     .           + (mw2-cmh2)**2/q2/q2
     .            *(B0C(cq2,mw2,cmh2) - B0C(czero,mw2,cmh2))
     .           - 2.d0/3.d0
      dSigWtmp = dSigWtmp/12.d0/sw2
      dSigW    = dSigW+dSigWtmp

** quark contribution
 111  dSigWtmp  = (0.d0,0.d0)
      m2genu(1) = cmup2
      m2genu(2) = cmc2
      m2genu(3) = mtop2

      m2gend(1) = cmdown2
      m2gend(2) = cms2
      m2gend(3) = cmb2

      do k = 1,2
         dSigWtmp = dSigWtmp + 1.d0/3.d0
     .   -(q2- omt * (m2gend(k)+m2genu(k))*0.5d0)
     .             * DB0C(cq2,m2genu(k),m2gend(k))
     .    -(1.d0)  * B0C(cq2,m2genu(k),m2gend(k))
     .      + omt  * 0.5d0*(m2genu(k)-m2gend(k))**2/q2 * 
     .      DB0C(cq2,m2genu(k),m2gend(k))
     .     - omt * 0.5d0*(m2genu(k)-m2gend(k))**2/q2/q2 * 
     .     (B0C(cq2,m2genu(k),m2gend(k))-B0C(czero,m2genu(k),m2gend(k)))
      enddo
      dSigWtmp = dSigWtmp 
** TOP & bottom
      k = 3
      dSigWtmp = dSigWtmp + 1.d0/3.d0
     .     -(q2-(m2gend(k)+ m2genu(k))*0.5d0)*
     .     DB0C(cq2,m2genu(k),m2gend(k))
     .     -(1.d0) * B0C(cq2,m2genu(k),m2gend(k))
     .     + 0.5d0*(m2genu(k)-m2gend(k))**2/q2 * 
     .     DB0C(cq2,m2genu(k),m2gend(k))
     .     - 0.5d0*(m2genu(k)-m2gend(k))**2/q2/q2 * 
     .     (B0C(cq2,m2genu(k),m2gend(k))-B0C(czero,m2genu(k),m2gend(k)))
**

      dSigWtmp = dSigWtmp/sw2
      dSigW    = dSigW+dSigWtmp

      dSigW = -dSigW*alpho4pi

      return
      end
************************************************************************************
      function SigH(q2,mh2)
*** B.5
      implicit none
      integer k
      double complex SigH,SigHtmp,cq2
      double precision mh2,q2
      double complex cmh2

      double complex m2gend(3),m2genu(3)

      integer ionlytop,omt
      common/onlytop/ionlytop,omt

#include "couplingandmasses.h"

#include "looptools.h"

      cq2  = cone * q2
      cmh2 = cmplx(mh2)

      SigH = (0.d0,0.d0)

** leptonic contribution (neglected!)
      SigHtmp  = (0.d0,0.d0)
      SigH     = SigH+SigHtmp

** quark contribution (only top & bottom!)
      SigHtmp = 2.d0*A0C(mtop2) + (4.d0*mtop2-q2)*B0C(cq2,mtop2,mtop2)
      SigHtmp = SigHtmp/sw2/2.d0/mw2 * mtop2 * 3.d0 ! 3 = Nc
      SigH    = SigH+SigHtmp

      SigHtmp = 2.d0*A0C(cmb2) + (4.d0*cmb2-q2)*B0C(cq2,cmb2,cmb2)
      SigHtmp = SigHtmp/sw2/2.d0/mw2 * cmb2 * 3.d0 ! 3 = Nc
      SigH    = SigH+SigHtmp

      if (ionlytop.eq.0) then
cme2,cmm2,cmtau2,cmup2,cmdown2,cmc2,cms2
      SigHtmp = 2.d0*A0C(cme2) + (4.d0*cme2-q2)*B0C(cq2,cme2,cme2)
      SigHtmp = SigHtmp/sw2/2.d0/mw2 * cme2 * 1.d0 ! 3 = Nc
      SigH    = SigH+SigHtmp

      SigHtmp = 2.d0*A0C(cmm2) + (4.d0*cmm2-q2)*B0C(cq2,cmm2,cmm2)
      SigHtmp = SigHtmp/sw2/2.d0/mw2 * cmm2 * 1.d0 ! 3 = Nc
      SigH    = SigH+SigHtmp

      SigHtmp=2.d0*A0C(cmtau2) + (4.d0*cmtau2-q2)*B0C(cq2,cmtau2,cmtau2)
      SigHtmp = SigHtmp/sw2/2.d0/mw2 * cmtau2 * 1.d0 ! 3 = Nc
      SigH    = SigH+SigHtmp

      SigHtmp = 2.d0*A0C(cmup2) + (4.d0*cmup2-q2)*B0C(cq2,cmup2,cmup2)
      SigHtmp = SigHtmp/sw2/2.d0/mw2 * cmup2 * 3.d0 ! 3 = Nc
      SigH    = SigH+SigHtmp

      SigHtmp = 2.d0*A0C(cmdown2) 
     .     + (4.d0*cmdown2-q2)*B0C(cq2,cmdown2,cmdown2)
      SigHtmp = SigHtmp/sw2/2.d0/mw2 * cmdown2 * 3.d0 ! 3 = Nc
      SigH    = SigH+SigHtmp

      SigHtmp = 2.d0*A0C(cmc2) + (4.d0*cmc2-q2)*B0C(cq2,cmc2,cmc2)
      SigHtmp = SigHtmp/sw2/2.d0/mw2 * cmc2 * 3.d0 ! 3 = Nc
      SigH    = SigH+SigHtmp

      SigHtmp = 2.d0*A0C(cms2) + (4.d0*cms2-q2)*B0C(cq2,cms2,cms2)
      SigHtmp = SigHtmp/sw2/2.d0/mw2 * cms2 * 3.d0 ! 3 = Nc
      SigH    = SigH+SigHtmp

      endif

* UV test
c      goto 111

** W contribution
      SigHtmp =(6.d0*mw2-2.d0*q2 + cmh2*cmh2/mw2*0.5d0)*B0C(cq2,mw2,mw2) 
     .        +(3.d0  + cmh2/mw2*0.5d0) * A0C(mw2) - 6.d0*mw2
      SigHtmp = -SigHtmp/sw2*0.5d0
      SigH    = SigH+SigHtmp

** Z contribution
c      goto 1234
      SigHtmp =(6.d0*mz2-2.d0*q2 + cmh2*cmh2/mz2*0.5d0)*B0C(cq2,mz2,mz2) 
     .        +(3.d0  + cmh2/mz2*0.5d0) * A0C(mz2) - 6.d0*mz2
      SigHtmp = -SigHtmp/4.d0/sw2/cw2
      SigH    = SigH+SigHtmp
 1234 continue
** higgs contribution
      SigHtmp = 3.d0*cmh2*cmh2*B0C(cq2,cmh2,cmh2) + cmh2*A0C(cmh2)
      SigHtmp = -3.d0 * SigHtmp/8.d0/sw2/mw2
      SigH    = SigH+SigHtmp

*** rescaling by alpha/4/pi

      SigH = -SigH*alpho4pi

      return
      end
************************************************************************************
      function dSigH(q2,mh2)
*** derivative of B.5
      implicit none
      integer k
      double complex dSigH,dSigHtmp,cq2
      double precision mh2,q2
      double complex cmh2

      double complex m2gend(3),m2genu(3)

      integer ionlytop,omt
      common/onlytop/ionlytop,omt

#include "couplingandmasses.h"

#include "looptools.h"

      cq2  = cone * q2
      cmh2 = cmplx(mh2)

      dSigH = (0.d0,0.d0)

** leptonic contribution (neglected!)
      dSigHtmp  = (0.d0,0.d0)
      dSigH     = dSigH+dSigHtmp

** quark contribution (only top & bottom!)
      dSigHtmp=(4.d0*mtop2-q2)*DB0C(cq2,mtop2,mtop2)
     .     -B0C(cq2,mtop2,mtop2)
      dSigHtmp = dSigHtmp/sw2/2.d0/mw2 * mtop2 * 3.d0 ! 3 = Nc
      dSigH    = dSigH+dSigHtmp

      dSigHtmp = (4.d0*cmb2-q2)*DB0C(cq2,cmb2,cmb2)-B0C(cq2,cmb2,cmb2)
      dSigHtmp = dSigHtmp/sw2/2.d0/mw2 * cmb2 * 3.d0 ! 3 = Nc
      dSigH    = dSigH+dSigHtmp

cme2,cmm2,cmtau2,cmup2,cmdown2,cmc2,cms2
      if (ionlytop.eq.0) then
         dSigHtmp=(4.d0*cmm2-q2)*DB0C(cq2,cmm2,cmm2)-B0C(cq2,cmm2,cmm2)
         dSigHtmp=dSigHtmp/sw2/2.d0/mw2 * cmm2 * 1.d0 ! 3 = Nc
         dSigH   = dSigH+dSigHtmp

         dSigHtmp=(4.d0*cme2-q2)*DB0C(cq2,cme2,cme2)-B0C(cq2,cme2,cme2)
         dSigHtmp=dSigHtmp/sw2/2.d0/mw2 * cme2 * 1.d0 ! 3 = Nc
         dSigH   = dSigH+dSigHtmp
         
         dSigHtmp = (4.d0*cmtau2-q2)*DB0C(cq2,cmtau2,cmtau2)
     .        -B0C(cq2,cmtau2,cmtau2)
         dSigHtmp = dSigHtmp/sw2/2.d0/mw2 * cmtau2 * 1.d0 ! 3 = Nc
         dSigH    = dSigH+dSigHtmp
         
         dSigHtmp=(4.d0*cmc2-q2)*DB0C(cq2,cmc2,cmc2)-B0C(cq2,cmc2,cmc2)
         dSigHtmp=dSigHtmp/sw2/2.d0/mw2 * cmc2 * 3.d0 ! 3 = Nc
         dSigH   = dSigH+dSigHtmp
         
         dSigHtmp=(4.d0*cms2-q2)*DB0C(cq2,cms2,cms2)-B0C(cq2,cms2,cms2)
         dSigHtmp=dSigHtmp/sw2/2.d0/mw2 * cms2 * 3.d0 ! 3 = Nc
         dSigH   = dSigH+dSigHtmp
         
         dSigHtmp = (4.d0*cmup2-q2)*DB0C(cq2,cmup2,cmup2)
     .        -B0C(cq2,cmup2,cmup2)
         dSigHtmp = dSigHtmp/sw2/2.d0/mw2 * cmup2 * 3.d0 ! 3 = Nc
         dSigH    = dSigH+dSigHtmp
         
         dSigHtmp = (4.d0*cmdown2-q2)*DB0C(cq2,cmdown2,cmdown2)
     .        -B0C(cq2,cmdown2,cmdown2)
         dSigHtmp = dSigHtmp/sw2/2.d0/mw2 * cmdown2 * 3.d0 ! 3 = Nc
         dSigH    = dSigH+dSigHtmp
      endif

* UV test
c       goto 111

** W contribution
      dSigHtmp =(6.d0*mw2-2.d0*q2+cmh2*cmh2/mw2*0.5d0)
     . *DB0C(cq2,mw2,mw2) 
     .         +(-2.d0)*B0C(cq2,mw2,mw2) 
      dSigHtmp = -dSigHtmp/2.d0/sw2
      dSigH    = dSigH+dSigHtmp

** Z contribution
c      goto 1234
      dSigHtmp=(6.d0*mz2-2.d0*q2+cmh2*cmh2/mz2*0.5d0)
     . *DB0C(cq2,mz2,mz2) 
     .         +(-2.d0 )*B0C(cq2,mz2,mz2)

      dSigHtmp = -dSigHtmp/4.d0/sw2/cw2
      dSigH    = dSigH+dSigHtmp
 1234 continue
** higgs contribution
      dSigHtmp = 3.d0*cmh2*cmh2*DB0C(cq2,cmh2,cmh2)
      dSigHtmp = -3.d0 * dSigHtmp/8.d0/sw2/mw2
      dSigH    = dSigH+dSigHtmp

*** rescaling by alpha/4/pi

 111  dSigH = -dSigH*alpho4pi

      return
      end
************************************************************************************
      function SigfL(q2,m2)
*** B.6
      implicit none
      integer k,ifirst      
      double complex SigfL,SigfLtmp,cq2
      double precision m2,q2
      double complex cmh2,gfp,gfm,cm2

      double complex m2gend(3),m2genu(3)

      common/commonSigfL/ifirst
      data ifirst /1/

#include "couplingandmasses.h"

#include "looptools.h"

      cq2   = cone * q2
      cm2   = cmplx(m2)
c      cmh2 = cmplx(mh2)

      SigfL = (0.d0,0.d0)

** photon contribution (already accounted for, make ur mind)
      SigfLtmp  = czero ! 2.d0*B1C(cq2,cmplx(m2),czero)+1.d0

* UV TEST
c      SigfLtmp  = 2.d0*B1C(cq2,cm2,czero)+1.d0

      SigfL     = SigfL+SigfLtmp

* UV TEST
c      goto 111

** Z contribution
      gfp =  -sw/cw*(-1d0)
      gfm = (-0.5d0-sw2*(-1.d0))/cw/sw
      SigfLtmp  = 2.d0*B1C(cq2,cm2,mz2)+1.d0
      SigfLtmp  = SigfLtmp * gfm * gfm
      SigfL     = SigfL+SigfLtmp
** Z and H contribution proportional to mass (neglecting H...)
      SigfLtmp  = B1C(cq2,cm2,mz2) ! + B1C(cq2,cmplx(m2),cmh2)
      SigfLtmp  = SigfLtmp * m2 /4.d0/sw2/mw2
      SigfL     = SigfL+SigfLtmp

* UV TEST
c      goto 111

** W contribution
      SigfLtmp  = 2.d0 * B1C(cq2,czero,mw2) + 1.d0
      SigfLtmp  = SigfLtmp /2.d0/sw2
      SigfL     = SigfL+SigfLtmp

*** rescaling by alpha/4/pi
 111  SigfL = -SigfL*alpho4pi

      return
      end
************************************************************************************
      function SigfR(q2,m2)
*** B.7
      implicit none
      integer k,ifirst
      double complex SigfR,SigfRtmp,cq2

      common/commonSigfR/ifirst
      data ifirst /1/

      double precision m2,q2
      double complex cmh2,gfp,gfm

      double complex m2gend(3),m2genu(3),cm2

#include "couplingandmasses.h"

#include "looptools.h"

      cq2 = cone * q2
      cm2 = cone * m2

c      cmh2 = cmplx(mh2)

      SigfR = (0.d0,0.d0)

** photon contribution (already accouted for, make ur mind)
      SigfRtmp  = czero ! 2.d0*B1C(cq2,cm2,czero)+1.d0

* UV TEST
c      SigfRtmp  = 2.d0*B1C(cq2,cm2,czero)+1.d0

      SigfR     = SigfR+SigfRtmp

* UV TEST
c      goto 111

** Z contribution
      gfp =  -sw/cw*(-1d0)
      gfm = (-0.5d0-sw2*(-1.d0))/cw/sw
      SigfRtmp  = 2.d0*B1C(cq2,cm2,mz2)+1.d0
      SigfRtmp  = SigfRtmp * gfp * gfp
      SigfR     = SigfR+SigfRtmp
** Z and H contribution proportional to mass (neglecting H...)
      SigfRtmp  = B1C(cq2,cm2,mz2) ! + B1C(cq2,cmplx(m2),cmh2)
      SigfRtmp  = SigfRtmp * m2 /4.d0/sw2/mw2
      SigfR     = SigfR+SigfRtmp

* UV TEST
c      goto 111

** W contribution
      SigfRtmp  = B1C(cq2,czero,mw2)
      SigfRtmp  = SigfRtmp /2.d0/sw2 * m2 / mw2
      SigfR     = SigfR+SigfRtmp

*** rescaling by alpha/4/pi
 111  SigfR = -SigfR*alpho4pi

      return
      end
************************************************************************************
      function SigfS(q2,m2)
*** B.8
      implicit none
      integer k,ifirst

      common/commonSigfS/ifirst
      data ifirst /1/

      double complex SigfS,SigfStmp,cq2
      double precision m2,q2
      double complex cmh2,gfp,gfm

      double complex m2gend(3),m2genu(3),cm2

#include "couplingandmasses.h"

#include "looptools.h"

      cq2   = cone * q2
      cm2   = cone * m2

      SigfS = (0.d0,0.d0)

** photon contribution (already accouted for, make ur mind)
      SigfStmp  = czero ! 4.d0*B0C(cq2,cmplx(m2),czero)-2.d0

* UV TEST
c      SigfStmp  = 4.d0*B0C(cq2,cm2,czero)-2.d0

      SigfS     = SigfS+SigfStmp

* UV TEST
c      goto 111

** Z contribution
      gfp =  -sw/cw*(-1.d0)
      gfm = (-0.5d0-sw2*(-1.d0))/cw/sw
      SigfStmp  = 4.d0*B0C(cq2,cm2,mz2)-2.d0
      SigfStmp  = SigfStmp * gfp * gfm
      SigfS     = SigfS+SigfStmp
** Z and H contribution proportional to mass (neglecting H...)
      SigfStmp  = B0C(cq2,cm2,mz2) ! - B0C(cq2,cmplx(m2),cmh2)
      SigfStmp  = SigfStmp * m2 /4.d0/sw2/mw2
      SigfS     = SigfS+SigfStmp

* UV TEST
c      goto 111

** W contribution
      SigfStmp  = 0.d0 ! because neutrino mass = 0
      SigfS     = SigfS+SigfStmp

*** rescaling by alpha/4/pi
 111  SigfS = -SigfS*alpho4pi

      return
      end
************************************************************************************

************************************************************************************
      function dSigfL(q2,m2)      
*** derivative of B.6
      implicit none
      integer k,ifirst

      integer*8 id
      
      common/commondSigfS/ifirst
      data ifirst /1/

      double complex dSigfL,dSigfLtmp,cq2,ctmp
      double precision m2,q2
      double complex cmh2,gfp,gfm,cm2

      double complex m2gend(3),m2genu(3)

#include "couplingandmasses.h"

#include "looptools.h"

      
      cq2   = cone * q2
      cm2   = cone * m2
c      cmh2 = cmplx(125.d0*125.d0)

      dSigfL = (0.d0,0.d0)

** photon contribution (already accouted for, make ur mind)
      dSigfLtmp  = czero ! 2.d0*DB1C(cq2,cmplx(m2),czero)

* UV test
c      dSigfLtmp  = 2.d0*DB1C(cq2,cm2,czero)

      dSigfL     = dSigfL+dSigfLtmp

* UV test
c      goto 111

** Z contribution
      gfp =  -sw/cw*(-1.d0)
      gfm = (-0.5d0-sw2*(-1.d0))/cw/sw
      dSigfLtmp  = 2.d0*DB1C(cq2,cm2,mz2)
      dSigfLtmp  = 2.d0*(-1d0/6.d0/mz2) ! Mauro's fix

c      print*,cq2/cm2,sqrt(cm2)
c      print*,'A->',DB1C(cq2,cm2,mz2),realpart(cq2),realpart(cm2)
c      print*,'B->',DB1(realpart(cq2),realpart(cm2),realpart(mz2))
c      print*,'C->',-1d0/6.d0/mz2
      
      dSigfLtmp  = dSigfLtmp * gfm * gfm
      dSigfL     = dSigfL+dSigfLtmp
** Z and H contribution proportional to mass (neglecting H...)
      dSigfLtmp  = DB1C(cq2,cm2,mz2) ! + DB1C(cq2,cmplx(m2),cmh2)
      dSigfLtmp  = (-1d0/6.d0/mz2) ! Mauro's fix
      dSigfLtmp  = dSigfLtmp * m2 /4.d0/sw2/mw2
      dSigfL     = dSigfL+dSigfLtmp

* UV test
c      goto 111

** W contribution
      dSigfLtmp  = 2.d0 * DB1C(cq2,czero,mw2)
      dSigfLtmp  = dSigfLtmp /2.d0/sw2
      dSigfL     = dSigfL+dSigfLtmp

*** rescaling by alpha/4/pi
 111  dSigfL = -dSigfL*alpho4pi

      return
      end
************************************************************************************
      function dSigfR(q2,m2)
*** derivative of B.7
      implicit none
      integer k,ifirst

      common/commondSigfR/ifirst
      data ifirst /1/

      double complex dSigfR,dSigfRtmp,cq2
      double precision m2,q2
      double complex cmh2,gfp,gfm,cm2

      double complex m2gend(3),m2genu(3)

#include "couplingandmasses.h"

#include "looptools.h"

      cq2   = cone * q2
      cm2   = cone * m2

      dSigfR = (0.d0,0.d0)

** photon contribution (already accouted for, make ur mind)
      dSigfRtmp  = czero ! 2.d0*DB1C(cq2,cmplx(m2),czero)

* UV test 
c      dSigfRtmp  = 2.d0*DB1C(cq2,cm2,czero)

      dSigfR     = dSigfR+dSigfRtmp

* UV test
c      goto 111

** Z contribution
      gfp =  -sw/cw*(-1d0)
      gfm = (-0.5d0-sw2*(-1.d0))/cw/sw
      dSigfRtmp  = 2.d0*DB1C(cq2,cm2,mz2)
      dSigfRtmp  = 2.d0*(-1d0/6.d0/mz2) ! Mauro's fix
      dSigfRtmp  = dSigfRtmp * gfp * gfp
      dSigfR     = dSigfR+dSigfRtmp
** Z and H contribution proportional to mass (neglecting H...)
      dSigfRtmp  = DB1C(cq2,cm2,mz2) ! + DB1C(cq2,cmplx(m2),cmh2)
      dSigfRtmp  = (-1d0/6.d0/mz2) ! Mauro's fix
      dSigfRtmp  = dSigfRtmp * m2 /4.d0/sw2/mw2
      dSigfR     = dSigfR+dSigfRtmp

* UV test
c      goto 111

** W contribution
      dSigfRtmp  = DB1C(cq2,czero,mw2)
      dSigfRtmp  = dSigfRtmp /2.d0/sw2 * m2 / mw2
      dSigfR     = dSigfR+dSigfRtmp

*** rescaling by alpha/4/pi
 111  dSigfR = -dSigfR*alpho4pi

      return
      end
************************************************************************************
      function dSigfS(q2,m2)
*** derivative of B.8
      implicit none
      integer k,ifirst

      common/commondSigfS/ifirst
      data ifirst /1/

      double complex dSigfS,dSigfStmp,cq2
      double precision m2,q2
      double complex cmh2,gfp,gfm,cm2

      double complex m2gend(3),m2genu(3)

#include "couplingandmasses.h"

#include "looptools.h"

      cq2   = cone * q2
      cm2   = cone * m2

      dSigfS = (0.d0,0.d0)

** photon contribution (already accouted for, make ur mind)
      dSigfStmp  = czero ! 4.d0*DB0C(cq2,cmplx(m2),czero)

* UV test 
c      dSigfStmp  = 4.d0*DB0C(cq2,cm2,czero)

      dSigfS     = dSigfS+dSigfStmp

* UV test
c      goto 111

** Z contribution
      gfp =  -sw/cw*(-1d0)
      gfm = (-0.5d0-sw2*(-1.d0))/cw/sw
      dSigfStmp  = 4.d0*DB0C(cq2,cm2,mz2)
      dSigfStmp  = dSigfStmp * gfp * gfm
      dSigfS     = dSigfS+dSigfStmp
** Z and H contribution proportional to mass (neglecting H...)
      dSigfStmp  = DB0C(cq2,cm2,mz2) ! - DB0C(cq2,cmplx(m2),cmh2)
      dSigfStmp  = dSigfStmp * m2 /4.d0/sw2/mw2
      dSigfS     = dSigfS+dSigfStmp

* UV test
c      goto 111

** W contribution
      dSigfStmp  = 0.d0 ! because neutrino mass = 0
      dSigfS     = dSigfS+dSigfStmp

*** rescaling by alpha/4/pi
 111  dSigfS = -dSigfS*alpho4pi

      return
      end
