      subroutine get_Htoploop(vertexout)
*** definitions in the notes
c      implicit none      
      implicit double complex (Z)

      double precision vertexout
      double complex   vertex
      double complex   cvertex

      integer          i,id,ifirst,iret,idpart
      integer*8        id1,id2
      double complex   C0lt,C1lt,C2lt,C00lt,C11lt,C12lt,C22lt

      double complex   C0ltAA,C1ltAA,C2ltAA,C00ltAA,C11ltAA,C12ltAA,
     .                 C22ltAA

      double complex   C0ltBB,C1ltBB,C2ltBB,C00ltBB,C11ltBB,C12ltBB,
     .                 C22ltBB

      double precision m1s, m2s, m3s,mzs
      double complex   cm1s, cm2s, cm3s
      double precision p3s, p4s, p1s, p2s

      double complex cp3s, cp4s, cp1s, cp2s
      double complex cp1p2s, cp1p3s, cp1p4s
      double complex cp2p3s, cp2p4s
      double complex cp3p4s
      double complex cp2p1s, cp3p1s, cp4p1s
      double complex cp3p2s, cp4p2s
      double complex cp4p3s

      double complex Htoploop

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double complex   covertop,mtop,mtop3,cmb,cmb3
      double precision me2,mm2,me4,mm4,TOP
      common/commonfortoploop/covertop,mtop,mtop3,cmb,cmb3,
     .                     me2,mm2,me4,mm4,TOP,
     .                     fsZZ,fsAZ,fsAA,ifirst
      data ifirst /1/

#include "invariants.h"

**** external parameters
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision mass(5)
      common/amasses/mass ! common used also to force pXs = m^2

      double precision arrNc(9)
      double complex arrgvi(9),arrgvgi(9),arrgai(9),arrmi(9),arrCHii(9)
      integer imin
      common/Hfermionloop/arrNc,arrgvi,arrgvgi,arrgai,arrmi,arrCHii,imin
      double precision Nc
      double complex gvi,gai,gvgi,mi,CHii
      double complex gvi2,gai2,gvgi2
      double complex mi2,mi3

***
      double precision dot
      double complex epsfun
      external dot,epsfun

#include "couplingandmasses.h"

#include "looptools.h"

      if (ifirst.eq.1) then

         covertop = im * 1.d0*(256.d0,0.d0)/16.d0/pi2
     .           * g*conjg(g)  ! leptonic current
     .           * g*conjg(g)  ! leptonic current
     .           * g * g       ! Z/g - top vertex
     .           * conjg(CHZZ) ! Born Hzz vertex
!!     .           * CHtt or CHbb ! already included in the FORM file!!!

         mtop  = sqrt(mtop2)
         mtop3 = mtop2 * mtop

         cmb  = sqrt(cmb2)
         cmb3 = cmb2 * cmb

         me2 = mass(1)*mass(1)
         mm2 = mass(3)*mass(3)
         me4 = me2*me2
         mm4 = me2*mm2

         TOP    = 1.d0 ! not really necessary, set to 1 in pippo

** UV test
c         covertop = czero
**
         fsZZ = 1.d0
         fsAZ = 1.d0 !-1.d0*0.5d0
         fsAA = 1.d0

********** setting loop variables, in common
         imin = 1

         arrNc(1) = 1.d0   ! electron
         arrNc(2) = 1.d0   ! muon
         arrNc(3) = 1.d0   ! tau
         arrNc(4) = 3.d0   ! down
         arrNc(5) = 3.d0   ! up
         arrNc(6) = 3.d0   ! strange
         arrNc(7) = 3.d0   ! charm
         arrNc(8) = 3.d0   ! bottom
         arrNc(9) = 3.d0   ! top

         arrmi(1) = sqrt(cme2)
         arrmi(2) = sqrt(cmm2)
         arrmi(3) = sqrt(cmtau2)
         arrmi(4) = sqrt(cmdown2)
         arrmi(5) = sqrt(cmup2)
         arrmi(6) = sqrt(cms2)
         arrmi(7) = sqrt(cmc2)
         arrmi(8) = sqrt(cmb2)
         arrmi(9) = sqrt(mtop2)

         do i = 1,9
            arrCHii(i) = CHtt/arrmi(9) * arrmi(i)
         enddo

         arrgvi(1) = gv
         arrgvi(2) = gv
         arrgvi(3) = gv
         arrgvi(4) = gvb
         arrgvi(5) = gvt
         arrgvi(6) = gvb
         arrgvi(7) = gvt
         arrgvi(8) = gvb
         arrgvi(9) = gvt

         arrgai(1) = ga
         arrgai(2) = ga
         arrgai(3) = ga
         arrgai(4) = gab
         arrgai(5) = gat
         arrgai(6) = gab
         arrgai(7) = gat
         arrgai(8) = gab
         arrgai(9) = gat

         arrgvgi(1) = gvg
         arrgvgi(2) = gvg
         arrgvgi(3) = gvg
         arrgvgi(4) = gvgb
         arrgvgi(5) = gvgt
         arrgvgi(6) = gvgb
         arrgvgi(7) = gvgt
         arrgvgi(8) = gvgb
         arrgvgi(9) = gvgt
**************

         ifirst = 0
      endif

******************************
      vertexout = 0.d0
      if (iweakcorr.eq.0) return
******************************

** UV test
c      P12 = czero
c      P34 = czero
**      

** UV test
* AA and ZA are not UV divergent!
c      P12g = czero
c      P34g = czero
**
      cvertex   = (0.d0,0.d0)
      vertex    = (0.d0,0.d0)
**********************************************************************************************

      cp1s   = cone * p3p4s
      cp2s   = cone * p1p2p3p4s
      cp1p2s = cone * p1p2s

      do i = imin,9
         
         CHii = arrCHii(i)

         Nc  = arrNc(i)
         mi  = arrmi(i)
         mi2 = mi  * mi
         mi3 = mi2 * mi

         gvi  = arrgvi(i)
         gai  = arrgai(i)
         gvgi = arrgvgi(i)

         gvi2   = gvi  * gvi
         gai2   = gai  * gai
         gvgi2  = gvgi * gvgi

         id1   = CgetC(cp1s,cp2s,cp1p2s,mi2,mi2,mi2)
         C0lt  = CvalC(cc0,id1)
         C1lt  = CvalC(cc1,id1)
         C2lt  = CvalC(cc2,id1)
         C00lt = CvalC(cc00,id1)
         C11lt = CvalC(cc11,id1)
         C12lt = CvalC(cc12,id1)
         C22lt = CvalC(cc22,id1)
         
         if (idpart.eq.0) then
            include 'form/Htopbottomloopeemm.f'
         else
            include 'form/Htopbottomloopeeee.f'         
         endif

         vertexout = vertexout + 2.d0 * dReal(Htoploop*covertop)
         cvertex   = cvertex + Htoploop*covertop      
      enddo

      return
      end
************************************************************************
      subroutine get_Hneutralloop(vertexout)
*** definitions in the notes
c      implicit none      
      implicit double complex (Z)

      double precision vertexout
      double complex   vertex
      double complex   cvertex

      integer          i,id,ifirst,iret,idpart
      integer*8        id1,id2,id3,id4
      double complex   C0lt,C1lt,C2lt,C00lt,C11lt,C12lt,C22lt

      double complex   C0ltHHZ,C1ltHHZ,C2ltHHZ,C00ltHHZ,C11ltHHZ,
     .                 C12ltHHZ,C22ltHHZ

      double complex   C0ltZZH,C1ltZZH,C2ltZZH,C00ltZZH,C11ltZZH,
     .                 C12ltZZH,C22ltZZH

      double complex   C0ltAAHHZ,C1ltAAHHZ,C2ltAAHHZ,C00ltAAHHZ,
     .                 C11ltAAHHZ,C12ltAAHHZ,C22ltAAHHZ
      double complex   C0ltAAZZH,C1ltAAZZH,C2ltAAZZH,C00ltAAZZH,
     .                 C11ltAAZZH,C12ltAAZZH,C22ltAAZZH

      double complex   C0ltBBHHZ,C1ltBBHHZ,C2ltBBHHZ,C00ltBBHHZ,
     .                 C11ltBBHHZ,C12ltBBHHZ,C22ltBBHHZ
      double complex   C0ltBBZZH,C1ltBBZZH,C2ltBBZZH,C00ltBBZZH,
     .                 C11ltBBZZH,C12ltBBZZH,C22ltBBZZH

      double precision m1s, m2s, m3s,mzs
      double complex   cm1s, cm2s, cm3s
      double precision p3s, p4s, p1s, p2s

      double complex cp3s, cp4s, cp1s, cp2s
      double complex cp1p2s, cp1p3s, cp1p4s
      double complex cp2p3s, cp2p4s
      double complex cp3p4s
      double complex cp2p1s, cp3p1s, cp4p1s
      double complex cp3p2s, cp4p2s
      double complex cp4p3s
      double complex cp1p2p3p4s

      double complex Hneutralloop

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double complex   coverN,mtop,mtop3,cmh2
      double precision me2,mm2,me4,mm4
      common/commonforNloop/coverN,
     .                     me2,mm2,me4,mm4,ifirst
      data ifirst /1/
      
#include "invariants.h"

**** external parameters
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision mass(5)
      common/amasses/mass
***
      double precision dot
      double complex epsfun
      external dot,epsfun

#include "couplingandmasses.h"

#include "looptools.h"

      if (ifirst.eq.1) then

         coverN = im * (128.d0,0.d0)/16.d0/pi2
     .           * g*conjg(g)  ! leptonic current
     .           * g*conjg(g)  ! leptonic current
     .           * conjg(CHZZ) ! Born Hzz vertex
!     .          *BLA BLA this is included in the FORM output!!

         me2 = mass(1)*mass(1)
         mm2 = mass(3)*mass(3)
         me4 = me2*me2
         mm4 = me2*mm2

***  

* UV test
c         coverN = czero
**
         ifirst = 0
      endif

******************************
      vertexout = 0.d0
      if (iweakcorr.eq.0) return
******************************

      cmh2 = cone * masshiggs*masshiggs

      
! there are no photons here!!
c      P12g = 1.d0/p1p2s
c      P34g = 1.d0/p3p4s
c      P14g = 1.d0/p1p4s
c      P23g = 1.d0/p2p3s

      cvertex   = (0.d0,0.d0)
      vertex    = (0.d0,0.d0)

      cp1s   = cone * p3p4s
      cp2s   = cone * p1p2p3p4s
      cp1p2s = cone * p1p2s

****
      id1   = CgetC(cp1s,cp2s,cp1p2s,mz2,cmh2,cmh2)
      C0ltHHZ  = CvalC(cc0,id1)
      C1ltHHZ  = CvalC(cc1,id1)
      C2ltHHZ  = CvalC(cc2,id1)
      C00ltHHZ = CvalC(cc00,id1)
      C11ltHHZ = CvalC(cc11,id1)
      C12ltHHZ = CvalC(cc12,id1)
      C22ltHHZ = CvalC(cc22,id1)

      id2   = CgetC(cp1s,cp2s,cp1p2s,cmh2,mz2,mz2)
      C0ltZZH  = CvalC(cc0,id2)
      C1ltZZH  = CvalC(cc1,id2)
      C2ltZZH  = CvalC(cc2,id2)
      C00ltZZH = CvalC(cc00,id2)
      C11ltZZH = CvalC(cc11,id2)
      C12ltZZH = CvalC(cc12,id2)
      C22ltZZH = CvalC(cc22,id2)

****
c$$$      id3   = CgetC(cp1p2s,cp2s,cp1s,mz2,cmh2,cmh2)
c$$$      C0ltBBHHZ  = CvalC(cc0,id3)
c$$$      C1ltBBHHZ  = CvalC(cc1,id3)
c$$$      C2ltBBHHZ  = CvalC(cc2,id3)
c$$$      C00ltBBHHZ = CvalC(cc00,id3)
c$$$      C11ltBBHHZ = CvalC(cc11,id3)
c$$$      C12ltBBHHZ = CvalC(cc12,id3)
c$$$      C22ltBBHHZ = CvalC(cc22,id3)
c$$$      id4   = CgetC(cp1p2s,cp2s,cp1s,cmh2,mz2,mz2)
c$$$      C0ltBBZZH  = CvalC(cc0,id4)
c$$$      C1ltBBZZH  = CvalC(cc1,id4)
c$$$      C2ltBBZZH  = CvalC(cc2,id4)
c$$$      C00ltBBZZH = CvalC(cc00,id4)
c$$$      C11ltBBZZH = CvalC(cc11,id4)
c$$$      C12ltBBZZH = CvalC(cc12,id4)
c$$$      C22ltBBZZH = CvalC(cc22,id4)

      if (idpart.eq.0) then
         include 'form/Hneutralloopeemm.f'
      else
         include 'form/Hneutralloopeeee.f'
      endif

      vertexout = vertexout + 2.d0 * dReal(Hneutralloop*coverN)
      cvertex   = cvertex + Hneutralloop*coverN

      return
      end
************************************************************************
      subroutine get_Hneutralblobs(vertexout)
*** definitions in the notes
c      implicit none      
      implicit double complex (Z)

      double precision vertexout
      double complex   vertex
      double complex   cvertex

      integer          i,id,ifirst,iret,idpart
      integer*8 id1,id2,id3,id4
      double complex   C0lt,C1lt,C2lt,C00lt,C11lt,C12lt,C22lt

      double complex   B0ZZ,B0HH

      double precision m1s, m2s, m3s,mzs
      double complex   cm1s, cm2s, cm3s
      double precision p3s, p4s, p1s, p2s

      double complex cp3s, cp4s, cp1s, cp2s
      double complex cp1p2s, cp1p3s, cp1p4s
      double complex cp2p3s, cp2p4s
      double complex cp3p4s
      double complex cp2p1s, cp3p1s, cp4p1s
      double complex cp3p2s, cp4p2s
      double complex cp4p3s
      double complex cp1p2p3p4s

      double complex Hblobloop,cmh2

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double complex   coverB,cWZphioWAphi,cZGGoAGG,
     .                     cZphiphioAphiphi,cZWWoAWW
      double precision me2,mm2,me4,mm4
      common/commonforNblob/coverB,
     .                     me2,mm2,me4,mm4,ifirst
      data ifirst /1/

#include "invariants.h"

**** external parameters
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision mass(5)
      common/amasses/mass
***
      double precision dot
      double complex epsfun
      external dot,epsfun

#include "couplingandmasses.h"

#include "looptools.h"

      if (ifirst.eq.1) then

         coverB = im * (32.d0,0.d0)/16.d0/pi2
     .           * g*conjg(g)  ! leptonic current
     .           * g*conjg(g)  ! leptonic current
     .           * conjg(CHZZ) ! Born Hzz vertex
!     .          *BLA BLA this is included in the FORM output!!

         me2 = mass(1)*mass(1)
         mm2 = mass(3)*mass(3)
         me4 = me2*me2
         mm4 = me2*mm2

** UV test
c         coverB = czero
**

         ifirst = 0
      endif

******************************
      vertexout = 0.d0
      if (iweakcorr.eq.0) return
******************************

      cmh2 = cone * masshiggs * masshiggs

      cvertex   = (0.d0,0.d0)
      vertex    = (0.d0,0.d0)

      cp1s   = cone * p3p4s
      cp2s   = cone * p1p2p3p4s
      cp1p2s = cone * p1p2s

      B0HH = B0C(cp2s,cmh2,cmh2)
      B0ZZ = B0C(cp2s,mz2,mz2)
****
      if (idpart.eq.0) then
         include 'form/Hneutralblobseemm.f'
      else
         include 'form/Hneutralblobseeee.f'
      endif

      vertexout = vertexout + 2.d0 * dReal(Hblobloop*coverB)
      cvertex   = cvertex + Hblobloop*coverB

      return
      end
************************************************************************
      subroutine get_Hchargedloop(vertexout)
*** definitions in the notes
c      implicit none      
      implicit double complex (Z)

      double precision vertexout
      double complex   vertex
      double complex   cvertex

      integer          i,id,ifirst,iret,idpart
      integer*8 id1,id2,id3,id4
      double complex   C0lt,C1lt,C2lt,C00lt,C11lt,C12lt,C22lt,
     .                 tmp

      double complex   C0ltAA,C1ltAA,C2ltAA,C00ltAA,
     .                 C11ltAA,C12ltAA,C22ltAA

      double complex   C0ltBB,C1ltBB,C2ltBB,C00ltBB,
     .                 C11ltBB,C12ltBB,C22ltBB

      double precision m1s, m2s, m3s,mzs
      double complex   cm1s, cm2s, cm3s
      double precision p3s, p4s, p1s, p2s

      double complex cp3s, cp4s, cp1s, cp2s
      double complex cp1p2s, cp1p3s, cp1p4s
      double complex cp2p3s, cp2p4s
      double complex cp3p4s
      double complex cp2p1s, cp3p1s, cp4p1s
      double complex cp3p2s, cp4p2s
      double complex cp4p3s
      double complex cp1p2p3p4s

      double complex Hchargedloop

      double precision dia1,dia2,dia3,dia4,dia5,dia6,dia7,dia8,dia9

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double complex   coverC,cWZphioWAphi,cZGGoAGG,
     .                     cZphiphioAphiphi,cZWWoAWW
      double precision me2,mm2,me4,mm4,ZZ,AA,AZ
      common/commonforCloop/coverC,cWZphioWAphi,cZGGoAGG,
     .                     cZphiphioAphiphi,cZWWoAWW,
     .                     me2,mm2,me4,mm4,ZZ,AA,AZ,ifirst
      data ifirst /1/

c      double precision dia1,dia2,dia3,dia4,dia5,dia6,dia7,dia8,dia9

#include "invariants.h"

**** external parameters
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision mass(5)
      common/amasses/mass
***
      double precision dot
      double complex epsfun
      external dot,epsfun

#include "couplingandmasses.h"

#include "looptools.h"

      if (ifirst.eq.1) then

         coverC = im * (32.d0,0.d0)/16.d0/pi2
     .           * g*conjg(g)  ! leptonic current
     .           * g*conjg(g)  ! leptonic current
     .           * conjg(CHZZ) ! Born Hzz vertex
!     .          *BLA BLA this is included in the FORM output!!

         me2 = mass(1)*mass(1)
         mm2 = mass(3)*mass(3)
         me4 = me2*me2
         mm4 = me2*mm2

         cWZphioWAphi     = CWZPhi/CWAPhi
         cZphiphioAphiphi = CZPhiPhi/CAPhiPhi
         cZWWoAWW         = CZWW/CAWW
         cZGGoAGG         = CZGG/CAGG

         ZZ = 1.d0
         AA = 1.d0
         AZ = 1.d0

** UV test
c         ZZ = 0.d0
c         AA = 0.d0
**

         ifirst = 0
      endif

******************************
      vertexout = 0.d0
      if (iweakcorr.eq.0) return
******************************


* UV test
c      P12 = czero
c      P34 = czero
*******************

** UV test
c      P12g = czero
c      P34g = czero
**

      cvertex   = (0.d0,0.d0)
      vertex    = (0.d0,0.d0)

      cp1s   = cone * p3p4s
      cp2s   = cone * p1p2p3p4s
      cp1p2s = cone * p1p2s

****
      id1     = CgetC(cp1s,cp2s,cp1p2s,mw2,mw2,mw2)
      C0ltAA  = CvalC(cc0,id1)
      C1ltAA  = CvalC(cc1,id1)
      C2ltAA  = CvalC(cc2,id1)
      C00ltAA = CvalC(cc00,id1)
      C11ltAA = CvalC(cc11,id1)
      C12ltAA = CvalC(cc12,id1)
      C22ltAA = CvalC(cc22,id1)

****
! C*BB not needed (used) anymore in pippo!
c$$$      id3     = CgetC(cp1p2s,cp2s,cp1s,mw2,mw2,mw2)
c$$$      C0ltBB  = CvalC(cc0,id3)
c$$$      C1ltBB  = CvalC(cc1,id3)
c$$$      C2ltBB  = CvalC(cc2,id3)
c$$$      C00ltBB = CvalC(cc00,id3)
c$$$      C11ltBB = CvalC(cc11,id3)
c$$$      C12ltBB = CvalC(cc12,id3)
c$$$      C22ltBB = CvalC(cc22,id3)
      

      if (idpart.eq.0) then
         include 'form/Hchargedloopeemm.f'
      else
         include 'form/Hchargedloopeeee.f'
      endif

      vertexout = vertexout + 2.d0 * dReal(Hchargedloop*coverC)
      cvertex   = cvertex + Hchargedloop*coverC

      return
      end

************************************************************************
      subroutine get_Hchargedblobs(vertexout)
*** definitions in the notes
c      implicit none      
      implicit double complex (Z)

      double precision vertexout
      double complex   cvertex

      integer          i,id,ifirst,iret,idpart
      integer*8 id1,id2,id3,id4
      double complex   C0lt,C1lt,C2lt,C00lt,C11lt,C12lt,C22lt

      double complex   B0WW,tmp

      double precision m1s, m2s, m3s,mzs,D
      double complex   cm1s, cm2s, cm3s,mw,mz
      double precision p3s, p4s, p1s, p2s

      double complex cp3s, cp4s, cp1s, cp2s
      double complex cp1p2s, cp1p3s, cp1p4s
      double complex cp2p3s, cp2p4s
      double complex cp3p4s
      double complex cp2p1s, cp3p1s, cp4p1s
      double complex cp3p2s, cp4p2s
      double complex cp4p3s
      double complex cp1p2p3p4s

      double complex Hblobloop

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double complex   coverB,Hcb,sDM2,Hcb2
      integer FFblob,WWblob
      double precision me2,mm2,me4,mm4,ZZ,AA,AZ,mh2
      common/commonforCblob/coverB,
     .                     me2,mm2,me4,mm4,ZZ,AA,AZ,ifirst
      data ifirst /1/

#include "invariants.h"

**** external parameters
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision mass(5)
      common/amasses/mass
***
      double precision dot
      double complex epsfun
      external dot,epsfun

#include "couplingandmasses.h"

#include "looptools.h"

      if (ifirst.eq.1) then

         coverB = im * (32.d0,0.d0)/16.d0/pi2
     .           * g*conjg(g)  ! leptonic current
     .           * g*conjg(g)  ! leptonic current
     .           * conjg(CHZZ) ! Born Hzz vertex
!     .          *BLA BLA this is included in the FORM output!!


         me2 = mass(1)*mass(1)
         mm2 = mass(3)*mass(3)
         me4 = me2*me2
         mm4 = me2*mm2

         ZZ = 1.d0
         AA = 1.d0
         AZ = 1.d0

         ifirst = 0
      endif

******************************
      vertexout = 0.d0
      if (iweakcorr.eq.0) return
******************************

* UV test
c      P12 = czero
c      P34 = czero
*******************
** UV test
c      P12g = czero
c      P34g = czero
**
      cvertex   = (0.d0,0.d0)

      cp2s   = cone * p1p2p3p4s

      B0WW = B0C(cp2s,mw2,mw2)

      if (idpart.eq.0) then
         include 'form/Hchargedblobseemm.f'
      else
         include 'form/Hchargedblobseeee.f'
      endif

      vertexout = vertexout + 2.d0 * dReal(Hblobloop*coverB)
      cvertex   = cvertex + Hblobloop*coverB

      return
      end
************************************************************************
      subroutine get_Hblobsquadrilinear(vertexout)
*** definitions in the notes
c      implicit none      
      implicit double complex (Z)

      double precision vertexout
      double complex   vertex
      double complex   cvertex

      integer          i,id,ifirst,iret,idpart
      integer*8 id1,id2,id3,id4
      double complex   C0lt,C1lt,C2lt,C00lt,C11lt,C12lt,C22lt

      double complex   B012HZ,B034HZ,tmp
      double complex   B012WW,B034WW

      double precision m1s, m2s, m3s,mzs
      double complex   cm1s, cm2s, cm3s
      double precision p3s, p4s, p1s, p2s

      double complex cp3s, cp4s, cp1s, cp2s
      double complex cp1p2s, cp1p3s, cp1p4s
      double complex cp2p3s, cp2p4s
      double complex cp3p4s
      double complex cp2p1s, cp3p1s, cp4p1s
      double complex cp3p2s, cp4p2s
      double complex cp4p3s
      double complex cp1p2p3p4s,cmh2

      double complex Hblobquadri

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double complex   coverB
      double precision me2,mm2,me4,mm4,ZZ,AA,AZ
      common/commonforQblob/coverB,
     .                     me2,mm2,me4,mm4,ZZ,AA,AZ,ifirst
      data ifirst /1/

#include "invariants.h"

**** external parameters
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision mass(5)
      common/amasses/mass
***
      double precision dot
      double complex epsfun
      external dot,epsfun

#include "couplingandmasses.h"

#include "looptools.h"

      if (ifirst.eq.1) then

         coverB = im * (32.d0,0.d0)/16.d0/pi2
     .           * g*conjg(g)  ! leptonic current
     .           * g*conjg(g)  ! leptonic current
     .           * conjg(CHZZ) ! Born Hzz vertex
!     .          *BLA BLA this is included in the FORM output!!

         me2 = mass(1)*mass(1)
         mm2 = mass(3)*mass(3)
         me4 = me2*me2
         mm4 = me2*mm2

         ZZ = 1.d0
         AA = 1.d0
         AZ = 1.d0

** UV test
c         ZZ = 0.d0
c         AA = 0.d0
**

         ifirst = 0
      endif

******************************
      vertexout = 0.d0
      if (iweakcorr.eq.0) return
******************************

      cmh2 = cone * masshiggs * masshiggs

* UV test
c      P12 = czero
c      P34 = czero
*******************

** UV test
c      P12g = czero
c      P34g = czero
**
      cvertex   = (0.d0,0.d0)
      vertex    = (0.d0,0.d0)

      cp1s   = cone * p3p4s
      cp1p2s = cone * p1p2s

      B012HZ = B0C(cp1p2s,mz2,cmh2)
      B034HZ = B0C(cp1s  ,mz2,cmh2)

      B012WW = B0C(cp1p2s,mw2,mw2)
      B034WW = B0C(cp1s  ,mw2,mw2)
      if (idpart.eq.0) then
         include 'form/Hblobquadrilineareemm.f'
      else
         include 'form/Hblobquadrilineareeee.f'
      endif

      vertexout = vertexout + 2.d0* dReal(Hblobquadri*coverB) 
      cvertex   = cvertex + Hblobquadri*coverB

      return
      end
