      subroutine lhe_initialize
      include 'LesHouches.h'
      logical isstandalone
      common/standalonelhe/isstandalone
      if (isstandalone) return

      lheinun    = 101
      lheoutun   = 102
      open(unit=lheinun, status='OLD',file=lheinfile)
      open(unit=lheoutun,status='UNKNOWN',file=lheoutfile)
      call lhefreadwritehdr
      return
      end

      subroutine lhe_finalize
      include 'LesHouches.h'
      logical isstandalone
      common/standalonelhe/isstandalone
      if (isstandalone) return

      write(lheoutun,'(a)')'</LesHouchesEvents>'
      close(lheinun)
      close(lheoutun)
      return
      end
      
      subroutine lhefreadwritehdr
      implicit double precision (a-h,m,l,o-z)
      integer ind ! nlf, old
      character* 100 string
      integer ipr,ibanner
      include 'inigenfin.h'
      include 'couplingandmasses.h'
      include 'LesHouches.h'
      double precision mass(5)
      common/amasses/mass
      integer test,imode
      common/imode/imode
      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed
      double precision mhnom,whtot
      common/higgsnominal/mhnom,whtot
      character*1 col(20)
      common/colors/col

      if (isstandalone) return

      ibanner = 0
      do while(ibanner.eq.0)
         read(lheinun,fmt='(a)') string
         ind = index(string,'<init>')
         if(ind.eq.0) then
            write(lheoutun,'(a)') trim(string)
         else
            !qua il nostro banner

            write(lheoutun,'(a)')"<!--"
            write(lheoutun,'(a)')"*************************************
     .***************************************************"
            write(lheoutun,'(a)')" "
            write(lheoutun,'(a)')" "
            write(lheoutun,'(a)')"             Hto4l v2.02          "
            write(lheoutun,'(a)')" "
            write(lheoutun,'(a)')" "
            write(lheoutun,'(1x,A)') 'PID = '//procid//' on '//machine
            write(lheoutun,'(1x,A,I8,A)') 
     .           'Running mode = '//fsc//'   '//ord
            if(imode.eq.2  .or. imode.eq.3  .or. imode.eq.3 .or.
     .         imode.eq.37 .or. imode.eq.38 .or. imode.eq.39) then
               if (iweakcorr.eq.1) then
                  write(lheoutun,'(1x,A)') 'including FULL QED+WEAK NLO'
               else
                  write(lheoutun,'(1x,A)') 'including only QED NLO'
               endif
            endif
            write(lheoutun,*)' '
            write(lheoutun,*)'SEED for PRNG',iseed

            write(lheoutun,*)col(5)
            write(lheoutun,*)'Run parameters:'
         
            write(lheoutun,'(1x,A,f7.3,A)')
     +           ' Higgs mass   ',mhnom,' GeV'
            write(lheoutun,'(1x,A,1x,f11.7,A)')
     +           ' Z mass       ',zmass,' GeV'
            write(lheoutun,'(1x,A,1x,f11.7,A)')
     +           ' Z width      ',zwidth,' GeV'
         
            write(lheoutun,'(1x,A,1x,f11.7,A)')
     +           ' W mass       ',wmass,' GeV'
            write(lheoutun,'(1x,A,1x,f11.7,A)')
     +           ' W width      ',wwidth,' GeV'
            
            write(lheoutun,'(1x,A,1x,f11.7,A)')
     +           ' G_fermi      ',gfermi*1d5,'*10^(-5) GeV^(-2)'
            
            write(lheoutun,'(1x,A,1x,f11.7,A)')
     +           ' 1/alpha(0)   ',1.d0/alpha0,'  '
            
            write(lheoutun,'(1x,A,1x,f11.7,A)')
     +           ' 1/alphaGF    ',1.d0/alphaGF,'  '
            
            write(lheoutun,'(1x,A,1x,f11.7,A)')
     +           ' 1/alpha      ',1.d0/alpha,'  '
            
            write(lheoutun,'(1x,A,1x,f11.7,A)')
     +           ' alpha0/alpha ',rescaleQED,'  '
            
            write(lheoutun,'(1x,A,f12.8,f12.8,f12.8,f12.8,A)')
     +           ' Lepton masses ',(mass(i),i=1,4),' GeV'
            
            write(lheoutun,'(a)')' '
            write(lheoutun,'(a)')' '
            write(lheoutun,'(a)')'*************************************
     .***************************************************'
            write(lheoutun,'(a)')"-->"
            backspace(lheinun)

            ibanner = 1
         endif
      enddo
      
      read(lheinun,fmt='(a)',err=998) string 
      ind = index(string,'<init>') 

      if(ind.ne.0) then
         read(lheinun,*) idbmup(1),idbmup(2),ebmup(1),ebmup(2),
     &        pdfgup(1),pdfgup(2),pdfsup(1),pdfsup(2),idwtup,nprup
         do ipr=1,nprup
            read(lheinun,*) xsecup(ipr),xerrup(ipr),xmaxup(ipr),
     &           lprup(ipr)
         enddo
         if((IDWTUP).eq.3) IDWTUP=-3
         if((IDWTUP).eq.4) IDWTUP=-4
         goto 999
      else
c         goto 1 ???
      endif

 998  write(*,*) 'lhefreadhdr: could not find <init> data'
      call exit(1)

 999  call lhefwritehdr

      end

      subroutine lhefreadev(mh,ph,endoffile)
      implicit none
c     Carlo
      double precision mh,ph(0:3)
c     stefano
      integer ilhe
      character*100 ilhefilename
      logical endoffile
      common/lheread/ilhe,ilhefilename!,endoffile
c stefano
      integer ind ! nlf
      character* 100 string
      include 'LesHouches.h'
      integer i,j
      logical isstandalone
      common/standalonelhe/isstandalone

      endoffile = .FALSE.
      if (isstandalone) return

 1    continue
      string=' '
      read(lheinun,fmt='(a)',err=777,end=666) string
      ind = index(string,'</LesHouchesEvents>')
      if (ind .ne. 0) goto 998
      ind = index(string,'<event>')
      if (ind .ne. 0) then
         read(lheinun,*,end=998,err=1)nup,idprup,xwgtup,scalup,
     &        aqedup,aqcdup
         do i=1,nup
            read(lheinun,*,end=998,err=1) idup(i),istup(i),mothup(1,i),
     &           mothup(2,i),icolup(1,i),icolup(2,i),(pup(j,i),j=1,5),
     &           vtimup(i),spinup(i)
         enddo
*[[ originally in main by Stefano
         do j=1, nup
            if (idup(j) .eq. 25) then
               mh    = pup(5,j)
               ph(0) = pup(4,j)
               ph(1) = pup(1,j)
               ph(2) = pup(2,j)
               ph(3) = pup(3,j)
               
c               flux  = 1.d0/2.d0/ph(0)
c               emin1 = ph(0)
c               emin2 = ph(0)              
! aggiusta lo stato dell'higgs
               istup(j) = +2
               indexhiggs = j   ! mettere questo in common!!

               endif
            enddo
*]]
!
!     mettere qui la do dopo la chiamata a questa routine nel main         
c
         goto 999
      else
         goto 1
      endif
c no event found:
 777  continue
c$$$      print *,"Error in reading"
c$$$      print *,string
      endoffile = .TRUE.
      goto 999
c      stop
 666  continue
      print *,"reached EOF"
      print *,string
      endoffile = .TRUE.
      goto 999
c      stop
 998  continue
cc      print *,"read </LesHouchesEvents>"
      endoffile = .TRUE.
      nup = 0

 999  continue
      end

c...lhefheader
c...writes initialization information to a les houches events file on unit lheoutun. 
      subroutine lhefwritehdr
      implicit none
!      integer nlf
      real * 8 version
      common/cversion/version
      data version/1.0/
      integer ipr,iran,n1ran,n2ran
      character * 3 whichpdfpk
      external whichpdfpk
      include 'LesHouches.h'

      logical isstandalone
      common/standalonelhe/isstandalone
      if (isstandalone) return

      write(lheoutun,'(a)') '<init>'
      write(lheoutun,110) idbmup(1),idbmup(2),ebmup(1),ebmup(2),
     &pdfgup(1),pdfgup(2),pdfsup(1),pdfsup(2),idwtup,nprup
      do 100 ipr=1,nprup
         write(lheoutun,120) xsecup(ipr),xerrup(ipr),xmaxup(ipr),
     &        lprup(ipr)
 100  continue
      write(lheoutun,'(a)') '</init>'
 110  format(1p,2(1x,i8),2(1x,e12.5),6(1x,i6))
 120  format(1p,3(1x,e12.5),1x,i6)
      end

c$$$c...lhefeader
c$$$c...writes event information to a les houches events file on unit lheoutun. 
      subroutine lhefwrite
      implicit none
!      integer nlf,old
      include 'LesHouches.h'
      integer i,j,endev,ind
      character*120 string
      logical isstandalone
      common/standalonelhe/isstandalone
      if (isstandalone) return

      write(lheoutun,'(a)')'<event>'
      write(lheoutun,210) nup,idprup,xwgtup,scalup,aqedup,aqcdup
      do 200 i=1,nup
         write(lheoutun,220) idup(i),istup(i),mothup(1,i),
     &        mothup(2,i),icolup(1,i),icolup(2,i),(pup(j,i),j=1,5),
     &        vtimup(i),spinup(i)
 200  continue

      endev = 0
      do while(endev.eq.0)
         read(lheinun,'(a)') string
         ind=index(string,'</event>')
         if(ind.eq.0) then
            write(lheoutun,'(a)') trim(string)
         else
            endev = 1
         endif
      enddo
      write(lheoutun,'(a)')'</event>'
      
 210  format(1p,2(1x,i6),4(1x,e12.5))
 220  format(1p,i8,5(1x,i5),5(1x,e16.9),1x,e12.5,1x,e10.3)
      end
********************************************************************
      subroutine lhewriteev(labhiggs,p1l,p2l,p3l,
     .     p4l,qphl,ng,pwidth)
! indexhiggs in common!
      implicit none
      double precision dot
      external dot
      double precision labhiggs(0:3),p1l(0:3),p2l(0:3),p3l(0:3),p4l(0:3)
     .      ,qphl(40,0:3),p1lhe(0:3),p2lhe(0:3),p3lhe(0:3),p4lhe(0:3),
     .      qphlhe(40,0:3),pz1lhe(0:3),pz2lhe(0:3),mztemp(1:4)
      double precision leptlhe(4,0:3)
      double precision pboost(0:3),mz1lhe,mz2lhe
      double precision pwidth
      integer i,j,ki
      integer ng,ires,nupold,plusz,pppp
      double precision zmass,zwidth
      double precision alpha0,alphaGF,alpha
      double precision mass(5)

      common/amasses/mass

      common/zparam/zmass,zwidth
      common/alphas/alpha0,alphaGF,alpha

      integer imode
      common/imode/imode
      integer ifsc
      common/fscindex/ifsc
      include 'LesHouches.h'

      logical isstandalone
      common/standalonelhe/isstandalone

      integer mothersph(50),motherslep(4)
      common/figli_di_padre_ignoto/mothersph,motherslep
      
      if (isstandalone) return

      aqedup = alpha

      xwgtup = pwidth
      
      nupold=nup
      
      nup = nupold + 6 + ng ! cos?? dovrebbe contenere il n giusto di particelle

cc boosts done in the decaying routine      
c      call new_boost(labhiggs,p1l,p1lhe,-1)
c      call new_boost(labhiggs,p2l,p2lhe,-1)
c      call new_boost(labhiggs,p3l,p3lhe,-1)
c      call new_boost(labhiggs,p4l,p4lhe,-1)

      leptlhe(1,:) = p1l
      leptlhe(2,:) = p2l
      leptlhe(3,:) = p3l
      leptlhe(4,:) = p4l

*** these are used below to "find" Z...

      p1lhe = p1l
      p2lhe = p2l
      p3lhe = p3l
      p4lhe = p4l
***  

      if (ng.gt.0) then
         do i=1, ng
            qphlhe(i,:) = qphl(i,:)
         enddo
      endif

**** comune per tutti

      do j = nupold +1, nup
         icolup(1,j) = 0
         icolup(2,j) = 0
         vtimup(j) = 0e0
         spinup(j) = 9e0
c         mothup(1,j) = indexhiggs
c         mothup(2,j) = indexhiggs
      enddo



***** le Z le riempo per ultime *******      
***** qui riempio il file lhe con leptoni e fotoni, manca mothup

***** leptoni

      pppp = nupold + 2

      if (ifsc .eq. 1) then
         idup(pppp + 1) =  11
         idup(pppp + 2) = -11
         idup(pppp + 3) =  13
         idup(pppp + 4) = -13
      elseif (ifsc .eq. 2) then
         idup(pppp + 1) =  13
         idup(pppp + 2) = -13
         idup(pppp + 3) =  13
         idup(pppp + 4) = -13
      elseif (ifsc .eq. 3) then
         idup(pppp + 1) =  11
         idup(pppp + 2) = -11
         idup(pppp + 3) =  11
         idup(pppp + 4) = -11
      endif
      ! momenti dei leptoni

      do i=1,4

         istup(pppp + i) = +1

         do j=1,3
            pup(j, pppp + i) = leptlhe(i,j)
         enddo

         pup(4, pppp + i) = leptlhe(i,0)
         pup(5, pppp + i) = mass(i)

         if(motherslep(i) .eq. 1) then
            mothup(1,pppp + i) = nupold + 1 
            mothup(2,pppp + i) = nupold + 1 
         elseif(motherslep(i) .eq. 2) then
            mothup(1,pppp + i) = nupold + 2 
            mothup(2,pppp + i) = nupold + 2 
         endif

      enddo

*****  fotoni, se ci sono
     
      if(ng .gt. 0) then

         pppp = nupold + 6

         do j = 1, ng
            idup(pppp + j)=22
            istup(pppp +j)=1
            
            pup(1,pppp + j) = qphlhe(j,1)
            pup(2,pppp + j) = qphlhe(j,2)
            pup(3,pppp + j) = qphlhe(j,3)
            pup(4,pppp + j) = qphlhe(j,0)
            pup(5,pppp + j) = mass(5)

c modified below           mothup(1,pppp + j) = nupold + 2 + mothersph(j)
c modified below           mothup(2,pppp + j) = nupold + 2 + mothersph(j)

            if(mothersph(j) .eq. 1) p1lhe = p1lhe + qphlhe(j,:) 
            if(mothersph(j) .eq. 2) p2lhe = p2lhe + qphlhe(j,:) 
            if(mothersph(j) .eq. 3) p3lhe = p3lhe + qphlhe(j,:) 
            if(mothersph(j) .eq. 4) p4lhe = p4lhe + qphlhe(j,:) 

            do ki = 1,4
               if (mothersph(j).eq.ki) then
                  if (motherslep(ki).eq.1) then
                     mothup(1,pppp + j) = nupold + 1
                  else
                     mothup(1,pppp + j) = nupold + 2
                  endif
               endif
            enddo
            mothup(2,pppp + j) = mothup(1,pppp + j)          

         enddo
      endif

**** infine le Z 
      if(motherslep(2) .eq. 1) then
         pz1lhe = p1lhe + p2lhe
         pz2lhe = p3lhe + p4lhe
      elseif(motherslep(2) .eq. 2) then
         pz1lhe = p1lhe + p4lhe
         pz2lhe = p3lhe + p2lhe
      endif

      mz1lhe=sqrt(dot(pz1lhe,pz1lhe))
      mz2lhe=sqrt(dot(pz2lhe,pz2lhe))

      idup(nupold + 1) = 23
      idup(nupold + 2) = 23
      
      istup(nupold + 1) = +2
      istup(nupold + 2) = +2
      
      pup(1,nupold+1) = pz1lhe(1)
      pup(2,nupold+1) = pz1lhe(2)
      pup(3,nupold+1) = pz1lhe(3)
      pup(4,nupold+1) = pz1lhe(0)
      pup(5,nupold+1) = mz1lhe
      
      
      pup(1,nupold+2) = pz2lhe(1)
      pup(2,nupold+2) = pz2lhe(2)
      pup(3,nupold+2) = pz2lhe(3)
      pup(4,nupold+2) = pz2lhe(0)
      pup(5,nupold+2) = mz2lhe
      
      mothup(1,nupold + 1) = indexhiggs
      mothup(2,nupold + 1) = indexhiggs
      mothup(1,nupold + 2) = indexhiggs
      mothup(2,nupold + 2) = indexhiggs
      
      call lhefwrite

      end
