      subroutine currents(gv,ga,s1,s2,s3,s4,h1,h2,h3,h4,cel,cmu)
      implicit double precision (a-h,o-z)
      double complex s1(2,4),s2(2,4),s3(2,4),s4(2,4)
      double complex s1l(4),s2l(4),s3l(4),s4l(4)
      double complex sa(4),sb(4)
      double complex cel(0:3),cmu(0:3),gv,ga,im
      integer h1,h2,h3,h4
      common/commcurrents/im,ifirst
      data ifirst/0/
      data im/(0.d0,1.d0)/

! the only imaginary is gd2 and so gd02,gd025...
      double precision gd0(4,4)
      double precision gd1(4,4)
      double complex   gd2(4,4)
      double precision gd3(4,4)
      double precision gd5(4,4)
      double precision gd00(4,4)
      double precision gd01(4,4)
      double complex   gd02(4,4)
      double precision gd03(4,4)
      double precision gd05(4,4)
      double precision gd005(4,4)
      double precision gd015(4,4)
      double complex   gd025(4,4)
      double precision gd035(4,4)

      common/gammamatrices/gd2,gd02,gd025,
     .     gd0,  gd1,  gd3, gd5,
     .     gd00, gd01, gd03,gd05,
     .     gd005,gd015,gd035

      double complex spinor_prod
      external spinor_prod !!! it's slower than the dot_product intrinsic function!

      if (ifirst.eq.0) then
         call Diracology
         ifirst = 1
      endif

!! notice: gd00 is the identity!
!! notice from GNU dot_product "If the vectors are COMPLEX(*), the result is SUM(CONJG(X)*Y)"

      s1l = s1(h1,:)
      s2l = s2(h2,:)
      s3l = s3(h3,:)
      s4l = s4(h4,:)

**** electron current!
      sa    =  s1l
      sb(1) =  gv*s2l(1) - ga*s2l(3) ! sb = gv*g00 x s2l - ga*g005 x s2l
      sb(2) =  gv*s2l(2) - ga*s2l(4)
      sb(3) =  gv*s2l(3) - ga*s2l(1)
      sb(4) =  gv*s2l(4) - ga*s2l(2)
      cel(0)=  dot_product(sa,sb)

      sb(1) =  gv*s2l(4) - ga*s2l(2) ! sb = gv*g01 x s2l - ga*g015 x s2l
      sb(2) =  gv*s2l(3) - ga*s2l(1)
      sb(3) =  gv*s2l(2) - ga*s2l(4)
      sb(4) =  gv*s2l(1) - ga*s2l(3)
      cel(1)=  dot_product(sa,sb)

      sb(1) = -im*sb(1)              ! sb = gv*g02 x s2l - ga*g025 x s2l
      sb(2) =  im*sb(2)
      sb(3) = -im*sb(3)
      sb(4) =  im*sb(4)
      cel(2)=  dot_product(sa,sb)

      sb(1) =  gv*s2l(3) - ga*s2l(1) ! sb = gv*g03 x s2l - ga*g035 x s2l
      sb(2) = -gv*s2l(4) + ga*s2l(2)
      sb(3) =  gv*s2l(1) - ga*s2l(3)
      sb(4) = -gv*s2l(2) + ga*s2l(4)
      cel(3) = dot_product(sa,sb)

**** muon current!
      sa    =  s3l
      sb(1) =  gv*s4l(1) - ga*s4l(3)
      sb(2) =  gv*s4l(2) - ga*s4l(4)
      sb(3) =  gv*s4l(3) - ga*s4l(1)
      sb(4) =  gv*s4l(4) - ga*s4l(2)
      cmu(0)=  dot_product(sa,sb)

      sb(1) =  gv*s4l(4) - ga*s4l(2)
      sb(2) =  gv*s4l(3) - ga*s4l(1)
      sb(3) =  gv*s4l(2) - ga*s4l(4)
      sb(4) =  gv*s4l(1) - ga*s4l(3)
      cmu(1)=  dot_product(sa,sb)

      sb(1) = -im*sb(1)
      sb(2) =  im*sb(2)
      sb(3) = -im*sb(3)
      sb(4) =  im*sb(4)
      cmu(2) = dot_product(sa,sb)

      sb(1) =  gv*s4l(3) - ga*s4l(1)
      sb(2) = -gv*s4l(4) + ga*s4l(2)
      sb(3) =  gv*s4l(1) - ga*s4l(3)
      sb(4) = -gv*s4l(2) + ga*s4l(4)
      cmu(3)= dot_product(sa,sb)

      return
      end
*************************************************************************
      function spinor_prod(s1,s2)
      double complex spinor_prod
      double complex s1(4),s2(4)
! that's slower than the intrinsic dot_product function...
      spinor_prod = conjg(s1(1))*s2(1) +
     .              conjg(s1(2))*s2(2) +
     .              conjg(s1(3))*s2(3) +
     .              conjg(s1(4))*s2(4)
      return
      end
***************************************
      subroutine get_spinors(p1,p2,p3,p4,s1,s2,s3,s4)
      implicit double precision (a-h,o-z)
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      double complex s1(2,4),s2(2,4),s3(2,4),s4(2,4)
      double complex im
      double precision mass(5)
      common/amasses/mass ! common used also to force pXs = m^2

      double precision me,mm
      common/getspinors/im,me,mm,ifirst
      data ifirst/0/
      
      if (ifirst.eq.0) then
         im = (0.d0,1.d0)
         me = mass(1)
         mm = mass(3)
         ifirst = 1
      endif

      den     =  sqrt(p1(0)+me)
      s1(1,1) =  den
      s1(1,2) =  0.d0
      s1(1,3) =  p1(3)/den
      s1(1,4) =  (p1(1)+im*p1(2))/den
      s1(2,1) =  0.d0
      s1(2,2) =  den
      s1(2,3) =  conjg(s1(1,4)) ! (p1(1)-im*p1(2))/(p1(0)+me)
      s1(2,4) = -s1(1,3)        ! (-p1(3)/(p1(0)+me)

      den     =  sqrt(p3(0)+mm)
      s3(1,1) =  den
      s3(1,2) =  0.d0
      s3(1,3) =  p3(3)/den
      s3(1,4) =  (p3(1)+im*p3(2))/den
      s3(2,1) =  0.d0
      s3(2,2) =  den
      s3(2,3) =  conjg(s3(1,4)) !(p3(1)-im*p3(2))/(p3(0)+mm)
      s3(2,4) = -s3(1,3)        !-p3(3)/(p3(0)+mm)

      den     =  sqrt(p2(0)+me)
      s2(1,1) =  (p2(1)-im*p2(2))/den
      s2(1,2) = -p2(3)/den
      s2(1,3) =  0.d0
      s2(1,4) =  den
      s2(2,1) = -s2(1,2)        ! p2(3)/(p2(0)+me)
      s2(2,2) =  conjg(s2(1,1)) !(p2(1)+im*p2(2))/(p2(0)+me)
      s2(2,3) =  den
      s2(2,4) =  0.d0

      den     =  sqrt(p4(0)+mm)
      s4(1,1) =  (p4(1)-im*p4(2))/den
      s4(1,2) = -p4(3)/den
      s4(1,3) =  0.d0
      s4(1,4) =  den
      s4(2,1) = -s4(1,2)        ! p4(3)/(p4(0)+mm)
      s4(2,2) =  conjg(s4(1,1)) !(p4(1)+im*p4(2))/(p4(0)+mm)
      s4(2,3) =  den
      s4(2,4) =  0.d0

      return
      end

*************************************************************
      subroutine newborn(p1,p2,p3,p4,bornout,bornIBA)
      implicit double complex (Z)

      double precision bornout,bornhel,bornhelp,bornIBA
      integer          i,ifirst,idpart,helid
      double complex   born,borntmp
      double complex   cover,P12,P12s,P34,P34s,P14,P14s,P23,P23s
      double complex   P123412s34s,P142314s23s,P12s34s1423,P123414s23s
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3),ptmp(0:3)
      double precision p1p2,p1p3,p1p4,p2p3,p2p4,p3p4
      double precision m1s, m2s, m3s, m4s, m5s, fuchIBA
      double complex   cm1s,cm2s,cm3s,cm4s,cm5s
      double precision BSM,MSQSM
      common/commonforborn/cm3s,m3s,cover,me2,mm2,me4,mm4,ifirst
      data ifirst /1/
      integer anm_cpg,basis,quadratics,CP
      common/anm/anm_cpg,basis,quadratics,CP

      integer iba
      common/ibaswitch/iba

**** parametri esterni
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision mass(5)
      common/amasses/mass ! common used also to force pXs = m^2
      double precision me2,mm2,me4,mm4,pis
***
      double precision dot
      double complex epsfun
      external dot,epsfun,fuchIBA
      
#include "couplingandmasses.h"

      if (ifirst.eq.1) then

         me2 = mass(1)*mass(1)
         mm2 = mass(3)*mass(3)
         me4 = me2*me2
         mm4 = mm2*mm2
         
         m3s  = zmass*zmass
         cm3s = m3s - im * zmass * zwidth * zwonoff
         
         cover = (32.d0,0.d0)* g*conjg(g) 
     .        * g*conjg(g) 
     .        * CHZZ*conjg(CHZZ)
         
         if(anm_cpg .eq. 0) ifirst = 0
      endif
      
      p1p2 = dot(p1,p2)
      p1p3 = dot(p1,p3)
      p1p4 = dot(p1,p4)
      p2p3 = dot(p2,p3)
      p2p4 = dot(p2,p4)
      p3p4 = dot(p3,p4)

      P12 = 1.d0/(dot(p1+p2,p1+p2) - cm3s)
      P34 = 1.d0/(dot(p3+p4,p3+p4) - cm3s)

      P123412s34s = P12*P34*conjg(P12*P34)


      if (idpart.eq.0) then
         include 'form/borneemm.f'
      else
*     [[ unnecessary if idpart=0
         P14 = 1.d0/(dot(p1+p4,p1+p4) - cm3s)
         P23 = 1.d0/(dot(p2+p3,p2+p3) - cm3s)
         
         P142314s23s = P14*P23*conjg(P14*P23)
         P12s34s1423 = conjg(P12*P34)*P14*P23
         P123414s23s = P12*P34*conjg(P14*P23)
*     ]]
         include 'form/borneeee.f'
      endif
      born = cover * born
      bornout = dreal(born)
      bornIBA = bornout
         
      if(anm_cpg .gt. 0) then
         call ANOMALOUS(p1,p2,p3,p4,BSM)
         bornout = bornout + BSM
      endif
      
      if (iba.eq.0) return
      
**********************************
      bornhelp = 0.d0
      do helid = 1,16
         call newbornHEL(p1,p2,p3,p4,helid,bornhel)
         bornhel  = bornhel * fuchIBA(helid)
         bornhelp = bornhelp + bornhel
      enddo
      bornIBA = bornhelp
      return
      end


      function fuchIBA(helid)
      implicit none
      double precision fuchIBA
      double complex   tmp,gmmt2,mut2,thzz,bt,xt
      double precision gmmh2,f3,t4,chzz,pis,seicwsw,qf1,qf3
      double precision g1,g3
      integer helid,ifirst
      data ifirst /0/
      integer hel(4,16)
      common/helicities/hel
      common/forIBA/gmmt2,mut2,thzz,gmmh2,seicwsw,f3,t4,chzz,qf1,qf3,
     .              pis,ifirst

*** external parameters
      double precision gfermi,masshiggs,sth,cth
      double precision tmass,twidth
      common/gdifermi/gfermi
      common/paramhiggs/masshiggs
      common/sthcth/sth,cth
      common/toppar/tmass,twidth

      if (ifirst.eq.0) then

         qf1 = -1.d0
         qf3 = -1.d0
         
         pis = 4.d0*atan(1.d0)
         pis = pis*pis

         mut2  = tmass*tmass - (0.d0,1.d0)*tmass*twidth

         gmmt2 = gfermi* mut2 / 8.d0/sqrt(2.d0)/pis
         gmmh2 = gfermi* masshiggs*masshiggs / 8.d0/sqrt(2.d0)/pis
         
         f3 = 5.d0/6.d0*pis -3.d0*sqrt(3.d0*pis) + 9.5d0
         
         t4 = 62.0308 * (gmmh2/2.d0)**2
         
         seicwsw = 6.d0*cth/sth

         chzz = 0.03d0

         bt = sqrt(1.d0-4.d0*mut2/masshiggs/masshiggs)
         xt = (bt-1.d0)/(bt+1.d0)

         thzz =   20.d0+6.d0*bt**2 
     .          + 3.d0*bt*(bt**2 + 1.d0)*log(xt)
     .          + 3.d0*(1.d0-bt**2)*(log(xt))**2

         ifirst = 1
      endif

      if (hel(1,helid).eq.1) then
         g1 = -sth/cth*qf1
      else
         g1 = -sth/cth*qf1 + (-0.5d0)/cth/sth
      endif

      if (hel(3,helid).eq.1) then
         g3 = -sth/cth*qf3
      else
         g3 = -sth/cth*qf3 + (-0.5d0)/cth/sth
      endif

      tmp = 1.d0
     .     + gmmt2 * (1.d0 + thzz - seicwsw * (qf1/g1 + qf3/g3)  )
     .     + gmmh2 * f3 + t4 + chzz

      fuchIBA = dReal(tmp)

      return
      end
***********************************************************
      subroutine newbornHEL(p1,p2,p3,p4,helid,bornout)
c      implicit none
      implicit double complex (Z)

      double precision bornout
      integer          i,ifirst,idpart,helid,i1,i2,i3,i4,irun
      integer          h1,h2,h3,h4
      double complex   born
      double complex   cover,P12,P12s,P34,P34s,P14,P14s,P23,P23s
      double complex   P123412s34s,P142314s23s,P12s34s1423,P123414s23s
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3),ptmp(0:3)
      double precision p1p2,p1p3,p1p4,p2p3,p2p4,p3p4
      double precision m1s, m2s, m3s, m4s, m5s
      double complex   cm1s,cm2s,cm3s,cm4s,cm5s

      common/commonforbornhel/cm3s,m3s,cover,me2,mm2,me4,mm4,ifirst
      data ifirst /1/

      integer hel(4,16)
      common/helicities/hel

**** parametri esterni
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision me2,mm2,me4,mm4,pis
      double precision mass(5)
      common/amasses/mass
***

#include "couplingandmasses.h"

      double precision dot
      double complex epsfun
      external dot,epsfun
      
      if (ifirst.eq.1) then

         me2 = mass(1)*mass(1)
         mm2 = mass(3)*mass(3)
         me4 = me2*me2
         mm4 = mm2*mm2

         m3s  = zmass*zmass
         cm3s = m3s - im * zmass * zwidth * zwonoff

         cover = (32.d0,0.d0)* g*conjg(g) 
     .                       * g*conjg(g) 
     .                       * CHZZ*conjg(CHZZ)         


         irun = 0
         do i1 = 1,-1,-2
            do i2 = 1,-1,-2
               do i3 = 1,-1,-2
                  do i4 = 1,-1,-2
                     irun = irun + 1
                     hel(1,irun) = i1
                     hel(2,irun) = i2
                     hel(3,irun) = i3
                     hel(4,irun) = i4
                  enddo
               enddo
            enddo
         enddo
         ifirst = 0
      endif

      h1 = hel(1,helid)
      h2 = hel(2,helid)
      h3 = hel(3,helid)
      h4 = hel(4,helid)

      p1p2 = dot(p1,p2)
      p1p3 = dot(p1,p3)
      p1p4 = dot(p1,p4)
      p2p3 = dot(p2,p3)
      p2p4 = dot(p2,p4)
      p3p4 = dot(p3,p4)

      do i = 0,3
         ptmp(i) =p1(i)+p2(i)
      enddo
      P12 = 1.d0/(dot(ptmp,ptmp) - cm3s)
      do i = 0,3
         ptmp(i) =p3(i)+p4(i)
      enddo
      P34 = 1.d0/(dot(ptmp,ptmp) - cm3s)
      do i = 0,3
         ptmp(i) =p1(i)+p4(i)
      enddo
      P14 = 1.d0/(dot(ptmp,ptmp) - cm3s)
      do i = 0,3
         ptmp(i) =p2(i)+p3(i)
      enddo
      P23 = 1.d0/(dot(ptmp,ptmp) - cm3s)

      P123412s34s = P12*P34*conjg(P12*P34)
      P142314s23s = P14*P23*conjg(P14*P23)
      P12s34s1423 = conjg(P12*P34)*P14*P23
      P123414s23s = P12*P34*conjg(P14*P23)
      
      if (idpart.eq.0) then
         include 'form/borneemmHEL.f'
      else
         include 'form/borneeeeHEL.f'
      endif

      born = cover * born

      bornout = dreal(born)

      return
      end
***********************************************************
      subroutine newrad(p1,p2,p3,p4,q,radout)
c      implicit none
      implicit double complex (Z)

      double precision radout,madg
      integer          i,ifirst,idpart,icount
      double complex   rad
      double complex   cover,P12,P12s,P34,P34s,P14,P14s,P23,P23s
      double complex   P12q,P12qs,P34q,P34qs,P14q,P14qs,P23q,P23qs
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3),ptmp(0:3),q(0:3)
      double precision p1p2,p1p3,p1p4,p2p3,p2p4,p3p4,p1q,p2q,p3q,p4q
      double precision p1p22,p1p32,p1p42,p2p32,p2p42,p3p42
      double precision p1qm1,p2qm1,p3qm1,p4qm1,p1qm2,p2qm2,p3qm2,p4qm2
      double precision m1s, m2s, m3s, m4s, m5s
      double complex   cm1s,cm2s,cm3s,cm4s,cm5s
      double complex   ep1p2p3p4,ep1p2p3q,ep1p2p4q,ep1p3p4q,ep2p3p4q
      double complex   FA1A1S,FA2A2S,FA1A2S,FA1A3S,FA1A4S,FA2A3S,FA2A4S,
     .                 FA3A4S,FA3A3S,FA4A4S

      common/commonforad/cm3s,m3s,cover,me2,mm2,me4,mm4,ifirst,icount
      data ifirst,icount /1,0/

**** parametri esterni
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision me2,mm2,me4,mm4
      double precision mass(5)
      common/amasses/mass ! common used also to force pXs = m^2
***

#include "couplingandmasses.h"

      double precision dot
      double complex epsfun
      external dot,epsfun
      
      if (ifirst.eq.1) then

c         print*,'RESTORE MASSES IN REAL EMISSION!!'
         me2 = mass(1)*mass(1) !* 0.d0
         mm2 = mass(3)*mass(3) !* 0.d0
         me4 = me2*me2
         mm4 = mm2*mm2
         m3s  = zmass*zmass
         cm3s = m3s - im * zmass * zwidth * zwonoff

         cover = (16.d0,0.d0)* g*conjg(g) 
     .                       * g*conjg(g) 
     .                       * CHZZ*conjg(CHZZ)         
     .                       * elc2

         cover = cover*rescaleQED
         
         ifirst = 0
      endif

c      if (icount.eq.0) open(10,file='getmomenta',status='unknown')
c      icount = icount + 1
c      read(10,*) p1(0)
c      read(10,*) p1(1)
c      read(10,*) p1(2)
c      read(10,*) p1(3)
c      read(10,*) p2(0)
c      read(10,*) p2(1)
c      read(10,*) p2(2)
c      read(10,*) p2(3)
c      read(10,*) p3(0)
c      read(10,*) p3(1)
c      read(10,*) p3(2)
c      read(10,*) p3(3)
c      read(10,*) p4(0)
c      read(10,*) p4(1)
c      read(10,*) p4(2)
c      read(10,*) p4(3)
c      read(10,*) q(0)
c      read(10,*) q(1)
c      read(10,*) q(2)
c      read(10,*) q(3)

      p1p2 = dot(p1,p2)
      p1p3 = dot(p1,p3)
      p1p4 = dot(p1,p4)
      p2p3 = dot(p2,p3)
      p2p4 = dot(p2,p4)
      p3p4 = dot(p3,p4)
      
      p1p22 = p1p2*p1p2
      p1p32 = p1p3*p1p3
      p1p42 = p1p4*p1p4
      p2p32 = p2p3*p2p3
      p2p42 = p2p4*p2p4
      p3p42 = p3p4*p3p4

      p1q = dot(p1,q)
      p2q = dot(p2,q)
      p3q = dot(p3,q)
      p4q = dot(p4,q)

      p1qm1 = 1.d0/p1q
      p2qm1 = 1.d0/p2q
      p3qm1 = 1.d0/p3q
      p4qm1 = 1.d0/p4q

      p1qm2 = p1qm1 * p1qm1
      p2qm2 = p2qm1 * p2qm1
      p3qm2 = p3qm1 * p3qm1
      p4qm2 = p4qm1 * p4qm1

      ep1p2p3p4 = epsfun(p1,p2,p3,p4)
      ep1p2p3q  = epsfun(p1,p2,p3,q)
      ep1p2p4q  = epsfun(p1,p2,p4,q)
      ep1p3p4q  = epsfun(p1,p3,p4,q)
      ep2p3p4q  = epsfun(p2,p3,p4,q)

      P12 = 1.d0/(dot(p1+p2,p1+p2) - cm3s)
      P34 = 1.d0/(dot(p3+p4,p3+p4) - cm3s)
      P14 = 1.d0/(dot(p1+p4,p1+p4) - cm3s)
      P23 = 1.d0/(dot(p2+p3,p2+p3) - cm3s)

      P12q = 1.d0/(dot(p1+p2+q,p1+p2+q) - cm3s)
      P34q = 1.d0/(dot(p3+p4+q,p3+p4+q) - cm3s)
      P14q = 1.d0/(dot(p1+p4+q,p1+p4+q) - cm3s)
      P23q = 1.d0/(dot(p2+p3+q,p2+p3+q) - cm3s)

      P12s = conjg(P12)
      P34s = conjg(P34)
      P14s = conjg(P14)
      P23s = conjg(P23)

      P12qs = conjg(P12q)
      P34qs = conjg(P34q)
      P14qs = conjg(P14q)
      P23qs = conjg(P23q)

      if (idpart.eq.0) then
         include 'form/radeemm.f'
         rad =  FA1A1S * P12q*P34 *P12qs*P34s 
     .         +FA2A2S * P12 *P34q*P12s *P34qs
         if (imode.ne.1.and.imode.ne.40) then
            rad = rad + 
     .           FA1A2S * P12q*P34 *P12s *P34qs
     .           +conjg(FA1A2S * P12q*P34 *P12s *P34qs)
         endif
      else
         include 'form/radeeee.f'
         rad = FA1A1S * P12q*P34 *P12qs*P34s  +
     .         FA2A2S * P12 *P34q*P12s *P34qs +
     .         FA3A3S * P14q*P23 *P14qs*P23s  +
     .         FA4A4S * P14 *P23q*P14s *P23qs +
c
     .         FA1A2S * P12q*P34 *P12s *P34qs +
     .   conjg(FA1A2S * P12q*P34 *P12s *P34qs)+
c
     .         FA1A3S * P12q*P34 *P14qs*P23s  +
     .   conjg(FA1A3S * P12q*P34 *P14qs*P23s) +
c
     .         FA1A4S * P12q*P34 *P14s *P23qs +
     .   conjg(FA1A4S * P12q*P34 *P14s *P23qs)+
c
     .         FA2A3S * P12 *P34q*P14qs*P23s  +
     .   conjg(FA2A3S * P12 *P34q*P14qs*P23s) +
c
     .         FA2A4S * P12 *P34q*P14s*P23qs  +
     .   conjg(FA2A4S * P12 *P34q*P14s*P23qs) +
c
     .         FA3A4S * P14q*P23 *P14s*P23qs  +
     .   conjg(FA3A4S * P14q*P23 *P14s*P23qs) ! THERE WAS A BLOODY MISTAKE HERE, FK!!
      endif

      radout = dreal(rad*cover)

c      call madinterface1ph(p1,p2,p3,p4,q,madg)
c      print*,radout,radout/madg/4.d0,icount
c      if (icount.eq.1000) then
c         close(10)
c         stop
c      endif

      return
      end
***********************************************************

c$$$      subroutine newbornSPINORS(p1,p2,p3,p4,bornout,bornIBA)
c$$$c      implicit none
c$$$      implicit double complex (Z)
c$$$
c$$$      double precision bornout,bornhel,bornhelp,bornIBA
c$$$      integer          i,ifirst,idpart,helid
c$$$      double complex   im,cone,born
c$$$      double complex   cover,P12,P12s,P34,P34s,P14,P14s,P23,P23s
c$$$      double complex   P123412s34s,P142314s23s,P12s34s1423,P123414s23s
c$$$      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3),ptmp(0:3)
c$$$      double precision p1p2,p1p3,p1p4,p2p3,p2p4,p3p4
c$$$      double precision m1s, m2s, m3s, m4s, m5s, fuchIBA
c$$$      double complex   cm1s,cm2s,cm3s,cm4s,cm5s
c$$$      double complex   spin1(2,4),spin2(2,4),spin3(2,4),spin4(2,4)
c$$$      integer h1,h2,h3,h4
c$$$      double precision bp
c$$$      double complex   bhel
c$$$      double complex ccel(0:3),ccmu(0:3)
c$$$      double complex ccel1(0:3),ccel2(0:3),ccel3(0:3),ccel4(0:3)
c$$$      common/immaginariborn/im,cone
c$$$      data im,cone /(0.d0,1.d0),(1.d0,0)/
c$$$
c$$$      double complex gv,ga,gvs,gas,gvs2,gas2,gvsgas,gvga
c$$$      common/commonforborntest/cm3s,m3s,gv,ga,gvs,gas,gvs2,gas2,gvsgas,
c$$$     .                     gvga,cover,me2,mm2,me4,mm4,pis,ifirst
c$$$      data ifirst /1/
c$$$
c$$$      integer iba
c$$$      common/ibaswitch/iba
c$$$
c$$$**** parametri esterni
c$$$      integer imode
c$$$      common/imode/imode
c$$$      common/identicalparticles/idpart
c$$$      double precision me2,mm2,me4,mm4,pis
c$$$      double precision zwonoff,zmass,zwidth
c$$$      common/zwidthonoff/zwonoff
c$$$      common/zparam/zmass,zwidth
c$$$      double precision mass(5)
c$$$      common/amasses/mass ! common used also to force pXs = m^2
c$$$      double precision G,V,GV1,GA1,GV3,GA3,czh
c$$$      common/elmanalitico/G,V,GV1,GA1,GV3,GA3
c$$$      double precision alpha_gsth,alphaem
c$$$      double precision alpha0,alphaGF,alpha
c$$$      common/alphas/alpha0,alphaGF,alpha
c$$$***
c$$$      double precision dot
c$$$      double complex epsfun
c$$$      external dot,epsfun,fuchIBA
c$$$
c$$$!! IT WORKS!!
c$$$      
c$$$      if (ifirst.eq.1) then
c$$$         gv     = cmplx(gv1) 
c$$$         ga     = cmplx(ga1)
c$$$         gvs    = gv*gv
c$$$         gas    = ga*ga
c$$$         gvs2   = gvs*gvs
c$$$         gas2   = gas*gas
c$$$         gvsgas = gvs*gas
c$$$         gvga   = gv*ga
c$$$         alphaem= alpha
c$$$         pis    = (4.d0*atan(1.d0))**2
c$$$         me2 = mass(1)*mass(1)
c$$$         mm2 = mass(3)*mass(3)
c$$$         me4 = me2*me2
c$$$         mm4 = mm2*mm2
c$$$         m3s  = zmass*zmass
c$$$         cm3s = m3s - im * zmass * zwidth * zwonoff
c$$$         cover = g**6*v*v
c$$$         ifirst = 0
c$$$      endif
c$$$
c$$$      P12 = 1.d0/(dot(p1+p2,p1+p2) - cm3s)
c$$$      P34 = 1.d0/(dot(p3+p4,p3+p4) - cm3s)
c$$$      P14 = 1.d0/(dot(p1+p4,p1+p4) - cm3s)
c$$$      P23 = 1.d0/(dot(p2+p3,p2+p3) - cm3s)
c$$$      
c$$$      call get_spinors(p1,p2,p3,p4,spin1,spin2,spin3,spin4)
c$$$
c$$$      bp = 0.d0
c$$$      if (idpart.eq.0) then
c$$$         do h1=1,2
c$$$         do h2=1,2
c$$$         do h3=1,2
c$$$         do h4=1,2
c$$$            call currents(gv,ga,spin1,spin2,spin3,spin4,h1,h2,h3,h4,
c$$$     .                    ccel,ccmu)
c$$$            bhel= ( ccel(0)*ccmu(0)-ccel(1)*ccmu(1)
c$$$     .             -ccel(2)*ccmu(2)-ccel(3)*ccmu(3) )*P12*P34
c$$$            bp = bp + bhel*conjg(bhel)
c$$$         enddo
c$$$         enddo
c$$$         enddo
c$$$         enddo
c$$$      else
c$$$         do h1=1,2
c$$$         do h2=1,2
c$$$         do h3=1,2
c$$$         do h4=1,2
c$$$            call currents(gv,ga,spin1,spin2,spin3,spin4,h1,h2,h3,h4,
c$$$     .                    ccel1,ccel2)
c$$$            call currents(gv,ga,spin1,spin4,spin3,spin2,h1,h4,h3,h2,
c$$$     .                    ccel3,ccel4)
c$$$
c$$$            bhel= ( ccel1(0)*ccel2(0)-ccel1(1)*ccel2(1)
c$$$     .             -ccel1(2)*ccel2(2)-ccel1(3)*ccel2(3) )*P12*P34
c$$$            bhel= bhel - ! the minus sign is for the exchange of identical particles!!
c$$$     .            ( ccel3(0)*ccel4(0)-ccel3(1)*ccel4(1)
c$$$     .             -ccel3(2)*ccel4(2)-ccel3(3)*ccel4(3) )*P14*P23
c$$$            bp = bp + bhel*conjg(bhel)
c$$$         enddo
c$$$         enddo
c$$$         enddo
c$$$         enddo
c$$$      endif
c$$$      born    = cover * bp
c$$$      bornout = dreal(born)
c$$$      bornIBA = bornout
c$$$      return
c$$$      end
