      program driver_hto4l
      implicit none
      character*10 weightmode
      integer ierr,ng
      integer*8 k,nmax,nskip
      double precision weight,beta,en,mh
      double precision ph(0:3)  ! Higgs momentum
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      double precision qph(40,0:3)
      double precision masshiggs,truemax
      common/paramhiggs/masshiggs ! this talks to Hto4l, read in hto4l_initialize
      common/inputtruemax/truemax
      logical endoffile
      
      print*,'Hto4l driver'
      print*,' '
      print*,'Number of points to be generated'//
     .     ' (i.e. of Higgs to be decayed) [nmax]'
      read(*,*)nmax
      print*,'Number of events to skip in LHE file (if any)'//
     .     ' [0=< nskip < nmax] (nmax+nskip LHE events are read)'
      read(*,*)nskip
      print*,'Weighted or unweighted mode?'
      read(*,*)weightmode ! 'weighted' or 'unweighted'
      print*,'Maximum value for differential partial width?'
      read(*,*)truemax ! 'weighted' or 'unweighted'

      call hto4l_initialize
      call lhe_initialize

! setting Higgs mass
      mh = masshiggs

! setting Higgs momentum      
      en    = masshiggs
      beta  = sqrt(abs(1.d0 - masshiggs**2/en/en))
      ph(0) = en
      ph(1) = 0.d0
      ph(2) = 0.d0
      ph(3) = en*beta
!
      endoffile = .FALSE.
      k = 1
      do while(k.le.(nmax+nskip).and..NOT.endoffile)
         call lhefreadev(mh,ph,endoffile)
         if (.NOT.endoffile.and.k.gt.nskip) then
            call hto4l_decay(weightmode,nmax,mh,ph,p1,p2,p3,p4,qph,
     &           ng,weight,ierr)
            call lhewriteev(ph,p1,p2,p3,p4,qph,ng,weight)
         endif
         k = k + 1
      enddo

      call hto4l_finalize
      call lhe_finalize
      
      stop
      end
