      program Hto4fg
      implicit double precision (a-h,m,l,o-z)
      dimension ph(0:3),p1(0:3),p2(0:3),p3(0:3),p4(0:3),q(0:3)
      dimension p1l(0:3),p2l(0:3),p3l(0:3),p4l(0:3),ql(0:3)
      dimension ptmp(0:3),pp(0:3),mass4(4),charges(4)
      dimension qph(40,0:3),qphl(40,0:3),emin(40),csi(1)
      real*4 timearray(2) ,timesum
      real*4 timearray2(2),timesum2

      double precision em,mm

      integer isvec(25)
      parameter (npart = 5)
      dimension w_sum(0:40),w_sum2(0:40),var(0:40),sigma(0:40)
      dimension width(0:40)
      character*30 suffix      
      character*9 crsstr
      character*1 tstr
      integer*8 ncalls,k,nmax,nhit
      integer lux,lpath,lsuff
      parameter (lux=4,k1=0,k2=0)
      character*100 outputfile,path,massadellhiggs
      character*8 procid
      character*30 machine,errpos
      data errpos/'                              '/

      common/photonmass/mg ! common for routine propagator in Asu3.f
      common/paramhiggs/masshiggs

      double precision mhnom,whtot
      common/higgsnominal/mhnom,whtot

      common/alphas/alpha0,alphaGF,alpha
      common/gdifermi/gfermi
      common/wparam/wmass,wwidth
      common/forcuts/egmax
      common/hadron_parton/ipartonic,iusempi
      common/recombinesmearcut/irecombine,ismearing,icut

      double precision mz1,mz2
      integer nphleg(4)
      common/eikcheck/mz1,mz2,nphleg
      integer iclosecomm(40)
      common/iclosecomm/iclosecomm

      double complex Dr,Drt
      common/deltaerre/Dr,Drt

      common/zwidthonoff/zwonoff
      common/zparam/zmass,zwidth

      common/imode/imode
      integer iba
      common/ibaswitch/iba
      common/identicalparticles/idpart

      parameter (nfs=3,nord=9)
      character*4 fsc,fsa(nfs)
      character*8 ord,orda(nord)

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double precision rescaleQED
      common/QEDrescale/rescaleQED

      data ord,fsa,orda/'        ',
     .                  'eemm','eeee','mmmm',
     .                  'born',
     .                  'exoalyin','exoalnin',
     .                  'psoal','psexp',
     .                  'newpsoal','newpsexp','matched','matchnin'
     . /

      double precision mass(5)
      common/amasses/mass

      common/nphotMODE/nphotmode

      data ((qph(i,j),i=1,40),j=0,3) / 160 * 0.d0/	
      data ((qphl(i,j),i=1,40),j=0,3) / 160 * 0.d0/	
      data emin /40*20000.d0/

      data path /'                                            
     >                                              '/
c      character*12 col(20)
      character*1 col(20)
      common/colors/col

      double precision phmass,egmin
      COMMON/INFRAR/phmass,egmin
      common/FSmasses/ame,amm

      common/todebug/emtx2,phsp
      
#include "looptools.h"

      call initcolors

*>>* PID of the process loaded in procid
      call itoa(getpid(),procid)
      call hostnm(machine)
*<<*
      print*,' '
      print*,col(20)//'***************************'
      print*,col(15)//'You''re running the program'//col(1)
      print*,'         '//col(12)//'Hto4fg! '//col(1)
      print*,col(20)//'***************************'//col(9)
      print*,'  '
      print*,col(6)//'Partonic mode? (0/1)'//col(1)
      read(*,*)ipartonic

c      print*,col(5)//'Enter running mode'//col(1)
c      read(*,*)imode

      print*,col(5)//'Enter fs particles (eemm/eeee/mmmm)'//col(1)
      read(*,*)fsc

      print*,col(5)//'Enter fs order of corrections'//col(1)
      print*,col(5)//' (born/exoalyin/exoalnin/psoal/psexp)'//col(1)
      print*,col(5)//'(*newpsoal/newpsexp/matched/matchnin*)'//col(1)
      read(*,*)ord

      print*,col(5)//'Enter if including IBA or not'//col(1)
      read(*,*)iba

      print*,col(6)//'Enter seed for RANLUX'//col(1)
      read(*,*)iseed
      print*,col(5)//'Nphotmode? (<0/0/1)'//col(1)
      read(*,*)nphotmode
      print*,col(6)//'Photon mass (GeV)'//col(1)
      read(*,*)mg
      print*,col(5)//'Minimum photon energy (egmin) in radiative'//
     >' event (GeV)'//col(1)
      read(*,*)egmin
      print*,col(5)//'Higgs mass (GeV)'//col(1)
      read(*,*)masshiggs

***   in common!
      mhnom = masshiggs
***
      print*,col(5)//'Higgs Total Width (GeV)'//col(1)
      read(*,*)whtot

      print*,col(5)//'switch on weak corrections? (0=only QED/1=full'//
     .' EW NLO)'//col(1)
      read(*,*)iweakcorr
      ionlyqed = 1 - iweakcorr

      print*,col(6)//'Apply selection cuts? (0/1)'//col(1)
      read(*,*)icut
      print*,col(5)//'Recombine photons and electrons? (0/1)'//col(1)
      read(*,*)irecombine
      print*,col(6)//'Smear momenta? (0/1)'//col(1)
      read(*,*)ismearing

      print*,col(5)//'Number of points to be generated'//col(1)
      read(*,*)nmax

      print*,col(5)//'Output directory (max. 20 char.)'//col(1)
      read(*,*)path
      print*,' '

****  checking for input consistency
      iok = 0
      do i = 1,nfs
         if (fsc.eq.fsa(i)) iok = 1
      enddo
      if (iok.eq.0) then
         print*,' ' 
         print*,'Wrong final state string: '//fsc
         print*,' Stopping here.'     
         print*,'###############################################'
         stop
      endif

      iok = 0
      do i = 1,nord
         if (ord.eq.orda(i)) iok = 1
      enddo
      if (iok.eq.0) then
         print*,' ' 
         print*,'Wrong order string: '//ord
         print*,' Stopping here.'     
         print*,'###############################################'
         stop
      endif

      if ((fsc.eq.'eeee'.or.fsc.eq.'mmmm').and.ord.eq.'exoalnin') then
         print*,' ' 
         print*,'Wrong input! Identical particles meaningless without'//
     .        ' interference. Stopping here.'
         print*,'###############################################'
         stop
      endif

      if ((fsc.eq.'eeee'.or.fsc.eq.'mmmm').and.ord.eq.'matchnin') then
         print*,' ' 
         print*,'Wrong input! Identical particles meaningless without'//
     .        ' interference. Stopping here.'
         print*,'###############################################'
         stop
      endif
****************************************************************************

*********** setting old imode (used in subroutines) ******************
      if (ord.eq.'exoalnin'.and.fsc.eq.'eemm') imode = 1
      if (ord.eq.'exoalyin'.and.fsc.eq.'eemm') imode = 2
      if (ord.eq.'exoalyin'.and.fsc.eq.'eeee') imode = 3
      if (ord.eq.'exoalyin'.and.fsc.eq.'mmmm') imode = 4
      if (ord.eq.'psoal'   .and.fsc.eq.'eemm') imode = 11
      if (ord.eq.'psexp'   .and.fsc.eq.'eemm') imode = 12
      if (ord.eq.'psoal'   .and.fsc.eq.'eeee') imode = 13
      if (ord.eq.'psexp'   .and.fsc.eq.'eeee') imode = 14
      if (ord.eq.'psoal'   .and.fsc.eq.'mmmm') imode = 15
      if (ord.eq.'psexp'   .and.fsc.eq.'mmmm') imode = 16
      if (ord.eq.'born'    .and.fsc.eq.'eemm') imode = 21
      if (ord.eq.'born'    .and.fsc.eq.'eeee') imode = 22
      if (ord.eq.'born'    .and.fsc.eq.'mmmm') imode = 23
      if (ord.eq.'newpsoal'.and.fsc.eq.'eemm') imode = 31
      if (ord.eq.'newpsoal'.and.fsc.eq.'eeee') imode = 32
      if (ord.eq.'newpsoal'.and.fsc.eq.'mmmm') imode = 33
      if (ord.eq.'newpsexp'.and.fsc.eq.'eemm') imode = 34
      if (ord.eq.'newpsexp'.and.fsc.eq.'eeee') imode = 35
      if (ord.eq.'newpsexp'.and.fsc.eq.'mmmm') imode = 36
      if (ord.eq.'matched' .and.fsc.eq.'eemm') imode = 37
      if (ord.eq.'matched' .and.fsc.eq.'eeee') imode = 38
      if (ord.eq.'matched' .and.fsc.eq.'mmmm') imode = 39
      if (ord.eq.'matchnin'.and.fsc.eq.'eemm') imode = 40
****************************************************************************

**** NAME OF FILES **********
      do ki =1,30
         suffix(ki:ki) = ' '
      enddo

      if (iba.eq.0) then
         if (imode.eq.1)  suffix='ex_nin_eemm_'
         if (imode.eq.2)  suffix='ex_yin_eemm_'
         if (imode.eq.3)  suffix='ex_yin_eeee_'
         if (imode.eq.4)  suffix='ex_yin_mmmm_'
         if (imode.eq.11) suffix='ps_oal_eemm_' 
         if (imode.eq.12) suffix='ps_exp_eemm_' 
         if (imode.eq.13) suffix='ps_oal_eeee_' 
         if (imode.eq.14) suffix='ps_exp_eeee_' 
         if (imode.eq.15) suffix='ps_oal_mmmm_' 
         if (imode.eq.16) suffix='ps_exp_mmmm_'
         if (imode.eq.21) suffix='born_eemm_' 
         if (imode.eq.22) suffix='born_eeee_' 
         if (imode.eq.23) suffix='born_mmmm_' 
         
         if (imode.eq.31) suffix='newps_oal_eemm_' 
         if (imode.eq.32) suffix='newps_oal_eeee_' 
         if (imode.eq.33) suffix='newps_oal_mmmm_' 
         
         if (imode.eq.34) suffix='newps_exp_eemm_' 
         if (imode.eq.35) suffix='newps_exp_eeee_' 
         if (imode.eq.36) suffix='newps_exp_mmmm_' 
         
         if (imode.eq.37) suffix='matched_exp_eemm_' 
         if (imode.eq.38) suffix='matched_exp_eeee_' 
         if (imode.eq.39) suffix='matched_exp_mmmm_' 
         if (imode.eq.40) suffix='matchnin_exp_eemm_'
      else
         if (imode.eq.1)  suffix='ex_nin_IBA_eemm_'
         if (imode.eq.2)  suffix='ex_yin_IBA_eemm_'
         if (imode.eq.3)  suffix='ex_yin_IBA_eeee_'
         if (imode.eq.4)  suffix='ex_yin_IBA_mmmm_'
         if (imode.eq.11) suffix='ps_oal_IBA_eemm_' 
         if (imode.eq.12) suffix='ps_exp_IBA_eemm_' 
         if (imode.eq.13) suffix='ps_oal_IBA_eeee_' 
         if (imode.eq.14) suffix='ps_exp_IBA_eeee_' 
         if (imode.eq.15) suffix='ps_oal_IBA_mmmm_' 
         if (imode.eq.16) suffix='ps_exp_IBA_mmmm_'
         if (imode.eq.21) suffix='born_IBA_eemm_' 
         if (imode.eq.22) suffix='born_IBA_eeee_' 
         if (imode.eq.23) suffix='born_IBA_mmmm_' 
         
         if (imode.eq.31) suffix='newps_oal_IBA_eemm_' 
         if (imode.eq.32) suffix='newps_oal_IBA_eeee_' 
         if (imode.eq.33) suffix='newps_oal_IBA_mmmm_' 
         
         if (imode.eq.34) suffix='newps_exp_IBA_eemm_' 
         if (imode.eq.35) suffix='newps_exp_IBA_eeee_' 
         if (imode.eq.36) suffix='newps_exp_IBA_mmmm_' 
         
         if (imode.eq.37) suffix='matched_exp_IBA_eemm_' 
         if (imode.eq.38) suffix='matched_exp_IBA_eeee_' 
         if (imode.eq.39) suffix='matched_exp_IBA_mmmm_' 
         if (imode.eq.40) suffix='matchnin_exp_IBA_eemm_' 
      endif

      if (ionlyqed.eq.1.and.
     >     (suffix(1:2).eq.'ex'.or.
     .      suffix(1:2).eq.'ma')) then
         ils = 1
         do while (suffix(ils:ils).ne.' ')
            ils = ils + 1
         enddo
         suffix = suffix(1:ils-1)//'QED_'
      endif

      call fptoa(masshiggs,massadellhiggs)
      tmp = abs(masshiggs-int(masshiggs))
      if (tmp.lt.1.d-10) call itoa(int(masshiggs),massadellhiggs)
      call merge_strings(suffix,massadellhiggs,suffix)

      do ki = 1,100
         if (path(ki:ki).ne.' ') lpath=ki
      enddo
      if (path(lpath:lpath).ne.'/') then
         lpath = lpath+1
         path(lpath:lpath)='/'
      endif
      call system('mkdir -p '//path)

      do ki = 1,30
         if (suffix(ki:ki).ne.' ') lsuff=ki
      enddo   

      call itoa(icut,tstr)
      crsstr(1:3) = '_c'//tstr
      call itoa(irecombine,tstr)
      crsstr(4:6) = '_r'//tstr
      call itoa(ismearing,tstr)
      crsstr(7:9) = '_s'//tstr   
      outputfile = path(1:lpath)//suffix(1:lsuff)//crsstr//'_statistics'

      call setfilenames(suffix,path)
*******************************

c      iwriout = 2000000
      iwriout = 100000
      if (imode.ge.37) iwriout = 20000

c      iwriout = 200

!      zmass  =  91.15348 !91.15348d0 ! in input!

      ame = 0.51099892d-3
      amm = 0.105658369d0

      statfactor = 2.d0 ! statistical factor!!
                        ! con 2 ottengo i numeri
                        ! di higgsdecay
      em     = ame
      mm     = amm
      phmass = mg

      if (fsc.eq.'eemm') then
         idpart  = 0
         mass(1) = ame
         mass(2) = ame
         mass(3) = amm
         mass(4) = amm
      elseif (fsc.eq.'eeee') then
         idpart  = 1
         mass(1) = ame
         mass(2) = ame
         mass(3) = ame
         mass(4) = ame
      elseif (fsc.eq.'mmmm') then
         idpart  = 1
         mass(1) = amm
         mass(2) = amm
         mass(3) = amm
         mass(4) = amm
      endif

      mass(5) = 0.d0

************** STATISTICAL FACTOR FOR COMPARISON TO PROPHECY4F
      statfact = 1.d0/2.d0
      if (idpart.eq.1) statfact = statfact * 4.d0
*********************************************************

!!!!!!!!!!!!!!!!!!!!
      statfactor = statfactor*statfact
c      print*,'WARNING:'
c      print*,'CHANGED THE STATISTICAL FACTOR TO AGREE WITH PROPHECY4F!'
c      print*,'by x',statfact,'(',statfactor,')'
!!!!!!!!!!!!!!!!!!!!!!!!

      do ki = 1,4
         mass4(ki)   = mass(ki)
         charges(ki) = -1.d0
      enddo

      ph(0) = masshiggs
      ph(1) = 0.d0
      ph(2) = 0.d0
      ph(3) = 0.d0
            
      flux = 1.d0/2.d0/ph(0)

      do ki = 0,40
         w_sum(ki)  = 0.d0
         w_sum2(ki) = 0.d0
         sigma(ki) = 0.d0
         width(ki) = 0.d0
      enddo
      w_sumt  = 0.d0
      w_sumt2 = 0.d0
      sigmat  = 0.d0
      widtht  = 0.d0

      ic = 0
      varbefore = 1d-9
      nphmax = 0
      emin1 = masshiggs
      emin2 = masshiggs
      nhit  = 0
      widthhm = 0.d0
      varhm   = 0.d0
      truemax = 0.d0
      setmax  = 2.2105d-4!1.433263d-3  !14.6295d0 !1.4333d-3!3.2066106225541241d-3 !4.4245d-3
      effhm   = 0.d0
      emtxmax = 0.d0
      phspmax = 0.d0
      
      call initlooptools

      call init_apar

      call initrndgen(iseed)

      call init_partonshower
! if Parton Shower is chosen, no exact photons are present!
      if (imode.gt.10.and.imode.lt.30) nphotmode = 0

c      open(16,file='rlxjump',status='unknown')
c      read(16,*)isvec
c      call rluxin(isvec)
c      close(16)

      call etime(timearray2,timesum2)
      k = 0
      iwri = 0
      do while(k.lt.nmax)

         call rluxut(isvec)
         emtx2 = 0.d0
         
         qphl(max(1,nphmax),:) = 0.d0 ! resetting photon momenta
         
         call phasespaceZatREST(ph,mass,ng,p1,p2,p3,p4,qph,
     >        phsp,wphsp,iephsp)
         call cutfflowinvmasses(p1,p2,p3,p4,icut)

         if (icut.gt.0) iephsp = icut

         if (ng.gt.nphmax) nphmax = ng
         
         wmulti = 1.d0
         q(0) = qph(1,0)
         q(1) = qph(1,1)
         q(2) = qph(1,2)
         q(3) = qph(1,3)
         
!! now multiplicity is put in phasespace!
c         call multiplicity(nphotmode,ng,wmulti)
c         if (ng.eq.1) then 
c            nch = 2*(idpart + 1) ! number of channels in radiative phase space
c            call phasespaceold(nch,ph,mass,egmin,p1,p2,p3,p4,q,
c     >                      phsp,wphsp,iephsp)
c         else
c            nch = idpart + 1 ! number of channels in born like phase space
c            call phasespace4f(nch,ph,mass,egmin,p1,p2,p3,p4,q,
c     >                        phsp,wphsp,iephsp)
c        endif
  
* Parton Shower         
         if (imode.gt.10.and.imode.lt.30.and.iephsp.eq.0) then 

            call newborn(p1,p2,p3,p4,emtx2,bornIBA)

c            call newbornSPINORS(p1,p2,p3,p4,emtx2,bornIBA)

c            print*,emtx2n/emtx2

            if (iba.eq.1) emtx2 = bornIBA

!!! test for PS scale
            q2 = zmass**2 ! old choice
            q21 = q2
            q22 = q2
***********************
c            call getPSscale(p1,p2,p3,p4,charges,mass4,q2)
c            q21 = q2
c            q22 = q2
c$$$            zma2 = zmass*zmass
c$$$            do i = 0,3
c$$$               ptmp(i) = p1(i)+p2(i)
c$$$            enddo
c$$$            p1p2 = dot(ptmp,ptmp)
c$$$            do i = 0,3
c$$$               ptmp(i) = p1(i)+p3(i)
c$$$            enddo
c$$$            p1p3 = dot(ptmp,ptmp)
c$$$            do i = 0,3
c$$$               ptmp(i) = p1(i)+p4(i)
c$$$            enddo
c$$$            p1p4 = dot(ptmp,ptmp)
c$$$            do i = 0,3
c$$$               ptmp(i) = p2(i)+p3(i)
c$$$            enddo
c$$$            p2p3 = dot(ptmp,ptmp)
c$$$            do i = 0,3
c$$$               ptmp(i) = p2(i)+p4(i)
c$$$            enddo
c$$$            p2p4 = dot(ptmp,ptmp)
c$$$
c$$$            q21 = p1p2
c$$$            if (abs(p1p4-zm2).lt.abs(p1p2-zm2)) q21 = p1p4
c$$$
c$$$            q22 = p3p4
c$$$            if (abs(p2p3-zm2).lt.abs(p3p4-zm2)) q22 = p2p3
***********************
            call QEDPartonShower(q21,q22,p1,p2,p3,p4,qph,q,ieps)
            ! in q is put the most energetic photon!
            iephsp = iephsp + ieps
         endif
**************************
         sez = 1.d0
         nzeropu = 1
         p1l = p1
         p2l = p2
         p3l = p3
         p4l = p4
         qphl(1:max(1,ng),:) = qph(1:max(1,ng),:)
         ql = qph(1,:)
         k = k + nzeropu
*************************
c         call readhiggsandboost(ph,p1,p2,p3,p4,q,qph,imode,
c     >        p1l,p2l,p3l,p4l,ql,qphl,sez,nzeropu)
c         if (sez.lt.1d-30) iephsp = 1

         egmax = 10.d0*ph(0)
         
         if (iephsp.eq.0) then
            call cutsandsmear(p1l,p2l,p3l,p4l,ql,qphl,ireject)
            if (ireject.eq.1) iephsp = 1
         endif
         if (iephsp.eq.1) then 
            phsp = 0.d0
            wphsp = 0.d0
            emtx2 = 0.d0
         endif
         
         if (iephsp.eq.0) then
            if (imode.lt.10.or.imode.gt.30) then
*************************************************************
               call matrixelement(p1,p2,p3,p4,qph,ng,emtx2)
c               if (ng.eq.1) then
c                  call newrad(p1,p2,p3,p4,q,emtx2)
c               else
c                  call virtual(p1,p2,p3,p4,emtx2virt,emtx2born,bornIBA)
c                  
c                  sf = soft_integral(phmass,egmin,p1,p2,p3,p4,charges)
c                  sf = sf * emtx2born
c                  
c                  emtx2 = bornIBA + emtx2virt + sf
c               endif
*************************************************************
            endif

!! START CHECKING NANs!!
c            if (abs(emtx2).lt.1.d100.and.abs(phsp).lt.1d100
c     .           .and.abs(wphsp).lt.1d100) then
c               continue
c            else

            if (isnan(emtx2).or.isnan(phsp).or.isnan(wphsp)) then
               print*,'POSSIBLE NAN!! ',ng,emtx2,phsp,wphsp
               open(16,file=path(1:lpath)//'rlxNaN-'//procid,
     .              access='append',status='unknown')
               write(16,*),'phsp*wphsp ',phsp*wphsp
               write(16,*),'k ',k
               write(16,*),'n. gammas: ',ng
               write(16,*),'fermion momenta'
               write(16,*),p1
               write(16,*),p2
               write(16,*),p3
               write(16,*),p4
               write(16,*),'conservation'           
               write(16,*),p1+p2+p3+p4+sum(qph(1:ng,:),1)
               write(16,*),'imode ',imode
               write(16,*),'|M|^2 ',emtx2
c               write(16,*),'1g ME ',fme
c               write(16,*),'virt ',emtx2virt
c               write(16,*),'SFF ',sf
               write(16,*)'       p1(0) = ',p1(0)
               write(16,*)'       p1(1) = ',p1(1)
               write(16,*)'       p1(2) = ',p1(2)
               write(16,*)'       p1(3) = ',p1(3)
               write(16,*)'       p2(0) = ',p2(0)
               write(16,*)'       p2(1) = ',p2(1)
               write(16,*)'       p2(2) = ',p2(2)
               write(16,*)'       p2(3) = ',p2(3)
               write(16,*)'       p3(0) = ',p3(0)
               write(16,*)'       p3(1) = ',p3(1)
               write(16,*)'       p3(2) = ',p3(2)
               write(16,*)'       p3(3) = ',p3(3)
               write(16,*)'       p4(0) = ',p4(0)
               write(16,*)'       p4(1) = ',p4(1)
               write(16,*)'       p4(2) = ',p4(2)
               write(16,*)'       p4(3) = ',p4(3)
               do ki = 1,max(1,ng)
                  write(16,*)'       q(0)  = ',qph(ki,0)
                  write(16,*)'       q(1)  = ',qph(ki,1)
                  write(16,*)'       q(2)  = ',qph(ki,2)
                  write(16,*)'       q(3)  = ',qph(ki,3)
               enddo
               write(16,*),'ISVEC FOR RANLUX'
               write(16,*),isvec
               write(16,*),'******************************'
               
               close(16)
            endif
!! END CHECKING NANs!!
         endif

         toMeV  = 1000.d0
         pwidth = phsp*emtx2*flux/statfactor*wmulti*wphsp*toMeV
         pwidth = pwidth * sez

         pfake = pwidth
         
c         pfake =  flux/statfactor*toMeV !* phsp
!     .        *bw(dot(p1+p2,p1+p2))*bw(dot(p3+p4,p3+p4))
         
c         if (emtx2.gt.emtxmax) emtxmax = emtx2
c         if (phsp.gt.phspmax)   phspmax = phsp
c     print*,emtxmax,phspmax
         
c         if (abs(emtx2).gt.0.d0)  then
c         pwidth = pwidth/emtx2*bw(dot(p1+p2,p1+p2))*bw(dot(p3+p4,p3+p4))
c         pwidth = pwidth * ph(0)**6
c         endif
c         pfake = pwidth
         
!! rejecting if it's a NAN....
         ipwnan = 0
c         if (abs(pwidth).lt.1.d100) then
c            continue
c         else
         if (isnan(pwidth)) then
            print*,'KILLED THE EVENT BECAUSE OF A NaN'
            pwidth = 0.d0
            ipwnan = 1

            p1l  = 0.d0
            p2l  = 0.d0
            p3l  = 0.d0
            p4l  = 0.d0
            qphl = 0.d0

            k = k - 1 ! bah...
            iwri = iwri - 1
         endif
!!!!!!!!!!!!!!!!!!!!!!!!!!
         w_sum(ng)  = w_sum(ng)  + pwidth
         w_sum2(ng) = w_sum2(ng) + pwidth*pwidth

         w_sumt  = w_sumt  + pwidth
         w_sumt2 = w_sumt2 + pwidth*pwidth

         ak = 1.d0*k
         width(ng) = w_sum(ng)/ak

         widtht    = w_sumt/ak

         var(ng)   = (w_sum2(ng)/ak - width(ng)**2)/ak
         sigma(ng) = sqrt(abs(var(ng)))

         sigmat = sqrt(abs((w_sumt2/ak - widtht**2)/ak))

***   unweightening *******************
         if (pwidth.gt.truemax) then
            truemax = pwidth
c            print*,sqrt(dot(p1+p2,p1+p2)),sqrt(dot(p3+p4,p3+p4))
         endif
         call wraprnd(csi,1)
         if (csi(1)*setmax.lt.pwidth) then
            nhit  = nhit + 1
         endif          
***************************************         
         ncalls = k
*>>   * CLEAR LT CACHE TO AVOID MEMORY LEAKS (?)
         call clearcache()
*<<*

*>>* Distributions     
         if (iephsp.eq.0.and.ipwnan.eq.0)
c     .        call distributions(pwidth,ncalls,p1l,p2l,p3l,p4l,ng,qphl)
     .        call distributions(pfake,ncalls,p1l,p2l,p3l,p4l,ng,qphl)
*<<*
         sig = sqrt(sigma(0)**2 + sigma(1)**2)

         if (k.gt.100000) then
            tolleranza = 1.2d0
            if (sigmat.gt.tolleranza*varbefore) then

               print*,'>>>>>>>> DUMPING EVENT n.',k,'<<<<<<<<<<'

               open(16,file=path(1:lpath)//'rlxjump-'//procid,
     .              access='append',status='unknown')

               write(16,*)'Event n. = ',k
               write(16,*)'var,varbefore = ',sigmat,varbefore
               write(16,*)'tolerance ',tolleranza
               write(16,*),'imode ',imode
               write(16,*)'ng     = ',ng
               write(16,*),'phsp  = ',phsp
               write(16,*),'wphsp = ',wphsp
               write(16,*),'|M|^2 = ',emtx2
               write(16,*),'mz1 and mz2 ',mz1,mz2
c               write(16,*),'virt  = ',emtx2virt
c               write(16,*),'SFF   = ',sf
               write(16,*),'nphleg ',nphleg
               write(16,*),'iclose ',iclosecomm(1:ng)
               write(16,*)'       p1(0) = ',p1(0)
               write(16,*)'       p1(1) = ',p1(1)
               write(16,*)'       p1(2) = ',p1(2)
               write(16,*)'       p1(3) = ',p1(3)
               write(16,*)'       p2(0) = ',p2(0)
               write(16,*)'       p2(1) = ',p2(1)
               write(16,*)'       p2(2) = ',p2(2)
               write(16,*)'       p2(3) = ',p2(3)
               write(16,*)'       p3(0) = ',p3(0)
               write(16,*)'       p3(1) = ',p3(1)
               write(16,*)'       p3(2) = ',p3(2)
               write(16,*)'       p3(3) = ',p3(3)
               write(16,*)'       p4(0) = ',p4(0)
               write(16,*)'       p4(1) = ',p4(1)
               write(16,*)'       p4(2) = ',p4(2)
               write(16,*)'       p4(3) = ',p4(3)
               do ki = 1,max(1,ng)
                  write(16,*)'       q(0)  = ',qph(ki,0)
                  write(16,*)'       q(1)  = ',qph(ki,1)
                  write(16,*)'       q(2)  = ',qph(ki,2)
                  write(16,*)'       q(3)  = ',qph(ki,3)
               enddo
               write(16,*),'ISVEC FOR RANLUX'
               write(16,*),isvec
               write(16,*),'******************************'
               close(16)
            endif
         endif

         varbefore = sigmat
c         if (sigma(2).gt.1d10) then
c            print*,k,sigma(2)
c            print*,egmin
c            print*,dot(p1,p1)
c            print*,dot(p2,p2)
c            print*,dot(p3,p3)
c            print*,dot(p4,p4)
c            print*,dot(qph(1,:),qph(1,:))
c            print*,dot(qph(2,:),qph(2,:))
c            print*,qph(1,0),qph(2,0)
c            print*,isvec
c            print*,'stopping main line 740'
c            stop
c         endif
         iwri = iwri + nzeropu
         if (iwri.ge.iwriout.or.k.ge.nmax) then
            open(10,file=outputfile,status='unknown')
            ic = ic + 1
            do ki = 0,nphmax
               width(ki) = width(ki) !*1000.d0 already accouted for by toMeV
               sigma(ki) = sigma(ki) !*1000.d0
            enddo
            wid = 0.d0 
            sig = 0.d0
            do ki = 0,nphmax
               wid = wid + width(ki)
               sig = sig + sigma(ki)**2
            enddo
            sig = sqrt(sig)
            perc0 = 0.d0
            perc1 = 0.d0
            perct = 0.d0

            if (abs(width(0)).gt.0.d0) perc0=sigma(0)/width(0) * 100.d0
            if (width(1).gt.0.d0)      perc1=sigma(1)/width(1) * 100.d0
            perct = sig/wid * 100.d0
            write(10,*)col(5)
            write(10,'(1x,A)') 'PID = '//procid//' on '//machine
            write(10,'(1x,A,I8,A)') 'Running mode = '//fsc//'   '//ord//
     +                              '      (i.e. imode =',imode,')'
            if (suffix(1:2).eq.'ex'.or.suffix(1:2).eq.'ma') then
               if (iweakcorr.eq.1) then
                  write(10,'(1x,A)') 'including FULL QED+WEAK NLO'
               else
                  write(10,'(1x,A)') 'including only QED NLO'
               endif
            endif
            write(10,*)' '
            write(10,'(1x,A,I15,A,I15)') 'event n.',k,' of ',nmax
            write(10,*)' '
            
            do ik = 0,nphmax
               write(10,'(1x,I2,A,f18.15,A,f18.15,A)')
     +             ik,' photons width ',width(ik),' +-',sigma(ik),' MeV'
               call geterrpos(sigma(ik),iep,errpos)
               if (iep.gt.0) write(10,'(1x,A)')
     +              '                '//'   '//errpos
            enddo

            write(10,'(1x,A,f18.15,A,f18.15,A)')
     +           'Total =         ',wid,' +-',sig,' MeV'

            call geterrpos(sig,iep,errpos)
            write(10,'(1x,A)')
     +           '                '//'  '//errpos

            write(10,'(1x,A,f18.15,A,f18.15,A,f18.15,A)')
     +           'accuracies = ',perc0,' %',perc1,' %',perct,' %'
            write(10,*)' '
            write(10,*)'Inputs:'
            write(10,'(1x,A,f7.3,A)')
     +           ' Higgs mass =',ph(0),' GeV'
            write(10,'(1x,A,f12.8,f12.8,f12.8,f12.8,A)')
     +           ' Lepton masses =',(mass(i),i=1,4),' GeV'

            write(10,'(1x,A,1x,f11.7,A)')
     +           ' Z mass  ',zmass,' GeV'
            write(10,'(1x,A,1x,f11.7,A)')
     +           ' Z width ',zwidth,' GeV'

            write(10,*)' '
            write(10,'(1x,A,f18.15,A)')
     +           ' Photon mass as IR regulator =',phmass,' GeV'
            write(10,'(1x,A,f10.6,A)')
     +           ' Minimum photon energy',egmin,' GeV'

            write(10,*)' '
            write(10,*)'Parameters:'

            write(10,'(1x,A,1x,f11.5,A)')
     +           ' W mass       ',wmass,' GeV'
            write(10,'(1x,A,1x,f11.5,A)')
     +           ' W width      ',wwidth,' GeV'

            write(10,'(1x,A,1x,f11.5,A)')
     +           ' G_fermi      ',gfermi*1d5,'*10^(-5) GeV^(-2)'

            write(10,'(1x,A,1x,f11.7,A)')
     +           ' 1/alpha(0) ',1.d0/alpha0,'  '

            write(10,'(1x,A,1x,f11.7,A)')
     +           ' 1/alphaGF  ',1.d0/alphaGF,'  '

            write(10,'(1x,A,1x,f11.7,A)')
     +           ' 1/alpha    ',1.d0/alpha,'  '

            write(10,'(1x,A,1x,f11.7,A)')
     +           ' alpha0/alpha (QED rescale factor)',rescaleQED,'  '

            write(10,'(1x,A,1x,f15.5,f15.5)')
     +           ' Dr (cmplx)  ',Dr

            call etime(timearray,timesum)
            delta = timearray(1) - timearray2(1)
            delta2 = timesum-timesum2

            write(10,*)''//col(6)
            write(10,'(1x,A,I8,A,f7.3,A)')
     +           'User time to generate the last     ',min(nmax,iwriout)
     +           ,' points: ',delta,' s'

            write(10,'(1x,A,I8,A,f7.3,A)')
     +           'Sys+User time to generate the last ',min(nmax,iwriout)
     +           ,' points: ',delta2,' s'

            write(10,'(1x,A,f15.3,A)')
     +           'Total CPU user time:    ',timearray(1),' s'
            write(10,'(1x,A,f15.3,A)')
     +           'Total CPU system time:  ',timearray(2),' s'
            write(10,'(1x,A,f15.3,A)')
     +           'Total elapsed CPU time: ',timesum,' s'
            write(10,*)'SEED for RANLUX',iseed
            write(10,*)'ISVEC for RANLUX'
            write(10,*)isvec
            write(10,*)''
            write(10,*)'Unweighted events'
            effhm   = (1.d0*nhit)/(1.d0*k)
            widthhm = setmax * effhm
            varhm   = setmax * sqrt(effhm*(1.d0-effhm)/k)
            write(10,*)'width =',widthhm,'+-',varhm
            write(10,*)'Eff.:',effhm*100.d0,'%'
            write(10,*)'truemax, setmax, truemax/setmax:',
     .           truemax,setmax,truemax/setmax
            
            close(10)
            call writedistributions
            iwri = 0
            call etime(timearray2,timesum2)
         endif

 1000    continue

      enddo
#ifdef LT210
      call ltexi
#endif
#ifdef LT28
      call ltexi
#endif
#ifdef LT25
      call ffexi
#endif
      stop
      end
