      program Hto4fg
      implicit double precision (a-h,m,l,o-z)
      dimension ph(0:3),p1(0:3),p2(0:3),p3(0:3),p4(0:3),q(0:3)
      dimension p1l(0:3),p2l(0:3),p3l(0:3),p4l(0:3),ql(0:3)
      dimension ptmp(0:3),pp(0:3),mass4(4),charges(4)
      dimension qph(40,0:3),qphl(40,0:3),csi(1)
      dimension qph20(20,0:3)
      real*4 timearray(2) ,timesum
      real*4 timearray2(2),timesum2

      double precision em,mm

      integer isvec(25),iseeds(1500)
      parameter (npart = 5)
      dimension w_sum(0:40),w_sum2(0:40),var(0:40),sigma(0:40)
      dimension width(0:40)
      character*30 suffix      
      character*9 crsstr
      character*1 tstr
      integer*8 ncalls,k,nmax
      integer lux,lpath,lsuff,iloc(1)
      parameter (lux=4,k1=0,k2=0)
      character*100 outputfile,path,massadellhiggs
      character*8 procid
      character*30 machine,errpos
      data errpos/'                              '/

      common/photonmass/mg ! common for routine propagator in Asu3.f
      common/paramhiggs/masshiggs

      double precision mhnom,whtot
      common/higgsnominal/mhnom,whtot

      common/alphas/alpha0,alphaGF,alpha
      common/wparam/wmass,wwidth
      common/gdifermi/gfermi
      common/forcuts/egmax
      common/hadron_parton/ipartonic,iusempi
      common/recombinesmearcut/irecombine,ismearing,icut

      double complex Dr,Drt
      common/deltaerre/Dr,Drt

      common/zwidthonoff/zwonoff
      common/zparam/zmass,zwidth

      common/imode/imode
      integer iba
      common/ibaswitch/iba
      common/identicalparticles/idpart

      parameter (nfs=3,nord=9)
      character*4 fsc,fsa(nfs)
      character*8 ord,orda(nord)

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double precision rescaleQED
      common/QEDrescale/rescaleQED

      data ord,fsa,orda/'        ',
     .                  'eemm','eeee','mmmm',
     .                  'born',
     .                  'exoalyin','exoalnin',
     .                  'psoal','psexp',
     .                  'newpsoal','newpsexp','matched','matchnin'
     . /

      double precision mass(5)
      common/amasses/mass

      common/nphotMODE/nphotmode

! imode = 1  H --> e+e- mu+mu- g   with no interference 
!                                  radiation between e and mu currents
! imode = 2  H --> e+e- mu+mu- g   including interference 
!                                  radiation between e and mu currents
! imode = 3  H --> e+e- e+e- g
! imode = 4  H --> mu+mu- mu+mu- g
!
! imode = 11 H --> e+e- mu+mu-    with order alpha Parton Shower
! imode = 12 H --> e+e- mu+mu-    with exponentiatied Parton Shower
! imode = 13 H --> e+e- e+e-      with order alpha Parton Shower
! imode = 14 H --> e+e- e+e-      with exponentiatied Parton Shower
! imode = 15 H --> mu+mu- mu+mu-  with order alpha Parton Shower
! imode = 16 H --> mu+mu- mu+mu-  with exponentiatied Parton Shower
!
! imode = 21  Born ee mm (via Parton Shower... :-) )
! imode = 22  Born ee ee (via Parton Shower... :-) )
! imode = 23  Born mm mm (via Parton Shower... :-) )

      data ((qph(i,j),i=1,40),j=0,3) / 160 * 0.d0/
      data ((qphl(i,j),i=1,40),j=0,3) / 160 * 0.d0/	
      data ((qph20(i,j),i=1,20),j=0,3) / 80 * 0.d0/

      data path /'                                            
     >                                              '/
c      character*12 col(20)
      character*1 col(20)
      common/colors/col

      COMMON/FMASSES/em,mm
      COMMON/INFRAR/phmass,egmin
      common/FSmasses/ame,amm

#include "looptools.h"
      include 'mpif.h'
      include 'mpishortcuts.h'

      call mpi_init(ierr)
      call mpi_comm_rank(MCW,myid,ierr)
      call mpi_comm_size(MCW,nprocs,ierr)

      pi      = 3.1415926535897932384626433832795029d0
      icount  = 0.d0

      call initcolors

*>>* PID of the process loaded in procid
      call itoa(getpid(),procid)
      call hostnm(machine)

***** 
      if (myid.eq.0) then
         do i = 1,nprocs-1
            call mpi_recv(machines(i),30,MCHAR,i,66,MCW,status,ierr)
         enddo
      else
         call mpi_send(machine,30,MCHAR,0,66,MCW,ierr)
      endif
*<<*
      if (myid.eq.0) then
      print*,' '
      print*,col(20)//'***************************'
      print*,col(15)//'You''re running the program'//col(1)
      print*,'         '//col(12)//'Hto4fg PARALLEL '//col(1)
      print*,col(20)//'***************************'//col(9)
      print*,'  '
      print*,col(6)//'Partonic mode? (0/1)'//col(1)
      read(*,*)ipartonic

c      print*,col(5)//'Enter running mode'//col(1)
c      read(*,*)imode

      print*,col(5)//'Enter fs particles (eemm/eeee/mmmm)'//col(1)
      read(*,*)fsc

      print*,col(5)//'Enter fs order of corrections'//col(1)
      print*,col(5)//'(born/exoalyin/exoalnin/psoal/psexp)'//col(1)
      print*,col(5)//'(*newpsoal/newpsexp/matched/matchnin*)'//col(1)
      read(*,*)ord

      print*,col(5)//'Enter if including IBA or not'//col(1)
      read(*,*)iba

      print*,col(6)//'Enter seed for RANLUX'//col(1)
      read(*,*)iseed
      print*,col(5)//'Nphotmode? (<0/0/1)'//col(1)
      read(*,*)nphotmode
      print*,col(6)//'Photon mass (GeV)'//col(1)
      read(*,*)mg
      print*,col(5)//'Minimum photon energy (egmin) in radiative'//
     >' event (GeV)'//col(1)
      read(*,*)egmin
      print*,col(5)//'Higgs mass (GeV)'//col(1)
      read(*,*)masshiggs
*** in common!
      mhnom = masshiggs
***
      print*,col(5)//'Higgs Total Width (GeV)'//col(1)
      read(*,*)whtot

c     print*,col(5)//'Z mass (GeV) [for quick comparison with'//
c     +' PROPHECY4f]'//col(1)
c      read(*,*)zmass
c      print*,col(5)//'Z width (GeV) [for quick comparison with'//
c     +' PROPHECY4f]'//col(1)
c      read(*,*)zwidth
c      print*,col(5)//'Z width on/off in MEs (0/1)'//col(1)
c      read(*,*)zwonoff

      print*,col(5)//'switch on weak corrections? (0=only QED/1=full'//
     .' EW NLO)'//col(1)
      read(*,*)iweakcorr
      ionlyqed = 1 - iweakcorr

      print*,col(6)//'Apply selection cuts? (0/1)'//col(1)
      read(*,*)icut
      print*,col(5)//'Recombine photons and electrons? (0/1)'//col(1)
      read(*,*)irecombine
      print*,col(6)//'Smear momenta? (0/1)'//col(1)
      read(*,*)ismearing

      print*,col(5)//'Number of points to be generated'//col(1)
      read(*,*)nmax

      print*,col(5)//'Output directory (max. 20 char.)'//col(1)
      read(*,*)path
      print*,' '
      endif

      call mpi_bcast(ipartonic,1,MI,0,MCW,ierr)
      call mpi_bcast(fsc,4,MCHAR,0,MCW,ierr)
      call mpi_bcast(ord,8,MCHAR,0,MCW,ierr)
      call mpi_bcast(iba,1,MI,0,MCW,ierr)
      call mpi_bcast(nphotmode,1,MI,0,MCW,ierr)
      call mpi_bcast(mg,1,MDP,0,MCW,ierr)
      call mpi_bcast(egmin,1,MDP,0,MCW,ierr)
      call mpi_bcast(masshiggs,1,MDP,0,MCW,ierr)
      call mpi_bcast(mhnom,1,MDP,0,MCW,ierr)
      call mpi_bcast(whtot,1,MDP,0,MCW,ierr)
c      call mpi_bcast(zmass,1,MDP,0,MCW,ierr)
c      call mpi_bcast(zwidth,1,MDP,0,MCW,ierr)
c      call mpi_bcast(zwonoff,1,MDP,0,MCW,ierr)
      call mpi_bcast(iweakcorr,1,MI,0,MCW,ierr)
      call mpi_bcast(ionlyqed,1,MI,0,MCW,ierr)
      call mpi_bcast(icut,1,MI,0,MCW,ierr)
      call mpi_bcast(irecombine,1,MI,0,MCW,ierr)
      call mpi_bcast(ismearing,1,MI,0,MCW,ierr)
      call mpi_bcast(path,100,MCHAR,0,MCW,ierr)
      
      if (myid.eq.0) then
         do i = 1,nprocs-1
            itmp = iseed + i*992341
            iseeds(i) = itmp ! storing the sent seeds....
            call mpi_send(itmp,1,MI,i,15,MCW,ierr)
         enddo
      else
         nmax = -1. + 2.**62 ! dunno how to send an integer*8 !!
         call mpi_recv(iseed,1,MI,0,15,MCW,status,ierr)
      endif

      do i = 0,nprocs
         nfrom(i) = 0
      enddo
      nfrommax = 0

      call mpi_barrier(MCW,ierr)
      
****  checking for input consistency
      iok = 0
      do i = 1,nfs
         if (fsc.eq.fsa(i)) iok = 1
      enddo
      if (iok.eq.0) then
         print*,' ' 
         print*,'Wrong final state string: '//fsc
         print*,' Stopping here.'     
         print*,'###############################################'
         stop
      endif

      iok = 0
      do i = 1,nord
         if (ord.eq.orda(i)) iok = 1
      enddo
      if (iok.eq.0) then
         print*,' ' 
         print*,'Wrong order string: '//ord
         print*,' Stopping here.'     
         print*,'###############################################'
         stop
      endif

      if ((fsc.eq.'eeee'.or.fsc.eq.'mmmm').and.ord.eq.'exoalnin') then
         print*,' ' 
         print*,'Wrong input! Identical particles meaningless without'//
     .        ' interference. Stopping here.'
         print*,'###############################################'
         stop
      endif
****************************************************************************

*********** setting old imode (still used in subroutines) ******************
      if (ord.eq.'exoalnin'.and.fsc.eq.'eemm') imode = 1
      if (ord.eq.'exoalyin'.and.fsc.eq.'eemm') imode = 2
      if (ord.eq.'exoalyin'.and.fsc.eq.'eeee') imode = 3
      if (ord.eq.'exoalyin'.and.fsc.eq.'mmmm') imode = 4
      if (ord.eq.'psoal'   .and.fsc.eq.'eemm') imode = 11
      if (ord.eq.'psexp'   .and.fsc.eq.'eemm') imode = 12
      if (ord.eq.'psoal'   .and.fsc.eq.'eeee') imode = 13
      if (ord.eq.'psexp'   .and.fsc.eq.'eeee') imode = 14
      if (ord.eq.'psoal'   .and.fsc.eq.'mmmm') imode = 15
      if (ord.eq.'psexp'   .and.fsc.eq.'mmmm') imode = 16
      if (ord.eq.'born'    .and.fsc.eq.'eemm') imode = 21
      if (ord.eq.'born'    .and.fsc.eq.'eeee') imode = 22
      if (ord.eq.'born'    .and.fsc.eq.'mmmm') imode = 23
      if (ord.eq.'newpsoal'.and.fsc.eq.'eemm') imode = 31
      if (ord.eq.'newpsoal'.and.fsc.eq.'eeee') imode = 32
      if (ord.eq.'newpsoal'.and.fsc.eq.'mmmm') imode = 33
      if (ord.eq.'newpsexp'.and.fsc.eq.'eemm') imode = 34
      if (ord.eq.'newpsexp'.and.fsc.eq.'eeee') imode = 35
      if (ord.eq.'newpsexp'.and.fsc.eq.'mmmm') imode = 36
      if (ord.eq.'matched' .and.fsc.eq.'eemm') imode = 37
      if (ord.eq.'matched' .and.fsc.eq.'eeee') imode = 38
      if (ord.eq.'matched' .and.fsc.eq.'mmmm') imode = 39
      if (ord.eq.'matchnin'.and.fsc.eq.'eemm') imode = 40
****************************************************************************

**** NAME OF FILES **********
      do ki =1,30
         suffix(ki:ki) = ' '
      enddo

      if (iba.eq.0) then
         if (imode.eq.1)  suffix='ex_nin_eemm_'
         if (imode.eq.2)  suffix='ex_yin_eemm_'
         if (imode.eq.3)  suffix='ex_yin_eeee_'
         if (imode.eq.4)  suffix='ex_yin_mmmm_'
         if (imode.eq.11) suffix='ps_oal_eemm_' 
         if (imode.eq.12) suffix='ps_exp_eemm_' 
         if (imode.eq.13) suffix='ps_oal_eeee_' 
         if (imode.eq.14) suffix='ps_exp_eeee_' 
         if (imode.eq.15) suffix='ps_oal_mmmm_' 
         if (imode.eq.16) suffix='ps_exp_mmmm_'
         if (imode.eq.21) suffix='born_eemm_' 
         if (imode.eq.22) suffix='born_eeee_' 
         if (imode.eq.23) suffix='born_mmmm_' 
         
         if (imode.eq.31) suffix='newps_oal_eemm_' 
         if (imode.eq.32) suffix='newps_oal_eeee_' 
         if (imode.eq.33) suffix='newps_oal_mmmm_' 
         
         if (imode.eq.34) suffix='newps_exp_eemm_' 
         if (imode.eq.35) suffix='newps_exp_eeee_' 
         if (imode.eq.36) suffix='newps_exp_mmmm_' 
         
         if (imode.eq.37) suffix='matched_exp_eemm_' 
         if (imode.eq.38) suffix='matched_exp_eeee_' 
         if (imode.eq.39) suffix='matched_exp_mmmm_' 
         if (imode.eq.40) suffix='matchnin_exp_eemm_'
      else
         if (imode.eq.1)  suffix='ex_nin_IBA_eemm_'
         if (imode.eq.2)  suffix='ex_yin_IBA_eemm_'
         if (imode.eq.3)  suffix='ex_yin_IBA_eeee_'
         if (imode.eq.4)  suffix='ex_yin_IBA_mmmm_'
         if (imode.eq.11) suffix='ps_oal_IBA_eemm_' 
         if (imode.eq.12) suffix='ps_exp_IBA_eemm_' 
         if (imode.eq.13) suffix='ps_oal_IBA_eeee_' 
         if (imode.eq.14) suffix='ps_exp_IBA_eeee_' 
         if (imode.eq.15) suffix='ps_oal_IBA_mmmm_' 
         if (imode.eq.16) suffix='ps_exp_IBA_mmmm_'
         if (imode.eq.21) suffix='born_IBA_eemm_' 
         if (imode.eq.22) suffix='born_IBA_eeee_' 
         if (imode.eq.23) suffix='born_IBA_mmmm_' 
         
         if (imode.eq.31) suffix='newps_oal_IBA_eemm_' 
         if (imode.eq.32) suffix='newps_oal_IBA_eeee_' 
         if (imode.eq.33) suffix='newps_oal_IBA_mmmm_' 
         
         if (imode.eq.34) suffix='newps_exp_IBA_eemm_' 
         if (imode.eq.35) suffix='newps_exp_IBA_eeee_' 
         if (imode.eq.36) suffix='newps_exp_IBA_mmmm_' 
         
         if (imode.eq.37) suffix='matched_exp_IBA_eemm_' 
         if (imode.eq.38) suffix='matched_exp_IBA_eeee_' 
         if (imode.eq.39) suffix='matched_exp_IBA_mmmm_' 
         if (imode.eq.40) suffix='matchnin_exp_IBA_eemm_' 
      endif

      if (ionlyqed.eq.1.and.
     >     (suffix(1:2).eq.'ex'.or.
     .      suffix(1:2).eq.'ma')
     .     ) then
         ils = 1
         do while (suffix(ils:ils).ne.' ')
            ils = ils + 1
         enddo
         suffix = suffix(1:ils-1)//'QED_'
      endif

      call fptoa(masshiggs,massadellhiggs)
      tmp = abs(masshiggs-int(masshiggs))
      if (tmp.lt.1.d-10) call itoa(int(masshiggs),massadellhiggs)
      call merge_strings(suffix,massadellhiggs,suffix)

      do ki = 1,100
         if (path(ki:ki).ne.' ') lpath=ki
      enddo
      if (path(lpath:lpath).ne.'/') then
         lpath = lpath+1
         path(lpath:lpath)='/'
      endif

      if (myid.eq.0) call system('mkdir -p '//path)

      do ki = 1,30
         if (suffix(ki:ki).ne.' ') lsuff=ki
      enddo   

      call itoa(icut,tstr)
      crsstr(1:3) = '_c'//tstr
      call itoa(irecombine,tstr)
      crsstr(4:6) = '_r'//tstr
      call itoa(ismearing,tstr)
      crsstr(7:9) = '_s'//tstr   
      outputfile = path(1:lpath)//suffix(1:lsuff)//crsstr//'_statistics'

      call setfilenames(suffix,path)
*******************************

      iwriout = 2000000
      if (imode.ge.37) iwriout = 2000000

      iwriout = 1000
      print*,'iwriout lowered!!!!'
      print*,'iwriout lowered!!!!'
      print*,'iwriout lowered!!!!'
      print*,'iwriout lowered!!!!'
      print*,'iwriout lowered!!!!'
      print*,'iwriout lowered!!!!'
      print*,'iwriout lowered!!!!'
      print*,'iwriout lowered!!!!'
      
      
      ame = 0.51099892d-3
      amm = 0.105658369d0

      statfactor = 2.d0 ! statistical factor!!
                        ! con 2 ottengo i numeri
                        ! di higgsdecay
      em     = ame
      mm     = amm
      phmass = mg

      if (fsc.eq.'eemm') then
         idpart  = 0
         mass(1) = ame
         mass(2) = ame
         mass(3) = amm
         mass(4) = amm
      elseif (fsc.eq.'eeee') then
         idpart  = 1
         mass(1) = ame
         mass(2) = ame
         mass(3) = ame
         mass(4) = ame
      elseif (fsc.eq.'mmmm') then
         idpart  = 1
         mass(1) = amm
         mass(2) = amm
         mass(3) = amm
         mass(4) = amm
      endif

      mass(5) = 0.d0

************** STATISTICAL FACTOR FOR COMPARISON TO PROPHECY4F
      statfact = 1.d0/2.d0
      if (idpart.eq.1) statfact = statfact * 4.d0
*********************************************************

!!!!!!!!!!!!!!!!!!!!
      statfactor = statfactor*statfact
c      print*,'WARNING:'
c      print*,'CHANGED THE STATISTICAL FACTOR TO AGREE WITH PROPHECY4F!'
c      print*,'by x',statfact,'(',statfactor,')'
!!!!!!!!!!!!!!!!!!!!!!!!

      do ki = 1,4
         mass4(ki)   = mass(ki)
         charges(ki) = -1.d0
      enddo

      ph(0) = masshiggs
      ph(1) = 0.d0
      ph(2) = 0.d0
      ph(3) = 0.d0
            
      flux = 1.d0/2.d0/ph(0)

      do ki = 0,40
         w_sum(ki)  = 0.d0
         w_sum2(ki) = 0.d0
         sigma(ki) = 0.d0
         width(ki) = 0.d0
      enddo
      w_sumt  = 0.d0
      w_sumt2 = 0.d0
      sigmat  = 0.d0
      widtht  = 0.d0

      ic = 0
      varbefore = 1d-9
      nphmax = 0

      call initlooptools
      call init_apar

      call initrndgen(iseed)

      call init_partonshower
! if Parton Shower is chosen, no exact photons are present!
      if (imode.gt.10.and.imode.lt.30) nphotmode = 0

c      open(16,file='rlxjump',status='unknown')
c      read(16,*)isvec
c      call rluxin(isvec)
c      close(16)


      k = 0
      iwri = 0

      ipack = 0
      istop = 0
      nrecvpacks = 0
      if (myid.ge.1) call mpi_irecv(istop,1,MI,0,5,MCW,STOPREQ,ierr)
      sez = 1.d0

c      if (myid.eq.0) then 
c         print*,'Renicing process 0, ID '//procid
c         call system('renice 15 '//procid)
c      endif


      call etime(timearray2,timesum2)
      call cpu_time(cputime1)

      do while(k.lt.nmax)
         if (myid.eq.0) goto 333

 1       continue

         call rluxut(isvec)
         emtx2 = 0.d0

c         qphl(max(1,nphmax),:) = 0.d0 ! resetting photon momenta

         call phasespaceZatREST(ph,mass,ng,p1,p2,p3,p4,qph,
     >        phsp,wphsp,iephsp)
         call cutfflowinvmasses(p1,p2,p3,p4,icut)
         if (icut.gt.0) iephsp = icut

         wmulti = 1.d0
         q(0) = qph(1,0)
         q(1) = qph(1,1)
         q(2) = qph(1,2)
         q(3) = qph(1,3)

! now multiplicity is put in phasespace!!
c         call multiplicity(nphotmode,ng,wmulti)
c         if (ng.eq.1) then 
c            nch = 2*(idpart + 1) ! number of channels in radiative phase space
c            call phasespaceold(nch,ph,mass,egmin,p1,p2,p3,p4,q,
c     >                      phsp,wphsp,iephsp)
c         else
c            nch = idpart + 1 ! number of channels in born like phase space
c            call phasespace4f(nch,ph,mass,egmin,p1,p2,p3,p4,q,
c     >                        phsp,wphsp,iephsp)
c         endif
  
* Parton Shower
         if (imode.gt.10.and.imode.lt.30.and.iephsp.eq.0) then
            call newborn(p1,p2,p3,p4,emtx2,bornIBA)

            if (iba.eq.1) emtx2 = bornIBA

!!! test for PS scale
            q2 = zmass**2 ! old choice
            q21 = q2
            q22 = q2
***********************
c            call getPSscale(p1,p2,p3,p4,charges,mass4,q2)
c            q21 = q2
c            q22 = q2
c$$$            zma2 = zmass*zmass
c$$$            do i = 0,3
c$$$               ptmp(i) = p1(i)+p2(i)
c$$$            enddo
c$$$            p1p2 = dot(ptmp,ptmp)
c$$$            do i = 0,3
c$$$               ptmp(i) = p1(i)+p3(i)
c$$$            enddo
c$$$            p1p3 = dot(ptmp,ptmp)
c$$$            do i = 0,3
c$$$               ptmp(i) = p1(i)+p4(i)
c$$$            enddo
c$$$            p1p4 = dot(ptmp,ptmp)
c$$$            do i = 0,3
c$$$               ptmp(i) = p2(i)+p3(i)
c$$$            enddo
c$$$            p2p3 = dot(ptmp,ptmp)
c$$$            do i = 0,3
c$$$               ptmp(i) = p2(i)+p4(i)
c$$$            enddo
c$$$            p2p4 = dot(ptmp,ptmp)
c$$$
c$$$            q21 = p1p2
c$$$            if (abs(p1p4-zm2).lt.abs(p1p2-zm2)) q21 = p1p4
c$$$
c$$$            q22 = p3p4
c$$$            if (abs(p2p3-zm2).lt.abs(p3p4-zm2)) q22 = p2p3
***********************
            call QEDPartonShower(q21,q22,p1,p2,p3,p4,qph,q,ieps)
            ! in q is put the most energetic photon!
            iephsp = iephsp + ieps
         endif

**************************
         sez = 1.d0
         nzeropu = 1
         p1l = p1
         p2l = p2
         p3l = p3
         p4l = p4
         qphl(1:max(1,ng),:) = qph(1:max(1,ng),:)
         ql = qph(1,:)
         k = k + nzeropu
*************************
c         call readhiggsandboost(ph,p1,p2,p3,p4,q,qph,imode,
c     >        p1l,p2l,p3l,p4l,ql,qphl,sez,nzeropu)
c         k = k + nzeropu
c         if (sez.lt.1d-30) iephsp = 1

**************************

         egmax = 10.d0*ph(0)

         if (iephsp.eq.0) then
            call cutsandsmear(p1l,p2l,p3l,p4l,ql,qphl,ireject)
            if (ireject.eq.1) iephsp = 1
         endif
         if (iephsp.eq.1) then 
            phsp = 0.d0
            wphsp = 0.d0
            emtx2 = 0.d0
         endif

         if (iephsp.eq.0) then
            if (imode.lt.10.or.imode.gt.30) then
*************************************************************
               call matrixelement(p1,p2,p3,p4,qph,ng,emtx2)

c               if (ng.eq.1) then
c                  call newrad(p1,p2,p3,p4,q,emtx2)
c               else
c                  call virtual(p1,p2,p3,p4,emtx2virt,emtx2born,bornIBA)
c                  
c                  sf = soft_integral(phmass,egmin,p1,p2,p3,p4,charges)
c                  sf = sf * emtx2born
c                  
c                  emtx2 = bornIBA + emtx2virt + sf
c               endif
*************************************************************
            endif

!! START CHECKING NANs!!
c            if (abs(emtx2).lt.1.d100.and.abs(phsp).lt.1d100
c     .           .and.abs(wphsp).lt.1d100) then
c               continue
c            else

            if (isnan(emtx2).or.isnan(phsp).or.isnan(wphsp)) then
               print*,'POSSIBLE NAN!! ',ng,emtx2,phsp,wphsp
               open(16,file=path(1:lpath)//'rlxNaN-'//procid,
     .              access='append',status='unknown')
               write(16,*),'phsp*wphsp ',phsp*wphsp
               write(16,*),'k ',k
               write(16,*),'n. gammas: ',ng
               write(16,*),'fermion momenta'
               write(16,*),p1
               write(16,*),p2
               write(16,*),p3
               write(16,*),p4
               write(16,*),'conservation'           
               write(16,*),p1+p2+p3+p4+sum(qph(1:ng,:),1)
               write(16,*),'imode ',imode
               write(16,*),'|M|^2 ',emtx2
c               write(16,*),'1g ME ',fme
c               write(16,*),'virt ',emtx2virt
c               write(16,*),'SFF ',sf
               write(16,*)'       p1(0) = ',p1(0)
               write(16,*)'       p1(1) = ',p1(1)
               write(16,*)'       p1(2) = ',p1(2)
               write(16,*)'       p1(3) = ',p1(3)
               write(16,*)'       p2(0) = ',p2(0)
               write(16,*)'       p2(1) = ',p2(1)
               write(16,*)'       p2(2) = ',p2(2)
               write(16,*)'       p2(3) = ',p2(3)
               write(16,*)'       p3(0) = ',p3(0)
               write(16,*)'       p3(1) = ',p3(1)
               write(16,*)'       p3(2) = ',p3(2)
               write(16,*)'       p3(3) = ',p3(3)
               write(16,*)'       p4(0) = ',p4(0)
               write(16,*)'       p4(1) = ',p4(1)
               write(16,*)'       p4(2) = ',p4(2)
               write(16,*)'       p4(3) = ',p4(3)
               do ki = 1,max(1,ng)
                  write(16,*)'       q(0)  = ',qph(ki,0)
                  write(16,*)'       q(1)  = ',qph(ki,1)
                  write(16,*)'       q(2)  = ',qph(ki,2)
                  write(16,*)'       q(3)  = ',qph(ki,3)
               enddo
               write(16,*),'myid ',myid
               write(16,*),'seed ',iseed
               write(16,*),'ISVEC FOR RANLUX'
               write(16,*),isvec
               write(16,*),'******************************'
               
               close(16)
c               stop
            endif
!! END CHECKING NANs!!
         endif

         ipack = ipack + 1

**** photons to be sent!!
         qph20(1:20,:) = qphl(1:20,:)
****
         do i = 0,3
            pack(1+i,ipack)  = p1(i)
            pack(5+i,ipack)  = p2(i)
            pack(9+i,ipack)  = p3(i)
            pack(13+i,ipack) = p4(i) 
         enddo
         do j = 1,20
            do i = 0,3
               pack(17+4*(j-1)+i,ipack) = qph20(j,i) 
            enddo
         enddo
         pack(97 ,ipack) = ng ! conversion int-real
         pack(98 ,ipack) = emtx2
         pack(99 ,ipack) = phsp
         pack(100,ipack) = wphsp

*>>* CLEAR LT CACHE TO AVOID MEMORY LEAKS (?)
         call clearcache()
*<<*
         if (ipack.eq.npack) then
            call mpi_test(STOPREQ,RORN,status,ierr)
            if (RORN.eqv..false.) then
               call mpi_send(pack,packsize*npack,
     .              MDP,0,30,MCW,ierr)               
               icount = icount + 1
               nfrom(myid) = nfrom(myid) + 1
               ipack = 0
            else
               goto 999
            endif
         endif
*###############################
         if (myid.ge.1) goto 1
*###############################

 333     continue ! after here only if myid = 0

         k = k + 1

         if (ipack.eq.0) then
            nrecvpacks = nrecvpacks + 1

cc doesnt work properly, because tends to get msgs from the same processes...
c            call mpi_recv(pack,packsize*npack,MDP,
c     .           MPIAS,30,MCW,status,ierr)
ccccccccccccccccccccc            

            TOBERECV=.false.
            do while(.not.TOBERECV)
               call wraprnd(csi,1)
               ifrom = 1 + csi(1)*(nprocs - 1)
               if (ifrom.gt.(nprocs-1)) ifrom = nprocs-1
               call mpi_iprobe(ifrom,30,MCW,TOBERECV,status,ierr)
               if (TOBERECV) then
                  call mpi_recv(pack,packsize*npack,MDP,
     .                 ifrom,30,MCW,status,ierr)
               endif
            enddo

            igotfrom = status(MPISR)

            nfrom(status(MPISR)) = nfrom(status(MPISR)) + 1
            if (status(MPISR).gt.nfrommax) nfrommax = status(MPISR)

         endif
         ipack = ipack+1
         do i = 0,3
            p1(i) = pack(i+1,ipack)
            p2(i) = pack(i+5,ipack)
            p3(i) = pack(i+9,ipack)
            p4(i) = pack(i+13,ipack)
         enddo

         do j = 1,20
            do i = 0,3
               qph20(j,i) = pack(17+4*(j-1)+i,ipack)
            enddo
         enddo

         ng     = int(pack(97,ipack))
         emtx2  = pack(98,ipack)
         phsp   = pack(99,ipack)
         wphsp  = pack(100,ipack)

         qph(1:20,:) = qph20(1:20,:)

         if (ipack.eq.npack) ipack = 0
                              
         toMeV = 1000.d0

         wmulti = 1.d0
         pwidth = phsp*emtx2*flux/statfactor*wmulti*wphsp*toMeV

!! rejecting if it's a NAN....
         ipwnan = 0
c         if (abs(pwidth).lt.1.d100) then
c            continue
c         else
         if (isnan(pwidth)) then

            print*,'KILLED THE EVENT BECAUSE OF A NaN'
            pwidth = 0.d0
            ipwnan = 1

            p1l  = 0.d0
            p2l  = 0.d0
            p3l  = 0.d0
            p4l  = 0.d0
            qphl = 0.d0
            
            k = k - 1 ! bah...
            iwri = iwri - 1

         endif
!!!!!!!!!!!!!!!!!!!!!!!!!!

         if (ng.gt.nphmax) nphmax = ng

         w_sum(ng)  = w_sum(ng)  + pwidth
         w_sum2(ng) = w_sum2(ng) + pwidth*pwidth

         w_sumt  = w_sumt  + pwidth
         w_sumt2 = w_sumt2 + pwidth*pwidth

         ak = 1.d0*k
         width(ng) = w_sum(ng)/ak

         widtht    = w_sumt/ak

         var(ng)   = (w_sum2(ng)/ak - width(ng)**2)/ak
         sigma(ng) = sqrt(abs(var(ng)))

         sigmat = sqrt(abs((w_sumt2/ak - widtht**2)/ak))

         ncalls = k

*>>* Distributions     
         p1l  = p1
         p2l  = p2
         p3l  = p3
         p4l  = p4
         qphl = qph
         if (ipwnan.eq.0) 
     .        call distributions(pwidth,ncalls,p1l,p2l,p3l,p4l,ng,qphl)
*<<*
         sig = sqrt(sigma(0)**2 + sigma(1)**2)

         if (k.gt.100000) then
            tolleranza = 1.2d0
            if (sigmat.gt.tolleranza*varbefore) then

               print*,'>>>>>>>> DUMPING EVENT n.',k,'<<<<<<<<<<'

               open(16,file=path(1:lpath)//'rlxjump-'//procid,
     .              access='append',status='unknown')

               write(16,*)'Event n. = ',k
               write(16,*)'var,varbefore = ',sigmat,varbefore
               write(16,*)'tolerance ',tolleranza
               write(16,*),'imode ',imode
               write(16,*)'ng     = ',ng
               write(16,*),'phsp  = ',phsp
               write(16,*),'wphsp = ',wphsp
               write(16,*),'|M|^2 = ',emtx2
c               write(16,*),'virt  = ',emtx2virt
c               write(16,*),'SFF   = ',sf
               write(16,*)'       p1(0) = ',p1(0)
               write(16,*)'       p1(1) = ',p1(1)
               write(16,*)'       p1(2) = ',p1(2)
               write(16,*)'       p1(3) = ',p1(3)
               write(16,*)'       p2(0) = ',p2(0)
               write(16,*)'       p2(1) = ',p2(1)
               write(16,*)'       p2(2) = ',p2(2)
               write(16,*)'       p2(3) = ',p2(3)
               write(16,*)'       p3(0) = ',p3(0)
               write(16,*)'       p3(1) = ',p3(1)
               write(16,*)'       p3(2) = ',p3(2)
               write(16,*)'       p3(3) = ',p3(3)
               write(16,*)'       p4(0) = ',p4(0)
               write(16,*)'       p4(1) = ',p4(1)
               write(16,*)'       p4(2) = ',p4(2)
               write(16,*)'       p4(3) = ',p4(3)
               do ki = 1,max(1,ng)
                  write(16,*)'       q(0)  = ',qph(ki,0)
                  write(16,*)'       q(1)  = ',qph(ki,1)
                  write(16,*)'       q(2)  = ',qph(ki,2)
                  write(16,*)'       q(3)  = ',qph(ki,3)
               enddo
               write(16,*),'Event in a package got from proc ',igotfrom
               write(16,*),'with seed ',iseeds(igotfrom)
               write(16,*),'ISVEC FOR RANLUX'
               write(16,*),isvec
               write(16,*),'******************************'
               close(16)
            endif
         endif

         varbefore = sigmat

         iwri = iwri + 1
         if (iwri.ge.iwriout.or.k.ge.nmax) then            
            open(10,file=outputfile,status='unknown')
            ic = ic + 1            
            do ki = 0,nphmax
               width(ki) = width(ki) !*1000.d0 already accouted for by toMeV
               sigma(ki) = sigma(ki) !*1000.d0
            enddo
            wid = 0.d0 
            sig = 0.d0
            do ki = 0,nphmax
               wid = wid + width(ki)
               sig = sig + sigma(ki)**2
            enddo
            sig = sqrt(sig)

            perc0 = 0.d0
            perc1 = 0.d0
            perct = 0.d0
            if (abs(width(0)).gt.0.d0) perc0=sigma(0)/width(0) * 100.d0
            if (width(1).gt.0.d0)      perc1=sigma(1)/width(1) * 100.d0
            perct = sig/wid * 100.d0
            write(10,*)col(5)
            write(10,'(1x,A)') 'PID = '//procid//' on '//machine//
     +           '(** PARALLEL MODE **)'
            write(10,'(1x,A,I8,A)') 'Running mode = '//fsc//'   '//ord//
     +                              '      (i.e. imode =',imode,')'
            if (suffix(1:2).eq.'ex'.or.suffix(1:2).eq.'ma') then
               if (iweakcorr.eq.1) then
                  write(10,'(1x,A)') 'including FULL QED+WEAK NLO'
               else
                  write(10,'(1x,A)') 'including only QED NLO'
               endif
            endif
            write(10,*)' '
            write(10,'(1x,A,I15,A,I15)') 'event n.',k,' of ',nmax
            write(10,*)' '

            do ik = 0,nphmax
               write(10,'(1x,I2,A,f18.15,A,f18.15,A)')
     +             ik,' photons width ',width(ik),' +-',sigma(ik),' MeV'
               call geterrpos(sigma(ik),iep,errpos)
               if (iep.gt.0) write(10,'(1x,A)')
     +              '                '//'   '//errpos
            enddo

            write(10,'(1x,A,f18.15,A,f18.15,A)')
     +           'Total =         ',wid,' +-',sig,' MeV'
            call geterrpos(sig,iep,errpos)
            write(10,'(1x,A)')
     +           '                '//'  '//errpos

            write(10,'(1x,A,f18.15,A,f18.15,A,f18.15,A)')
     +           'accuracies = ',perc0,' %',perc1,' %',perct,' %'
            write(10,*)' '
            write(10,*)'Inputs:'
            write(10,'(1x,A,f7.3,A)')
     +           ' Higgs mass =',ph(0),' GeV'
            write(10,'(1x,A,f12.8,f12.8,f12.8,f12.8,A)')
     +           ' Lepton masses =',(mass(i),i=1,4),' GeV'

            write(10,'(1x,A,1x,f11.7,A)')
     +           ' Z mass  ',zmass,' GeV'
            write(10,'(1x,A,1x,f11.7,A)')
     +           ' Z width ',zwidth,' GeV'

            write(10,*)' '
            write(10,'(1x,A,f18.15,A)')
     +           ' Photon mass as IR regulator =',phmass,' GeV'
            write(10,'(1x,A,f10.6,A)')
     +           ' Minimum photon energy',egmin,' GeV'

            write(10,*)' '
            write(10,*)'Parameters:'

            write(10,'(1x,A,1x,f11.5,A)')
     +           ' W mass       ',wmass,' GeV'
            write(10,'(1x,A,1x,f11.5,A)')
     +           ' W width      ',wwidth,' GeV'

            write(10,'(1x,A,1x,f11.5,A)')
     +           ' G_fermi      ',gfermi*1d5,'*10^(-5) GeV^(-2)'

            write(10,'(1x,A,1x,f11.7,A)')
     +           ' 1/alpha(0) ',1.d0/alpha0,'  '

            write(10,'(1x,A,1x,f11.7,A)')
     +           ' 1/alphaGF  ',1.d0/alphaGF,'  '

            write(10,'(1x,A,1x,f11.7,A)')
     +           ' 1/alpha    ',1.d0/alpha,'  '

            write(10,'(1x,A,1x,f11.7,A)')
     +           ' alpha0/alpha (QED rescale factor)',rescaleQED,'  '

            write(10,'(1x,A,1x,f15.5,f15.5)')
     +           ' Dr (cmplx)  ',Dr

            call etime(timearray,timesum)
            delta  = timearray(1) - timearray2(1)
            delta2 = timesum-timesum2
            call cpu_time(cputime2)

            write(10,*)''//col(6)
            write(10,'(1x,A,I8,A,f7.3,A)')
     +           'User time to generate the last     ',min(nmax,iwriout)
     +           ,' points: ',delta,' s'

            write(10,'(1x,A,I8,A,f7.3,A)')
     +           'Sys+User time to generate the last ',min(nmax,iwriout)
     +           ,' points: ',delta2,' s'

            write(10,'(1x,A,I8,A,f7.3,A)')
     +           'CPU time to generate the last ',min(nmax,iwriout)
     +           ,' points: ',cputime2-cputime1,' s'


            write(10,'(1x,A,f15.3,A)')
     +           'Total CPU user time:    ',timearray(1),' s'
            write(10,'(1x,A,f15.3,A)')
     +           'Total CPU system time:  ',timearray(2),' s'
            write(10,'(1x,A,f15.3,A)')
     +           'Total elapsed CPU time: ',timesum,' s'
            close(10)

            open(16,file=path(1:lpath)//'parallel-run-'//procid,
     .           status='unknown')

            write(16,*)' '
            write(16,*)'Parallel run statistics'
            write(16,*)'Number of parallel processes: ',nprocs
            write(16,'(A,I5,A)')' From     |     n. packages '//
     +           '(with ',npack,' events)'//
     +           ' | sorted by n. of packages'
 
            call sortnfrom(nfrommax,nfrom,idsorted)

            nftot = 0
            do i = 1,nfrommax
               write(16,'(1X,I4,A,I10,A,I4,I10,A)')i,'     ',nfrom(i),
     +                      '         on '//machines(i)(1:15)//' |'//
     +                      '  ',
     +              idsorted(i),nfrom(idsorted(i)),
     +              '    on '//machines(idsorted(i))(1:15)
               nftot = nftot + nfrom(i)
            enddo
            write(16,'(1X,A,3X,I10)'),'Total:',nftot
            close(16)

            call writedistributions
            iwri = 0
            call etime(timearray2,timesum2)
            call cpu_time(cputime1)
         endif

 1000    continue
      enddo

 999  continue

      if (myid.eq.0) then
         ! sending stop signal to the slave processes
         istop = 1
         do i = 1,nprocs-1
            call mpi_send(istop,1,MI,i,5,MCW,ierr)
         enddo
      endif

!! collecting possible pending send instances
      if (myid.eq.0) then
         do i = 1,nprocs-1
            RORN=.true.
            do while(RORN)
               call mpi_irecv(pack,packsize*npack,MDP,
     .              i,30,MCW,RECVREQ,ierr)
               call mpi_test(RECVREQ,RORN,status,ierr)
            enddo
         enddo
      endif

      print*,'MPI finalizing process ',myid
      
      call mpi_barrier(MCW,ierr)

      call mpi_finalize(ierrmpi)

#ifdef LT210
      call ltexi
#endif

#ifdef LT28
      call ltexi
#endif

#ifdef LT25
      call ffexi
#endif

      stop
      end
***************************************************************
      subroutine sortnfrom(nmax,nfrom,idsorted)
      implicit none
      include 'mpif.h'
      include 'mpishortcuts.h'
      integer nmax,i,k,imax,itmp
      integer nfromtmp(nmax)
      do k = 1,nmax
         idsorted(k) = k
         nfromtmp(k) = nfrom(k)
      enddo
      do i = 1,nmax
         imax = nfromtmp(i)
         do k = i+1,nmax
            if (nfrom(k).gt.imax) then
               imax = nfromtmp(k)
               itmp = nfromtmp(i)
               nfromtmp(i) = nfromtmp(k)
               nfromtmp(k) = itmp
               itmp = idsorted(i)
               idsorted(i) = idsorted(k)
               idsorted(k) = itmp
            endif
         enddo
      enddo
      return
      end
