      subroutine phasespaceZatREST(ph,mass,ng,p1,p2,p3,p4,
     .     qext,phsp,w,ie)
      implicit double precision (a-h,m,l,o-z)      
      dimension ph(0:3),p1(0:3),p2(0:3),p3(0:3),p4(0:3),q(0:3)
      dimension pp1(0:3),pp2(0:3),pp3(0:3),pp4(0:3),qp(0:3)
      dimension pz1(0:3),pz2(0:3),ptmp(0:3),pza(0:3),pzb(0:3)
      dimension q1(0:3),q2(0:3),q3(0:3),q4(0:3)
      dimension qpz1(0:3,20),qpz2(0:3,20)
      dimension mass(5),dir(0:3),vers(0:3),qext(40,0:3),qall(0:3,40)
      double precision csi(1),rnd5(5),rnd1(1),rnd2(2)

      integer idpart
      real*4 timearray(2),timesum
      common/identicalparticles/idpart
      common/switch24/iswitchforidpart

      double precision phmass,egmin
      COMMON/INFRAR/phmass,egmin

      common/nphotMODE/nphotmode

      parameter (nmaxph = 50)
      integer radpattern(nmaxph)
      common/emissionpattern/radpattern

      integer nphleg(4)
      common/eikcheck/mz1,mz2,nphleg

      common/ifirstphsp/ifirst,i34
      data ifirst /0/
      data i34 /1/

      common/qtoosoft/ieq
      data ieq /0/      
      
      parameter (pi = 3.1415926535897932384626433832795029D0)

      integer mothersph(50),motherslep(4)
      common/figli_di_padre_ignoto/mothersph,motherslep
      data mothersph, motherslep /54*0/
      
      w    = 1.d0
      phsp = 1.d0
      ie   = 0

! the simplest part...
! Zeta's --------------------
! Zeta's symmetrization
      q2min  = 0.d0
      sq2max = ph(0)
!! BEST SAMPLING !    
      q2max = sq2max*sq2max
      call get_zinvmasses(q2max,mass,mz1,mz2,wz1z2)
      if ((mz1+mz2).gt.sq2max) then
         ie   = 1
         phsp = 0.d0
         w    = 0.d0
         return         
      endif
      w = w * wz1z2
      minv12 = mz1*mz1
      minv22 = mz2*mz2
!!

c 222  continue

*** lhe assignment
      mothersph  = 0
      motherslep = 0
***   
      
! I could put here a (efficient) multiplicity generation!
**** now starting dealing with photons
      nphleg(1) = 0
      nphleg(2) = 0
      nphleg(3) = 0
      nphleg(4) = 0
      
      eps=4.d0*egmin/ph(0)
      call multiplicity(mz1,mz2,mass,eps,nphotmode,ng,wmulti)
      w = w*wmulti

c      ndiff = 8 + 3*ng
      duepigrechi = (2.d0*pi)**(-8-3*ng)

***********************************
      if (ng.gt.0) then
         call get_pattern_OPT2(4,mz1,mz2,mass,ng,radpattern,wpattern)
         w = w * wpattern
         do k = 1,ng
            nphleg(radpattern(k)) = nphleg(radpattern(k)) + 1
         enddo
      endif
******
**
! now I decide that Z1 decays into pp1 pp2 (q) and Z2 into pp3 pp4 (q).
! The q is attached to the Z according to the radpattern.
**
      mr1 = mass(1)
      mr2 = mass(2)
      mr3 = mass(3)
      mr4 = mass(4)
      mr5 = mass(5)
      mr5 = 0.d0

! checking if the Zs are within their bounds
      q2minbound1 = (mr1+mr2+mr5)**2
      q2maxbound1 = (ph(0) - mr3 - mr4)**2
      if (minv12.lt.q2minbound1.or.minv12.gt.q2maxbound1) then
         ie = 1
         phsp = 0.d0
         w = 0.d0
         return
      endif      
      q2minbound2 = (mr3+mr4)**2
      q2maxbound2 = (ph(0) - mr1 - mr2 - mr5)**2
      if (minv22.lt.q2minbound2.or.minv22.gt.q2maxbound2) then
         ie = 1
         phsp = 0.d0
         w = 0.d0
         return
      endif
! checking that mz1 + mz2 <= ph(0), to avoid unphysical phase space 
! points not checked above!
      if ((mz1+mz2).gt.ph(0)) then
         ie = 1
         phsp = 0.d0
         w = 0.d0
         return
      endif

! decaying H into Z1 and Z2
      call wraprnd(rnd2,2)
      call decay2b(rnd2(1),rnd2(2),ph(0),mz1,mz2,pz1,pz2,
     >     phsp2b,w2b,ie)
      w =  w * w2b
      phsp = phsp * phsp2b
      
      if (ie.gt.0) then
         ie = 1
         phsp = 0.d0
         w = 0.d0
         return
      endif
**** Start decay of the two Zs
! Number of photons per Z
      iswitchforidpart = 0
      nphz1 = nphleg(1) + nphleg(2)
      nphz2 = nphleg(3) + nphleg(4)

      motherslep(1) = 1
      motherslep(2) = 1
      motherslep(3) = 2
      motherslep(4) = 2
      if (idpart.eq.1) then
! the other channel!
         call wraprnd(csi,1)
         if (csi(1).lt.0.5d0) then
            iswitchforidpart = 1
            nphz1 = nphleg(1) + nphleg(4)
            nphz2 = nphleg(2) + nphleg(3)
            motherslep(4) = 1
            motherslep(2) = 2
         endif
      endif

*     Decaying Z1
      if (nphz1.eq.0) then
      ! pz1 --> pp1 pp2
         call wraprnd(rnd2,2)
         call decay2b(rnd2(1),rnd2(2),mz1,mr1,mr2,pp1,pp2,
     .        phsp2b,w2b,iez1)
         w =  w * w2b         
         phsp = phsp * phsp2b
      else
      ! pz1 --> pp1 pp2 qp      
         bz = sqrt(1.d0 - minv12/pz1(0)**2)
         gz = 1.d0/sqrt(1-bz**2)
         emin = gz * egmin * ( 1.d0 - bz) 

c         emin = egmin
         
         emax = (minv12+mr5**2-(mr1 + mr2)**2)/2.d0/mz1      

c         emax = minv12/4.d0/mr1 - mr1
         
         n2 = (1-iswitchforidpart)*nphleg(2)+iswitchforidpart*nphleg(4)
c         call decayNG(nphleg(1),n2,mz1,emin,emax,mr1,mr2,
c     >               pp1,pp2,qpz1,phsp3b,w3b,iez1)

         call decayCRF(nphleg(1),n2,mz1,emin,emax,mr1,mr2,
     >               pp1,pp2,qpz1,phsp3b,w3b,iez1)

         wz1 = w3b
         w =  w * w3b
         phsp = phsp * phsp3b
      endif

*     Decaying Z2
      if (nphz2.eq.0) then
      ! pz2 --> pp3 pp4
         call wraprnd(rnd2,2)
         call decay2b(rnd2(1),rnd2(2),mz2,mr3,mr4,pp3,pp4,
     .        phsp2b,w2b,iez2)
         w =  w * w2b         
         phsp = phsp * phsp2b
      else
      ! pz2 --> pp3 pp4 qp      
         bz = sqrt(1.d0 - minv22/pz2(0)**2)
         gz = 1.d0/sqrt(1-bz**2)
         emin = gz * egmin * ( 1.d0 - bz) 

c         emin = egmin

         emax = (minv22+mr5**2-(mr3 + mr4)**2)/2.d0/mz2

c         emax = minv12/4.d0/mr3 - mr3
         
         n2 = (1-iswitchforidpart)*nphleg(4)+iswitchforidpart*nphleg(2)
c         call decayNG(nphleg(3),n2,mz2,emin,emax,mr3,mr4,
c     >               pp3,pp4,qpz2,phsp3b,w3b,iez2)

         call decayCRF(nphleg(3),n2,mz2,emin,emax,mr3,mr4,
     >               pp3,pp4,qpz2,phsp3b,w3b,iez2)

         wz2 = w3b
         w =  w * w3b         
         phsp = phsp * phsp3b
      endif

*** checking if sth went wrong in the Zs decays
      if ((iez1+iez2).gt.0) then
         ie = 1
         w = 0.d0
         phsp = 0.d0
         return
      endif

      if (ng.gt.0) then
**  Back into the H rest frame
         if (nphz1.ge.1) then
            do i = 1,nphz1
               q1 = qpz1(:,i)
               call new_boost(pz1,q1,q2,-1)
         ! checking if in the H rest frame the photons are too soft
               if (q2(0).lt.egmin) then 
                  ieq = ieq + 1
                  ie = 1
                  w = 0.d0
                  phsp = 0.d0
                  return
               endif
               qpz1(:,i) = q2
            enddo
c            if ((nphz1+nphz2).eq.6) print*,'Z1 ',qpz1(0,1:nphz1)
         endif
         if (nphz2.ge.1) then 
            do i = 1,nphz2
               q1 = qpz2(:,i)
               call new_boost(pz2,q1,q2,-1)
         ! checking if in the H rest frame the photons are too soft
               if (q2(0).lt.egmin) then
                  ieq = ieq + 1
                  ie = 1
                  w = 0.d0
                  phsp = 0.d0
                  return
               endif
               qpz2(:,i) = q2
            enddo
c            if ((nphz1+nphz2).eq.6) print*,'Z2 ',qpz2(0,1:nphz2)
         endif
      else
         qext(1,0) = 0.d0
         qext(1,1) = 0.d0
         qext(1,2) = 0.d0
         qext(1,3) = 0.d0
      endif
*** assigning the momenta
      if (iswitchforidpart.eq.0) then ! always the case if idpart = 0
        call new_boost(pz1,pp1,p1,-1)
        call new_boost(pz1,pp2,p2,-1)
        call new_boost(pz2,pp3,p3,-1)
        call new_boost(pz2,pp4,p4,-1)
      else
         call new_boost(pz1,pp1,p1,-1)
         call new_boost(pz1,pp2,p4,-1)
         call new_boost(pz2,pp3,p3,-1)
         call new_boost(pz2,pp4,p2,-1)
      endif
**** end decay of the two Zs

      phsp = duepigrechi*phsp

**** calculating here the regulator(s)
      if (ng.eq.0) then
         if (idpart.eq.1) then
            ! no need of any regulator if idpart = 0!!
            anum = bw(minv12)*bw(minv22)
c            q1 = p1 + p2
c            q2 = p3 + p4
c            q3 = p1 + p4
c            q4 = p2 + p3
            do k = 0,3
               q1(k) = p1(k) + p2(k)
               q2(k) = p3(k) + p4(k)
               q3(k) = p1(k) + p4(k)
               q4(k) = p2(k) + p3(k)
            enddo
            minv12 = dot(q1,q1)
            minv34 = dot(q2,q2)
            minv14 = dot(q3,q3)
            minv23 = dot(q4,q4)
            den = (bw(minv12)*bw(minv34) + bw(minv14)*bw(minv23))*0.5d0
            w = w * anum/den
         endif
         return ! ALWAYS RETURNING IF ng = 0
      endif

*** BELOW THIS POINT ONLY IF ng>0 ! if ng=0 the subroutine already returned. no need to check if ng>=1
c      if (ng.gt.0) then
      if (nphz1.gt.0) qall(:,        1: nphz1       ) = qpz1(:,1:nphz1)
      if (nphz2.gt.0) qall(:,(nphz1+1):(nphz1+nphz2)) = qpz2(:,1:nphz2)

** loading momenta in output
! doesn't work! -->   qext(1:ng,:) = qall(:,1:ng) ??
      do k = 0,3
         qext(1:ng,k) = qall(k,1:ng)
      enddo
**
      anum = 1.d0
      n1 = nphleg(1)
      n2 = nphleg(2)
      n3 = nphleg(3)
      n4 = nphleg(4)

      if (iswitchforidpart.eq.0) then ! always the case if idpart = 0
         if (n1.ge.1) then
            do i = 1,n1
               anum = anum * 1.d0/dot(p1,qall(:,i)) *qall(0,i)*p1(0)
               mothersph(i) = 1
            enddo
         endif
         if (n2.ge.1) then
            do i = n1+1,n1+n2
               anum = anum * 1.d0/dot(p2,qall(:,i)) *qall(0,i)*p2(0)
               mothersph(i) = 2
            enddo
         endif
         if (n3.ge.1) then
            do i = n1+n2+1,n1+n2+n3
               anum = anum * 1.d0/dot(p3,qall(:,i)) *qall(0,i)*p3(0)
               mothersph(i) = 3
            enddo
         endif
         if (n4.ge.1) then
            do i = n1+n2+n3+1,n1+n2+n3+n4
               anum = anum * 1.d0/dot(p4,qall(:,i)) *qall(0,i)*p4(0)
               mothersph(i) = 4
            enddo
         endif
      else
         if (n1.ge.1) then
            do i = 1,n1
               anum = anum * 1.d0/dot(p1,qall(:,i)) *qall(0,i)*p1(0)
               mothersph(i) = 1
            enddo
         endif
         if (n4.ge.1) then
            do i = n1+1,n1+n4
               anum = anum * 1.d0/dot(p4,qall(:,i)) *qall(0,i)*p4(0)
               mothersph(i) = 4
            enddo
         endif
         if (n3.ge.1) then
            do i = n1+n4+1,n1+n4+n3
               anum = anum * 1.d0/dot(p3,qall(:,i)) *qall(0,i)*p3(0)
               mothersph(i) = 3
            enddo
         endif
         if (n2.ge.1) then
            do i = n1+n4+n3+1,n1+n4+n3+n2
               anum = anum * 1.d0/dot(p2,qall(:,i)) *qall(0,i)*p2(0)
               mothersph(i) = 2
            enddo
         endif
      endif

c$$$      if (iswitchforidpart.eq.0) then ! always the case if idpart = 0
c$$$         if ((n1+n2).ge.1) then
c$$$            do i = 1,n1+n2
c$$$               anum = anum *(
c$$$     .              1.d0/dot(p1,qall(:,i)) *qall(0,i)*p1(0)
c$$$     .           +  1.d0/dot(p2,qall(:,i)) *qall(0,i)*p2(0)
c$$$     .              ) * 0.5d0
c$$$               mothersph(i) = 1
c$$$            enddo
c$$$         endif
c$$$         if ((n3+n4).ge.1) then
c$$$            do i = n1+n2+1,n1+n2+n3+n4
c$$$               anum = anum * (
c$$$     .              1.d0/dot(p3,qall(:,i)) *qall(0,i)*p3(0)
c$$$     .           +  1.d0/dot(p4,qall(:,i)) *qall(0,i)*p4(0)               
c$$$     .              ) * 0.5d0
c$$$               mothersph(i) = 3
c$$$            enddo
c$$$         endif
c$$$      else
c$$$         if (n1.ge.1) then
c$$$            do i = 1,n1
c$$$               anum = anum * 1.d0/dot(p1,qall(:,i)) *qall(0,i)*p1(0)
c$$$               mothersph(i) = 1
c$$$            enddo
c$$$         endif
c$$$         if (n4.ge.1) then
c$$$            do i = n1+1,n1+n4
c$$$               anum = anum * 1.d0/dot(p4,qall(:,i)) *qall(0,i)*p4(0)
c$$$               mothersph(i) = 4
c$$$            enddo
c$$$         endif
c$$$         if (n3.ge.1) then
c$$$            do i = n1+n4+1,n1+n4+n3
c$$$               anum = anum * 1.d0/dot(p3,qall(:,i)) *qall(0,i)*p3(0)
c$$$               mothersph(i) = 3
c$$$            enddo
c$$$         endif
c$$$         if (n2.ge.1) then
c$$$            do i = n1+n4+n3+1,n1+n4+n3+n2
c$$$               anum = anum * 1.d0/dot(p2,qall(:,i)) *qall(0,i)*p2(0)
c$$$               mothersph(i) = 2
c$$$            enddo
c$$$         endif
c$$$      endif
      
      anum = anum*bw(minv12)*bw(minv22)
c      goto 666
!!! WOW!!
      call handregulator(ng,p1,p2,p3,p4,qall(:,1:ng),den)
!!!!!!!!
      w = w*anum/den
      return                    !! RETURNING

c$$$      do k = 0,3
c$$$         q1(k) = p1(k) + p2(k) + q(k)
c$$$         q2(k) = p3(k) + p4(k)
c$$$         q3(k) = p1(k) + p2(k)
c$$$         q4(k) = p3(k) + p4(k) + q(k)
c$$$      enddo

 666  continue

      q = qall(:,1)

      q1 = p1+p2+q
      q2 = p3+p4
      q3 = p1+p2
      q4 = p3+p4+q

      minv12q = dot(q1,q1)
      minv34  = dot(q2,q2)
      minv12  = dot(q3,q3)
      minv34q = dot(q4,q4)

c      minv12q = dot(p1+p2+q,p1+p2+q)
c      minv34  = dot(p3+p4,p3+p4)
c      minv12  = dot(p1+p2,p1+p2)
c      minv34q = dot(p3+p4+q,p3+p4+q)

      coll1 = p1(0)/dot(p1,q)*q(0)!*an1
      coll2 = p2(0)/dot(p2,q)*q(0)!*an2
      coll3 = p3(0)/dot(p3,q)*q(0)!*an3
      coll4 = p4(0)/dot(p4,q)*q(0)!*an4

      den = (bw(minv12q) * bw(minv34) *(coll1+coll2) +
     .      i34* bw(minv12)  * bw(minv34q)*(coll3+coll4))

      if (idpart.eq.1) then
c$$$         do k = 0,3
c$$$            q1(k) = p1(k) + p4(k) + q(k)
c$$$            q2(k) = p2(k) + p3(k)
c$$$            q3(k) = p1(k) + p4(k)
c$$$            q4(k) = p2(k) + p3(k) + q(k)
c$$$         enddo

         q1 = p1+p4+q
         q2 = p2+p3
         q3 = p1+p4
         q4 = p2+p3+q

         minv14q = dot(q1,q1)
         minv23  = dot(q2,q2)
         minv14  = dot(q3,q3)
         minv23q = dot(q4,q4)

c         minv14q = dot(p1+p4+q,p1+p4+q)
c         minv23  = dot(p2+p3,p2+p3)
c         minv14  = dot(p1+p4,p1+p4)
c         minv23q = dot(p2+p3+q,p2+p3+q)


         den = (den
     .        + bw(minv14q) * bw(minv23) * (coll1+coll4)
     .        + bw(minv14)  * bw(minv23q)* (coll2+coll3)
     .        )*0.5d0
      endif

      w = w * anum/den
      
c      endif

      return
      end
*********************************************************************
      subroutine get_regulatorNG(ng,p1,p2,p3,p4,q,den)
      implicit none
      integer ng,k,m,n,ngl,k1,k2,k3,k4,s1,s2,s3,s4
c      double precision ql(0:3,0:ng)
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3),q(0:3,ng)
      double precision pz12(0:3),pz34(0:3),pz14(0:3),pz23(0:3)
      double precision qtmp(0:3),ptmp(0:3)
      double precision p1p2(0:3),p3p4(0:3),p1p4(0:3),p2p3(0:3)
      double precision den,collt(4,ng)
      integer i,j,l
      integer idpart
      common/identicalparticles/idpart

      integer indexes(ng),dngm1,div
      integer indexes1(ng),indexes2(ng),indexes3(ng),indexes4(ng)

      double precision dot,bw,coll1,coll2,coll3,coll4,coll
      external bw,dot
! using Fortran 90/95 features, for readability and (maybe) speed....

      p1p2 = p1 + p2
      p3p4 = p3 + p4
      if (idpart.eq.1) then
         p1p4 = p1 + p4
         p2p3 = p2 + p3
      endif

      do k = 1,ng
         collt(1,k) = p1(0)*q(0,k)/dot(p1,q(:,k))
         collt(2,k) = p2(0)*q(0,k)/dot(p2,q(:,k))
         collt(3,k) = p3(0)*q(0,k)/dot(p3,q(:,k))
         collt(4,k) = p4(0)*q(0,k)/dot(p4,q(:,k))
      enddo


      den = 0.d0

c      iand(k1,k2).ne.0 means that at least one photon is present in both k1 and k2,
c      which can not be!
      dngm1 = 2**ng-1
      do k1 = 0,dngm1
      do k2 = 0,dngm1-k1
         if (iand(k2,k1).ne.0) cycle ! "cycle" cycles the innermost do-loop (in this case k2)
      do k3 = 0,dngm1-k1-k2
         if (iand(k2,k3).ne.0.or.iand(k1,k3).ne.0) cycle
         k4 =   dngm1-k1-k2-k3

* initializing pzXY and coll for this photon configuration
         pz12 = p1p2
         pz34 = p3p4
         if (idpart.eq.1) then
            pz14 = p1p4
            pz23 = p2p3
         endif
         coll = 1.d0
****************************************************

         div = 1
         do n = 1,ng
**************
! do not touch this! :O
            s4 = n*iand(k1,div)/div
            s3 = n*iand(k2,div)/div
            s2 = n*iand(k3,div)/div
            s1 = n*iand(k4,div)/div
            div=div*2
**************
            if (s1.gt.0) then
               coll = coll*collt(1,s1)
               pz12 = pz12 + q(:,s1)
               if (idpart.eq.1) pz14 = pz14 + q(:,s1)
            endif
            if (s2.gt.0) then
               coll = coll*collt(2,s2)
               pz12 = pz12 + q(:,s2)
               if (idpart.eq.1) pz23 = pz23 + q(:,s2)
            endif
            if (s3.gt.0) then
               coll = coll*collt(3,s3)
               pz34 = pz34 + q(:,s3)
               if (idpart.eq.1) pz23 = pz23 + q(:,s3)
            endif
            if (s4.gt.0) then
               coll = coll*collt(4,s4)
               pz34 = pz34 + q(:,s4)
               if (idpart.eq.1) pz14 = pz14 + q(:,s4)
            endif

c            den=den+bw(dot(pz12,pz12))*bw(dot(pz34,pz34))*coll !! WRONG HERE
c            if (idpart.eq.1)
c     .      den=den+bw(dot(pz14,pz14))*bw(dot(pz23,pz23))*coll

         enddo

         den=den+bw(dot(pz12,pz12))*bw(dot(pz34,pz34))*coll !!! IT'S HERE
         if (idpart.eq.1)
     .        den=den+bw(dot(pz14,pz14))*bw(dot(pz23,pz23))*coll

      enddo
      enddo
      enddo
      
      if (idpart.eq.1) den = den*0.5d0

      return
      end
*********************************************************************
      subroutine get_pattern_OPT2(ncharged,sc1,sc2,mass,n,ep,w)
      implicit none
      integer n,ncharged,k,ie
      double precision mass(5),prob(4),w
      double precision sc1,sc2,part,coll1,coll2
      double precision csi(1),anorm
      integer nmaxph
      parameter (nmaxph = 50)
      integer ep(nmaxph)

! sc1 > 2*m1 always. So collX > 0 always, because 2*log(2) > 1.
      coll1 = 2.d0*log(sc1/mass(1)) - 1.d0
      coll2 = 2.d0*log(sc2/mass(3)) - 1.d0

      anorm = 0.5d0/(coll1 + coll2)

      prob(1) = coll1*anorm
      prob(2) = prob(1)
      prob(3) = coll2*anorm
      prob(4) = prob(3)

      w = 1.d0

      do k = 1,n
         call wraprnd(csi,1)
         ie = 1
         part = prob(ie)
         do while(part.lt.csi(1))
            ie = ie + 1
            part = part + prob(ie)
         enddo
         ep(k) = ie
         w = w*1.d0/prob(ie)
      enddo
      return
      end
***********************************
      subroutine get_pattern_OPT(ncharged,scale,mass,n,ep,w)
      implicit none
      integer n,ep(n),ncharged,k,ie
      double precision mass(5),prob(4),w
      double precision scale,part,al1,al2
      double precision csi(1),anorm

c      al1 = log(scale/mass(1)**2) - 1.d0
c      al2 = log(scale/mass(3)**2) - 1.d0

      al1 = 2.d0*log(scale/mass(1)) - 1.d0
      al2 = 2.d0*log(scale/mass(3)) - 1.d0
c i.e. 
c      al1 = log(scale**2/mass(1)**2) - 1.d0
c      al2 = log(scale**2/mass(3)**2) - 1.d0
c !!!

      anorm = 1.d0/(al1 + al2)/2.d0

      prob(1) = al1*anorm
      prob(2) = prob(1)
      prob(3) = al2*anorm
      prob(4) = al2*anorm

      w = 1.d0

      do k = 1,n
         call wraprnd(csi,1)
         ie = 1
         part = prob(ie)
         do while(part.lt.csi(1))
            ie = ie + 1
            part = part + prob(ie)
         enddo
         ep(n) = ie

         w = w*1.d0/prob(ie)

      enddo

      return
      end
***********************************
      subroutine get_pattern(ncharged,n,ep)
      integer n,ep(n),ncharged,k
      double precision csi(1)
      do k = 1,n
         call wraprnd(csi,1)
         ep(k) = 1.d0*ncharged*csi(1) + 1
         if (ep(k).gt.ncharged) ep(k) = ncharged ! to avoid round-offs...
      enddo
      return
      end
**************************************************
      subroutine regulator(nch,ich,idir,mass,ph,p1,p2,p3,p4,q,reg,regi)
      implicit double precision (a-h,m,l,o-z)
      double precision numeratore
      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3),q(0:3)
      dimension ptmp(0:3),q2(0:3),q3(0:3),q4(0:3),q1(0:3)
      dimension coll(4),ph(0:3),mass(5)
      dimension q5(0:3),q6(0:3),q7(0:3),q8(0:3)
      parameter (pi = 3.1415926535897932384626433832795029D0)

      common/ifirst_reg/ifirst
      data ifirst /0/

! Now 4 channels (ichzdec)  are possible:
! 1) p1z --> p1 p2 q  and  p2z --> p3 p4    ich = 1 
! 2) p1z --> p1 p2    and  p2z --> p3 p4 q  ich = 2
! 3) p1z --> p1 p4 q  and  p2z --> p3 p2    ich = 3
! 4) p1z --> p1 p4    and  p2z --> p3 p2 q  ich = 4

      i34on = nch/2 - 1

      do k = 0,3
         q1(k) = p1(k) + p2(k) + q(k)
         q2(k) = p3(k) + p4(k)
         q3(k) = p1(k) + p2(k)
         q4(k) = p3(k) + p4(k) + q(k)
         q5(k) = p1(k) + p4(k) + q(k)
         q6(k) = p2(k) + p3(k)
         q7(k) = p1(k) + p4(k)
         q8(k) = p2(k) + p3(k) + q(k)
      enddo
      minv12q = dot(q1,q1)
      minv34  = dot(q2,q2)
      minv12  = dot(q3,q3)
      minv34q = dot(q4,q4)
      minv14q = dot(q5,q5)
      minv23  = dot(q6,q6)
      minv14  = dot(q7,q7)
      minv23q = dot(q8,q8)

      coll(1) = p1(0)/dot(p1,q) 
      coll(2) = p2(0)/dot(p2,q)
      coll(3) = p3(0)/dot(p3,q)
      coll(4) = p4(0)/dot(p4,q)

      coll12 = coll(1) + coll(2)
      coll34 = coll(3) + coll(4)
      coll14 = coll(1) + coll(4)
      coll23 = coll(2) + coll(3)

      q2min   = 0.d0     !(mass(1) + mass(2) + mass(5))**2
      q2max   = ph(0)**2 !(ph(0) - mass(3) - mass(4))**2
      mnrm12q = bwnorm(q2max,q2min)
      q2min   = 0.d0
      q2max   = (ph(0) - sqrt(minv34))**2
      mnrm12qs = bwnorm(q2max,q2min)


      q2min   = 0.d0     !(mass(3) + mass(4))**2
      q2max   = (ph(0) - sqrt(minv12q))**2
      mnrm34  = bwnorm(q2max,q2min)
      mnrm34s  = mnrm12q


      q2min   = 0.d0     !(mass(1) + mass(2))**2
      q2max   = ph(0)**2 !(ph(0) - mass(3) - mass(4) - mass(5))**2
      mnrm12  = bwnorm(q2max,q2min)
      q2max   = (ph(0) - sqrt(minv34q))**2
      mnrm12s  = bwnorm(q2max,q2min)


      q2min   = 0.d0     !(mass(3) + mass(4) + mass(5))**2
      q2max   = (ph(0) - sqrt(minv12))**2
      mnrm34q = bwnorm(q2max,q2min)
      mnrm34qs  = mnrm12q

      q2min   = 0.d0     !(mass(1) + mass(4) + mass(5))**2
      q2max   = ph(0)**2 !(ph(0) - mass(3) - mass(2))**2
      mnrm14q = bwnorm(q2max,q2min)
      q2max   = (ph(0) - sqrt(minv23))**2
      mnrm14qs = bwnorm(q2max,q2min)


      q2min   = 0.d0     !(mass(3) + mass(2))**2
      q2max   = (ph(0) - sqrt(minv14q))**2
      mnrm23  = bwnorm(q2max,q2min)
      mnrm23s  = mnrm12q


      q2min   = 0.d0     !(mass(1) + mass(4))**2
      q2max   = ph(0)**2 !(ph(0) - mass(3) - mass(2) - mass(5))**2
      mnrm14  = bwnorm(q2max,q2min)
      q2max   = (ph(0) - sqrt(minv23q))**2
      mnrm14s = bwnorm(q2max,q2min)


      q2min   = 0.d0     !(mass(3) + mass(2) + mass(5))**2
      q2max   = (ph(0) - sqrt(minv14))**2
      mnrm23q = bwnorm(q2max,q2min)
      mnrm23qs = mnrm12q

      denominatore = bw(minv12q)* bw(minv34) *coll12*
     >        (1.d0/mnrm12q/mnrm34 + 1.d0/mnrm12qs/mnrm34s) +
     >               bw(minv12) * bw(minv34q)*coll34*
     >        (1.d0/mnrm12/mnrm34q + 1.d0/mnrm12s/mnrm34qs) +
     >       i34on * bw(minv14q)* bw(minv23) *coll14*
     >        (1.d0/mnrm14q/mnrm23 + 1.d0/mnrm14qs/mnrm23s) +
     >       i34on * bw(minv14) * bw(minv23q)*coll23*
     >        (1.d0/mnrm14/mnrm23q + 1.d0/mnrm14s/mnrm23qs)

      if (ich.eq.1.and.idir.eq.1) numeratore = 
     >     bw(minv12q)*bw(minv34)*coll(1)*
     >    (1.d0/mnrm12q/mnrm34 + 1.d0/mnrm12qs/mnrm34s)
      if (ich.eq.1.and.idir.eq.2) numeratore = 
     >     bw(minv12q)*bw(minv34)*coll(2)*
     >    (1.d0/mnrm12q/mnrm34 + 1.d0/mnrm12qs/mnrm34s)

      if (ich.eq.2.and.idir.eq.1) numeratore = 
     >     bw(minv12) *bw(minv34q)*coll(3)*
     >    (1.d0/mnrm12/mnrm34q + 1.d0/mnrm12s/mnrm34qs)
      if (ich.eq.2.and.idir.eq.2) numeratore = 
     >     bw(minv12) *bw(minv34q)*coll(4)*
     >    (1.d0/mnrm12/mnrm34q + 1.d0/mnrm12s/mnrm34qs)

      if (ich.eq.3.and.idir.eq.1) numeratore = 
     >     bw(minv14q)*bw(minv23)*coll(1)*
     >    (1.d0/mnrm14q/mnrm23 + 1.d0/mnrm14qs/mnrm23s)
      if (ich.eq.3.and.idir.eq.2) numeratore = 
     >     bw(minv14q)*bw(minv23)*coll(4)*
     >    (1.d0/mnrm14q/mnrm23 + 1.d0/mnrm14qs/mnrm23s)

      if (ich.eq.4.and.idir.eq.1) numeratore =
     >     bw(minv14) *bw(minv23q)*coll(2)*
     >    (1.d0/mnrm14/mnrm23q + 1.d0/mnrm14s/mnrm23qs)
      if (ich.eq.4.and.idir.eq.2) numeratore =
     >     bw(minv14) *bw(minv23q)*coll(3)*
     >   (1.d0/mnrm14/mnrm23q + 1.d0/mnrm14s/mnrm23qs)

*      reg = 8.d0*numeratore/denominatore
*      regi = 8.d0 * numeratore

      reg  = 2.d0*nch*numeratore/denominatore
      regi = 2.d0*nch*numeratore
      return
      end
**************************************************
      function bw(s)
      implicit double precision (a-h,o-z)
      common/zparam/zmass,zwidth
      common/bwcommon/zm2,zm2w2,ifirst
      data ifirst /0/
      if (ifirst.eq.0) then
         zm2   = zmass*zmass
         zm2w2 = zm2*zwidth*zwidth
         ifirst = 1
      endif
      bw = (s-zm2)*(s-zm2)+zm2w2     
      bw = 1.d0/bw
c      bw = 1.d0/((s - zmass**2)**2 + zwidth**2*zmass**2)
      return
      end
*******************************
      subroutine regulator4f(nch,ich,mass,ph,p1,p2,p3,p4,q,reg,regi)
      implicit double precision (a-h,m,l,o-z)
      double precision numeratore
      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3),q(0:3)
      dimension ph(0:3),mass(5)
      dimension ptmp(0:3),q2(0:3),q3(0:3),q4(0:3),q1(0:3)
      parameter (pi = 3.1415926535897932384626433832795029D0)

      common/ifirst_reg4f/ifirst
      data ifirst /0/

c$$$      if (ifirst.eq.0) then
c$$$         print*,' '
c$$$         print*,' WARNING: REGULATOR = 1 !!!! '
c$$$         print*,' '
c$$$         ifirst = 1
c$$$      endif
c$$$      reg = 1.d0
c$$$      return

! Channels:
! 1) p1z --> p1 p2 and  p2z --> p3 p4  ich = 1 
! 2) p1z --> p1 p4 and  p2z --> p3 p2  ich = 2

      do k = 0,3
         q1(k) = p1(k) + p2(k)
         q2(k) = p3(k) + p4(k)
         q3(k) = p1(k) + p4(k)
         q4(k) = p3(k) + p2(k)
      enddo
      minv12 = dot(q1,q1)
      minv34 = dot(q2,q2)
      minv14 = dot(q3,q3)
      minv23 = dot(q4,q4)

      mnrm12 = bwnorm(ph(0)**2,0.d0)
      mnrm34 = bwnorm((ph(0)-sqrt(minv12))**2,0.d0)
      mnrm14 = bwnorm(ph(0)**2,0.d0)
      mnrm23 = bwnorm((ph(0)-sqrt(minv14))**2,0.d0)

! for switched configurations...
      mnrm12s = bwnorm((ph(0)-sqrt(minv34))**2,0.d0)
      mnrm34s = mnrm12
      mnrm14s = bwnorm((ph(0)-sqrt(minv23))**2,0.d0)
      mnrm23s = mnrm14

      denominatore = bw(minv12)*bw(minv34)* 
     >     (1.d0/mnrm12/mnrm34 + 1.d0/mnrm12s/mnrm34s) +
     >     (nch-1) * bw(minv14)*bw(minv23)*
     >     (1.d0/mnrm14/mnrm23 + 1.d0/mnrm14s/mnrm23s)

      if (ich.eq.1) numeratore = bw(minv12)*bw(minv34)*
     >     (1.d0/mnrm12/mnrm34 + 1.d0/mnrm12s/mnrm34s) 
      if (ich.eq.2) numeratore = bw(minv14)*bw(minv23)*
     >     (1.d0/mnrm14/mnrm23 + 1.d0/mnrm14s/mnrm23s)

c      reg = 2.d0*numeratore/denominatore
c      regi = 2.d0 * numeratore

      reg  = nch*numeratore/denominatore
      regi = nch * numeratore

      return
      end
**************************************************
      function bwnorm(q2max,q2min)
      implicit double precision (a-h,o-z)
      common/zparam/zmass,zwidth
      common/bwnormcommon/uozmzw,zmszw,ifirst
      data ifirst/0/
      if (ifirst.eq.0) then
         uozmzw = 1.d0/zmass/zwidth
         zmszw  = zmass/zwidth
         ifirst = 1
      endif
c      am = zmass
c      ag = zwidth      
c      bwnorm = 1.d0/(am*ag)*( atan( q2max/am/ag-am/ag )
c     >        - atan( q2min/am/ag-am/ag ) )

c      bwnorm=1.d0/(zmass*zwidth)*(atan(q2max/zmass/zwidth-zmass/zwidth)
c     >        - atan( q2min/zmass/zwidth-zmass/zwidth ) )

      bwnorm=uozmzw*(atan(q2max*uozmzw-zmszw)
     >        - atan( q2min*uozmzw -zmszw) )
      return
      end
