      subroutine init_apar
      implicit double precision (a-h,m,o-z)
      double precision i3f1
      common/photonmass/mg ! common for routine propagator in Asu3.f

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed
      
      integer ionlytop,omt
      common/onlytop/ionlytop,omt
      data ionlytop,omt /0,1/

      double complex SigZZ,dSigZZ
      double complex SigW,dSigW
      external SigZZ,dSigZZ,SigW,dSigW

      common/FSmasses/ame,amm

      double precision zmasspdg,zwidthpdg,wmasspdg,wwidthpdg
      common/WZpdgvalues/zmasspdg,zwidthpdg,wmasspdg,wwidthpdg

      integer anm_cpg,basis,quadratics,CP
      common/anm/anm_cpg,basis,quadratics,CP

      
#include "couplingandmasses.h"

      czero = (0.d0,0.d0)
      cone  = (1.d0,0.d0)
      im    = (0.d0,1.d0)
      pi    = 4.d0*atan(1.d0)
      pi2   = pi * pi

      wwonoff = 1.d0
      zwonoff = 1.d0

c$$$      print*, "Z boson width set to zero!!!"
c$$$      print*, "Z boson width set to zero!!!"
c$$$      print*, "Z boson width set to zero!!!"
c$$$      print*, " "
c$$$      wwonoff = 0d0
c$$$      zwonoff = 0d0
            
      call setmassesandconstants

** translation to fixed-width scheme
      zmass = zmasspdg/sqrt(1.d0+zwidthpdg**2/zmasspdg**2)
      wmass = wmasspdg/sqrt(1.d0+wwidthpdg**2/wmasspdg**2)

      zwidth = zwidthpdg/sqrt(1.d0+zwidthpdg**2/zmasspdg**2)
      wwidth = wwidthpdg/sqrt(1.d0+wwidthpdg**2/wmasspdg**2)


      
      sth = sqrt((zmass*zmass - wmass*wmass)/zmass/zmass)
      cth = sqrt(1.d0 - sth*sth)

      g_gf    = sqrt ( 4d0*sqrt(2d0)*gfermi* wmass*wmass )
      g_alpha = 1.d0/sth*sqrt(4.d0*pi*alpha0)

      g = g_gf ! g_alpha

      V = wmass/cth/cth

      I3F1 = -0.5D0
      QF1  = -1.D0

      GV1= 1.D0/2.D0/cth*(I3F1 - 2.D0*QF1*sth*sth)

      GA1= 1.D0/2.D0/cth*I3F1
      GV3= GV1
      GA3= GA1

      alphaGF = (g * sth)**2/4.d0/pi
      
      alpha = alphaGF


      
      rescaleQED = 1.d0
c      print*,'QED rescaled to alpha0!'
      rescaleQED = alpha0/alpha

      ME = ame
      MM = amm
      MH = masshiggs

      alpho4pi = alpha/4.d0/pi

      elc2   = 4.d0*pi * alpha
      elc    = sqrt(elc2)

      mz2r = zmass*zmass
      mw2r = wmass*wmass

      cme2    = cmplx(me*me)
      cmm2    = cmplx(mm*mm)
      cmtau2  = cmplx(mtau*mtau)
      cmup2   = cmplx(mup*mup)
      cmdown2 = cmplx(mdown*mdown)
      cmc2    = cmplx(mc*mc)
      cms2    = cmplx(ms*ms)
      cmb2    = cmplx(mb*mb)

! calculating top width
      twidth = GFERMI * (tmass**2-mw2r)**2*(tmass**2+2.d0*mw2r)
      twidth = twidth/8.d0/pi/sqrt(2.d0)/tmass**3
      
      I3F1 = -0.5D0
      QF1  = -1.D0

*** #### REAL COUPLINGS ***********************
! nota che V*g = -im * CHZZ perchè elc = g * sth !!
      CHZZ  =  im*elc*wmass/sth/cth/cth
      CHHZZ =  im * elc2 * 0.5d0/sth/sth/cth/cth
      CHWW  =  im*elc*wmass/sth
      CZWW  = -im*elc* (-cth/sth) ! A.7
      CAWW  = -im*elc             ! A.7

      CHtt = -im * elc * 0.5d0 /sth/sqrt(mw2r)*tmass
      CHbb = -im * elc * 0.5d0 /sth/sqrt(mw2r)*mb

      CWZPhi  = -im*elc*sqrt(mw2r)*sth/cth
      CWAPhi  = -im*elc*sqrt(mw2r)
      CWHPhip = im * elc / sth * 0.5d0
      CWHPhim = -CWHPhip
      CWHPhi  =  CWHPhip
      CAPhiPhi = im*elc * (-1.d0)
      CZPhiPhi = im*elc * (-(sth**2-cth**2)/2.d0/sth/cth)
      CHPhiPhi = im*elc*(-1.d0*masshiggs*masshiggs/sqrt(mw2r)/2.d0/sth)
      CAGG     = im*elc
      CZGG     = im*elc * cth/sth
      CHGG     = im*elc * (-1.d0 * sqrt(mw2r)/2.d0/sth)

      CWWAA     = -im * elc * elc
      CWWZZ     = -im * elc * elc * cth**2/sth**2
      CWWAZ     =  im * elc * elc * cth/sth
      CAAPhiPhi =  im * elc * elc * 2.d0
      CZZPhiPhi =  im * elc * elc *(sth**2-cth**2)**2/2.d0/sth**2/cth**2
      CAZPhiPhi =  im * elc * elc * (sth**2-cth**2)/sth/cth
      CHZWPhi   =  im * elc * elc * (-1.d0/2.d0/cth)
      CHAWPhi   =  im * elc * elc * (-1.d0/2.d0/sth)

      CHHH      = -im*elc*masshiggs**2/sqrt(mw2r)*3.d0/2.d0/sth 
      CZHChi    =  elc * 0.5d0 /sth/cth
      CHChiChi  = -im*elc*masshiggs**2/sqrt(mw2r)*1.d0/2.d0/sth 
      CZZChiChi =  CHHZZ

      g    = im * elc /sth

! boson to fermions couplings, as in PhD Denner and ***DIVIDED BY g***
      gv = 1.D0/2.D0/cth*(I3F1 - 2.D0*QF1*sth*sth) ! Z \to f \bar(f) vector coupling
      ga = 1.D0/2.D0/cth*I3F1                      ! Z \to f \bar(f) axial coupling
      gw = 1.D0/2.D0/SQRT(2.D0)                    ! W \to f \bar(\nu) vector and axial coupling
      gnu = 1.D0/4.D0/cth                          ! Z \to \nu \bar(\nu) vector and axial coupling
      gvg = sth                                    ! A \to f \bar(f) vector (and only one) coupling

! top couplings!!
      gvgt = -2.d0/3.d0 * sth
      gvt = 0.5d0/cth* (0.5d0 - 2.d0 * 2.d0/3.d0*sth*sth)
      gat = 0.5d0/cth * 0.5d0 

! bottom couplings
      gvgb = 1.d0/3.d0 * sth
      gvb  = 0.5d0/cth* (-0.5d0 + 2.d0 * 1.d0/3.d0*sth*sth)
      gab  = 0.5d0/cth * (-0.5d0)


      if(anm_cpg .gt. 0) then
         goto 111
      endif

c$$$      print*, "Real couplings!!!"
c$$$      print*, "Real couplings!!!"
c$$$      print*, "Real couplings!!!"
c$$$      print*, " " 
c$$$      goto 111


*** #### COMPLEX COUPLINGS ***********************
c      DO K = 1,100
! complex masses
      mtop2 = tmass*tmass - im*tmass*twidth !* 0.d0
      mw2   = wmass*wmass - im*wmass*wwidth !* 0.d0
      mz2   = zmass*zmass - im*zmass*zwidth !* 0.d0
! complex sin and cos 
      sw2   = (mz2-mw2)/mz2
      cw2   = 1.d0 - sw2      
      sw    = sqrt(sw2)
      cw    = sqrt(cw2)
**
      CHZZ  =  im*elc*sqrt(mw2)/sw/cw2
      CHHZZ =  im * elc * elc  * 0.5d0/sw2/cw2
      CHWW  =  im * elc * sqrt(mw2)/sw
      CZWW  = -im*elc* (-cw/sw)
      CAWW  = -im*elc

      CHtt = -im * elc * 0.5d0 /sw/sqrt(mw2)*sqrt(mtop2)
      CHbb = -im * elc * 0.5d0 /sw/sqrt(mw2)*sqrt(cmb2)

      CWZPhi  = -im*elc*sqrt(mw2)*sw/cw
      CWAPhi  = -im*elc*sqrt(mw2)
      CWHPhip =  im * elc / sw * 0.5d0
      CWHPhim = -CWHPhip
      CWHPhi  =  CWHPhip
      CAPhiPhi = im*elc * (-1.d0)
      CZPhiPhi = im*elc * (-(sw2-cw2)/2.d0/sw/cw)
      CAGG     =  im*elc
      CZGG     = -im*elc * cw/sw
      CHGG     =  im*elc * (-1.d0 * sqrt(mw2)/2.d0/sw)

      CWWAA     = -im * elc * elc
      CWWZZ     = -im * elc * elc * cw2/sw2
      CWWAZ     =  im * elc * elc * cw/sw
      CAAPhiPhi =  im * elc * elc * 2.d0
      CZZPhiPhi =  im * elc * elc * (sw2-cw2)**2/2.d0/sw2/cw2
      CAZPhiPhi =  im * elc * elc * (sw2-cw2)/sw/cw
      CHZWPhi   =  im * elc * elc * (-1.d0/2.d0/cw)
      CHAWPhi   =  im * elc * elc * (-1.d0/2.d0/sw)

      CZHChi    =  elc * 0.5d0 /sw/cw
      CZZChiChi =  CHHZZ

*** higgs mass dependent couplings
      CHPhiPhi = -im*elc*masshiggs**2/sqrt(mw2)/2.d0/sw
      CHHH     = -im*elc*masshiggs**2/sqrt(mw2)*1.5d0/sw
      CHChiChi = -im*elc*masshiggs**2/sqrt(mw2)*0.5d0/sw
****
      g = im * elc /sw

! boson to fermions couplings, as in PhD Denner and ***DIVIDED BY g***
      gv   = 1.D0/2.D0/cw*(I3F1 - 2.D0*QF1*sw2)
      ga   = 1.D0/2.D0/cw*I3F1
      gw   = 1.D0/2.D0/SQRT(2.D0)
      gnu  = 1.D0/4.D0/cw
      gvg  = sw

! top couplings
      gvgt = -2.d0/3.d0 * sw
      gvt  = 0.5d0/cw* (0.5d0 - 2.d0 * 2.d0/3.d0*sw2)
      gat  = 0.5d0/cw * 0.5d0 

! bottom couplings
      gvgb = 1.d0/3.d0 * sw
      gvb  = 0.5d0/cw* (-0.5d0 + 2.d0 * 1.d0/3.d0*sw2)
      gab  = 0.5d0/cw * (-0.5d0)

 111  continue
***
*** useful products, used to compact Form outputs...
      gvg2  = gvg*gvg
      gvg4  = gvg2*gvg2
      gvgs  = conjg(gvg)
      gvgm2 = gvg*gvgs

      gv2  = gv*gv
      ga2  = ga*ga
      gvs  = conjg(gv)
      gas  = conjg(ga)
      gvs2 = gvs*gvs
      gas2 = gas*gas

      gv4 = gv2*gv2
      ga4 = ga2*ga2

      gvga   = gv*ga 
      gvsgas = gvs*gas
      gvgas  = gv*gas
      gvsga  = gvs*ga

      gvm2 = gv*gvs
      gam2 = ga*gas

      gvm22 = gvm2*gvm2
      gam22 = gam2*gam2

      gvgt2 = gvgt*gvgt
      gvt2  = gvt*gvt
      gat2  = gat*gat

      gvgb2 = gvgb*gvgb
      gvb2  = gvb*gvb
      gab2  = gab*gab

      gw2 = gw*gw
      gw4 = gw2*gw2

      gnu2 = gnu*gnu

!! setting CTS at the first run, modified if needed in virtual.F
      call get_counterterms(masshiggs*masshiggs)
***********************************************************************************
      kfm = 1.d0
      kfm = 0.d0 ! kfm = 0 kills fermion masses in weak pentagons, boxes, weak vertexes
                 ! this is to avoid LT problems in phase space corners. It is also faster.
                 ! kfm = 1 keeps physical fermion masses.
***********************************************************************************
      return
      end


      double precision function factorial(n)
      implicit none
      integer n,nl,k,nfactorial      
      double precision factarray(0:15)
      common/factarray/factarray
      data factarray /
     .     1d0,
     .     1d0,
     .     2d0,
     .     6d0,
     .     24d0,
     .     120d0,
     .     720d0,
     .     5040d0,
     .     40320d0,
     .     362880d0,
     .     3628800d0,
     .     39916800d0,
     .     479001600d0,
     .     6227020800d0,
     .     87178291200d0,
     .     1307674368000d0/
      if (n.le.15) then
         factorial = factarray(n)
         return
      endif
      nl = n
      factorial = 1.d0
      do while(nl.gt.0)
         factorial = 1.d0*nl * factorial
         nl = nl - 1
      enddo
      return
      end
**************************************************
      subroutine initlooptools
      implicit double precision (a-h,o-z)
      double precision mudim

      double precision phmass,egmin
      COMMON/INFRAR/phmass,egmin

      double precision mass(5)
      common/amasses/mass
#include "looptools.h"
      
#ifdef LT210
      call ltini
#endif
#ifdef LT28
      call ltini
#endif
#ifdef LT25
      call ffini
#endif
      deltauv= 0.d0
      mudim= 1.d0

c      mudim= 100.d0

c      deltauv= 100.d0
c      mudim= 0.05d0

      call setdelta(deltauv)
      call setmudim(mudim)

      call setversionkey(0*KeyBget + 0*KeyC0   + 0*KeyD0
     .                 + 0*KeyD0C  + 0*KeyEget + 0*KeyEgetC)

! default 9
c      print*,'WARNING: changed warning digits from 9 to 12 in LT'
c      call setwarndigits(12)

c      call setdebugkey(DebugAll)

c      call setmaxdev(1d-5)

      call setlambda(phmass**2)
      return
      end

***************************************************
*** Levi-Civita tensor contracted with 4 momenta
      double complex function epsfun(q1,q2,q3,q4)
      implicit double precision (a-h,o-z)
      dimension q1(0:3),q2(0:3),q3(0:3),q4(0:3)

      e = q1(1)*q2(2)*q3(3)*q4(0) - q1(1)*q2(2)*q3(0)*q4(3) +
     .    q1(1)*q2(3)*q3(0)*q4(2) - q1(1)*q2(3)*q3(2)*q4(0) +
     .    q1(1)*q2(0)*q3(2)*q4(3) - q1(1)*q2(0)*q3(3)*q4(2) +
     .    q1(2)*q2(1)*q3(0)*q4(3) - q1(2)*q2(1)*q3(3)*q4(0) +
     .    q1(2)*q2(3)*q3(1)*q4(0) - q1(2)*q2(3)*q3(0)*q4(1) +
     .    q1(2)*q2(0)*q3(3)*q4(1) - q1(2)*q2(0)*q3(1)*q4(3) +
     .    q1(3)*q2(1)*q3(2)*q4(0) - q1(3)*q2(1)*q3(0)*q4(2) +
     .    q1(3)*q2(2)*q3(0)*q4(1) - q1(3)*q2(2)*q3(1)*q4(0) +
     .    q1(3)*q2(0)*q3(1)*q4(2) - q1(3)*q2(0)*q3(2)*q4(1) +
     .    q1(0)*q2(1)*q3(3)*q4(2) - q1(0)*q2(1)*q3(2)*q4(3) +
     .    q1(0)*q2(2)*q3(1)*q4(3) - q1(0)*q2(2)*q3(3)*q4(1) +
     .    q1(0)*q2(3)*q3(2)*q4(1) - q1(0)*q2(3)*q3(1)*q4(2)

      e = -e !! e chittemmuorto!!!
      epsfun = (0.d0,1.d0) * e
      return
      end
*** Levi-Civita tensor contracted with 4 momenta
      function e_(q1,q2,q3,q4)
      implicit double precision (a-h,o-z)
      dimension q1(0:3),q2(0:3),q3(0:3),q4(0:3)
      double complex im
      common/esig/esign
      common/imm/im
      data im /(0.d0,1.d0)/
*
      e_ = 0.d0
      return

!!! va moltiplicata per -1 rispetto a Form!!!
      e_ =q1(1)*q2(2)*q3(3)*q4(0) - q1(1)*q2(2)*q3(0)*q4(3) +
     .    q1(1)*q2(3)*q3(0)*q4(2) - q1(1)*q2(3)*q3(2)*q4(0) +
     .    q1(1)*q2(0)*q3(2)*q4(3) - q1(1)*q2(0)*q3(3)*q4(2) +
     .    q1(2)*q2(1)*q3(0)*q4(3) - q1(2)*q2(1)*q3(3)*q4(0) +
     .    q1(2)*q2(3)*q3(1)*q4(0) - q1(2)*q2(3)*q3(0)*q4(1) +
     .    q1(2)*q2(0)*q3(3)*q4(1) - q1(2)*q2(0)*q3(1)*q4(3) +
     .    q1(3)*q2(1)*q3(2)*q4(0) - q1(3)*q2(1)*q3(0)*q4(2) +
     .    q1(3)*q2(2)*q3(0)*q4(1) - q1(3)*q2(2)*q3(1)*q4(0) +
     .    q1(3)*q2(0)*q3(1)*q4(2) - q1(3)*q2(0)*q3(2)*q4(1) +
     .    q1(0)*q2(1)*q3(3)*q4(2) - q1(0)*q2(1)*q3(2)*q4(3) +
     .    q1(0)*q2(2)*q3(1)*q4(3) - q1(0)*q2(2)*q3(3)*q4(1) +
     .    q1(0)*q2(3)*q3(2)*q4(1) - q1(0)*q2(3)*q3(1)*q4(2)
       e_ = esign * e_ !!!! Carlo
c       e_ = -1.d0 * im  * e_ !!!! Carlo
      return
      end

*************************************************
      subroutine Diracology
      implicit none      
      double complex im
! the only imaginary is gd2 and so gd02,gd025...
      double precision gd0(4,4)
      double precision gd1(4,4)
      double complex   gd2(4,4)
      double precision gd3(4,4)
      double precision gd5(4,4)
      double precision gd00(4,4)
      double precision gd01(4,4)
      double complex   gd02(4,4)
      double precision gd03(4,4)
      double precision gd05(4,4)
      double precision gd005(4,4)
      double precision gd015(4,4)
      double complex   gd025(4,4)
      double precision gd035(4,4)
      common/gammamatrices/gd2,gd02,gd025,
     .     gd0,  gd1,  gd3, gd5,
     .     gd00, gd01, gd03,gd05,
     .     gd005,gd015,gd035

      im = (0.d0,1.d0)
      gd0 = 0.d0
      gd1 = 0.d0
      gd2 = (0.d0,0.d0)
      gd3 = 0.d0
      gd5 = 0.d0

      gd0(1,1) =  1.d0 
      gd0(2,2) =  1.d0 
      gd0(3,3) = -1.d0 
      gd0(4,4) = -1.d0 

      gd1(1,4) =  1.d0 
      gd1(2,3) =  1.d0 
      gd1(3,2) = -1.d0 
      gd1(4,1) = -1.d0 

      gd2(1,4) = -im
      gd2(2,3) =  im
      gd2(3,2) =  im
      gd2(4,1) = -im

      gd3(1,3) =  1.d0
      gd3(2,4) = -1.d0
      gd3(3,1) = -1.d0
      gd3(4,2) =  1.d0

      gd5 = im*matmul(gd0,matmul(gd1,matmul(gd2,gd3)))

      gd00 = matmul(gd0,gd0)
      gd01 = matmul(gd0,gd1)
      gd02 = matmul(gd0,gd2)
      gd03 = matmul(gd0,gd3)
      gd05 = matmul(gd0,gd5)

      gd005 = matmul(gd00,gd5)
      gd015 = matmul(gd01,gd5)
      gd025 = matmul(gd02,gd5)
      gd035 = matmul(gd03,gd5)

      return
      end
**************************************************
      subroutine geterrpos(s,i,str)
      implicit double precision (a-h,o-z)
      character*30 str     
      sl = s
      ires = 0
      i = 0
      do k=1,30
         str(k:k) = ' '
      enddo
      if (abs(sl).lt.1d-13) return
      if (abs(sl).gt.1.d10) return
      if (isnan(sl)) return ! to avoid infinite loops...
      do while (ires.lt.1)
         sl   = sl*10.d0
         ires = sl
         i = i + 1
      enddo
      str(i+1:i+1) = '^'
      return
      end
***********************************************************************
      subroutine cutfflowinvmasses(p1,p2,p3,p4,icut)
      implicit none
      integer icut,ifirst
#include "couplingandmasses.h"
      double precision dot,cut,cut2,cutlowinvmass
      external dot
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      integer idpart
      common/identicalparticles/idpart
      common/cutfflowinvmass/cut,cut2,ifirst

      common/cutonlowinvmasses/cutlowinvmass ! from input

      data ifirst /0/
      if (ifirst.eq.0) then
c         print*,'**************************************'//
c     .        '**************************'
c         print*,'* cutting ffbar invariant masses lower'//
c     .        ' than 0.001 x higgs mass *'
c         print*,'**************************************'//
c     .        '**************************'
         cut    = 1.d-6 * masshiggs*masshiggs
         cut2   = cutlowinvmass**2
         ifirst = 1

         if (cut2.gt.0.d0) then
            print*,'Rejecting events with all opposite '//
     .           'charge pair inv. masses >',cutlowinvmass,' GeV'
         endif
      endif

      icut = 0
      if (dot(p1+p2,p1+p2).lt.cut) then
         icut = 1
         return
      endif
      if (dot(p3+p4,p3+p4).lt.cut) then
         icut = 2
         return
      endif
      if (idpart.eq.1) then
         if (dot(p1+p4,p1+p4).lt.cut) then
            icut = 3
            return
         endif
         if (dot(p3+p2,p3+p2).lt.cut) then
            icut = 4
            return
         endif
      endif

***   extra cut from input, mainly to improve MC unweighting efficiency
***   all opposite charge pair inv. masses are required to be > cutlowinvmass
      if (dot(p1+p2,p1+p2).lt.cut2) then
         icut = 1
         return
      endif
      if (dot(p3+p4,p3+p4).lt.cut2) then
         icut = 2
         return
      endif
      if (dot(p1+p4,p1+p4).lt.cut2) then
         icut = 3
         return
      endif
      if (dot(p3+p2,p3+p2).lt.cut2) then
         icut = 4
         return
      endif

      return
      end
************************************************************************
      subroutine readhiggsandboost(ph,p1,p2,p3,p4,q,qph,imode,
     >           p1l,p2l,p3l,p4l,ql,qphl,sez,nzeropu)
      implicit double precision (a-h,m,l,o-z)
      parameter (itoberead = 5000)
      dimension ph(0:3),p1(0:3),p2(0:3),p3(0:3),p4(0:3),q(0:3),ptmp(0:3)
      dimension p1l(0:3),p2l(0:3),p3l(0:3),p4l(0:3),ql(0:3),phl(0:3)
      dimension qph(40,0:3),qphl(40,0:3)
      dimension phlm(itoberead,0:5)
      common/readhigges/phlm
      common/ifirstinreadhiggsandboost/ifirst,iused,icount
      common/hadron_parton/ipartonic,iusempi
      data ifirst /0/
      data iused /0/
      data icount/0/
#ifdef MPIRUN
      include 'mpif.h'
      include 'mpishortcuts.h'
#endif
      masshiggs = ph(0)
      sez = 1.d0
      nzeropu = 1
      iusempi = 0

      if (iused.eq.itoberead) iused = 0

      do k=0,3
         phl(k) = ph(k)
      enddo
*******************************************************************
      if (iusempi.eq.1) then
         if (iused.eq.0) then
            iused = iused + 1            
            icount = icount + 1            
#ifdef MPIRUN
            call mpi_recv(phlm,itoberead*6,MDP,0,10,MCW,status,
     >           ierrmpi)            
#endif
c$$$  icount = 0
c$$$  do k=1,itoberead
c$$$  icount = phlm(k,5) + icount
c$$$  enddo
c$$$  print*,icount
            do k=0,3
               phl(k) = phlm(iused,k)
            enddo
            sez = phlm(iused,4)
            nzeropu = nint(phlm(iused,5))
         else
            iused = iused + 1
            do k=0,3
               phl(k) = phlm(iused,k)
            enddo
            sez = phlm(iused,4)
            nzeropu = nint(phlm(iused,5))
         endif
      endif
*******************************************************************
      call new_boost(phl,p1,p1l,-1)
      call new_boost(phl,p2,p2l,-1)
      call new_boost(phl,p3,p3l,-1)
      call new_boost(phl,p4,p4l,-1)
      if (q(0).gt.0) then
         call new_boost(phl,q,ql,-1)
      else
         do k=0,3
            ql(k) = q(k)
         enddo         
      endif
! for Parton Shower
      if (imode.gt.10.and.imode.lt.20) then
         do k = 1,40
            do i = 0,3
               qphl(k,i) = 0.d0
            enddo
            if (qph(k,0).gt.0.d0) then
               do i = 0,3
                  ptmp(i) = qph(k,i)
               enddo
               call new_boost(phl,ptmp,ptmp,-1)
               do i = 0,3
                  qphl(k,i) = ptmp(i)
               enddo
            endif
         enddo
      endif
      ifirst = 1
      return
      end
************************************************************
      subroutine sort_vector(v,sv,iold,n)
! pensare quick sort!!
      implicit double precision (a-h,o-z)
      integer n
      dimension iold(n)
      dimension v(n),sv(n)
      do k = 1,n
         iold(k) = k
         sv(k) = v(k)
      enddo
      do i = 1,n
         vmax = sv(i)
         do j=i+1,n
            if (v(j).gt.vmax) then
               vmax = sv(j)
               vtmp = sv(i)
               sv(i) = sv(j)
               sv(j) = vtmp
               ktmp = iold(i)
               iold(i) = iold(j)
               iold(j) = ktmp
            endif
         enddo
      enddo
      return
      end
************************************************************
      subroutine decay2b(rnd1,rnd2,mass,m1,m2,p1,p2,
     >     phsp,w,ie)
      implicit double precision (a-h,m,l,o-z)
      double precision rnd1,rnd2
      dimension p1(0:3),p2(0:3)
      parameter (pi = 3.1415926535897932384626433832795029D0)

      if (mass.lt.(m1+m2)) then
         ie   = 1
         w    = 0.d0
         phsp = 0.d0
         return
      endif

      ie   = 0
      w    = 1.d0
      phsp = 1.d0

      cth = 2.d0*rnd1 - 1.d0
      phi = 2.d0*pi*rnd2
      w   = 4.d0*pi*w
      
      sth  = sqrt(1.d0 - cth**2)
      cphi = cos(phi)
      sphi = sin(phi)
      
      sqla = sqrt(lambda(mass**2,m1**2,m2**2))
      phsp = phsp * sqla/8.d0/mass**2

      pmod = sqla/2.d0/mass

      p1(0) = sqrt(pmod**2 + m1**2)
      p1(1) = pmod * sphi * sth
      p1(2) = pmod * cphi * sth
      p1(3) = pmod * cth

! to avoid round-offs when pmod is really small!!
      p2(0) = sqrt(pmod**2+m2**2)
      p2(1) = - p1(1)
      p2(2) = - p1(2)
      p2(3) = - p1(3)
      return
      end
***********************************************************
      subroutine decayCRF_BCK(n1,n2,mass,egmin,egmax,m1,m2,p1o,p2o,
     >     qout,phsp,w,ie)
! old routine, works great but better the new one below
      implicit double precision (a-h,m,l,o-z)
      double precision csi(1),rnd2(2),rnd(3*(n1+n2)+2)
      dimension p1(0:3),p2(0:3),q(0:3),vers(0:3),pzcrf(0:3)
      dimension qall(0:3,n1+n2),dir1(0:3),dir2(0:3)!,dirfake(0:3)
      double precision qout(0:3,20),p1o(0:3),p2o(0:3)
      double precision kone(0:3),mat(0:3,0:3)
      parameter (pi = 3.1415926535897932384626433832795029D0)
      common/zparam/zmass,zwidth

      common/decayCFRdistr/var1,var2,var3
! using Fortran 90/95 features for clarity...

! n random needed nr = 3*(2+n1+n2)-4 = 2 + 3*(n1+n2)
      ie   = 0
      w    = 1.d0
      phsp = 1.d0

      if ((n1+n2).eq.0) then
         call wraprnd(rnd2,2)
         call decay2b(rnd2(1),rnd2(2),mass,m1,m2,p1,p2,
     >        phsp,w,ie)
         p1o = p1
         p2o = p2
         qout(0,1) = 0.d0
         qout(1,1) = 0.d0
         qout(2,1) = 0.d0
         qout(3,1) = 0.d0
         return
      endif
**
      ntot = n1+n2
**
! mh....
c     if (mass.lt.(m1+m2+ntot*egmin).or.egmax.lt.egmin) then
c         ie   = 1
c         phsp = 0.d0
c         w    = 0.d0
c         return
c      endif
! better...
      if (mass.lt.(m1+m2)) then
         ie   = 1
         phsp = 0.d0
         w    = 0.d0
         return
      endif

*****************************
!!! I'M IN THE REFERENCE WHERE p1 and p2 ARE ALWAYS BACK TO BACK
!! check the notes for conventions and ideas
      call wraprnd(rnd,3*ntot+2)
      ir  = 1
**
      cth = 2.d0*rnd(ir) - 1.d0
      phi = 2.d0*pi*rnd(ir+1)
      ir  = ir + 2
      w   = 4.d0*pi*w
      
      sth  = sqrt(1.d0 - cth**2)
      cphi = cos(phi)
      sphi = sin(phi)

!***** components of the versor directed along the independent fermion momentum
      vx = sth*sphi
      vy = sth*cphi
      vz = cth
!*****
c      dir1(0) = zmass/2.d0 ! BETTER ??  !mass*0.5d0 !  0.5d0*(mass**2 + m1**2 - m2**2)/mass
      dir1(0) = mass*0.5d0
      beta    = sqrt( (1.d0 - m1/dir1(0))*(1.d0 + m1/dir1(0)) )
      dir1(1) = dir1(0)*beta*vx
      dir1(2) = dir1(0)*beta*vy
      dir1(3) = dir1(0)*beta*vz

      dir2(0) =  dir1(0)
      dir2(1) = -dir1(1)
      dir2(2) = -dir1(2)
      dir2(3) = -dir1(3)

      egtot = 0.d0
      wegt  = 1.d0
      kone  = 0.d0

********************
      mz2  = mass*mass
      emin = egmin
      emax = 0.25d0*mz2/m1-m1     ! I do not use egmax!! it's correct...
! different emax...
      if (n1.gt.0) then
         do k = 1,n1
            call alongd(rnd(ir),rnd(ir+1),dir1,m1,vers,wvers)
            ir = ir + 2
            w  = w * wvers
            emax = mz2-dot(kone,kone)-4.d0*m1*m1-4.d0*m1*kone(0)
            emax = emax/(4.d0*m1+2.d0*dot(vers,kone))
            if (emin.gt.emax) then
               ie = 1
               w  = 0.d0
               phsp = 0.d0
               return
            endif
            call get_egammasoft(rnd(ir),emin,emax,eg,weg)
            ir     = ir + 1
            egtot  = egtot + eg
            qall(:,k) = eg*vers
            kone = kone + eg*vers
            wegt = wegt*weg
         enddo
      endif

      if (n2.gt.0) then
         do k = n1+1,n1+n2
            call alongd(rnd(ir),rnd(ir+1),dir2,m2,vers,wvers)
            ir = ir + 2
            w  = w * wvers
            emax = mz2-dot(kone,kone)-4.d0*m1*m1-4.d0*m1*kone(0)
            emax = emax/(4.d0*m1+2.d0*dot(vers,kone))
            if (emin.gt.emax) then
               ie = 1
               w  = 0.d0
               phsp = 0.d0
               return
            endif
            call get_egammasoft(rnd(ir),emin,emax,eg,weg)
            ir     = ir + 1
            egtot  = egtot + eg
            qall(:,k) = eg*vers
            kone = kone + eg*vers
            wegt = wegt*weg
         enddo
      endif

** weights for energies generation
      w   = w * wegt
****

***  kone momentum is the sum of all generated photons
c already summed in the do-loop      kone  = sum(qall,2) ! notice qall here has n1+n2 dimensions
***
      E1 = (sqrt(mz2+tridot(kone,kone)) - kone(0))*0.5d0

      if (E1.lt.m1) then
         ie = 1
         w  = 0.d0
         phsp = 0.d0
         return
      endif

      b1    = sqrt( (1.d0-m1/E1)*(1.d0+m1/E1) )
      p1mod = E1 * b1
      p1(0) = E1
      p1(1) = p1mod * vx
      p1(2) = p1mod * vy
      p1(3) = p1mod * vz
      
      p2(0) =   p1(0)
      p2(1) = - p1(1)
      p2(2) = - p1(2)
      p2(3) = - p1(3)
      
!! I need also a factor 1/2 for each particle.
!! So I start with prodomega = 1/4 for the 2 fermions, and multiply by 1/2 each photon
      prodomega = 0.25d0
      do k = 1,ntot
         prodomega = prodomega*qall(0,k)*0.5d0
      enddo
      
! phase space where p1+p2 is at rest
      s12  = dot(p1+p2,p1+p2)
      s12k = dot(p1+p2+kone,p1+p2+kone)
      
!! MINCHIA, FUNZIONA
      phspp = prodomega*0.5d0/s12k*s12
      phspp = phspp * b1 / (1.d0 + kone(0)/sqrt(s12))

!    there was a small error, 'cause b1 was not sqrt'ed above
c      var1 = s12/s12k
c      var2 =  1.d0/(1.d0 + kone(0)/sqrt(s12))
c      var3 = var1*var2

***   now boosting back where pz is at rest
c      pzcrf(0)   = sqrt(mz2+tridot(kone,kone))
c      pzcrf(1:3) = kone(1:3)
!     i.e.
      pzcrf = p1+p2+kone

      call new_boost(pzcrf,p1,p1o,1)
      call new_boost(pzcrf,p2,p2o,1)
      do k = 1,ntot
         dir1 = qall(:,k)
         call new_boost(pzcrf,dir1,dir1,1)
         qout(:,k) = dir1
      enddo

      phsp = phspp
      return
      end
***********************************************************
      subroutine decayCRF(n1,n2,mass,egmin,egmax,m1,m2,p1o,p2o,
     >     qout,phsp,w,ie)
! new routine
      implicit double precision (a-h,m,l,o-z)
      double precision csi(1),rnd2(2),rnd(3*(n1+n2)+2),rnd1(1)
      dimension p1(0:3),p2(0:3),q(0:3),vers(0:3),pzcrf(0:3)
      dimension qall(0:3,n1+n2),dir1(0:3),dir2(0:3)!,dirfake(0:3)
      double precision qout(0:3,20),p1o(0:3),p2o(0:3)
      double precision kone(0:3),mat(0:3,0:3)
      parameter (pi = 3.1415926535897932384626433832795029D0)
      common/zparam/zmass,zwidth

      common/decayCFRdistr/var1,var2,var3

      dimension x(max(1,n1+n2)),y(max(1,n1+n2)),rndxy(max(1,n1+n2))
      dimension versarr(0:3,max(1,n1+n2)),VV(0:3)
      
!  using Fortran 90/95 features for clarity...

! n random needed nr = 3*(2+n1+n2)-4 = 2 + 3*(n1+n2)
      ie   = 0
      w    = 1.d0
      phsp = 1.d0

      if ((n1+n2).eq.0) then
         call wraprnd(rnd2,2)
         call decay2b(rnd2(1),rnd2(2),mass,m1,m2,p1,p2,
     >        phsp,w,ie)
         p1o = p1
         p2o = p2
         qout(0,1) = 0.d0
         qout(1,1) = 0.d0
         qout(2,1) = 0.d0
         qout(3,1) = 0.d0
         return
      endif
*
      if (mass.lt.(m1+m2)) then
         ie   = 1
         phsp = 0.d0
         w    = 0.d0
         return
      endif
**
      ntot = n1+n2
**
*****************************
!! I'M IN THE REFERENCE WHERE p1 and p2 ARE ALWAYS BACK TO BACK
!! check the notes for conventions and ideas
**
      call wraprnd(rnd2,2)
      cth = 2.d0*rnd2(1) - 1.d0
      phi = 2.d0*pi*rnd2(2)
      w   = 4.d0*pi*w
      
      sth  = sqrt(1.d0 - cth**2)
      cphi = cos(phi)
      sphi = sin(phi)

!***** components of the versor directed along the independent fermion momentum
      vx = sth*sphi
      vy = sth*cphi
      vz = cth
!*****
c      dir1(0) = zmass/2.d0 ! BETTER ??  !mass*0.5d0 !  0.5d0*(mass**2 + m1**2 - m2**2)/mass
      dir1(0) = mass*0.5d0
      beta    = sqrt( (1.d0 - m1/dir1(0))*(1.d0 + m1/dir1(0)) )
      dir1(1) = dir1(0)*beta*vx
      dir1(2) = dir1(0)*beta*vy
      dir1(3) = dir1(0)*beta*vz

      dir2(0) =  dir1(0)
      dir2(1) = -dir1(1)
      dir2(2) = -dir1(2)
      dir2(3) = -dir1(3)
********************
      mz2 = mass*mass
      qm2 = 4.d0*m1*m1

      call get_yx(mz2,qm2,ntot,y,x,yjac,wxy,iexy)
      if (iexy.gt.0) then
         ie   = 1
         phsp = 0.d0
         w    = 0.d0
         return
      endif
      w  = w * wxy

      VV = 0.d0
      do k = 1,ntot
         call wraprnd(rnd2,2)
         if (k.le.n1) then
            call alongd(rnd2(1),rnd2(2),dir1,m1,vers,wvers)
         else
            call alongd(rnd2(1),rnd2(2),dir2,m2,vers,wvers)
         endif
         w  = w * wvers
         versarr(:,k) = x(k)*vers
         VV           = VV + versarr(:,k) ! this is now V in the notes
      enddo
      
      oodensp = 1.d0 /(1.d0 + 0.25d0 * dot(VV,VV) + VV(0))
      sp      = mz2 * oodensp
      if (sp.lt.qm2) then
         ie   = 1
         phsp = 0.d0
         w    = 0.d0
         return
      endif
      sqspm = sqrt(sp)*0.5d0

      versarr   = versarr * sqspm
      kone      = 0.d0
      prodomega = 1.d0
      do k = 1,ntot
         qall(:,k) = versarr(:,k)
         kone      = kone + qall(:,k)
         prodomega = prodomega * qall(0,k)
      enddo

c      E1 = (sqrt(mz2+tridot(kone,kone)) - kone(0))*0.5d0
      E1 = sqspm

c not needed     if (E1.lt.m1) then
c         ie   = 1
c         w    = 0.d0
c         phsp = 0.d0
c         return
c      endif

      b1    = sqrt( (1.d0-m1/E1)*(1.d0+m1/E1) )
      p1mod = E1 * b1
      p1(0) = E1
      p1(1) = p1mod * vx
      p1(2) = p1mod * vy
      p1(3) = p1mod * vz

      p2(0) =  p1(0)
      p2(1) = -p1(1)
      p2(2) = -p1(2)
      p2(3) = -p1(3)

!! I need also a factor 1/2 for each particle + one extra 1/2 from phase space
      prodomega = prodomega * (0.5d0)**(ntot+3)

      yjac  = yjac * (1.d0 + VV(0)) !

!    there was a small error, 'cause b1 was not sqrt'ed above      
      phspp = b1 * prodomega * oodensp*oodensp !!! 
      phspp = phspp * sqspm**ntot * yjac
      
***   now boosting back where pz is at rest
c      pzcrf(0)   = sqrt(mz2+tridot(kone,kone))
c      pzcrf(1:3) = kone(1:3)
!     i.e.
      pzcrf = p1+p2+kone
      call new_boost(pzcrf,p1,p1o,1)
      call new_boost(pzcrf,p2,p2o,1)
      do k = 1,ntot
         dir1 = qall(:,k)
         call new_boost(pzcrf,dir1,dir1,1)
         qout(:,k) = dir1
      enddo
      phsp = phspp
      return
      end
***** 
      function det3x3(mat)
      implicit double precision (a-h,m,l,o-z)
      double precision mat(3,3)
      det   = mat(1,1)*( mat(2,2)*mat(3,3)-mat(2,3)*mat(3,2) )
     .      - mat(1,2)*( mat(2,1)*mat(3,3)-mat(2,3)*mat(3,1) )
     .      + mat(1,3)*( mat(2,1)*mat(3,2)-mat(2,2)*mat(3,1) )
      return
      end
******************************************
      function det(p,mat)
      implicit double precision (a-h,m,l,o-z)
      double precision p(0:3)
      double precision mat(0:3,0:3)
      b   = sqrt(tridot(p,p))/p(0)
      b2  = b**2
      bx  = p(1)/p(0)
      by  = p(2)/p(0)
      bz  = p(3)/p(0)
      g   = 1.d0/sqrt(1.d0 - b2)
      gm1 = g - 1

      mat(1,1) = 1.d0 + gm1*bx*bx/b2
      mat(2,2) = 1.d0 + gm1*by*by/b2
      mat(3,3) = 1.d0 + gm1*bz*bz/b2
      mat(1,2) = gm1*bx*by/b2
      mat(1,3) = gm1*bx*bz/b2
      mat(2,3) = gm1*by*bz/b2
      mat(2,1) = mat(1,2)
      mat(3,1) = mat(1,3)
      mat(3,2) = mat(2,3)
      mat(0,0) =  g
      mat(0,1) = -g*bx
      mat(0,2) = -g*by
      mat(0,3) = -g*bz
      mat(1,0) = mat(0,1)
      mat(2,0) = mat(0,2)
      mat(3,0) = mat(0,3)

      det   = det3x3(mat(1:3,1:3))
     
      return
      end
***********************************************************
      subroutine decayNG(n1,n2,mass,egmin,egmax,m1,m2,p1o,p2o,
     >     qout,phsp,w,ie)
      implicit double precision (a-h,m,l,o-z)
      double precision csi(1),rnd2(2),rnd(3*(n1+n2)+2)
      dimension p1(0:3),p2(0:3),q(0:3),vers(0:3),ptmp(0:3)
      dimension qall(0:3,n1+n2),dir1(0:3),dir2(0:3)!,dirfake(0:3)
      double precision qout(0:3,20),p1o(0:3),p2o(0:3)
      double precision kone(0:3)
      parameter (pi = 3.1415926535897932384626433832795029D0)
      common/zparam/zmass,zwidth

! using Fortran 90/95 features for clarity...

! n random needed nr = 3*(2+n1+n2)-4 = 2 + 3*(n1+n2)
      ie   = 0
      w    = 1.d0
      phsp = 1.d0

      if ((n1+n2).eq.0) then
         call wraprnd(rnd2,2)
         call decay2b(rnd2(1),rnd2(2),mass,m1,m2,p1,p2,
     >        phsp,w,ie)
         p1o = p1
         p2o = p2
         qout(0,1) = 0.d0
         qout(1,1) = 0.d0
         qout(2,1) = 0.d0
         qout(3,1) = 0.d0
         return
      endif
**
      ntot = n1+n2
**
c      print*,egmin
      if (mass.lt.(m1+m2+ntot*egmin).or.egmax.lt.egmin) then
c         print*,egmin,ntot
         ie   = 1
         phsp = 0.d0
         w    = 0.d0
         return
      endif
      
*****************************
* indip is the independent fermion
* n1l is the n of photons sampled along dir1
* n2l is the n of photons sampled along dir2
      if (n2.eq.0) then
         indip = 1
      elseif (n1.eq.0) then
         indip = 2
      else
         indip = 1
         call wraprnd(csi(1),1)
         if (csi(1).lt.0.5d0) indip = 2
      endif

      if (indip.eq.1) then
         n1l  = n1
         n2l  = n2
      else
         n1l  = n2
         n2l  = n1
      endif
***********************         

!!!! **** hints: th,phi give the directions of the independent momentum.*****
!!!! if n1>n2 it's better to let it be p1, otherwise p2 (it means just exchange
!!! p1 and p2 at the end of the routine.
!!! Notice that being th and phi flat, it's ok to use always dir1 as the direction
!!! of the independent fermion momentum. Actually dir2 is needed only when n1+n2 > 1

! generating here all the needed random numbers!
      call wraprnd(rnd,3*ntot+2)
      ir  = 1
**
      cth = 2.d0*rnd(ir) - 1.d0
      phi = 2.d0*pi*rnd(ir+1)
      ir  = ir + 2
      w   = 4.d0*pi*w
      
      sth  = sqrt(1.d0 - cth**2)
      cphi = cos(phi)
      sphi = sin(phi)

!***** components of the versor directed along the independent fermion momentum
      vx = sth*sphi
      vy = sth*cphi
      vz = cth
!*****

      dir1(0) = zmass/2.d0 ! BETTER ??  !mass*0.5d0 !  0.5d0*(mass**2 + m1**2 - m2**2)/mass
c      dir1(0) = mass*0.5d0 !  0.5d0*(mass**2 + m1**2 - m2**2)/mass
      beta    = sqrt( (1.d0 - m1/dir1(0))*(1.d0 + m1/dir1(0)) )
      dir1(1) = dir1(0)*beta*vx
      dir1(2) = dir1(0)*beta*vy
      dir1(3) = dir1(0)*beta*vz

      dir2(0) =  dir1(0)
      dir2(1) = -dir1(1)
      dir2(2) = -dir1(2)
      dir2(3) = -dir1(3)

      egtot = 0.d0
      wegt  = 1.d0
      if (ntot.eq.1) then
         call alongd(rnd(ir),rnd(ir+1),dir1,m1,vers,wvers) ! along the independent fermion
         ir = ir + 2
         w  = w * wvers
         qall(:,1) = vers       ! I use qall temporarily to store the vers for the n-th gamma
         
         c = vx*qall(1,1)+vy*qall(2,1)+vz*qall(3,1)
         if (c.ge. 1.d0) c =  1.d0
         if (c.le.-1.d0) c = -1.d0
         call get_egammanew(rnd(ir),egmin,egmax,mass,c,eg,weg)
         ir     = ir + 1
         egtot  = egtot + eg
         qall(:,1) = eg*qall(:,1)
         wegt = wegt*weg
      else ! if ntot > 1 generating here only the directions of the photons
         do k = 1,n1l
            call alongd(rnd(ir),rnd(ir+1),dir1,m1,vers,wvers) ! along the independent fermion
            ir = ir + 2
            w  = w * wvers
            qall(:,k) = vers    ! I use qall temporarily to store the vers for the n-th gamma
         enddo
         if (n2l.gt.0) then
            do k = n1l+1,n1l+n2l
               call alongd(rnd(ir),rnd(ir+1),dir2,m2,vers,wvers) ! along the other direction!
               ir = ir + 2
               w  = w * wvers
               qall(:,k) = vers ! I use qall temporarily to store the vers for the n-th gamma
            enddo
         endif

**************** generating photon energies when ntot > 1. if ntot = 1 already done above
         eiforlast = mass
c         dirfake = dir2
         do k = 1,ntot-1 ! ntot - 1 are generated soft, as 1/eg
            
            if ((egmax - egtot).lt.egmin)  then
               ie   = 1
               phsp = 0.d0
               w    = 0.d0
               return
            endif

            call get_egammasoft(rnd(ir),egmin,egmax-egtot,eg,weg) ! notice the upper limit!!
            wegt  = wegt * weg
            ir    = ir + 1
            egtot = egtot + eg

            eiforlast = eiforlast  ! notice here that qall has still stored the versor
     .                - eg*(1.d0-qall(1,k)*vx-qall(2,k)*vy-qall(3,k)*vz)

            qall(:,k) = eg*qall(:,k)

c            dirfake = dirfake - qall(:,k)

         enddo
! last photon
c         call get_egammasoft(rnd(ir),egmin,egmax-egtot,eg,weg) ! notice the upper limit!!
         c = qall(1,ntot)*vx+qall(2,ntot)*vy+qall(3,ntot)*vz
         call get_egammanew(rnd(ir),egmin,egmax-egtot,eiforlast,c,eg,
     .                      weg)
         wegt = wegt * weg
         ir = ir + 1
         egtot = egtot + eg
         qall(:,ntot) = eg * qall(:,ntot)

**************** end generating photon energies when ntot > 1
      endif

      summa = egtot + m1 + m2
      if (summa.gt.mass) then
         ie = 1
         w  = 0.d0
         phsp = 0.d0
         return
      endif
** weights for energies generation
      w   = w * wegt
****      

***  kone momentum is the sum of all generated photons
      kone  = sum(qall,2) ! notice qall here has n1+n2 dimensions
***
      o  = kone(0)
      ox = kone(1)
      oy = kone(2)
      oz = kone(3)
      
      Ei = mass
      
      odv  = ox*vx + oy*vy + oz*vz
      abig = Ei**2 - 2.d0 * Ei * o + dot(kone,kone) ! + m1**2 - m2**2 ! m1 always = m2!!
      bbig = -2.d0 * (Ei - o)
      cbig = -2.d0 * odv
      arg  = abig**2*bbig**2-m1**2*bbig**2*(bbig**2-cbig**2)
      
      if (arg.lt.0.d0) then
         ie = 1
         w  = 0.d0
         phsp = 0.d0
         return
      endif
      p1mod_1 = abig*cbig + sqrt(arg)
      p1mod_1 = p1mod_1 / (bbig**2 - cbig**2)
      p1mod_2 = abig*cbig - sqrt(arg)
      p1mod_2 = p1mod_2 / (bbig**2 - cbig**2)
     
      p1jac = 1.d0
      if (p1mod_1.gt.0.d0.and.p1mod_2.gt.0.d0) then
         call wraprnd(csi,1)
         if (csi(1).lt.0.5) p1mod = p1mod_1
         if (csi(1).gt.0.5) p1mod = p1mod_2
         p1jac = 2.d0
      endif
      if (p1mod_1.gt.0.d0.and.p1mod_2.lt.0.d0) then
         p1mod = p1mod_1
      endif
      if (p1mod_1.lt.0.d0.and.p1mod_2.gt.0.d0) then
         p1mod = p1mod_2
      endif
      if (p1mod_1.lt.0.d0.and.p1mod_2.lt.0.d0) then
         ie = 1
         w  = 0.d0
         phsp = 0.d0
         return
      endif
      w = w * p1jac
      
      p1(0) = sqrt( m1**2 + p1mod**2)

      p1(1) = p1mod * vx
      p1(2) = p1mod * vy
      p1(3) = p1mod * vz
      
      p2(0) =  Ei - p1(0) - kone(0)
      p2(1) = - p1(1) - kone(1)
      p2(2) = - p1(2) - kone(2)
      p2(3) = - p1(3) - kone(3)
      
      foo  = 1.d0 + odv/p1mod
      bar  = abs((p2(0) + p1(0)*foo))

!! I need also a factor 1/2 for each particle.
!! So I start with prodomega = 1/4 for the 2 fermions, and multiply by 1/2 each photon
      prodomega=0.25d0
      do k = 1,ntot
         prodomega = prodomega*qall(0,k)*0.5d0
      enddo
      phsp = phsp * p1mod/bar * prodomega

      if (phsp.lt.0.d0.or.w.lt.0.d0) then
         ie = 1
         w  = 0.d0
         phsp = 0.d0
      endif

! up-to-here p1 and p2 were dummy...

! loading fermion momenta
      if (indip.eq.1) then
         p1o = p1
         p2o = p2
      else
         p1o = p2
         p2o = p1
      endif


c      if (n2l.gt.2) then
c         print*,ntot
c      print*,tridot(dir2,p2)/sqrt(tridot(dir2,dir2))/sqrt(tridot(p2,p2))
c      endif

**********************************************************
!      loading output q's
      if (n1.eq.0.or.n2.eq.0) then
         qout(:,1:ntot) = qall(:,1:ntot) 
      else
         if (indip.eq.1) then
            qout(:,1:ntot) = qall(:,1:ntot) 
         else
            qout(:,n1+1:n1+n2) = qall(:,1:n1l) ! n1l = n2
            qout(:,1:n1)       = qall(:,n1l+1:n1l+n2l) ! n2l = n1
         endif
      endif
            
*********************************************************
      if (ntot.eq.1) return ! no need for the extra "regulator" if ntot=1

*** Below here only if ntot > 1
      if (n1.ge.1.and.n2.ge.1) then
         prod1 = 1.d0
         do k = 1,n1
            prod1 = prod1*p1o(0)/dot(p1o,qout(:,k))*qout(0,k)
         enddo
         prod2 = 1.d0
         do k = n1+1,n1+n2
            prod2 = prod2*p2o(0)/dot(p2o,qout(:,k))*qout(0,k)
         enddo

         if (indip.eq.1) then         
            w = w* prod1/(prod1+prod2) * 2.d0 ! 2.d0 in babayaga, it's the weight for indip
         else
            w = w* prod2/(prod1+prod2) * 2.d0
         endif
      endif
***********
      return
      end
**************************************************
      subroutine exchange_mom(p1,p2)
      implicit double precision (A-H,O-Z)
      dimension p1(0:3),p2(0:3),p4(0:3)
      do i=0,3
         p4(i)=p1(i)
         p1(i)=p2(i)
         p2(i)=p4(i)
      enddo
      return
      end
**************************************************
      subroutine new_boost(p,q,qq,idir)
      integer idir
      double precision p(0:3),q(0:3),qq(0:3),vboost(0:3)
      double precision b,g
! idir =  1: q is boosted where p is at rest and put in qq
! idir = -1: q, in the frame where p is at rest, is boosted where p is not
!            at rest. The boosted q is put in qq.

      if (idir.eq.1) then
         vboost(0) = 0.d0
         vboost(1) = p(1)/p(0)
         vboost(2) = p(2)/p(0)
         vboost(3) = p(3)/p(0)
      else
         vboost(0) = 0.d0
         vboost(1) = -p(1)/p(0)
         vboost(2) = -p(2)/p(0)
         vboost(3) = -p(3)/p(0)
      endif

      b=sqrt(vboost(1)**2+vboost(2)**2+vboost(3)**2)

      g = 1.d0/sqrt((1.d0-b)*(1.d0+b))

ccc      g=1.d0/sqrt(1.d0-b**2)
      call boost(g,vboost,q,qq)
      return
      end
**************************************************
      subroutine initcolors
c      character*12 col(20)
      character*1 col(20)
      common/colors/col
c$$$      data col /'\e[00;00;30m', !1
c$$$     >     '\e[00;00;31m',      !2
c$$$     >     '\e[00;00;32m',      !3
c$$$     >     '\e[00;00;33m',      !4
c$$$     >     '\e[00;00;34m',      !5
c$$$     >     '\e[00;00;35m',      !6
c$$$     >     '\e[00;00;36m',      !7
c$$$     >     '\e[00;00;37m',      !8
c$$$     >     '\e[00;01;30m',      !9
c$$$     >     '\e[00;04;30m',      !10
c$$$     >     '\e[00;07;30m',      !11
c$$$     >     '\e[00;01;31m',      !12
c$$$     >     '\e[00;01;32m',      !13
c$$$     >     '\e[00;01;33m',      !14
c$$$     >     '\e[00;01;34m',      !15
c$$$     >     '\e[00;01;35m',      !16
c$$$     >     '\e[00;01;36m',      !17
c$$$     >     '\e[43;01;37m',      !18
c$$$     >     '\e[00;07;31m',      !19
c$$$     >     '\e[00;05;31m'/      !20

      data col /' ', !1
     >     ' ',      !2
     >     ' ',      !3
     >     ' ',      !4
     >     ' ',      !5
     >     ' ',      !6
     >     ' ',      !7
     >     ' ',      !8
     >     ' ',      !9
     >     ' ',      !10
     >     ' ',      !11
     >     ' ',      !12
     >     ' ',      !13
     >     ' ',      !14
     >     ' ',      !15
     >     ' ',      !16
     >     ' ',      !17
     >     ' ',      !18
     >     ' ',      !19
     >     ' '/      !20
      return
      end
**************************************************
      function dot(p,q)
      implicit double precision (a-h,o-z)
      double precision p(0:3),q(0:3),qtmp(0:3)
c      dot=p(0)*q(0)-p(1)*q(1)-p(2)*q(2)-p(3)*q(3)

      dot = p(0)*q(0) - dot_product(p(1:3),q(1:3))

c      qtmp(0) = q(0)
c      qtmp(1) = -q(1)
c      qtmp(2) = -q(2)
c      qtmp(3) = -q(3)     
c      dot = dot_product(p,qtmp)

      return
      end
**************************************************
      function tridot(p,q)
      implicit double precision (a-h,o-z)
      double precision p(0:3),q(0:3)
      tridot=p(1)*q(1)+p(2)*q(2)+p(3)*q(3)

c      tridot = dot_product(p(1:3),q(1:3))

      return
      end
**************************************************
      subroutine boost(g,v,p,q)
      implicit double precision (a-h,o-z)
      double precision p(0:3),q(0:3),pp(0:3),v(0:3)
*
      do i=0,3
         pp(i)=p(i)
         q(i)=p(i)
      enddo
*
      if (g.eq.1.d0) return
*
      ppdv=tridot(pp,v)
      uov2=1.d0/(v(1)**2+v(2)**2+v(3)**2)
*
      q(0)=g*(pp(0)-ppdv)
      do i=1,3
         q(i)=pp(i)+(g-1.d0)*ppdv*uov2*v(i)-g*v(i)*pp(0)
      enddo
*
      return
      end
**************************************************
      double precision function lambda(x,y,z)
      double precision x,y,z
      lambda = x*x+y*y+z*z-2.d0*x*y-2.d0*x*z-2.d0*y*z
      lambda = abs(lambda)
      return
      end
**************************************************
      subroutine rot(idir,vect,pin,pout)
      implicit double precision (a-h,o-z)       
      double precision pin(0:3),pout(0:3),pp(0:3),r(3,3),
     >     vers(3),vect(0:3)
*
* This subroutine rotates the 4-vector pin in the frame where the z-axis is
* directed along the 4-vector vect(0,1,2,3). The rotated vector is stored
* in pout
*
* idir =  1 ---> direct rotation matrix
* idir = -1 ---> inverse rotation matrix
*      
      pp(0) = pin(0)
      pp(1) = pin(1)
      pp(2) = pin(2)
      pp(3) = pin(3)
      
      vmo = 1.d0/sqrt(vect(1)**2+vect(2)**2+vect(3)**2)
      
      vers(1) = vect(1)*vmo
      vers(2) = vect(2)*vmo
      vers(3) = vect(3)*vmo
            
      vt = sqrt(vers(1)**2+vers(2)**2)

!   BUG - pointed out by CLEO people
!      
!      v1ovt = vers(1)/vt
!      if (vt.eq.0.d0) v1ovt = 0.d0
!      v2ovt = vers(2)/vt
!      if (vt.eq.0.d0) v2ovt = 1.d0
 
      v1ovt = 0.d0
      v2ovt = 1.d0
      if (vt.gt.0.d0) then
         v1ovt = vers(1)/vt
         v2ovt = vers(2)/vt
      endif
     
      if (idir.eq.(-1)) then !! INVERSE rotation matrix

      !       r(1,1) =  vers(3)*v2ovt
      !       r(1,2) = -v1ovt
      !       r(1,3) =  vers(2)
 
      !       r(2,1) =  vers(3)*v1ovt
      !       r(2,2) =  v2ovt
      !       r(2,3) =  vers(1)
 
      !       r(3,1) = -vt
      !       r(3,2) =  0.d0
      !       r(3,3) =  vers(3)

       r(1,1) =  vers(3)*v1ovt
       r(1,2) = -v2ovt
       r(1,3) =  vers(1)
      
       r(2,1) =  vers(3)*v2ovt
       r(2,2) =  v1ovt
       r(2,3) =  vers(2)
      
       r(3,1) = -vt
       r(3,2) =  0.d0
       r(3,3) =  vers(3)      

      else ! if (idir.eq.1) !! DIRECT rotation matrix

      ! r(1,1) =  vers(3)*v2ovt
      ! r(2,1) = -v1ovt
      ! r(3,1) =  vers(2)
      
      ! r(1,2) =  vers(3)*v1ovt
      ! r(2,2) =  v2ovt
      ! r(3,2) =  vers(1)
      
      ! r(1,3) = -vt
      ! r(2,3) =  0.d0
      ! r(3,3) =  vers(3)      

       r(1,1) =  vers(3)*v1ovt
       r(2,1) = -v2ovt
       r(3,1) =  vers(1)
      
       r(1,2) =  vers(3)*v2ovt
       r(2,2) =  v1ovt
       r(3,2) =  vers(2)
      
       r(1,3) = -vt
       r(2,3) =  0.d0
       r(3,3) =  vers(3)      
     
      endif
            
      pout(0) = pp(0)
      pout(1) = r(1,1)*pp(1) + r(1,2)*pp(2) + r(1,3)*pp(3)
      pout(2) = r(2,1)*pp(1) + r(2,2)*pp(2) + r(2,3)*pp(3)
      pout(3) = r(3,1)*pp(1) + r(3,2)*pp(2) + r(3,3)*pp(3)
      
      return
      end
**************************************************
      double precision FUNCTION SCALPROD(QI,QJ)
      IMPLICIT NONE
      double precision QI(0:3),QJ(0:3)
      SCALPROD= -QI(1)*QJ(1)-QI(2)*QJ(2)-QI(3)*QJ(3)+QI(0)*QJ(0)
      RETURN
      END
*****************************************************
      subroutine resetname(name)
      integer i
      character*(*) name
      do i = 1,len(name)
         name(i:i) = ' '
      enddo
      return
      end
**************************************************
      function ifirstemptychar(name)
      integer i,k
      character*(*) name
      i = 1
      do k = 1,len(name)
         if (name(k:k).ne.' ') i=k
      enddo
      ifirstemptychar = i ! + 1
      return
      end
**************************************************
      subroutine merge_strings(str1,str2,merged)
      character*(*) merged,str1,str2
      integer n1
      n1 = ifirstemptychar(str1)
      if (str1(n1:n1).eq.' ') then
         merged=str2
      else
         merged=str1(:n1)//str2
      endif
      return
      end
**************************************************
      subroutine itoa(int,a)
      implicit integer (h-n)
      implicit character (a-g)
      character*(*) a
      parameter (nbase=10)
      call resetname(a)
      ichar0 = ichar('0')
      idiv = nbase
      i    = int
      ncifre    = 1
      do while((i/idiv).gt.0)
         idiv = idiv * nbase
         ncifre = ncifre+1
      enddo
      idiv = idiv/nbase
      do k =1,ncifre
         icifra = i/idiv
         ia = icifra + ichar0
         a(k:k) = char(ia)
         i = i - icifra*idiv
         idiv = idiv/nbase
      enddo      
      return
      end
************************************************
      subroutine fptoa(d,a)
      implicit integer (h-n)
      double precision d !,dec,tmp
      real*4 dec,tmp
      character*(*) a
      character*30 adec
      parameter (ndecimali=100000000)
      parameter (nbase=10)

!      d = din

      intpart = d
      call itoa(intpart,a)

      dec = d-intpart
      idecimali = dec*ndecimali

      tmp = intpart
      tmp = tmp*ndecimali
      tmp = tmp + idecimali

!      do k = 1,10000
!         print*,'attenzione fptoa non funziona con '
!         print*,'massa ad ex 150.1'
!      enddo

      if (anint(d*ndecimali-tmp).gt.0) then 
         idecimali = idecimali+1
         tmp = tmp + 1
      endif
      call itoa(idecimali,adec)

      nleadzeri = 0
      i = 1
      icont = 1
      ictrl = 0
      do while(i.lt.ndecimali.and.idecimali.gt.0)
         i = i*nbase
         ictrl = dec * i - ictrl
         if (ictrl.ge.1) icont = 0
         if (ictrl.eq.0) nleadzeri = nleadzeri + 1*icont
      enddo

      ladec = len(adec)
      istop = 0
      do k=1,ladec
         i = ladec+1 - k
         if (adec(i:i).ne.' ') then
            if (adec(i:i).ne.'0') istop = 1
            if (adec(i:i).eq.'0'.and.istop.eq.0) adec(i:i)=''
         endif
      enddo
      
      call merge_strings(a,'.',a)

      if (nleadzeri.gt.0) then
         do k=1,nleadzeri
            call merge_strings(a,'0',a)
         enddo
      endif

      call merge_strings(a,adec,a)
      return
      end
****************************************************
      subroutine realtoa(d,a)
      implicit integer (h-n)
      real*4 d !,dec,tmp
      real*4 dec,tmp
      character*(*) a
      character*30 adec
      parameter (ndecimali=100000000)
      parameter (nbase=10)

!      d = din

      intpart = d
      call itoa(intpart,a)

      dec = d-intpart
      idecimali = dec*ndecimali

      tmp = intpart
      tmp = tmp*ndecimali
      tmp = tmp + idecimali

!      do k = 1,10000
!         print*,'attenzione fptoa non funziona con '
!         print*,'massa ad ex 150.1'
!      enddo

      if (anint(d*ndecimali-tmp).gt.0) then 
         idecimali = idecimali+1
         tmp = tmp + 1
      endif
      call itoa(idecimali,adec)

      nleadzeri = 0
      i = 1
      icont = 1
      ictrl = 0
      do while(i.lt.ndecimali.and.idecimali.gt.0)
         i = i*nbase
         ictrl = dec * i - ictrl
         if (ictrl.ge.1) icont = 0
         if (ictrl.eq.0) nleadzeri = nleadzeri + 1*icont
      enddo

      ladec = len(adec)
      istop = 0
      do k=1,ladec
         i = ladec+1 - k
         if (adec(i:i).ne.' ') then
            if (adec(i:i).ne.'0') istop = 1
            if (adec(i:i).eq.'0'.and.istop.eq.0) adec(i:i)=''
         endif
      enddo
      
      call merge_strings(a,'.',a)

      if (nleadzeri.gt.0) then
         do k=1,nleadzeri
            call merge_strings(a,'0',a)
         enddo
      endif

      call merge_strings(a,adec,a)
      return
      end
****************************************************


**************************************************
      SUBROUTINE TSPENCE(XR,XI,OMXR,CLI2R,CLI2I)
! from TOPAZ0
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
*
      COMMON/TQPARAM/QPI,QPIS,QEPS,QDELTA
*
      DIMENSION B(0:14),BF(0:14)
      DIMENSION CLNX(2),CLNOMX(2),CLNOY(2),CLNZ(2),CLNOMZ(2)
      DIMENSION ADD1(2),ADD2(2),ADD3(2),PAR(2),RES(2),CT(15),SN(15)
      DIMENSION X(2),OMX(2),Y(2),OY(2),OMY(2),Z(2),OMZ(2),T(2),OMT(2)
      common/storedtspence/b,bf,ifirst
      data ifirst /0/
c CARLO
      if (ifirst.eq.0) then
         QDELTA= 9.025809333D0
         QEPS= 1.D-30
         QPI= 3.141592653589793238462643D0
         QPIS= QPI*QPI
         ifirst = 1
      endif
c CARLO
      X(1)= XR
      X(2)= XI
      OMX(1)= OMXR
      OMX(2)= -XI
      IF(XR.LT.0.D0) THEN
          Y(1)= OMXR
          Y(2)= -XI
          SIGN1= -1.D0
          CALL TCQLNX(X,CLNX)
          CALL TCQLNOMX(X,OMX,CLNOMX)
          ADD1(1)= QPIS/6.D0-CLNX(1)*CLNOMX(1)+CLNX(2)*CLNOMX(2)
          ADD1(2)= -CLNX(1)*CLNOMX(2)-CLNX(2)*CLNOMX(1)
      ELSE
          Y(1)= X(1)
          Y(2)= X(2)
          SIGN1= 1.D0
          ADD1(1)= 0.D0
          ADD1(2)= 0.D0
      ENDIF
      OMY(1)= 1.D0-Y(1)
      OMY(2)= -Y(2)
      YM2= Y(1)*Y(1)+Y(2)*Y(2)
      YM= SQRT(YM2)
      IF(YM.GT.1.D0) THEN
          Z(1)= Y(1)/YM2
          Z(2)= -Y(2)/YM2
          SIGN2= -1.D0
          OY(1)= -Y(1)
          OY(2)= -Y(2)
          CALL TCQLNX(OY,CLNOY)
          ADD2(1)= -QPIS/6.D0-0.5D0*((CLNOY(1))**2-(CLNOY(2))**2)
          ADD2(2)= -CLNOY(1)*CLNOY(2)
      ELSE
          Z(1)= Y(1)
          Z(2)= Y(2)
          SIGN2= 1.D0
          ADD2(1)= 0.D0
          ADD2(2)= 0.D0
      ENDIF
      OMZ(1)= 1.D0-Z(1)
      OMZ(2)= -Z(2)
      ZR= Z(1)
      IF(ZR.GT.0.5D0) THEN
          T(1)= 1.D0-Z(1)
          T(2)= -Z(2)
          OMT(1)= 1.D0-T(1)
          OMT(2)= -T(2)
          SIGN3= -1.D0
          CALL TCQLNX(Z,CLNZ)
          CALL TCQLNOMX(Z,OMZ,CLNOMZ)
          ADD3(1)= QPIS/6.D0-CLNZ(1)*CLNOMZ(1)+CLNZ(2)*CLNOMZ(2)
          ADD3(2)= -CLNZ(1)*CLNOMZ(2)-CLNZ(2)*CLNOMZ(1)
      ELSE
          T(1)= Z(1)
          T(2)= Z(2)
          OMT(1)= 1.D0-T(1)
          OMT(2)= -T(2)
          SIGN3= 1.D0
          ADD3(1)= 0.D0
          ADD3(2)= 0.D0
      ENDIF
      CALL TCQLNOMX(T,OMT,PAR)

      if (ifirst.eq.0) then
         B(0)= 1.D0
         B(1)= -1.D0/2.D0
         B(2)= 1.D0/6.D0
         B(4)= -1.D0/30.D0
         B(6)= 1.D0/42.D0
         B(8)= -1.D0/30.D0
         B(10)= 5.D0/66.D0
         B(12)= -691.D0/2730.D0
         B(14)= 7.D0/6.D0
         FACT= 1.D0
         DO N=0,14
            BF(N)= B(N)/FACT
            FACT= FACT*(N+2.D0)
         ENDDO
      endif
      PARR= PAR(1)
      PARI= PAR(2)
      PARM2= PARR*PARR+PARI*PARI
      PARM= SQRT(PARM2)
      CT(1)= PARR/PARM
      SN(1)= PARI/PARM
      DO N=2,15
          CT(N)= CT(1)*CT(N-1)-SN(1)*SN(N-1)
          SN(N)= SN(1)*CT(N-1)+CT(1)*SN(N-1)
      ENDDO
*      
      RES(1)= -((((((((BF(14)*CT(15)*PARM2+BF(12)*CT(13))*PARM2+
     #                 BF(10)*CT(11))*PARM2+BF(8)*CT(9))*PARM2+
     #                 BF(6)*CT(7))*PARM2+BF(4)*CT(5))*PARM2+
     #                 BF(2)*CT(3))*(-PARM)+BF(1)*CT(2))*(-PARM)+
     #                 BF(0)*CT(1))*PARM 
      RES(2)= -((((((((BF(14)*SN(15)*PARM2+BF(12)*SN(13))*PARM2+
     #                 BF(10)*SN(11))*PARM2+BF(8)*SN(9))*PARM2+
     #                 BF(6)*SN(7))*PARM2+BF(4)*SN(5))*PARM2+
     #                 BF(2)*SN(3))*(-PARM)+BF(1)*SN(2))*(-PARM)+
     #                 BF(0)*SN(1))*PARM 
      CLI2R= SIGN1*(SIGN2*(SIGN3*RES(1)+ADD3(1))+ADD2(1))+ADD1(1)
      CLI2I= SIGN1*(SIGN2*(SIGN3*RES(2)+ADD3(2))+ADD2(2))+ADD1(2)
*
      ifirst = 1
      RETURN
      END
*
*-----CQLNX---------------------------------------------
*     COMPUTES  LN(Z)                              
*
      SUBROUTINE TCQLNX(ARG,RES)
! from TOPAZ0
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
*
      DIMENSION ARG(2),AARG(2),RES(2)
*
      QPI= 3.141592653589793238462643D0
      DO I= 1,2
          AARG(I)= ABS(ARG(I))
      ENDDO
      ZM2= (ARG(1))**2+(ARG(2))**2
      ZM= SQRT(ZM2)
      RES(1)= LOG(ZM)
      IF(ARG(1).EQ.0.D0) THEN
          IF(ARG(2).GT.0.D0) THEN
              TETA= QPI/2.D0
          ELSE
              TETA= -QPI/2.D0
          ENDIF
          RES(2)= TETA
          RETURN
      ELSE IF(ARG(2).EQ.0.D0) THEN 
               IF(ARG(1).GT.0.D0) THEN
                   TETA= 0.D0
               ELSE
                   TETA= QPI
               ENDIF
          RES(2)= TETA
          RETURN
      ELSE
          TNTETA= AARG(2)/AARG(1)
          TETA= ATAN(TNTETA)
          SR= ARG(1)/AARG(1)
          SI= ARG(2)/AARG(2)
          IF(SR.GT.0.D0) THEN
              RES(2)= SI*TETA
          ELSE
              RES(2)= SI*(QPI-TETA)
          ENDIF
          RETURN
      ENDIF
      END
*
*-----CQLNOMX---------------------------------------
*     COMPUTES LN(1-X)                 
*     USUALLY |X| << 1                 
      SUBROUTINE TCQLNOMX(ARG,OMARG,RES)
! from TOPAZ0
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION ARG(2),OMARG(2),RES(2),ARES(2),CT(10),SN(10)
*
      ZR= ARG(1)
      ZI= ARG(2)
      ZM2= ZR*ZR+ZI*ZI
      ZM= SQRT(ZM2)
      IF(ZM.LT.1.D-7) THEN
          CT(1)= ZR/ZM
          SN(1)= ZI/ZM
          DO N=2,10
              CT(N)= CT(1)*CT(N-1)-SN(1)*SN(N-1)
              SN(N)= SN(1)*CT(N-1)+CT(1)*SN(N-1)
          ENDDO
          ARES(1)= CT(10)/10.D0
          ARES(2)= SN(10)/10.D0
          DO K=9,1,-1
              ARES(1)= ARES(1)*ZM+CT(K)/K
              ARES(2)= ARES(2)*ZM+SN(K)/K
          ENDDO
          ARES(1)= -ARES(1)*ZM
          ARES(2)= -ARES(2)*ZM
      ELSE
          CALL TCQLNX(OMARG,ARES)
      ENDIF
      RES(1)= ARES(1)
      RES(2)= ARES(2)
      RETURN
      END
**************************************************
      double precision FUNCTION DDILOG(X)
      double precision X,Y,T,S,A,PI3,PI6,ZERO,ONE,HALF,MALF,MONE,MTWO
      double precision C(0:18),H,ALFA,B0,B1,B2
      DATA ZERO /0.0D0/, ONE /1.0D0/
      DATA HALF /0.5D0/, MALF /-0.5D0/, MONE /-1.0D0/, MTWO /-2.0D0/
      DATA PI3 /3.28986 81336 96453D0/, PI6 /1.64493 40668 48226D0/
      DATA C( 0) / 0.42996 69356 08137 0D0/
      DATA C( 1) / 0.40975 98753 30771 1D0/
      DATA C( 2) /-0.01858 84366 50146 0D0/
      DATA C( 3) / 0.00145 75108 40622 7D0/
      DATA C( 4) /-0.00014 30418 44423 4D0/
      DATA C( 5) / 0.00001 58841 55418 8D0/
      DATA C( 6) /-0.00000 19078 49593 9D0/
      DATA C( 7) / 0.00000 02419 51808 5D0/
      DATA C( 8) /-0.00000 00319 33412 7D0/
      DATA C( 9) / 0.00000 00043 45450 6D0/
      DATA C(10) /-0.00000 00006 05784 8D0/
      DATA C(11) / 0.00000 00000 86121 0D0/
      DATA C(12) /-0.00000 00000 12443 3D0/
      DATA C(13) / 0.00000 00000 01822 6D0/
      DATA C(14) /-0.00000 00000 00270 1D0/
      DATA C(15) / 0.00000 00000 00040 4D0/
      DATA C(16) /-0.00000 00000 00006 1D0/
      DATA C(17) / 0.00000 00000 00000 9D0/
      DATA C(18) /-0.00000 00000 00000 1D0/
      IF(X .EQ. ONE) THEN
         DDILOG=PI6
         RETURN
      ELSE IF(X .EQ. MONE) THEN
         DDILOG=MALF*PI6
         RETURN
      END IF
      T=-X
      IF(T .LE. MTWO) THEN
         Y=MONE/(ONE+T)
         S=ONE
         A=-PI3+HALF*(LOG(-T)**2-LOG(ONE+ONE/T)**2)
      ELSE IF(T .LT. MONE) THEN
         Y=MONE-T
         S=MONE
         A=LOG(-T)
         A=-PI6+A*(A+LOG(ONE+ONE/T))
      ELSE IF(T .LE. MALF) THEN
         Y=(MONE-T)/T
         S=ONE
         A=LOG(-T)
         A=-PI6+A*(MALF*A+LOG(ONE+T))
      ELSE IF(T .LT. ZERO) THEN
         Y=-T/(ONE+T)
         S=MONE
         A=HALF*LOG(ONE+T)**2
      ELSE IF(T .LE. ONE) THEN
         Y=T
         S=ONE
         A=ZERO
      ELSE
         Y=ONE/T
         S=MONE
         A=PI6+HALF*LOG(T)**2
      END IF
      H=Y+Y-ONE
      ALFA=H+H
      B1=ZERO
      B2=ZERO
      DO I = 18,0,-1
         B0=C(I)+ALFA*B1-B2
         B2=B1
         B1=B0
      enddo
      DDILOG=-(S*(B0-H*B2)+A)
c      print*,ddilog, li2(x)
      RETURN
      END
**************************************************
      subroutine cutsandsmear(p1,p2,p3,p4,q,qph,ireject)
! ireject = 1 reject the event, ireject = 1 do not reject
      implicit double precision (a-h,m,o-z)
      common/photonmass/mg ! common for routine propagator in Asu3.f
      common/forcuts/egmax
      common/imode/imode
      common/recombinesmearcut/irecombine,ismearing,icut

      common/paramhiggs/masshiggs
      common/zparam/zmass,zwidth

      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3),q(0:3),ptmp(0:3)
      dimension qph(40,0:3)
! quando entra q e' il fotone piu' energetico.
! qph e' tutto nullo nel caso di ordine alpha esatto.
! carico q in qph in ogni caso, ricombino, smearo con qph ed cerco di
! nuovo il fotone + energetico da mettere in q

      ireject = 1
      if (q(0).gt.egmax) return

      if (irecombine.eq.1) then
         if (imode.lt.10) then
            do k = 0,3
               qph(1,k) = q(k)
            enddo
         endif
         if (imode.lt.20.and.
     >      (imode.ne.4.and.imode.ne.15.and.imode.ne.16)) then
            call recombine_photons_dedp(p1,qph)
            call recombine_photons_dedp(p2,qph)
            if (imode.eq.3.or.imode.eq.13.or.imode.eq.14) then
               call recombine_photons_dedp(p3,qph)
               call recombine_photons_dedp(p4,qph)
            endif
         endif
      endif

******** BEGIN SMEARING ***
      if (ismearing.eq.1) then
* exact order alpha
         if (imode.le.3) then
            call smearingel(p1,p1)
            call smearingel(p2,p2)
            if (imode.le.2) then
               call smearingmu(p3,p3)
               call smearingmu(p4,p4)
            else
               call smearingel(p3,p3)
               call smearingel(p4,p4)
            endif
         endif
         if (imode.eq.4) then
            call smearingmu(p1,p1)
            call smearingmu(p2,p2)
            call smearingmu(p3,p3)
            call smearingmu(p4,p4)
         endif
* parton shower
         if (imode.gt.10.and.imode.lt.20) then
            if (imode.le.14) then
               call smearingel(p1,p1)
               call smearingel(p2,p2)
               if (imode.eq.11.or.imode.eq.12) then
                  call smearingmu(p3,p3)
                  call smearingmu(p4,p4)
               else
                  call smearingel(p3,p3)
                  call smearingel(p4,p4)
               endif
            endif
            if (imode.gt.14) then
               call smearingmu(p1,p1)
               call smearingmu(p2,p2)
               call smearingmu(p3,p3)
               call smearingmu(p4,p4)
            endif
         endif
* born
         if (imode.gt.20) then
            if (imode.eq.21) then
               call smearingel(p1,p1)
               call smearingel(p2,p2)
               call smearingmu(p3,p3)
               call smearingmu(p4,p4)
            endif
            if (imode.eq.22) then
               call smearingel(p1,p1)
               call smearingel(p2,p2)
               call smearingel(p3,p3)
               call smearingel(p4,p4)
            endif
            if (imode.eq.23) then
               call smearingmu(p1,p1)
               call smearingmu(p2,p2)
               call smearingmu(p3,p3)
               call smearingmu(p4,p4)
            endif
         endif
         
* photon smearing
         do k = 1,40
            if (qph(k,0).gt.0.d0) then
               do i = 0,3
                  ptmp(i) = qph(k,i)
               enddo
               call smearingph(ptmp,ptmp)
               do i = 0,3
                  qph(k,i) = ptmp(i)
               enddo
            endif
         enddo
      endif
******** END SMEARING ***
** finding again the most energetic photon...
      if (ismearing.eq.1.or.irecombine.eq.1) then
         do i = 0,3
            q(i) = 0.d0
         enddo
         call fotonepiuenergetico(qph,q)
      endif
******

      if (icut.eq.1) then
         eta1 = 1.d0/2.d0*log( (P1(0) + P1(3))/(P1(0) - P1(3)) )
         eta1 = abs(eta1)
         p_T1 = sqrt( P1(1)**2 + P1(2)**2 )
         
         eta2 = 1.d0/2.d0*log( (P2(0) + P2(3))/(P2(0) - P2(3)) )
         eta2 = abs(eta2)
         p_T2 = sqrt( P2(1)**2 + P2(2)**2 )
         
         eta3 = 1.d0/2.d0*log( (P3(0) + P3(3))/(P3(0) - P3(3)) )
         eta3 = abs(eta3)
         p_T3 = sqrt( P3(1)**2 + P3(2)**2 )
         
         eta4 = 1.d0/2.d0*log( (P4(0) + P4(3))/(P4(0) - P4(3)) )
         eta4 = abs(eta4)
         p_T4 = sqrt( P4(1)**2 + P4(2)**2 )
         
         t = 20.d0
         b = 7.d0
         
         if ((p_T1.gt.t.and.p_T2.gt.t).and.(p_T3.gt.b.and.p_T4.gt.b)) 
     >        then 
            goto 45
      else if ((p_T3.gt.t.and.p_T4.gt.t).and.(p_T1.gt.b.and.p_T2.gt.b))
     >           then
            goto 45        
      else if ((p_T1.gt.t.and.p_T3.gt.t).and.(p_T2.gt.b.and.p_T4.gt.b))
     >           then
            goto 45
      else if ((p_T1.gt.t.and.p_T4.gt.t).and.(p_T2.gt.b.and.p_T3.gt.b))
     >           then
            goto 45
      else if ((p_T2.gt.t.and.p_T3.gt.t).and.(p_T1.gt.b.and.p_T4.gt.b))
     >           then
            goto 45       
      else if ((p_T2.gt.t.and.p_T4.gt.t).and.(p_T1.gt.b.and.p_T3.gt.b))
     >           then
            goto 45       
         else
            ireject = 1
            return
         endif
         
 45      ec=2.5d0
         if ((eta1.gt.ec.or.eta2.gt.ec).or.(eta3.gt.ec.or.eta4.gt.ec)) 
     >        then
            ireject = 1
            return	   
         endif         
***********************HIGGS MASS Dependent CUTS!!!!!!!!!!!!!!!*********
 55      continue   
         deltam = 10.d0
         m34    = 30.d0

         if (masshiggs.gt.122.5d0.and.masshiggs.lt.137.5d0) then
            deltam = 15.d0
            m34    = 20.d0
         endif
         if (masshiggs.gt.107.5d0.and.masshiggs.lt.122.5d0) then
            deltam = 20.d0
            m34    = 15.d0
         endif

         Mm = zmass - deltam
         Mp = zmass + deltam

************************************************************************
         mp12 = sqrt( (P1(0)+P2(0))**2 - (P1(1)+P2(1))**2 -
     >        (P1(2)+P2(2))**2 - (P1(3)+P2(3))**2 ) 
         mp34 = sqrt( (P3(0)+P4(0))**2 - (P3(1)+P4(1))**2 -
     >        (P3(2)+P4(2))**2 - (P3(3)+P4(3))**2 ) 
         mp14 = sqrt( (P1(0)+P4(0))**2 - (P1(1)+P4(1))**2 -
     >        (P1(2)+P4(2))**2 - (P1(3)+P4(3))**2 ) 
         mp32 = sqrt( (P3(0)+P2(0))**2 - (P3(1)+P2(1))**2 -
     >        (P3(2)+P2(2))**2 - (P3(3)+P2(3))**2 )
         mp13 = sqrt( (P1(0)+P3(0))**2 - (P1(1)+P3(1))**2 -
     >        (P1(2)+P3(2))**2 - (P1(3)+P3(3))**2 ) 
         mp24 = sqrt( (P2(0)+P4(0))**2 - (P2(1)+P4(1))**2 -
     >        (P2(2)+P4(2))**2 - (P2(3)+P4(3))**2 )  
                  
         if ((Mm.LE.mp12.and.mp12.LE.Mp).and.(mp34.GT.m34)) then
            ireject = 0    
            
         else if ((Mm.LE.mp34.and.mp34.LE.Mp).and.(mp12.GT.m34)) then
            ireject = 0
            
         else if ((Mm.LE.mp14.and.mp14.LE.Mp).and.(mp32.GT.m34)) then
            ireject = 0
            
         else if ((Mm.LE.mp32.and.mp32.LE.Mp).and.(mp14.GT.m34)) then
            ireject = 0
            
         else if ((Mm.LE.mp13.and.mp13.LE.Mp).and.(mp24.GT.m34)) then
            ireject = 0
            
         else if ((Mm.LE.mp24.and.mp24.LE.Mp).and.(mp13.GT.m34)) then
            ireject = 0
         else
            ireject = 1
         endif         
      else
         ireject = 0
      endif

      return
      end
**********************************************************
      subroutine recombine_photons_dedp(Pl,qph)
* Ricombina fotoni secondo le specifiche di ATLAS LHC ed azzera in qph 
* i quadrimomenti corrispondenti ai fotoni ricombinati!!!!
** Parametro e` il piano DeltaR, secondo le specifiche di Atlas TDR...solo per
*** calorimetro elettromagnetico avviene la ricombinazione.
      implicit double precision (a-h,o-z)
      parameter (deta = 0.075d0)
      parameter (dphi = 0.175d0)
      dimension Pl(0:3),qtmp(0:3),qph(40,0:3)
      
      deltaR = sqrt( deta**2 + dphi**2 )
      
      ilcount = 0
      ifot   = 0
      etae = 0.5d0 * log( (Pl(0)+Pl(3) )/( Pl(0)-Pl(3) ) )
      phie = atan( Pl(2)/Pl(1) )
      if (Pl(1).eq.0.d0) then
         phie = 0.d0  
      endif
	 
      do k = 1,40
         if (qph(k,0).gt.0.5d-8) then
            ifot = ifot + 1
            do i=0,3
               qtmp(i) = qph(k,i)
            enddo
            
            etaph = 0.5d0 * log((qtmp(0)+qtmp(3))/(qtmp(0)-qtmp(3)))	       
            phiph = atan( qtmp(2)/qtmp(1) )
            if (Pl(1).eq.0.d0) then
               phiph = 0.d0  
            endif
            
            deltaeta = abs(etae - etaph)
            deltaphi = abs(phie - phiph)
            cone = sqrt( deltaeta**2 + deltaphi**2 )
            
            if (cone.le.deltaR) then
               ilcount = ilcount + 1
               do i=0,3
                  Pl(i) = Pl(i) + qtmp(i)
                  qph(k,i) = 0.d0
               enddo
            endif
	 endif
      enddo
      
      return
      end	       
********************************************************
      subroutine smearingel(p,q)
      implicit double precision (a-h,o-z)
      integer NCALLS
      parameter (LUX=4,k1=0,k2=0,LEN=2)
      double precision rvec(LEN)
      dimension vec(LEN)
      dimension p(0:3),q(0:3)
      double precision modl,pSM
      dimension v(0:3),CMV(2)
      
      pi = 4.d0 * atan(1.d0)
      
      call WRAPRND(RVEC,LEN)
      CMV(1) = RVEC(1)
      CMV(2) = RVEC(2)
      
      eta = 1.d0/2.d0*log( (p(0) + p(3))/(p(0) - p(3)) )
      eta = abs(eta)
      
      if (eta.le.0.3d0) then
         a = 0.0854d0
         b = 0.005d0
      endif
      
      if (eta.gt.0.3d0.and.eta.le.1.1d0) then
         a = 0.1244d0
         b = 0.0039d0
      endif
      
      if (eta.gt.1.1d0) then
         a = 0.116d0
         b = 0.0032d0
      endif
      
      modl = sqrt( p(1)**2 + p(2)**2 + p(3)**2 )
      
      v(0) = p(0)/modl
      v(1) = p(1)/modl
      v(2) = p(2)/modl
      v(3) = p(3)/modl
      
      sigma = p(0)*sqrt( a**2/p(0) + b**2 )
      
      x = sqrt( -2.d0*log(CMV(1)) )*cos( 2.d0*pi*CMV(2) )
      y = sqrt( -2.d0*log(CMV(1)) )*sin( 2.d0*pi*CMV(2) )
      
      pSM = modl + sigma*x
      
      if (pSM.lt.0.d0) pSM = modl
      
      q(0) = pSM*v(0)
      q(1) = pSM*v(1)
      q(2) = pSM*v(2)
      q(3) = pSM*v(3) 
      
      return
      end     
************************************************************************
      subroutine smearingph(p,q)
      implicit double precision (a-h,o-z)
      integer NCALLS
      parameter (LUX=4,k1=0,k2=0,LEN=2)
      double precision rvec(LEN)
      dimension vec(LEN)
      dimension p(0:3),q(0:3)
      double precision modl,pSM
      dimension v(0:3),CMV(2)
      
      pi = 4.d0 * atan(1.d0)
      
      call WRAPRND(RVEC,LEN)
      CMV(1) = RVEC(1)
      CMV(2) = RVEC(2)
      
      eta = 1.d0/2.d0*log( (p(0) + p(3))/(p(0) - p(3)) )
      eta = abs(eta)
      
      if (eta.lt.2.d0) then
         a = 0.0954d0
         b = 0.0023d0
      endif
      
      if (eta.ge.2.d0) then
         a = 0.107d0
         b = 0.0028d0
      endif
      
      modl = sqrt( p(1)**2 + p(2)**2 + p(3)**2 )
      
      v(0) = p(0)/modl
      v(1) = p(1)/modl
      v(2) = p(2)/modl
      v(3) = p(3)/modl
      
      sigma = p(0)*sqrt( a**2/p(0) + b**2 )
      
      x = sqrt( -2.d0*log(CMV(1)) )*cos( 2.d0*pi*CMV(2) )
      y = sqrt( -2.d0*log(CMV(1)) )*sin( 2.d0*pi*CMV(2) )
      
      pSM = modl + sigma*x
      
      if (pSM.lt.0.d0) pSM = modl
      
      q(0) = pSM*v(0)
      q(1) = pSM*v(1)
      q(2) = pSM*v(2)
      q(3) = pSM*v(3)
      return
      end
************************************************************************
      subroutine smearingmu(p,q)
      implicit double precision (a-h,o-z)
      integer NCALLS
      parameter (LUX=4,k1=0,k2=0,LEN=2)
      double precision rvec(LEN)
      dimension vec(LEN)
      dimension p(0:3),q(0:3)
      double precision modl,pSM,steta
      dimension v(0:3),CMV(2)
      
      pi = 4.d0 * atan(1.d0) 
      
      call WRAPRND(RVEC,LEN)
      CMV(1) = RVEC(1)
      CMV(2) = RVEC(2)
      
      eta = 1.d0/2.d0*log( (p(0) + p(3))/(p(0) - p(3)) )
      eta = abs(eta)
      
      p_T = sqrt( p(1)**2 + p(2)**2 )
      
      if (p_T.lt.1000.d0) then
	 sigma = 0.9343d0
      endif
      
      if (p_T.ge.1000.d0) then
	 sigma = 0.9402d0
      endif
      
      modl = sqrt( p(1)**2 + p(2)**2 + p(3)**2 )
      
      v(0) = p(0)/modl
      v(1) = p(1)/modl
      v(2) = p(2)/modl
      v(3) = p(3)/modl
      
      x = sqrt( -2.d0*log(CMV(1)) )*cos( 2.d0*pi*CMV(2) )
      y = sqrt( -2.d0*log(CMV(1)) )*sin( 2.d0*pi*CMV(2) )
      steta = p_T/modl
      
      
      p_Tbefore = p_T
      p_T = p_T + sigma*x
      
      if (p_T.lt.0.d0) then
         p_T = p_Tbefore
      endif
      
      pSM = p_T/steta
      q(0) = pSM*v(0)
      q(1) = pSM*v(1)
      q(2) = pSM*v(2)
      q(3) = pSM*v(3)      
      
      return
      end


***********************************************************
      subroutine cpmom(p1,p2)
      implicit none
      integer k
      double precision p1(0:3),p2(0:3)
      do k = 0,3
         p2(k) = p1(k)
      enddo
      return
      end

**********************************************************
      subroutine handregulator(ng,p1,p2,p3,p4,qph,den)
      implicit double precision (a-h,m,o-z)

      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      dimension qph(0:3,ng),q1(0:3),q2(0:3),q3(0:3)
      dimension p12(0:3),p34(0:3),pz1(0:3),pz2(0:3)

      dimension p14(0:3),p23(0:3),pz12(0:3),pz34(0:3)
      dimension pz14(0:3),pz23(0:3)

      dimension p12q1(0:3),p12q2(0:3)
      dimension p12q1q2(0:3)
      dimension p34q1(0:3),p34q2(0:3)
      dimension p34q1q2(0:3)
      dimension coll1(ng),coll2(ng),coll3(ng),coll4(ng)
      dimension collt(4,ng)
      dimension pt(0:3,4)
      integer   pow4(0:ng)
      integer   pow2(0:ng)
      common/identicalparticles/idpart

!      pow4(0) = 1
      pow2(0) = 1
      do k = 1,ng
!        pow4(k)    = pow4(k-1)*4
         pow2(k)    = pow2(k-1)*2
         collt(1,k) = 1.d0/dot(p1,qph(:,k)) * p1(0)*qph(0,k)
         collt(2,k) = 1.d0/dot(p2,qph(:,k)) * p2(0)*qph(0,k)
         collt(3,k) = 1.d0/dot(p3,qph(:,k)) * p3(0)*qph(0,k)
         collt(4,k) = 1.d0/dot(p4,qph(:,k)) * p4(0)*qph(0,k) 
      enddo

* OPTIMIZED
      IF (idpart.eq.0) THEN
      p12 = p1+p2
      p34 = p3+p4
      den = 0.d0
      do j = 0,2**ng-1
         pz12 = p12
         pz34 = p34
         prod = 1.d0
         do k = 1,ng
            iz = mod(j,pow2(k)) / pow2(k-1) + 1
            if (iz.eq.1) then
               pz12  = pz12 + qph(:,k)
               prod = prod * (collt(1,k)+collt(2,k))
            else
               pz34  = pz34 + qph(:,k)
               prod = prod * (collt(3,k)+collt(4,k))
            endif
         enddo
         prod = prod*bw(dot(pz12,pz12))*bw(dot(pz34,pz34))
         den = den + prod
      enddo
      ELSE
*************** FOR IDENTICAL PARTICLES
      p12 = p1+p2
      p34 = p3+p4
      p14 = p1+p4
      p23 = p2+p3

      den = 0.d0
      do j = 0,2**ng-1
         pz12 = p12
         pz34 = p34
         pz14 = p14
         pz23 = p23
         prod1234 = 1.d0
         prod1423 = 1.d0
         do k = 1,ng
            iz = mod(j,pow2(k)) / pow2(k-1) + 1
            if (iz.eq.1) then
               pz12  = pz12 + qph(:,k)
               pz14  = pz14 + qph(:,k)

               prod1234 = prod1234 * (collt(1,k)+collt(2,k))
               prod1423 = prod1423 * (collt(1,k)+collt(4,k))
            else
               pz34 = pz34 + qph(:,k)
               pz23 = pz23 + qph(:,k)

               prod1234 = prod1234 * (collt(3,k)+collt(4,k))
               prod1423 = prod1423 * (collt(2,k)+collt(3,k))
            endif
         enddo
         prod1234 = prod1234*bw(dot(pz12,pz12))*bw(dot(pz34,pz34))
         prod1423 = prod1423*bw(dot(pz14,pz14))*bw(dot(pz23,pz23))
         den = den + (prod1234+prod1423)*0.5d0
      enddo
      ENDIF

      return ! RETURNING HERE

*** NOT OPTIMIZED
      
      print*,'pow4 not defined!'

      den = 0.d0
      do j = 1,4**ng
         pz1 = p12
         pz2 = p34
         prod = 1.d0
         do k = 1,ng
            i = mod(j,pow4(k)) / pow4(k-1) + 1
c            i = mod(j,pow4(k)) * 4/pow4(k) + 1
            if (i.le.2) pz1 = pz1 + qph(:,k)
            if (i.gt.2) pz2 = pz2 + qph(:,k)
            prod = prod * collt(i,k)
         enddo
         prod = prod*bw(dot(pz1,pz1))*bw(dot(pz2,pz2))
         den = den + prod
      enddo

c      print*,den

      return
      end
*******************************************************************************
      subroutine writeoutputHto4l(writecond)
      implicit double precision (a-h,m,l,o-z)
#include "inigenfin.h"
      character*10 weimo
      integer ierr
      integer*8 k,kunw,kw,nmaxprw,nmaxprunw,imtxcalc
      double precision phin(0:3)
      common/howmanycalctimes/imtxcalc
      common/qtoosoft/ieq

      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3),q(0:3)
      dimension p1l(0:3),p2l(0:3),p3l(0:3),p4l(0:3),ql(0:3)
      dimension ptmp(0:3),pp(0:3),charges(4)
      dimension qph(40,0:3),qphl(40,0:3),csi(1)
      real*4 timearray(2) ,timesum

      double precision em,mm

      integer isvec(25)
      parameter (npart = 5)
      character*9 crsstr
      character*1 tstr
      integer*8 ncalls
      integer lpath,lsuff
      character*100 massadellhiggs
      character*30 errpos
      data errpos/'                              '/

      common/photonmass/mg ! common for routine propagator in Asu3.f
      common/paramhiggs/masshiggs

      double precision mhnom,whtot
      common/higgsnominal/mhnom,whtot

      common/alphas/alpha0,alphaGF,alpha
      common/gdifermi/gfermi
      common/wparam/wmass,wwidth
      common/forcuts/egmax
      common/hadron_parton/ipartonic,iusempi
      common/recombinesmearcut/irecombine,ismearing,icut

      double precision mz1,mz2
      integer nphleg(4)
      common/eikcheck/mz1,mz2,nphleg
      integer iclosecomm(40)
      common/iclosecomm/iclosecomm

      double complex Dr,Drt
      common/deltaerre/Dr,Drt

      common/zwidthonoff/zwonoff
      common/zparam/zmass,zwidth

      common/imode/imode
      integer iba
      common/ibaswitch/iba
      common/identicalparticles/idpart

      parameter (nfs=3,nord=9)
      character*4 fsa(nfs)
      character*8 orda(nord)

      logical writecond
      
      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double precision rescaleQED
      common/QEDrescale/rescaleQED

      double precision mass(5)
      common/amasses/mass

      common/nphotMODE/nphotmode


c      character*12 col(20)
      character*1 col(20)
      common/colors/col

      double precision phmass,egmin
      COMMON/INFRAR/phmass,egmin
      common/FSmasses/ame,amm

      common/todebug/emtx2,phsp
      
      common/Hdecaygen/nmaxprw,nmaxprunw,kw,ifirstdecay,iwmod,
     >     iunwmod,istopsearch,isearch,nover,nnegw,nnegunw

      integer*8 ntotin
      common/tobeprinted/ntotin

      integer nsearch
      common/searchpoints/nsearch

      common/suggestedtruemax/truemaxsuggested
      common/cutonlowinvmasses/cutlowinvmass
*------------------------------------------------------------------------      
      double precision Hto4l_dCz,Hto4l_Caa,Hto4l_Cza,Hto4l_Czz,
     .     Hto4l_Czbx,Hto4l_dGlL,Hto4l_dGlR,
     .     Hto4l_dGhlL,Hto4l_dGhlR,
     .     Hto4l_tCaa,Hto4l_tCza,Hto4l_tCzz
      common/dim6/Hto4l_dCz,Hto4l_Caa,Hto4l_Cza,Hto4l_Czz,
     .     Hto4l_Czbx,Hto4l_dGlL,Hto4l_dGlR,
     .     Hto4l_dGhlL,Hto4l_dGhlR,
     .     Hto4l_tCaa,Hto4l_tCza,Hto4l_tCzz

*-------------------------------------------------------------------------
      double precision  S_cH,S_cHl,S_cHlp,S_cHe,
     .     S_cll,S_cT,S_c2W,S_c2B,S_cg,S_cW,
     .     S_cB,S_cHW,S_cHB,S_tcg,S_tcHW,S_tcHB
      common/SILH/S_cH,S_cHl,S_cHlp,S_cHe,
     .     S_cll,S_cT,S_c2W,S_c2B,S_cg,S_cW,
     .     S_cB,S_cHW,S_cHB,S_tcg,S_tcHW,S_tcHB
*------------------------------------------------------------------------
      double precision W_cHl3,W_cHl1,W_cHe,W_cHWB,W_cll,
     .     W_cHD,W_cHbx,W_cHW,W_cHB,W_tcHW,
     .     W_tcHB,W_tcHWB
      common/warsaw/W_cHl3,W_cHl1,W_cHe,W_cHWB,W_cll,
     .     W_cHD,W_cHbx,W_cHW,W_cHB,W_tcHW,
     .     W_tcHB,W_tcHWB
*------------------------------------------------------------------------

      integer anm_cpg,basis,quadratics,CP
      common/anm/anm_cpg,basis,quadratics,CP
*-------------------------------------------------------------------------
      
      iwri = iwri + 1
      
      if (writecond) then
         open(10,file=outputfile,status='unknown')

         do ki = 0,nphmax
            width(ki) = width(ki) !*1000.d0 already accouted for by toXeV
            sigma(ki) = sigma(ki) !*1000.d0
         enddo
         wid = 0.d0 
         sig = 0.d0
         do ki = 0,nphmax
            wid = wid + width(ki)
            sig = sig + sigma(ki)**2
         enddo
         sig = sqrt(sig)
         perc0 = 0.d0
         perc1 = 0.d0
         perct = 0.d0
         
         if (abs(width(0)).gt.0.d0) perc0=sigma(0)/width(0) * 100.d0
         if (width(1).gt.0.d0)      perc1=sigma(1)/width(1) * 100.d0
         perct = sig/wid * 100.d0
         write(10,'(1x,A)') 'PID = '//procid//' on '//machine
         write(10,'(1x,A,I8,A)') 'Running mode = '//fsc//'   '//ord
c     +                             //'      (i.e. imode =',imode,')'

         if (suffix(1:2).eq.'ex'.or.suffix(1:2).eq.'ma') then
            if (iweakcorr.eq.1) then
               write(10,'(1x,A)') '      including FULL QED+WEAK NLO'
            else
               write(10,'(1x,A)') '      including only QED NLO'
            endif
         endif

         write(10,*)' '
         write(10,*)'SEED for PRNG',iseed

         write(10,*)col(5)
         write(10,*)'Run parameters:'
         
         write(10,'(1x,A,1x,f7.3,A)')
     +        ' Higgs mass   ',mhnom,' GeV'
         write(10,'(1x,A,1x,f11.7,A)')
     +        ' Z mass       ',zmass,' GeV'
         write(10,'(1x,A,1x,f11.7,A)')
     +        ' Z width      ',zwidth,' GeV'
         
         write(10,'(1x,A,1x,f11.7,A)')
     +        ' W mass       ',wmass,' GeV'
         write(10,'(1x,A,1x,f11.7,A)')
     +        ' W width      ',wwidth,' GeV'
         
         write(10,'(1x,A,1x,f11.7,A)')
     +        ' G_fermi      ',gfermi*1d5,'*10^(-5) GeV^(-2)'
         
         write(10,'(1x,A,1x,f11.7,A)')
     +        ' 1/alpha(0)   ',1.d0/alpha0,'  '
         
         write(10,'(1x,A,1x,f11.7,A)')
     +        ' 1/alphaGF    ',1.d0/alphaGF,'  '
         
         write(10,'(1x,A,1x,f11.7,A)')
     +        ' 1/alpha      ',1.d0/alpha,'  '
         
         write(10,'(1x,A,1x,f11.7,A)')
     +        ' alpha0/alpha ',rescaleQED,'  '
         
         write(10,'(1x,A,f12.8,f12.8,f12.8,f12.8,A)')
     +        ' Lepton masses ',(mass(i),i=1,4),' GeV'


         write(10, '(A)') ' ' 
         write(10, '(A)') 'CUT ON LEADING AND SUBLEADING SFOS'
         write(10,'(1x,A,1x,f11.7,A)')
     +        ' M_cut = ', cutlowinvmass,' GeV'
                  
         if(anm_cpg .eq. 1) then
            write(10,*) ' '
            if(basis .eq. 1) then
               write(10,'(A)') 'Higgs basis coefficients'
            
               write(10,'(1x,A,1x,f11.7,A)') ' dCz    = ',
     .              Hto4l_dCz, '  '
               write(10,'(1x,A,1x,f11.7,A)') ' Caa    = ',
     .              Hto4l_Caa, '  '
               write(10,'(1x,A,1x,f11.7,A)') ' Cza    = ',
     .              Hto4l_Cza, '  '
               write(10,'(1x,A,1x,f11.7,A)') ' Czz    = ',
     .              Hto4l_Czz, '  '
               write(10,'(1x,A,1x,f11.7,A)') ' Czbx   = ',
     .              Hto4l_Czbx, '  '
               write(10,'(1x,A,1x,f11.7,A)') ' dGlL  = ',
     .              Hto4l_dGlL, '  '
               write(10,'(1x,A,1x,f11.7,A)') ' dGlR  = ',
     .              Hto4l_dGlR, '  '
               write(10,'(1x,A,1x,f11.7,A)') ' dGhlL  = ',
     .              Hto4l_dGhlL, '  '
               write(10,'(1x,A,1x,f11.7,A)') ' dGhlR  = ',
     .              Hto4l_dGhlR, '  '
               write(10,'(1x,A,1x,f11.7,A)') ' tCaa   = ',
     .              Hto4l_tCaa, '  '
               write(10,'(1x,A,1x,f11.7,A)') ' tCza   = ',
     .              Hto4l_tCza, '  '
               write(10,'(1x,A,1x,f11.7,A)') ' tCzz   = ',
     .              Hto4l_tCzz, '  '
            elseif(basis .eq. 2) then
               write(10,'(A)') 'SILH basis coefficients'
               write(10,'(1x,A,1x,f11.7,A)') ' cH     = ', S_cH,     ' '
               write(10,'(1x,A,1x,f11.7,A)') ' cT     = ', S_cT,     ' '
               write(10,'(1x,A,1x,f11.7,A)') ' c2W    = ', S_c2W,    ' '
               write(10,'(1x,A,1x,f11.7,A)') ' c2B    = ', S_c2B,    ' '
               write(10,'(1x,A,1x,f11.7,A)') ' cg     = ', S_cg,     ' '
               write(10,'(1x,A,1x,f11.7,A)') ' cW     = ', S_cW,     ' '
               write(10,'(1x,A,1x,f11.7,A)') ' cB     = ', S_cB,     ' '
               write(10,'(1x,A,1x,f11.7,A)') ' cHW    = ', S_cHW,    ' '
               write(10,'(1x,A,1x,f11.7,A)') ' cHB    = ', S_cHB,    ' '
               write(10,'(1x,A,1x,f11.7,A)') ' cHl    = ', S_cHl,    ' '
               write(10,'(1x,A,1x,f11.7,A)') ' cHlp   = ', S_cHlp,   ' '
               write(10,'(1x,A,1x,f11.7,A)') ' cHe    = ', S_cHe,    ' '
               write(10,'(1x,A,1x,f11.7,A)') ' cll    = ', S_cll,    ' '
               write(10,'(1x,A,1x,f11.7,A)') ' tcg    = ', S_tcg,    ' '
               write(10,'(1x,A,1x,f11.7,A)') ' tcHW   = ', S_tcHW,   ' '
               write(10,'(1x,A,1x,f11.7,A)') ' tcHB   = ', S_tcHB,   ' '
            elseif(basis .eq. 3) then
               write(10,'(1x,A,1x,f11.7,A)') ' W_cHD      = ',
     &              W_cHD,       ' '
               write(10,'(1x,A,1x,f11.7,A)') ' W_cHbx     = ',
     &              W_cHbx,      ' '
               write(10,'(1x,A,1x,f11.7,A)') ' W_cHW      = ',
     &              W_cHW,       ' '
               write(10,'(1x,A,1x,f11.7,A)') ' W_cHB      = ',
     &              W_cHB,       ' '
               write(10,'(1x,A,1x,f11.7,A)') ' W_cHWB     = ',
     &              W_cHWB,      ' '       
               write(10,'(1x,A,1x,f11.7,A)') ' W_cHl1     = ',
     &              W_cHl1,     ' '        
               write(10,'(1x,A,1x,f11.7,A)') ' W_cHl3     = ',
     &              W_cHl3,     ' '            
               write(10,'(1x,A,1x,f11.7,A)') ' W_cHe      = ',
     &              W_cHe,       ' '       
               write(10,'(1x,A,1x,f11.7,A)') ' W_cll      = ',
     &              W_cll
               write(10,'(1x,A,1x,f11.7,A)') ' W_tcHW     = ',
     &              W_tcHW,      ' '
               write(10,'(1x,A,1x,f11.7,A)') ' W_tcHB     = ',
     &              W_tcHB,      ' '
               write(10,'(1x,A,1x,f11.7,A)') ' W_tcHWB    = ',
     &              W_tcHWB,     ' '
            endif
            
            if(quadratics.eq.0) then
               write(10,*) ' '
               write(10,'(A)')
     +         'ONLY INTERFERENCES BETWEEN SM AND BSM ARE CONSIDERED'
            endif
            if(quadratics.eq.1) then
               write(10,*) ' '
               write(10,'(A)')
     +         'QUADRATICS BSM EFFECTS ARE CONSIDERED'
            endif
         else
            write(10,*) ' '
            write(10,'(A)') 'D=6 coefficients off'
         endif
         
c           write(10,'(1x,A,1x,f15.5,f15.5)')
c     +           ' Dr (cmplx)  ',Dr
         write(10,*)' '
         if (iunwmod.eq.1) then
            write(10,*)'Generating ',ntotin,' unweigthed events'
         else
            write(10,*)'Generating ',ntotin,' weigthed events'
         endif
         write(10,*)' '
         write(10,*)'WEIGHTED EVENTS STATISTICS'
         write(10,'(1x,A,I19,A,I19)')
     +        'weighted event n.',kw,' of ',nmaxprw
c         write(10,*)' '        
         do ik = 0,nphmax
            write(10,'(1x,I2,A,f18.15,A,f18.15,A)')
     +           ik,' photons width ',width(ik),' +-',sigma(ik),' MeV'
c               call geterrpos(sigma(ik),iep,errpos)
c               if (iep.gt.0) write(10,'(1x,A)')
c     +              '                '//'   '//errpos
         enddo
c         write(10,*)' '
         write(10,'(1x,A,f18.15,A,f18.15,A)')
     +        'Total =         ',wid,' +-',sig,' MeV (weighted events)'
         call geterrpos(sig,iep,errpos)
         write(10,'(1x,A)')
     +        '                '//'  '//errpos

c            write(10,'(1x,A,f18.15,A,f18.15,A,f18.15,A)')
c     +           'accuracies = ',perc0,' %',perc1,' %',perct,' %'
         write(10,'(1x,A,f18.15,A)')
     +        'accuracy = ',perct,' %'
         write(10,*)' '

         write(10,*)'UNWEIGHTED EVENTS STATISTICS'
         if (istopsearch.eq.1.and.nhitmiss.gt.0) then
            write(10,'(1x,A,I19,A,I19)')
     +           'unweighted event n.',nhit,' of ',nmaxprunw
            
            effhm   = (1.d0*nhit)/(1.d0*nhitmiss)
            if (isnan(effhm)) effhm = 0.d0
            widthhm = setmax * effhm
            varhm   = setmax * sqrt(effhm*(1.d0-effhm)/nhitmiss)
            if (isnan(varhm)) varhm = 0.d0
            write(10,'(1x,A,f18.15,A,f18.15,A)')
     +           'Total =         ',widthhm,' +-',varhm,' MeV '//
     +           '(unweigthed events)'
            call geterrpos(varhm,iep,errpos)
            write(10,'(1x,A)')
     +        '                '//'  '//errpos
            write(10,*)'n. hit        = ',nhit
            write(10,*)'n. hit + miss = ',nhitmiss
            write(10,*)'Unweightening efficiency:',effhm*100.d0,'%'
            write(10,*)'N. of negative unweighted events: ',nnegunw
            write(10,*)'Unweightening biases:'
            write(10,*)' truemax, setmax, truemax/setmax:',
     .           truemax,setmax,truemax/setmax
            write(10,*)' Suggested max. value to set in input:',
     .           truemaxsuggested

            wover   =sumover/nhitmiss
            wovererr=sqrt(abs((sumover2/nhitmiss - wover**2)/nhitmiss))
            write(10,*)' n. points over max. ',nover
            write(10,'(1x,A,f18.15,A,f18.15,A)')
     +           ' width over max. ',wover,' +-',wovererr,' MeV '
            write(10,*)'  fraction over unw. and w.',
     +           wover/widthhm*100d0,wover/wid*100d0,' %'
         else
            write(10,*)' NOT STARTED YET, looking for the maximum'//
     +           ' over',nsearch,' phase space points '
         endif

         
         call etime(timearray,timesum)
         delta  = timearray(1) - timearray2(1)
         delta2 = timesum-timesum2
         
         write(10,*)''//col(6)
! kbefore unknown here....
c         write(10,'(1x,A,I8,A,f20.4,A)')
c     +        'User time to generate the last     ',kw-kbefore
c     +        ,' points: ',delta,' s'
c         write(10,'(1x,A,I8,A,f20.4,A)')
c     +        'Sys+User time to generate the last ',kw-kbefore
c     +        ,' points: ',delta2,' s'
         write(10,'(1x,A,f20.4,A)')
     +        'Total CPU user time:    ',timearray(1),' s'
         write(10,'(1x,A,f20.4,A)')
     +        'Total CPU system time:  ',timearray(2),' s'
         write(10,'(1x,A,f20.4,A)')
     +        'Total elapsed CPU time: ',timesum,' s'
         write(10,*)''
c            write(10,*)'ISVEC for RANLUX'
c            write(10,*)isvec
         close(10)
         call writedistributions
         kbefore = kw
         iwri = 0
         call etime(timearray2,timesum2)
      endif
      return
      end
*******************************************************************************************      
      
