      subroutine multiplicity(sc1,sc2,mass,eps,nphotmode,n,w)
      implicit double precision (a-h,l,o-z)
      double precision csi(1)
      double precision mass(5)
      common/identicalparticles/idpart
      common/imode/imode
      common/alphas/alpha0,alphaGF,alpha
      parameter (pi = 3.1415926535897932384626433832795029D0)

! nphotmode = 0,1 --> 0 or 1 photon width
! nphotmode < 0 --> 0 and 1 photon width
! nphotmode = -100 arbitrary number of photons

      if (nphotmode.ge.0) then
         w = 1.d0
         n = nphotmode
         return
      endif

      coll  = 4.d0*log(sc1/mass(1))
     .      + 4.d0*log(sc2/mass(3)) 
     .      - 4.d0

      aieps = -2.d0*log(eps)-1.5d0+2.d0*eps-0.5d0*eps**2
      arg   =  alpha/2.d0/pi * coll * aieps

      if (imode.le.33) then ! for orders alpha
         sffa = (1.d0 - arg)
         if (sffa.lt.0.d0) sffa = 0.05d0

         p0 = sffa
         p1 = 1.d0 - sffa      
         ptot = p0 + p1
         call wraprnd(csi,1)
         if (csi(1).lt.p0) then 
            n = 0
            w = ptot / p0
         else
            n = 1
            w = ptot / p1
         endif
         return
      endif
! else an arbitrary number of photons are emitted (for matching and new PS)
      ffs = exp(-arg)
      call wraprnd(csi,1)
      ptot = ffs
      pn   = ptot
      n = 0
      do while(csi(1).gt.ptot)
         n    = n + 1
         pn   = pn*arg/n
         ptot = ptot + pn
      enddo
      w = 1.d0/pn
      return
      end
********************************
      function bwforsampling(s,mf)
      implicit none
      double precision bwforsampling,s
      double precision bw,mf,a,b,sqs,extra
      external bw
      bwforsampling = bw(s)
      return
      end
********************************
      subroutine get_zinvmasses_BACKUP(q2max,mass,m1,m2,w)
      implicit double precision (a-h,l,m,o-z)
      double precision rnd(1)
      dimension mass(5)
c default      parameter (np = 5000)
      parameter (np = 1500)
      dimension cik(0:np),tgk(0:np),sk(0:np),fk(0:np),cikcumul(0:np)

      double precision mhnom,whtot
      common/higgsnominal/mhnom,whtot
      
      common/linearcurveBCKroutine/ds,totint,sq2max,cik,cikcumul,
     .     tgk,sk,fk,ifirst
      common/integlimits/q2maxz1,q2maxz2,q2minz1,q2minz2

      data ifirst/0/
      double precision lambda,intbwlam
      external lambda,intbwlam

      cutinf  = 30.d0*30.d0
      cutinf2 = 70.d0*70.d0
      cutinf2 = cutinf
      if (ifirst.eq.0) then

         q2maxz1 = (sqrt(q2max)-mass(3)-mass(4))**2
         q2minz1 = (mass(1)+mass(2))**2

         q2maxz2 = (sqrt(q2max)-mass(1)-mass(2))**2
         q2minz2 = (mass(3)+mass(4))**2

c         q2minz1 = cutinf2
c         q2minz2 = cutinf
         
         ds = (q2maxz1-q2minz1)/np
         
         sk(0) = q2minz1
         do k = 1,np
            sk(k) = sk(k-1) + ds
         enddo

         sq2max   = sqrt(q2max)
         sq2maxz1 = sqrt(q2maxz1)
         sq2maxz2 = sqrt(q2maxz2)

         do k = 0,np
c            fk(k) = bw(sk(k))*bwnorm((sq2max-sqrt(sk(k)))**2,q2minz2)
            fk(k) = bw(sk(k))*intbwlam(q2max,q2minz2,sk(k))
c     fk(k) = fk(k)*1d-4/(125.d0 - 60d0)*(125.d0 -sqrt(sk(k)))
         enddo

         
         do k = 0,np-1
            tgk(k) = (fk(k+1)-fk(k))/ds
         enddo
         tgk(np) = 0.d0

         cik(0) = 0.d0
         do k = 1,np
            cik(k)=ds*(fk(k-1)+0.5d0*tgk(k-1)*ds)
         enddo

         cikcumul(0) = 0.d0
         do k = 1,np
            cikcumul(k) = cikcumul(k-1) + cik(k)
         enddo
         totint = cikcumul(np)

         print*,'done!!'
         
         ifirst = 1
      endif

**** get the first Z, inv mass**2 s1
      call wraprnd(rnd,1)
      csiN = rnd(1)*totint
      k = 0
      do while(csiN.gt.cikcumul(k))
         k = k + 1
      enddo
      k = k -1
      cumul = cikcumul(k)

      a = tgk(k)
      b = fk(k)
      c = 2.d0*(cumul-csiN)
      xt = (-b + sqrt(b*b-a*c))/a ! only this solution is physical

      s1 = xt + sk(k)
      
      fs1 = fk(k) + tgk(k)*(s1-sk(k))      
      w1 = totint/fs1

      m1 = sqrt(s1)

**** get the second Z, inv mass**2 s2
c      call get_zinvm2((sq2max-m1)**2,q2minz2,s2,w2)
      call get_zinvm2broken(sq2max,m1,q2minz2,s2,w2)      
      m2 = sqrt(s2)
      
      w = w1*w2

!! symmetrization      
c      call wraprnd(rnd,1)
c      if (rnd(1).le.0.5d0) then
c         tmpm = m1
c         m1 = m2
c         m2 = tmpm
c      endif
***      
      return
      end
****************************************************
      subroutine get_zinvmasses(q2max,mass,m1,m2,w)
      implicit double precision (a-h,l,m,o-z)
      double precision rnd(1)

      dimension mass(5)

c default      parameter (np = 5000)
      parameter (np = 1000)
      parameter (nm = 100)

      double precision mhnom,whtot
      common/higgsnominal/mhnom,whtot
            
      dimension cik(0:np),tgk(0:np),sk(0:np),fk(0:np),cikcumul(0:np)           
      common/linearcurve/ds,totint,sq2max,cik,cikcumul,tgk,sk,fk,ifirst,
     .     j,jprevious
      data ifirst,j,jprevious/0,-100,-50/

      dimension cikm(0:np,nm),tgkm(0:np,nm),skm(0:np,nm),
     .     fkm(0:np,nm),cikcumulm(0:np,nm),
     .     ifirstv(nm),dsv(nm),totintv(nm) 
      double precision hmasses(nm),hmmin,hmmax
      common/linearcurvem/dsv,totintv,cikm,cikcumulm,tgkm,skm,fkm,
     .     hmasses,hmmin,hmmax,dmass,ifirstv
      data ifirstv/nm*0/
      
      common/integlimits/q2maxz1,q2maxz2,q2minz1,q2minz2

      double precision lambda,intbwlamforsampling
      external lambda,intbwlamforsampling

      common/cutonlowinvmasses/cutlowinvmass ! from input      
      
      if (ifirst.eq.0) then
c         whtot = 4d-3
         hmmin = mhnom - 10.d0*whtot
         dmass = 20.d0*whtot/nm
         hmasses(1) = hmmin
         do k = 2,nm
            hmasses(k) = hmasses(k-1) + dmass
         enddo
         hmmax = hmasses(nm)

         q2minz1 = (mass(1)+mass(2))**2
         q2minz2 = (mass(3)+mass(4))**2


* OLDER GENERATION CUT ON DIFFERENT PARTICLES, NO LONGER USED!          
c$$$         q2minz1 = 15d0*15d0
c$$$         q2minz2 = 15d0*15d0
c$$$
c$$$         print*, "generation cut on invariant lepton-lepton pairs"
c$$$         print*, "q2minz1 =", sqrt(q2minz1)
c$$$         print*, "q2minz2 =", sqrt(q2minz2)
c$$$         print*, " "

         ifirst = 1
      endif

      jprevious = j
      
      sq2max   = sqrt(q2max)
      if (sq2max.gt.hmmin.and.sq2max.lt.hmmax) then
         j = (sq2max - hmmin)/dmass + 1
         sq2max = hmasses(j)
      else
         j = -100
      endif
      
      if (j.gt.0) then
         if (ifirstv(j).eq.0) then
            q2maxz1 = (sq2max - mass(3)-mass(4))**2
            q2maxz2 = (sq2max - mass(1)-mass(2))**2
         
            dsv(j) = (q2maxz1-q2minz1)/np
         
            skm(0,j) = q2minz1
            do k = 1,np
               skm(k,j) = skm(k-1,j) + dsv(j)
            enddo
            
            do k = 0,np
               fkm(k,j) = bwforsampling(skm(k,j),mass(1))
     .          *intbwlamforsampling(sq2max**2,q2minz2,skm(k,j),mass(3))
            enddo
            
            do k = 0,np-1
               tgkm(k,j) = (fkm(k+1,j)-fkm(k,j))/dsv(j)
            enddo
            tgkm(np,j) = 0.d0
            
            cikm(0,j) = 0.d0
            do k = 1,np
               cikm(k,j)=dsv(j)*(fkm(k-1,j)+0.5d0*tgkm(k-1,j)*dsv(j))
            enddo
            
            cikcumulm(0,j) = 0.d0
            do k = 1,np
               cikcumulm(k,j) = cikcumulm(k-1,j) + cikm(k,j)
            enddo
            totintv(j) = cikcumulm(np,j)
            
c            print*,'done j =',j
            
            ifirstv(j) = 1
         endif
         if (jprevious.ne.j) then
            ds       = dsv(j)
            totint   = totintv(j)
            cik      = cikm(:,j)
            cikcumul = cikcumulm(:,j)
            tgk      = tgkm(:,j)
            sk       = skm(:,j)
            fk       = fkm(:,j)
         endif
      else

         q2maxz1 = (sqrt(q2max)-mass(3)-mass(4))**2
         q2maxz2 = (sqrt(q2max)-mass(1)-mass(2))**2
         
         ds = (q2maxz1-q2minz1)/np
         
         sk(0) = q2minz1
         do k = 1,np
            sk(k) = sk(k-1) + ds
         enddo

         sq2max   = sqrt(q2max)
         sq2maxz1 = sqrt(q2maxz1)
         sq2maxz2 = sqrt(q2maxz2)

         do k = 0,np
            fk(k) = bwforsampling(sk(k),mass(1))
     .       *intbwlamforsampling(q2max,q2minz2,sk(k),mass(3))
         enddo
         
         do k = 0,np-1
            tgk(k) = (fk(k+1)-fk(k))/ds
         enddo
         tgk(np) = 0.d0

         cik(0) = 0.d0
         do k = 1,np
            cik(k)=ds*(fk(k-1)+0.5d0*tgk(k-1)*ds)
         enddo

         cikcumul(0) = 0.d0
         do k = 1,np
            cikcumul(k) = cikcumul(k-1) + cik(k)
         enddo
         totint = cikcumul(np)
      endif

**** get the first Z, inv mass**2 s1
      call wraprnd(rnd,1)
      csiN = rnd(1)*totint
      k = 0
      do while(csiN.gt.cikcumul(k))
         k = k + 1
      enddo
      k = k -1
      cumul = cikcumul(k)

      a  = tgk(k)
      b  = fk(k)
      c  = 2.d0*(cumul-csiN)
      xt = (-b + sqrt(b*b-a*c))/a ! only this solution is physical

      s1 = xt + sk(k)
      
      fs1 = fk(k) + tgk(k)*(s1-sk(k))      
      w1  = totint/fs1

      m1 = sqrt(s1)

**** get the second Z, inv mass**2 s2
c      call get_zinvm2((sq2max-m1)**2,q2minz2,s2,w2)
      call get_zinvm2broken(sq2max,m1,q2minz2,s2,w2)      
      m2 = sqrt(s2)

      w = w1*w2

!! symmetrization      
c      call wraprnd(rnd,1)
c      if (rnd(1).le.0.5d0) then
c         tmpm = m1
c         m1 = m2
c         m2 = tmpm
c      endif
***      
      return
      end
*******************************************
      function intbwlamforsampling(s,ymin,x,m)
      implicit double precision (a-h,o-z)
      double precision intbwlamforsampling,m
      parameter (np=10000)
      double precision lambda
      external lambda
      intbwlamforsampling = 0.d0
      ymax = (sqrt(s)-sqrt(x))**2
      dy = (ymax -ymin)/np
      y = ymin
      do k = 1,np
         fy = bwforsampling(y,m)*sqrt(lambda(s,x,y))
         intbwlamforsampling = intbwlamforsampling + dy*fy
         y = y + dy
      enddo
      return
      end
*******************************************
      function intbwlam(s,ymin,x)
      implicit double precision (a-h,o-z)
      double precision intbwlam
      parameter (np=10000)
      double precision lambda
      external lambda
      intbwlam = 0.d0
      ymax = (sqrt(s)-sqrt(x))**2
      dy = (ymax -ymin)/np
      y = ymin
      do k = 1,np
         fy = bw(y)*sqrt(lambda(s,x,y))
         intbwlam = intbwlam + dy*fy
         y = y + dy
      enddo
      return
      end
********************************************
      subroutine get_zinvm2broken(smax,m1,q2min,minv2,w)
! this accounts also for sqrt(lambda) of the 2b phase space
      implicit double precision (a-h,o-z)
      double precision minv2,m1,m1q
      double precision rnd(1)
      common/zparam/zmass,zwidth
      common/getzinvmcommon2/am,ag,am2,ag2,amag,amsag,am2ag2,ifirst
      data ifirst/0/

      parameter (np = 1000)

      dimension cik(0:np),tgk(0:np),sk(0:np),fk(0:np),cikcumul(0:np)
      common/linearcurve2/ds,totint,sq2max,cik,cikcumul,
     .     tgk,sk,fk,ifirst2
      data ifirst2/0/
      double precision lambda,mf
      external lambda
      
      if (ifirst.eq.0) then
         am     = zmass
         ag     = zwidth
         am2    = am*am
         ag2    = ag*ag
         amag   = am*ag
         amsag  = am/ag
         am2ag2 = am2*ag2
         ifirst = 1
      endif

      mf = 0.5d0*sqrt(q2min)
      
      if (ifirst2.eq.0) then

         q2max = (smax - m1)**2

         ds = (q2max-q2min)/np
         
         sk(0) = q2min
         do k = 1,np
            sk(k) = sk(k-1) + ds
         enddo

         m1q   = m1*m1
         smaxq = smax*smax
         do k = 0,np
            fk(k)=bwforsampling(sk(k),mf)*sqrt(lambda(smaxq,m1q,sk(k)))
c            fk(k) = fk(k)
c     fk(k) = fk(k)*1d-4/(125.d0 - 60d0)*(125.d0 -sqrt(sk(k)))
         enddo

         do k = 0,np-1
            tgk(k) = (fk(k+1)-fk(k))/ds
         enddo
         tgk(np) = 0.d0

         cik(0) = 0.d0
         do k = 1,np
            cik(k)=ds*(fk(k-1)+0.5d0*tgk(k-1)*ds)
         enddo

         cikcumul(0) = 0.d0
         do k = 1,np
            cikcumul(k) = cikcumul(k-1) + cik(k)
         enddo
         totint = cikcumul(np)
         
!! always 0!         ifirst2 = 1
      endif
      call wraprnd(rnd,1)
      csiN = rnd(1)*totint
      k = 0
      do while(csiN.gt.cikcumul(k))
         k = k + 1
      enddo
      k = k -1
      cumul = cikcumul(k)

      a = tgk(k)
      b = fk(k)
      c = 2.d0*(cumul-csiN)
      xt = (-b + sqrt(b*b-a*c))/a ! only this solution is physical

      s1 = xt + sk(k)

      fs1 = fk(k) + tgk(k)*(s1-sk(k))      
      w = totint/fs1

      minv2 = s1

      return
      end
********************
      subroutine get_zinvm2(q2max,q2min,minv2,w)
      implicit double precision (a-h,o-z)
      double precision minv2
      double precision rnd(1)
      common/zparam/zmass,zwidth
      common/getzinvmcommon2/am,ag,am2,ag2,amag,amsag,am2ag2,ifirst
      data ifirst/0/

      if (ifirst.eq.0) then
         am     = zmass
         ag     = zwidth
         am2    = am*am
         ag2    = ag*ag
         amag   = am*ag
         amsag  = am/ag
         am2ag2 = am2*ag2
         ifirst = 1
      endif

      call wraprnd(rnd,1)

      iflat = 0
      if (iflat.eq.1) then
         minv2 = (q2max - q2min)*rnd(1) + q2min
         w = q2max - q2min
      else
c         anbw  = bwnorm(q2max,q2min)         
c         tmp   = atan(q2min/am/ag-am/ag)
c         minv2 = ag*am*( tan(am*ag*anbw*rnd+tmp)+am/ag )
c         w     = 1.d0/anbw/((minv2-am**2)**2+am**2*ag**2)
c         w     = 1.d0/w
         anbw  = bwnorm(q2max,q2min)         
         tmp   = atan(q2min/amag-amsag)
         minv2 = amag*( tan(amag*anbw*rnd(1)+tmp)+amsag )
         w     = anbw*((minv2-am2)**2+am2ag2)
      endif

      return
      end
********************************
      subroutine get_zinvm(rnd,q2max,q2min,minv2,w)
      implicit double precision (a-h,o-z)
      double precision minv2
      double precision rnd
      common/zparam/zmass,zwidth
      common/getzinvmcommon/am,ag,am2,ag2,amag,amsag,am2ag2,ifirst
      data ifirst/0/

      if (ifirst.eq.0) then
         am     = zmass
         ag     = zwidth
         am2    = am*am
         ag2    = ag*ag
         amag   = am*ag
         amsag  = am/ag
         am2ag2 = am2*ag2
         ifirst = 1
      endif

      iflat = 0
      if (iflat.eq.1) then
         minv2 = (q2max - q2min)*rnd + q2min
         w = q2max - q2min
      else
c         anbw  = bwnorm(q2max,q2min)         
c         tmp   = atan(q2min/am/ag-am/ag)
c         minv2 = ag*am*( tan(am*ag*anbw*rnd+tmp)+am/ag )
c         w     = 1.d0/anbw/((minv2-am**2)**2+am**2*ag**2)
c         w     = 1.d0/w
         anbw  = bwnorm(q2max,q2min)         
         tmp   = atan(q2min/amag-amsag)
         minv2 = amag*( tan(amag*anbw*rnd+tmp)+amsag )
         w     = anbw*((minv2-am2)**2+am2ag2)
      endif

      return
      end
******************************************************
      subroutine get_egammasoft_BCK(rnd,egmin,egmax,eg,w)
      implicit double precision (a-h,o-z)
      double precision rnd
      aln = log(egmax/egmin)
      eg  = egmin * exp(aln*rnd)
      w   = aln*eg
      return
      end
****************************************************
      subroutine get_yx(s,qm2,n,y,x,yjac,w,ie)
      implicit double precision (a-h,o-z)
      double precision x(n),y(n)
c      common/decayCFRdistr/var1,var2,var3
c      var1 = 0.d0
      
!     last notes, 4/6/2015
      ie   = 0
      ymax = 1.d0 - qm2/s
      ymin = 5d-5
      w    = 1.d0
      yjac = 1.d0
      do k = 1,n
         call get_y(ymin,ymax,yn,wn)
         y(k) = yn
         w    = w * wn
      enddo

      sumy = sum(y)
      if (sumy.gt.ymax) then
         ie = 1
         w  = 0.d0
         return
      endif

      x    = y    / (1.d0 - sumy)
      yjac = 1.d0 / (1.d0 - sumy)**n

c      var1 = y(1)

      return
      end
****************************************************
      subroutine get_y_BETTER_THE_ONE_BELOW(ymin,ymax,y,w)
      implicit double precision (a-h,o-z)
      double precision rnd(1)
      a     = 1.d0/ymin
      an0   = a*ymin

      anir  = log(max(ymax,ymin)/ymin)
      antot = an0 + anir

      call wraprnd(rnd,1)
      csiN = rnd(1) * antot
      if (csiN.le.an0) then
         y = csiN/a
         w = antot/a
      else
         y = ymin * exp(csiN-an0)
         w = antot*y
      endif
      return
      end
****************************************************      
      subroutine get_y(ymin,ymax,y,w)
! inspired by AP vertex
      implicit double precision (a-h,o-z)
      double precision rnd(1)
      common/getycmn/a,an0,ifirst
      data ifirst /0/
      if (ifirst.eq.0) then
         a = 2.d0 - 2.d0*ymin +ymin*ymin
         a = a / ymin
         an0   = a*ymin
         ifirst = 1
      endif

      anir = 2.d0 * log(ymax/ymin) - 2.d0 * (ymax-ymin)
     .     + 0.5d0 * (ymax*ymax - ymin*ymin)

      antot = an0 + anir

      ihit = 0
      do while(ihit.eq.0)
         call get_y_wrongAP(ymin,ymax,y,fwrong)
         fy = apfun(ymin,y)

         call wraprnd(rnd,1)
         if (rnd(1).le.fy/fwrong) ihit = 1         
      enddo

      w = antot/fy
      return
      end
****************************************************
      subroutine get_y_wrongAP(ymin,ymax,y,f)
      implicit double precision (a-h,o-z)
      double precision rnd(1)
      a     = 1.d0/ymin
      an0   = a*ymin

      anir  = log(ymax/ymin)
      antot = an0 + anir

      call wraprnd(rnd,1)
      csiN = rnd(1) * antot
      if (csiN.le.an0) then
         y = csiN/a
         f = 2.d0*a
      else
         y = ymin * exp(csiN-an0)
         f = 2.d0/y
      endif
      return
      end
****************************************************
      function apfun(ymin,y)
      implicit double precision (a-h,o-z)
      common/apfuncmn/a,ifirst
      data ifirst /0/
      if (ifirst.eq.0) then
         a = 2.d0 - 2.d0*ymin +ymin*ymin
         a = a / ymin
         ifirst = 1
      endif
      apfun = a
      if (y.lt.ymin) return
      apfun = 2.d0 - 2.d0*y + y*y
      apfun = apfun/y
      return
      end
****************************************************
      subroutine get_egammasoft(rnd,egmin,egmax,eg,w)
      implicit double precision (a-h,o-z)
      double precision rnd
!**     as 1/E for egmin < E < egmax
!**   and (depending on the comments with !)
!**    1)   as 1/sqrt(E) + a in 0 < E < Egmin (a to make it continue)
!** or 2)   as 1/egmin in 0 < E < Egmin
      a     = 1.d0/egmin    ! 2)
!     .  - 1.d0/sqrt(egmin) ! 1)
      
      an0   = a*egmin       ! 2)
!     .  + 2.d0*sqrt(egmin) ! 1)

      anir  = log(egmax/egmin)
      antot = an0 + anir

      csiN = rnd * antot
      if (csiN.le.an0) then
!         x = (-1.d0 + sqrt(1.d0+a*csiN))/a ! 1)
!         eg = x*x                          ! 1)
!         w = antot/(1.d0/x+a)              ! 1)
         eg = csiN/a                        ! 2)
         w  = antot/a                       ! 2)
      else
         eg  = egmin * exp(csiN-an0)
         w   = antot*eg
      endif
      return
      end
****************************************************
      subroutine get_egamma(rnd,egmin,egmax,eg,w)
      implicit double precision (a-h,o-z)
      double precision rnd,csi(1)

      iflat = 0
      if (iflat.eq.1) then
         eg = (egmax-egmin)*rnd + egmin
         w  = (egmax - egmin)
      else      
c$$$         aln = log(egmax/egmin)
c$$$         eg  = egmin * exp(aln*rnd)
c$$$         w   = aln*eg
!0.000768770405 +-  2.29284843E-06 GeV
!      return
***************************
         call wraprnd(csi,1)
         i = 1
         psing = 0.8d0
         pflat = 1.d0 - psing
         if (csi(1).gt.pflat) i = 2
                  
         aln = log(egmax/egmin)
         
         if (i.eq.1) then
            eg = (egmax-egmin)*rnd + egmin
         else
            eg  = egmin * exp(aln*rnd)
         endif
         
         w1  = (egmax - egmin)
         w2   = aln*eg
         
         w = 1.d0/(pflat/w1 + psing/w2)
**************************
      endif
      return
      end
*********************************
      subroutine get_egammanew(rnd,egmin,egmax,ei,c,eg,w)
      implicit double precision (a-h,o-z)
      double precision rnd,csi(1)

c      iflat = 0 !! never flat, commenting out
c      if (iflat.eq.1) then
c         eg = (egmax-egmin)*rnd + egmin
c         w  = (egmax - egmin)
c      else      
***************************
      ak  = c - 1.d0            ! Notice: ak is **always** negative!!
**
      if (ak.gt.-1.d-8) then
         ak = -1d-8            ! to avoid NaNs when ak is 0!
      endif
**

      aleps = log(ei+ak*egmin)
      an1   = 1.d0/ak*(log(ei+ak*egmax)-aleps)     
      an2 = log(egmax/egmin)

c      print*,an1,ei+ak*egmax

!!! this choice of p1 (and p2) is to generate ***exactly*** according to 1/eg * 1 / (ei + ak * eg)!!
      p1 = -ak * an1/(an2-ak*an1)
      p2 = 1.d0 - p1
!!!
      call wraprnd(csi,1)
      if (csi(1).lt.p1) then
!     this generates according to 1/(ei + ak*eg)
         eg = 1.d0/ak*(exp(ak*an1*rnd+aleps)-ei)
      else
!     this generates according to 1/eg
         eg  = egmin * exp(an2*rnd)
      endif
      
      w1 = an1*(ei+ak*eg)
      w2 = an2*eg
      
      w = 1.d0/(p1/w1 + p2/w2)
**************************
c      endif
      return
      end
*********************************
      subroutine get_cth(rnd,beta,c,w)
      implicit none
      double precision beta,rnd,c,w,n
      n = 1.d0/beta*log((1.d0+beta)/(1.d0-beta))
      c = (1.d0 - exp(-n*rnd*beta)*(1.d0+beta))/beta
      w = n * (1.d0 - beta*c)
      return
      end
******************************
*--------------------------------------------------      
      subroutine alongd(rnd1,rnd2,p,m,vers,w)
      implicit double precision (a-h,o-z)
      double precision m
      parameter (pi = 3.1415926535897932384626433832795029D0)
      dimension p(0:3),vers(0:3),ptmp(0:3)
      double precision csi(1)
      double precision rnd1,rnd2

      b1 = (1.d0 + m/p(0)) * (1.d0 - m/p(0))
      b1 = sqrt(b1)

      vers(0) = 1.d0
      phph = 2.d0*pi*rnd1
      an  = 1.d0/b1*log((1.d0+b1)/(1.d0-b1))

      cth = (1.d0 - (1.d0+b1)*
     .     exp(-b1*an*rnd2))/b1
      sth = sqrt(1.d0-cth*cth)
      cph = cos(phph)
      sph = sin(phph)
      
      vers(1) = vers(0)*sph*sth
      vers(2) = vers(0)*cph*sth
      vers(3) = vers(0)*cth
      call rot(-1,p,vers,vers)

      w = dot(p,vers)*an*2.d0*pi/p(0)

      return
      end
*--------------------------------------------------
      subroutine alongdTRY(rnd1,rnd2,p,m,vers,w)
      implicit double precision (a-h,o-z)
      double precision m,moe2
      parameter (pi = 3.1415926535897932384626433832795029D0)
      dimension p(0:3),vers(0:3),ptmp(0:3)
      double precision csi(1)
      double precision rnd1,rnd2

      moe2 = m*m/p(0)/p(0)
      
      b1 = (1.d0 + m/p(0))* (1.d0 - m/p(0))
      b1 = sqrt(b1)

      vers(0) = 1.d0
      phph = 2.d0*pi*rnd1
      an  =  1.d0/b1*log((1.d0+b1)/(1.d0-b1))

      ant = an - 1.d0

      ihit = 0
      nhm  = 0
      do while(ihit.eq.0)
         nhm = nhm + 1
         call wraprnd(csi,1)
         cth = (1.d0 - (1.d0+b1)*
     .        exp(-b1*an*csi(1)))/b1
         fs  = 1.d0/(1.d0 - b1*cth)
         ft  = fs - 0.5d0 * moe2/(1.d0 - b1 * cth)/(1.d0 - b1 * cth)
         call wraprnd(csi,1)
         if (csi(1).lt.ft/fs) ihit = 1
      enddo

      sth = sqrt(1.d0-cth*cth)
      cph = cos(phph)
      sph = sin(phph)

      vers(1) = vers(0)*sph*sth
      vers(2) = vers(0)*cph*sth
      vers(3) = vers(0)*cth
      call rot(-1,p,vers,vers)

      w = ant * 2.d0*pi / ft
      
      return
      end
*******************************************************
      subroutine alongdTRY2(rnd1,rnd2,p,m,vers,w)
      implicit double precision (a-h,o-z)
      double precision m
      parameter (pi = 3.1415926535897932384626433832795029D0)
      dimension p(0:3),vers(0:3),ptmp(0:3),pm(0:3)
      double precision csi(1)
      double precision rnd1,rnd2
      
      b1 = (1.d0 + m/p(0)) * (1.d0 - m/p(0))
      b1 = sqrt(b1)

      vers(0) = 1.d0
      phph    = 2.d0*pi*rnd1
      an      = 1.d0/b1*log((1.d0+b1)/(1.d0-b1))

      cth = (1.d0 - (1.d0+b1)*
     .     exp(-b1*an*rnd2))/b1
      sth = sqrt(1.d0-cth*cth)
      cph = cos(phph)
      sph = sin(phph)

c      ich = 1
      call wraprnd(csi,1)
      if (csi(1).le.0.5d0) then
         cth = -cth
      endif
      
      vers(1) = vers(0)*sph*sth
      vers(2) = vers(0)*cph*sth
      vers(3) = vers(0)*cth
      call rot(-1,p,vers,vers)

c     wsing = p(0)*vers(0)/dot(p,vers)/an/2.d0/pi

      pm = p
      pm(1:3) = -pm(1:3)
      
      w1 = dot(p, vers)*an*2.d0*pi/p(0)
      w2 = dot(pm,vers)*an*2.d0*pi/p(0)

      w = 0.5d0 * (1.d0/w1 + 1.d0/w2)
      w = 1.d0/w
********************************************
c$$$      a1 = dot(p,vers)/p(0)
c$$$      a2 = 1.d0 - b1*cth      
c$$$      print*,a1 - a2
********************************************
      return
      end
