      function soft_integral_DD(l,egmax,p1,p2,p3,p4,ch)
! this should work also for massless momenta...
      implicit double precision (a-h,l,m,o-z)
      dimension p(0:3),q(0:3),pmat(4,0:3)
      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3),pa(0:3),pb(0:3)
      double precision mass(5)
      common/amasses/mass
      common/imode/imode
      dimension ch(4)
      dimension masses(4),eta(4)
      common/sffcommonDD/aopi,masses,eta,ifirst
      data ifirst/0/
      double complex cspen
      external cspen

#include "couplingandmasses.h"
! ch are the charges of the field (not anti-field!!)
! Use this convention: the integer factor in front of the charge
! must be
! -1 --> for incoming particle
! -1 --> for outgoing anti-particle
! +1 --> for outgoing particle
! +1 --> for incoming anti-particle

      if (ifirst.eq.0) then
         pi = 4.d0 * atan(1.d0)
!         pi2 is already in common...

         eta(1) =  1.d0 * ch(1)
         eta(2) = -1.d0 * ch(2)
         eta(3) =  1.d0 * ch(3)
         eta(4) = -1.d0 * ch(4)

         masses(1) = mass(1)
         masses(2) = mass(2)
         masses(3) = mass(3)
         masses(4) = mass(4)

c         amm = 0.105658369d0
c         masses =  amm

         aopi = alpha/pi

         aopi = aopi * rescaleQED

         ifirst = 1
      endif
*
      pmat(1,:) = p1
      pmat(2,:) = p2
      pmat(3,:) = p3
      pmat(4,:) = p4
c
      softint = 0.d0      
      do i = 1,4
         do j = i+1,4
            pa  = pmat(i,:)
            pb  = pmat(j,:)
            sab = dot(pa+pb,pa+pb)
c            sab = 2.d0*dot(pa,pb)

            termine = 2d0*log(2d0*egmax/l)*
     .           (1d0-log(sab/masses(i)/masses(j))) 
     .           -log(4d0*pa(0)*pb(0)/masses(i)/masses(j))
     &           +log(2d0*pa(0)/masses(i))**2
     .           +log(2d0*pb(0)/masses(j))**2 
     .           +pi2/3d0 
c     .     +cspen(dcmplx(1d0-4d0*pa(0)*pb(0)/dot(pa+pb,pa+pb)))
     &           +ddilog(1.d0-4.d0*pa(0)*pb(0)/sab)
            softint = softint + eta(i)*eta(j)*termine
         enddo
      enddo

      soft_integral_DD = softint * aopi

      return
      end
***********************************************************************************************
      function soft_integral_new(l,egmax,p1,p2,p3,p4,ch)
! this should work also for massless momenta...
      implicit double precision (a-h,l,m,o-z)
      parameter (npart = 4)
      dimension p(0:3),q(0:3),pmat(npart,0:3)
      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      double precision mass(5)
      common/amasses/mass
      common/imode/imode
      dimension ch(npart)
      dimension masses(npart),eta(npart)
      common/sffcommonNEW/ao2pi,masses,eta,ifirst
      data ifirst/0/

#include "couplingandmasses.h"
! ch are the charges of the field (not anti-field!!)
! Use this convention: the integer factor in front of the charge
! must be
! -1 --> for incoming particle
! -1 --> for outgoing anti-particle
! +1 --> for outgoing particle
! +1 --> for incoming anti-particle

      if (ifirst.eq.0) then
         pi = 4.d0 * atan(1.d0)

         eta(1) =  1.d0 * ch(1)
         eta(2) = -1.d0 * ch(2)
         eta(3) =  1.d0 * ch(3)
         eta(4) = -1.d0 * ch(4)

         masses(1) = mass(1)
         masses(2) = mass(2)
         masses(3) = mass(3)
         masses(4) = mass(4)

c         amm = 0.105658369d0
c         masses =  amm

         ao2pi = alpha/2.d0/pi

         ao2pi = ao2pi * rescaleQED

         ifirst = 1
      endif

      linfra    = log(egmax/l)
      linfrapl2 = linfra + log(2.d0)

      pmat(1,:) = p1
      pmat(2,:) = p2
      pmat(3,:) = p3
      pmat(4,:) = p4

      npartl = npart

! off-diagonal contributions
      softint = 0.d0
      do i = 1,npartl-1
         do j = i+1,npartl
            etaij = eta(i) * eta(j)

**********************************************************
* switching off interferences when imode = 1,40
            if (imode.eq.1.or.imode.eq.40) then       
               if ((i.eq.1.and.j.ne.2).or.(i.eq.2)) etaij=0.d0
            endif
**********************************************************
            if (abs(etaij).gt.1.d-3) then
               call rescale_momenta_new(npart,i,j,pmat,masses,p,q,rho)
               q2 = masses(j)*masses(j)
               vl = 0.5d0*(rho*rho*masses(i)*masses(i) - q2)
               v  = vl/(p(0) - q(0)) 
               arglog = 1.d0+2.d0*vl/q2               
               terminfra = 0.d0
               if (arglog.gt.0.d0) then 
                  terminfra = linfrapl2*log(arglog)
                  tot = terminfra + termfinite_new(p,q,v,rho,i,j)
               else
                  tot = 0.d0
               endif

               tot = -tot *2.d0*dot(p,q)/vl* etaij
               tot =  tot * 2.d0 ! this is the double product when
                                ! squaring the eikonal

               softint  = softint + tot
            endif
         enddo
      enddo      
      soft_integral_new = softint

! diagonal contributions
      softint = 0.d0
      do  i = 1,npartl
         etaii = eta(i)*eta(i)
         if (etaii.gt.1.d-3) then
            betai=(1.d0-masses(i)/pmat(i,0))*(1.d0+masses(i)/pmat(i,0))
            betai=sqrt(betai)
!     m2se2 = masses(i)**2/pmat(i,0)**2
!     umb2  = (1.d0 - betai)*(1.d0 + betai)
!     m2se2/umb2 is always = 1 !!!!
            term = 2.d0*linfrapl2 + log((1.d0-betai)/(1.d0+betai))/betai
!! ovvero
c            terma = 2.d0*linfrapl2 
c     .           + 2.d0/betai * log(masses(i)/pmat(i,0)/(1.d0+betai))

            term = -2.d0 * term * etaii
            softint = softint + term
         endif
      enddo
! divide by 2 to obtain exactly what is inside {} in Dittmaier & Kraemer
! paper (hep-ph/0109062)
      soft_integral_new =  (soft_integral_new + softint)/2.d0*ao2pi
      return
      end
***********************************************************************************************
      subroutine rescale_momenta_new(npart,i,j,pmat,masses,p,q,rho)
      implicit double precision (a-h,m,o-z)
      dimension p(0:3),q(0:3),pmat(npart,0:3),masses(npart)
      dimension p1(0:3),p2(0:3)
      
      do k = 0,3
         p1(k) = pmat(i,k)
         p2(k) = pmat(j,k)
      enddo

      m12 = masses(i)**2
      m22 = masses(j)**2
      
      p1p2 = dot(p1,p2)

      rho1 = p1p2 + sqrt(p1p2**2 - m12*m22)
      rho1 = rho1 / m12

c      rho2 = p1p2 - sqrt(p1p2**2 - m12*m22)
c      rho2 = rho2 / m12
!  better numerical solution !
      rho2 = m22/m12/rho1

      if ( (rho1*p1(0)-p2(0)) .gt. 0.d0) rho = rho1
      if ( (rho2*p1(0)-p2(0)) .gt. 0.d0) rho = rho2

      p = rho * p1
      q = p2

      return
      end
***********************************************************************************************
      function termfinite_new(p,q,v,rho,i,j)
      implicit double precision (a-h,m,o-z)
      dimension p(0:3),q(0:3)
      double complex cspen,carg

      parameter (npart=4)
      dimension masses(npart),eta(npart)
      common/sffcommonNEW/ao2pi,masses,eta,ifirst

      u0   = p(0)
      umod = sqrt(tridot(p,p))
      pp = u0 + umod
      pm = u0 - umod
      ppopm = pp*pp/rho/rho/masses(i)/masses(i) ! the same as pp/pm
      
      u0   = q(0)
      umod = sqrt(tridot(q,q))
      qp = u0 + umod
      qm = u0 - umod
      qpoqm = qp*qp/masses(j)/masses(j)  ! the same as qp/qm
      
      termfinite_new =
     .          log(ppopm)**2/4.d0 + ddilog((v-pm)/v) + ddilog((v-pp)/v)
     .        - log(qpoqm)**2/4.d0 - ddilog((v-qm)/v) - ddilog((v-qp)/v)

      return
      end
*****************************************************************
      function soft_integral(l,egmax,p1,p2,p3,p4,ch)
      implicit double precision (a-h,l,m,o-z)
      parameter (npart = 4)
      dimension eta(npart),p(0:3),q(0:3),pmat(npart,0:3)
      dimension masses(npart),ch(npart)
      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      double precision mass(5)
      common/amasses/mass
c      common/alphas/alpha0,alphaGF,alpha
      common/imode/imode

      common/sffcommon/ao2pi,masses,eta,ifirst
      data ifirst/0/

#include "couplingandmasses.h"
! ch are the charges of the field (not anti-field!!)
! Use this convention: the integer factor in front of the charge
! must be
! -1 --> for incoming particle
! -1 --> for outgoing anti-particle
! +1 --> for outgoing particle
! +1 --> for incoming anti-particle

      if (ifirst.eq.0) then
         pi = 4.d0 * atan(1.d0)

         eta(1) =  1.d0 * ch(1)
         eta(2) = -1.d0 * ch(2)
         eta(3) =  1.d0 * ch(3)
         eta(4) = -1.d0 * ch(4)

         masses(1) = mass(1)
         masses(2) = mass(2)
         masses(3) = mass(3)
         masses(4) = mass(4)

c         amm = 0.105658369d0
c         masses =  amm

         ao2pi = alpha/2.d0/pi

         ao2pi = ao2pi * rescaleQED

         ifirst = 1
      endif

*
      linfra    = log(egmax/l)
      linfrapl2 = linfra + log(2.d0)

      do k = 0,3
         pmat(1,k) = p1(k)
         pmat(2,k) = p2(k)
         pmat(3,k) = p3(k)
         pmat(4,k) = p4(k)
      enddo

      npartl = npart

! off-diagonal contributions
      softint = 0.d0
      do i = 1,npartl-1
         do j = i+1,npartl
            etaij = eta(i) * eta(j)

**********************************************************
* switching off interferences when imode = 1,40
            if (imode.eq.1.or.imode.eq.40) then       
               if ((i.eq.1.and.j.ne.2).or.(i.eq.2)) etaij=0.d0
            endif
**********************************************************
            if (abs(etaij).gt.1.d-3) then
               call rescale_momenta(npart,i,j,pmat,masses,p,q)
               q2 = dot(q,q)
               vl = dot(p,p) - q2
               vl = vl/2.d0
               v  = vl/(p(0) - q(0)) 
               arglog = 1.d0+2.d0*vl/q2
               
               terminfra = 0.d0
               if (arglog.gt.0.d0) then 
                  terminfra = linfrapl2*log(arglog)
                  tot = terminfra + termfinite(p,q,v)
               else
                  tot = 0.d0
               endif

               tot = - tot *2.d0*dot(p,q)/vl* etaij
               tot = tot * 2.d0 ! this is the double product when
                                ! squaring the eikonal

               softint  = softint + tot
            endif
         enddo
      enddo      
      soft_integral = softint

! diagonal contributions
      softint = 0.d0
      do  i = 1,npartl
         etaii = eta(i)**2
         if (etaii.gt.1.d-3) then
            betai=(1.d0-masses(i)/pmat(i,0))*(1.d0+masses(i)/pmat(i,0))
            betai=sqrt(betai)
!     m2se2 = masses(i)**2/pmat(i,0)**2
!     umb2  = (1.d0 - betai)*(1.d0 + betai)
!     m2se2/umb2 is always = 1 !!!!
            term = 2.d0*linfrapl2 + log((1.d0-betai)/(1.d0+betai))/betai 
            term = -2.d0 * term * etaii
            softint = softint + term
         endif
      enddo
! divide by 2 to obtain exactly what is inside {} in Dittmaier & Kraemer
! paper (hep-ph/0109062)
      soft_integral =  (soft_integral + softint)/2.d0*ao2pi
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function soft_L_TENTATIVO(eps,p1,p2,p3,p4)
      implicit double precision (a-h,l,m,o-z)
      parameter (npart = 4)
      dimension eps(npart),epsbck(npart)
      dimension eta(npart),p(0:3),q(0:3),pmat(npart,0:3)
      dimension masses(npart),ch(npart)
      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      double precision mass(5)
      common/amasses/mass
c      common/alphas/alpha0,alphaGF,alpha
      common/imode/imode
*      double precision masshiggs
*      common/paramhiggs/masshiggs
      common/identicalparticles/idpart
      common/switch24/iswitchforidpart

      double precision phmass,egmin
      COMMON/INFRAR/phmass,egmin

      double complex cvirt,cs,C0lt,clcoll
      
      common/bigLcommonNEW/cs,ao2pi,pi26,pi23,masses,eta,ifirst
      data ifirst/0/

#include "couplingandmasses.h"

#include "looptools.h"

      integer*8 id1
      
! ch are the charges of the field (not anti-field!!)
! Use this convention: the integer factor in front of the charge
! must be
! -1 --> for incoming particle
! -1 --> for outgoing anti-particle
! +1 --> for outgoing particle
! +1 --> for incoming anti-particle

      if (ifirst.eq.0) then
         im = (0.d0,1.d0)
         pi = 4.d0 * atan(1.d0)

         pi26 = pi*pi/6.d0
         pi23 = pi*pi/3.d0

         eta(1) =  1.d0 *( -1.d0)
         eta(2) = -1.d0 *( -1.d0)
         eta(3) =  1.d0 *( -1.d0)
         eta(4) = -1.d0 *( -1.d0)

         masses(1) = mass(1)
         masses(2) = mass(2)
         masses(3) = mass(3)
         masses(4) = mass(4)

         ao2pi = alpha/2.d0/pi

         ao2pi = ao2pi * rescaleQED
        
         ifirst = 1
      endif

*
      aieps =      -2.d0*log(eps(1))-1.5d0+2.d0*eps(1)-0.5d0*eps(1)**2
      aieps = aieps-2.d0*log(eps(2))-1.5d0+2.d0*eps(2)-0.5d0*eps(2)**2
      aieps = aieps-2.d0*log(eps(3))-1.5d0+2.d0*eps(3)-0.5d0*eps(3)**2
      aieps = aieps-2.d0*log(eps(4))-1.5d0+2.d0*eps(4)-0.5d0*eps(4)**2

      aieps2 = aieps !- aieps

      epsbck = eps

      
c      eps12 = eps(1)*eps(2)
c      eps34 = eps(3)*eps(4)

c      eps12 = 2.d0*egmin*egmin/dot(p1+p2,p1+p2)
c      eps34 = 2.d0*egmin*egmin/dot(p3+p4,p3+p4)
      
c      aieps = -2.d0 * (log(eps12)+log(eps34)) * 0.25d0
c      aieps = aieps - 3.d0/2.d0
      
      do k = 0,3
         pmat(1,k) = p1(k)
         pmat(2,k) = p2(k)
         pmat(3,k) = p3(k)
         pmat(4,k) = p4(k)
      enddo

      npartl = npart

      l = 1d-6
      
      linfra    = log(egmin/l) + 1.5d0
      linfrapl2 = linfra !+ log(2.d0)
      
! off-diagonal contributions
      softint = 0.d0
      do i = 1,npartl-1
         do j = i+1,npartl
            etaij = eta(i) * eta(j)

**********************************************************
* switching off interferences when imode = 1,40
            if (imode.eq.1.or.imode.eq.40) then
               if ((i.eq.1.and.j.ne.2).or.(i.eq.2)) etaij=0.d0
            endif

c            if ((i.eq.1.and.j.ne.2).or.(i.eq.2)) then
c               etaij=0.d0
c            endif
               
**********************************************************
            if (abs(etaij).gt.1.d-3) then
               call rescale_momenta(npart,i,j,pmat,masses,p,q)
               q2 = masses(j)*masses(j)
               vl = 0.5d0*(dot(p,p) - q2)
               v  = vl/(p(0) - q(0)) 
               arglog = 1.d0+2.d0*vl/q2
               terminfra = 0.d0
               if (arglog.gt.0.d0) then 

                  lcoll = log(arglog)*0.5d0 ! log(arglog) e' 2 * log(s/m^2) !!
                  lcoll = lcoll - 1.d0 ! for diagonal terms!!

                  cs = dot(pmat(i,:)+pmat(j,:),pmat(i,:)+pmat(j,:))
     .                + im*1d-12

                  clcoll = log(-masses(i)*masses(j)/cs) ! notice, this is -1*lcoll!!!
                  clcoll = clcoll + 1.d0 ! for diagonal terms!! with the previous note...

                  if ((i.eq.1.and.j.ne.2).or.(i.eq.2)) then
                     lcoll  = lcoll  + 1.d0 ! remove diag term when interference is calculated
                     clcoll = clcoll - 1.d0
                  endif
                  
                  cvirt = log(-l*l/cs)*clcoll
     .                 - 0.25d0*(log(-masses(i)*masses(i)/cs))**2
     .                 - 0.25d0*(log(-masses(j)*masses(j)/cs))**2
     .                 - pi26

                  
                  terminfra = linfra * lcoll * 2.d0
                  tot = terminfra + termfinite(p,q,v)
                  
c                  p1s = masses(i)*masses(i)
c                  p2s = masses(j)*masses(j)
c                  m1s = l*l
c                  m2s = masses(i)*masses(i)
c                  m3s = masses(j)*masses(j)
c                  p1p2s = dot(pmat(i,:)+pmat(j,:),pmat(i,:)+pmat(j,:))
c                  id1   = Cget(p1s,p1p2s,p2s,m1s,m2s,m3s)
c                  C0lt  = Cval(cc0,id1)
c                  clcoll = log(-l*l/cs)
c                  cvirt = C0lt*cs + clcoll
c                  if ((i.eq.1.and.j.ne.2).or.(i.eq.2)) then
c                     cvirt = cvirt -clcoll
c                  endif

                  tot = tot - cvirt - pi23
! -p23 ?!?!?!?
                  
c                  cs = abs(cs)
c                  print*,lcoll/2.d0, log(cs/masses(i)/masses(j))
c                   print*,tot,
c     .                 log(cs/masses(i)/masses(j))*
c     .                 log(4.d0*egmin*egmin/cs) + pi*pi/3.d0

               else
                  tot = 0.d0
               endif

c               print*,tot,cvirt
c               stop
               
               tot = tot *2.d0*dot(p,q)/vl* etaij
!               tot =  tot * 2.d0 ! this is the double product when
                                ! squaring the eikonal
               
               softint  = softint + tot

****               
            endif
         enddo
      enddo


      soft_L = softint*ao2pi

      eps = epsbck

      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function soft_L(eps,p1,p2,p3,p4)
      implicit double precision (a-h,l,m,o-z)
      parameter (npart = 4)
      dimension eps(npart)
      dimension eta(npart),p(0:3),q(0:3),pmat(npart,0:3)
      dimension masses(npart),ch(npart)
      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      double precision mass(5)
      common/amasses/mass
c      common/alphas/alpha0,alphaGF,alpha
      common/imode/imode
*      double precision masshiggs
*      common/paramhiggs/masshiggs
      common/identicalparticles/idpart
      common/switch24/iswitchforidpart

      common/bigLcommon/ao2pi,masses,eta,self,ifirst
      data ifirst/0/

#include "couplingandmasses.h"

! ch are the charges of the field (not anti-field!!)
! Use this convention: the integer factor in front of the charge
! must be
! -1 --> for incoming particle
! -1 --> for outgoing anti-particle
! +1 --> for outgoing particle
! +1 --> for incoming anti-particle

      if (ifirst.eq.0) then
         pi = 4.d0 * atan(1.d0)

         eta(1) =  1.d0 *( -1.d0)
         eta(2) = -1.d0 *( -1.d0)
         eta(3) =  1.d0 *( -1.d0)
         eta(4) = -1.d0 *( -1.d0)

         masses(1) = mass(1)
         masses(2) = mass(2)
         masses(3) = mass(3)
         masses(4) = mass(4)

         ao2pi = alpha/2.d0/pi

         ao2pi = ao2pi * rescaleQED

         self    = 4.d0

         ifirst = 1
      endif
*
      do k = 0,3
         pmat(1,k) = p1(k)
         pmat(2,k) = p2(k)
         pmat(3,k) = p3(k)
         pmat(4,k) = p4(k)
      enddo

      npartl = npart

      softint = 0.d0
      do i = 1,npartl-1
         do j = i+1,npartl
            etaij = eta(i) * eta(j)

**********************************************************
* switching off interferences when imode = 1,40
            if (imode.eq.1.or.imode.eq.40) then
               if ((i.eq.1.and.j.ne.2).or.(i.eq.2)) etaij=0.d0
            endif

c            iof = 0
c            if ((i.eq.1.and.j.ne.2).or.(i.eq.2)) iof = 1
c            etaij = etaij * iof
**********************************************************
            if (abs(etaij).gt.1.d-3) then
               call rescale_momenta(npart,i,j,pmat,masses,p,q)

               q2 = dot(q,q)
               vl = dot(p,p) - q2
               vl = vl/2.d0
               v  = vl/(p(0) - q(0)) 
               arglog = 1.d0+2.d0*vl/q2
               terminfra = 0.d0
               if (arglog.gt.0.d0) terminfra = log(arglog)

               tot = terminfra !+ termfinite(p,q,v)
               tot = - tot * dot(p,q)/vl* etaij

               softint = softint + tot
            endif
         enddo
      enddo
      
      aieps =      -2.d0*log(eps(1))-1.5d0+2.d0*eps(1)-0.5d0*eps(1)**2
      aieps = aieps-2.d0*log(eps(2))-1.5d0+2.d0*eps(2)-0.5d0*eps(2)**2
      aieps = aieps-2.d0*log(eps(3))-1.5d0+2.d0*eps(3)-0.5d0*eps(3)**2
      aieps = aieps-2.d0*log(eps(4))-1.5d0+2.d0*eps(4)-0.5d0*eps(4)**2      
      aieps = aieps*0.25d0

      soft_L = (softint - self)*ao2pi*aieps

c      soft_L_BACKUP = soft_L
      
      return
      end
**********************************************************

      subroutine getPSscale(p1,p2,p3,p4,ch,masses,scale2)
      implicit double precision (a-h,l,m,o-z)
      parameter (npart = 4)
      dimension eta(npart),p(0:3),q(0:3),pmat(npart,0:3)
      dimension masses(npart),ch(npart)
      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3)

! ch are the charges of the field (not anti-field!!)
! Use this convention: the integer factor in front of the charge
! must be
! -1 --> for incoming particle
! -1 --> for outgoing anti-particle
! +1 --> for outgoing particle
! +1 --> for incoming anti-particle
      eta(1) =  1.d0 * ch(1)
      eta(2) = -1.d0 * ch(2)
      eta(3) =  1.d0 * ch(3)
      eta(4) = -1.d0 * ch(4)
*
      linfra    = log(egmax/l)
      linfrapl2 = linfra + log(2.d0)

      do k = 0,3
         pmat(1,k) = p1(k)
         pmat(2,k) = p2(k)
         pmat(3,k) = p3(k)
         pmat(4,k) = p4(k)
      enddo

      npartl = npart

! off-diagonal contributions
      softint = 0.d0
      do i = 1,npartl-1
         do j = i+1,npartl
            etaij = eta(i) * eta(j)
            if (abs(etaij).gt.1.d-3) then
               call rescale_momenta(npart,i,j,pmat,masses,p,q)
               q2 = dot(q,q)
               vl = dot(p,p) - q2
               vl = vl/2.d0
               v  = vl/(p(0) - q(0)) 
               arglog = 1.d0+2.d0*vl/q2
               terminfra = 0.d0
               if (arglog.gt.0.d0) terminfra = log(arglog)
               tot = terminfra !+ termfinite(p,q,v)
               tot = - tot * dot(p,q)/vl* etaij
               softint  = softint + tot
            endif
         enddo
      enddo      
      collog = softint - 4.d0 ! diagonal contribution

c     scalelog = 1/4*(collog+2*log(m1^2)+2*log(m2^2))
c     i.e.
      scale2log = collog/4.d0 + log(masses(1))+ log(masses(3))
c
      scale2 = exp(scale2log)
      return
      end

      subroutine rescale_momenta(npart,i,j,pmat,masses,p,q)
      implicit double precision (a-h,m,o-z)
      dimension p(0:3),q(0:3),pmat(npart,0:3),masses(npart)
      dimension p1(0:3),p2(0:3)
      
      p1 = pmat(i,:)
      p2 = pmat(j,:)
      
      m12 = masses(i)*masses(i)
      m22 = masses(j)*masses(j)
      
      p1p2 = dot(p1,p2)

      rho1 = p1p2 + sqrt(p1p2*p1p2 - m12*m22)
      rho1 = rho1 / m12

c      rho2 = p1p2 - sqrt(p1p2**2 - m12*m22)
c      rho2 = rho2 / m12
!  better numerical solution !
      rho2 = m22/m12/rho1

      rho = rho1
      if ( (rho2*p1(0)-p2(0)) .gt. 0.d0) rho = rho2

      p = rho * p1
      q = p2

      return
      end

************************************
      function termfinite(p,q,v)
      implicit double precision (a-h,o-z)
      dimension p(0:3),q(0:3)

      u0   = p(0)
      umod = sqrt(tridot(p,p))
      pp = u0 + umod
      pm = u0 - umod

      u0   = q(0)
      umod = sqrt(tridot(q,q))
      qp = u0 + umod
      qm = u0 - umod

c      a1 = (v-pm)/v
c      a2 = (v-pp)/v
c      a3 = (v-qm)/v
c      a4 = (v-qp)/v
c      call tspence(a1,0.d0,1.d0-a1,dd1,dd1i)
c      call tspence(a2,0.d0,1.d0-a2,dd2,dd2i)
c      call tspence(a3,0.d0,1.d0-a3,dd3,dd3i)
c      call tspence(a4,0.d0,1.d0-a4,dd4,dd4i)
c      termfin2 = log(pp/pm)**2/4.d0 + dd1 + dd2
c     >        - log(qp/qm)**2/4.d0 - dd3 - dd4

      termfin = log(pp/pm)**2/4.d0 + ddilog((v-pm)/v) + ddilog((v-pp)/v)
     >        - log(qp/qm)**2/4.d0 - ddilog((v-qm)/v) - ddilog((v-qp)/v)

      termfinite = termfin

      return
      end

c$$$      function soft_integralIRtest(l,egmax,p1,p2,p3,p4)
c$$$      implicit double precision (a-h,l,m,o-z)
c$$$      double complex soft_integralIRtest,bfact
c$$$      double complex softint,softarray(8)
c$$$      parameter (npart = 4)
c$$$      dimension eta(npart),p(0:3),q(0:3),pmat(npart,0:3)
c$$$      dimension masses(npart),ch(npart)
c$$$      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3)
c$$$      common/imode/imode
c$$$
c$$$      double precision mass(5)
c$$$      common/amasses/mass ! common used also to force pXs = m^2
c$$$
c$$$
c$$$      double complex bornC(2,2)
c$$$      common/fortestIR/bornC
c$$$      common/softarrayc/softarray,sffnormale
c$$$
c$$$
c$$$! ch are the charges of the field (not anti-field!!)
c$$$! Use this convention: the integer factor in front of the charge
c$$$! must be
c$$$! -1 --> for incoming particle
c$$$! -1 --> for outgoing anti-particle
c$$$! +1 --> for outgoing particle
c$$$! +1 --> for incoming anti-particle
c$$$      masses(1) = mass(1)
c$$$      masses(2) = mass(2)
c$$$      masses(3) = mass(3)
c$$$      masses(4) = mass(4)
c$$$
c$$$      ch(1) = -1.d0
c$$$      ch(2) = -1.d0
c$$$      ch(3) = -1.d0
c$$$      ch(4) = -1.d0
c$$$
c$$$      eta(1) =  1.d0 * ch(1)
c$$$      eta(2) = -1.d0 * ch(2)
c$$$      eta(3) =  1.d0 * ch(3)
c$$$      eta(4) = -1.d0 * ch(4)
c$$$*     
c$$$      do k = 1,8
c$$$         softarray(k) = (0.d0,0.d0)
c$$$      enddo
c$$$*
c$$$      linfra    = log(egmax/l)
c$$$      linfrapl2 = linfra + log(2.d0)
c$$$
c$$$      do k = 0,3
c$$$         pmat(1,k) = p1(k)
c$$$         pmat(2,k) = p2(k)
c$$$         pmat(3,k) = p3(k)
c$$$         pmat(4,k) = p4(k)
c$$$      enddo
c$$$
c$$$      npartl = npart
c$$$
c$$$! off-diagonal contributions
c$$$      softint = 0.d0
c$$$      do i = 1,npartl-1
c$$$         do j = i+1,npartl
c$$$
c$$$            azzera = 0.d0
c$$$            if (i.eq.2.and.j.eq.3) then 
c$$$               azzera = 1.d0
c$$$               bfact  = 1.d0 * bornC(2,1)
c$$$               k = 1
c$$$            endif
c$$$            if (i.eq.1.and.j.eq.3) then 
c$$$               azzera = 1.d0
c$$$               bfact  = bornC(2,1) + bornC(1,2)
c$$$               k = 2
c$$$            endif
c$$$            if (i.eq.1.and.j.eq.4) then 
c$$$               azzera = 1.d0
c$$$               bfact  = bornC(2,1)
c$$$               k = 3
c$$$            endif
c$$$            if (i.eq.2.and.j.eq.4) then 
c$$$               azzera = 1.d0
c$$$               bfact  = bornC(2,1) + bornC(1,2)
c$$$               k = 4
c$$$            endif
c$$$            if (i.eq.3.and.j.eq.4) then 
c$$$               azzera = 1.d0
c$$$               bfact  = 1.d0 * bornC(1,2)
c$$$               k = 5
c$$$            endif
c$$$            if (i.eq.1.and.j.eq.2) then 
c$$$               azzera = 1.d0
c$$$               bfact  = bornC(1,2)
c$$$               k = 7
c$$$            endif
c$$$
c$$$c            print*,bornC(2,1),bornC(1,2)
c$$$c            if (i.eq.1.and.j.eq.2) azzera = bornC(1,2)
c$$$c            if (i.eq.3.and.j.eq.4) azzera = bornC(1,1) + bornC(1,2)
c$$$c            if (i.eq.2.and.j.eq.3) azzera = bornC(2,1) + bornC(2,2)
c$$$
c$$$            etaij = eta(i) * eta(j) * azzera
c$$$c            print*,'etaij =',i,j,etaij
c$$$
c$$$**********************************************************
c$$$* switching off interferences when imode = 1
c$$$c            if (imode.eq.1) then               
c$$$c            if ((i.eq.1.and.j.ne.2).or.(i.eq.2)) etaij=0.d0
c$$$c            endif
c$$$!            print*,i,j,etaij
c$$$**********************************************************
c$$$            
c$$$c            if (abs(etaij).gt.1.d-8) then
c$$$            call rescale_momenta(npart,i,j,pmat,masses,p,q)
c$$$            q2 = dot(q,q)
c$$$            vl = dot(p,p) - q2
c$$$            vl = vl/2.d0
c$$$            v  = vl/(p(0) - q(0)) 
c$$$            arglog = 1.d0+2.d0*vl/q2
c$$$            terminfra = 0.d0
c$$$            if (arglog.gt.0.d0) terminfra = linfrapl2*log(arglog)
c$$$            tot = terminfra + termfinite(p,q,v)
c$$$            tot = - tot *2.d0*dot(p,q)/vl* etaij
c$$$            tot = tot * 2.d0  ! this is the double product when
c$$$                              ! squaring the eikonal
c$$$            softint  = softint + bfact*tot
c$$$            if (azzera.gt.0.5d0) softarray(k) = bfact*tot/2.d0
c$$$c            endif
c$$$         enddo
c$$$      enddo      
c$$$c      soft_integral = softint
c$$$
c$$$      soft_integralIRtest = softint/2.d0
c$$$
c$$$! diagonal contributions
c$$$c      softint = 0.d0
c$$$c      do  i = 1,npartl
c$$$c IR TEST ! multiplied by 0!
c$$$c$$$         etaii = eta(i)**2 * 0.d0
c$$$c$$$         if (etaii.gt.1.d-3) then
c$$$c$$$            betai=(1.d0-masses(i)/pmat(i,0))*(1.d0+masses(i)/pmat(i,0))
c$$$c$$$            betai=sqrt(betai)
c$$$c$$$!     m2se2 = masses(i)**2/pmat(i,0)**2
c$$$c$$$!     umb2  = (1.d0 - betai)*(1.d0 + betai)
c$$$c$$$!     m2se2/umb2 is always = 1 !!!!
c$$$c$$$            term = 2.d0*linfrapl2 + log((1.d0-betai)/(1.d0+betai))/betai 
c$$$c$$$            term = -2.d0 * term * etaii
c$$$c$$$            softint = softint + term
c$$$c$$$         endif
c$$$c$$$      enddo
c$$$c$$$
c$$$c$$$      soft_integral =  soft_integral + softint*(bornC(1,1) + bornC(1,2)
c$$$c$$$     .                                        + bornC(2,1) + bornC(2,2))
c$$$
c$$$
c$$$
c$$$      return
c$$$      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        FUNCTION CSPEN(Z) ! from Prophecy2.0
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C       SPENCE-FUNKTION KOMPLEX, FREI NACH HOLLIK                     C
C---------------------------------------------------------------------C
C       20.07.83    LAST CHANGED 10.05.89        ANSGAR DENNER        C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        COMPLEX*16 CSPEN,W,SUM,Z,U
        REAL*8 RZ,AZ,A1
        REAL*8 B(9)/
     1   0.1666666666666666666666666667D0,
     2  -0.0333333333333333333333333333D0,
     3   0.0238095238095238095238095238D0,
     4  -0.0333333333333333333333333333D0,
     5   0.0757575757575757575757575758D0,
     6  -0.2531135531135531135531135531D0,
     7   1.1666666666666666666666666667D0,
     8  -7.09215686274509804D0         ,
     9  54.97117794486215539D0         /
C     BEACHTE:                 B(N)=B2N
C     B(1)=1./6.
C     B(2)=-1./30.
C     B(3)=1./42.
C     B(4)=-1./30.
C     B(5)=5./66.
C     B(6)=-691./2730.
C     B(7)=7./6.
C     B(8)=-3617./510.
C     B(9)=43867./798.
C     B(10)=-174611./330.
C     B(11)=854513./138.
C     PI=3.1415926535897932384
C     PI*PI/6.=1.6449..., PI*PI/3=3.28986...
C
      Z =Z*DCMPLX(1D0)
      RZ=DREAL(Z)
      AZ=CDABS(Z)
      A1=CDABS(1D0-Z)
C     IF((SNGL(RZ) .EQ. 0.0) .AND. (SNGL(DIMAG(Z)) .EQ. 0.0)) THEN
C ---> CHANGED  10.5.89
      IF(AZ .LT. 1D-20) THEN
        CSPEN=-CDLOG(1D0-Z)
        RETURN
      END IF
c      IF((SNGL(RZ) .EQ. 1.0) .AND. (SNGL(DIMAG(Z)) .EQ. 0.0)) THEN
c ---> changed 5.7.94
       IF( (ABS(RZ-1D0).LT.1D-18) .AND. (ABS(DIMAG(Z)).LT.1D-18) ) THEN
        CSPEN=1.64493406684822643D0
        RETURN
      END IF
      IF(RZ.GT.5D-1) GOTO 20
      IF(AZ.GT.1D0) GOTO 10
      W=-CDLOG(1D0-Z)
      SUM=W-0.25D0*W*W
      U=W
      IF(CDABS(U).LT.1D-10) GOTO 2
      DO 1 K=1,9
      U=U*W*W/DFLOAT(2*K*(2*K+1))
      IF(CDABS(U*B(K)/SUM).LT.1D-20) GOTO 2
      SUM=SUM+U*B(K)
 1    CONTINUE
 2    CSPEN=SUM
      RETURN
10    W=-CDLOG(1D0-1D0/Z)
      SUM=W-0.25D0*W*W
      U=W
      IF(CDABS(U).LT.1D-10) GOTO 12

      DO 11 K=1,9
      U=U*W*W/DFLOAT(2*K*(2*K+1))
      IF(CDABS(B(K)*U/SUM).LT.1D-20) GOTO 12
      SUM=SUM+U*B(K)
11    CONTINUE
12    CSPEN=-SUM-1.64493406684822643D0-.5D0*CDLOG(-Z)**2
      RETURN
20    IF(A1.GT.1D0) GOTO 30
      W=-CDLOG(Z)
      SUM=W-0.25D0*W*W
      U=W
      IF(CDABS(U).LT.1D-10) GOTO 22
      DO 21 K=1,9
      U=U*W*W/DFLOAT(2*K*(2*K+1))
      IF(CDABS(U*B(K)/SUM).LT.1D-20) GOTO 22
      SUM=SUM+U*B(K)
21    CONTINUE
22    CSPEN=-SUM+1.64493406684822643D0-CDLOG(Z)*CDLOG(1D0-Z)
      RETURN
30    W=CDLOG(1D0-1D0/Z)
      SUM=W-0.25D0*W*W
      U=W
      IF(CDABS(U).LT.1D-10) GOTO 32
      DO 31 K=1,9
      U=U*W*W/DFLOAT(2*K*(2*K+1))
      IF(CDABS(U*B(K)/SUM).LT.1D-20) GOTO 32
      SUM=SUM+U*B(K)
31    CONTINUE
32    CSPEN=SUM+3.28986813369645287D0
     *               +.5D0*CDLOG(Z-1D0)**2-CDLOG(Z)*CDLOG(1D0-Z)
50    CONTINUE
        END
