************************************
      subroutine initrndgen(iseed)
      implicit integer (a-z)
      parameter (lux=4,k1=0,k2=0)
c      call gslrndinit(iseed) ! interface to GNU Scientific Library PRNG, see gsl_random.c
      call rluxgo(lux,iseed,k1,k2)
      return
      end
**************************************************
      subroutine wraprnd(csiout,n)
      implicit none
      integer n,k
      double precision csiout(n)
      real*4 csi(n)
c      call gslrnd(csiout,n) ! interface to GNU Scientific Library PRNG, see gsl_random.c
      call ranlux(csi,n)
      do k = 1,n
         csiout(k) = 1.d0*csi(k)
      enddo
      return
      end
*****************************************************************
      subroutine setmassesandconstants
      implicit none
      include 'couplingandmasses.h'
      double precision zmasspdg,zwidthpdg,wmasspdg,wwidthpdg
      common/WZpdgvalues/zmasspdg,zwidthpdg,wmasspdg,wwidthpdg
      
      alpha0 = 1.D0/137.03599911D0
      gfermi = 1.16637d-5

* Below masses and widths in GeV      
** PDG VALUES [[
      zmasspdg  = 91.1876d0 ! Z PDG mass.  It is internally translated to the fixed-width scheme.
      zwidthpdg = 2.4952d0  ! Z PDG width. It is internally translated to the fixed-width scheme.
      wmasspdg  = 80.398d0  ! W PDG mass.  It is internally translated to the fixed-width scheme.
      wwidthpdg = 2.141d0   ! W PDG width. It is internally translated to the fixed-width scheme.
**             ]]
      mtau   = 1.77684d0 ! tau lepton mass
      mup    = 0.190d0   ! up quark mass
      mdown  = 0.190d0   ! down quark mass
      mc     = 1.4d0     ! charm quark mass
      ms     = 0.190d0   ! strange quark mass
      mb     = 4.75d0    ! bottom quark mass
      tmass  = 172.5d0   ! top quark mass
! the top width is calculated internally in init_apar
      return
      end
*****************************************************************
      subroutine cuts(p1,p2,p3,p4,qph,icut)
* cuts at generation level, extra cuts besides the invariant mass specified in input
      implicit none
      integer icut,ifirst
      include 'couplingandmasses.h'
      double precision dot,cut
      common/cutt/cut
      external dot
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      double precision qph(40,0:3)
      double precision mz12,mz34,mzlead,mzsub,mz(1:4),zzzmass
      integer i,j
      integer idpart
      common/identicalparticles/idpart
      double precision cutlowinvmass
      common/cutonlowinvmasses/cutlowinvmass ! from input
      data ifirst /1/
      common/prime/ifirst
      
      if (ifirst.eq.1) then
         cut    = 1.d-6 * masshiggs*masshiggs
         !cut    = 0d0
         ifirst = 0
      endif

      icut = 0
      zzzmass  = 91.1876d0

****** cut on all the combinations
      if (dot(p1+p2,p1+p2).lt.cut) then
         icut = 1
         return
      endif
      if (dot(p3+p4,p3+p4).lt.cut) then
         icut = 2
         return
      endif
      if (idpart.eq.1) then
         if (dot(p1+p4,p1+p4).lt.cut) then
            icut = 3
            return
         endif
         if (dot(p3+p2,p3+p2).lt.cut) then
            icut = 4
            return
         endif
      endif
      
****** cut on leading and subleading SFOS!
      if(idpart .eq. 0) then 
         mz12 = sqrt(dot(p1+p2,p1+p2))
         mz34 = sqrt(dot(p3+p4,p3+p4))
         if(mz12 .gt. mz34) then ! look for the leading and subleading sfos invariant mass pairs
            mzlead = mz12
            mzsub  = mz34
         else
            mzlead = mz34
            mzsub  = mz12
         endif
         if(mzsub .lt. cutlowinvmass) icut = 5
      else
         mz(1) = sqrt(dot(p1+p2,p1+p2))
         mz(2) = sqrt(dot(p1+p4,p1+p4))
         mz(3) = sqrt(dot(p2+p3,p2+p3))
         mz(4) = sqrt(dot(p3+p4,p3+p4))

         mzlead=mz(1)
         mzsub=mz(1)
         j=1

         do i=1,3 ! look for the leading and subleading sfos invariant mass pairs
            if(abs(mz(i+1)-zzzmass) .lt. abs(mzlead-zzzmass)) then
               mzlead=mz(i+1)
               j=i+1
            endif
         enddo
         mz(j)=0
         do i=1,3
            if(abs(mz(i+1)-zzzmass) .lt. abs(mzsub-zzzmass)) then
               mzsub=mz(i+1)
            endif
         enddo
         if(mzsub .lt. cutlowinvmass) icut = 5
      endif
      end
