      subroutine setinvariants(p1,p2,p3,p4)
      implicit none
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3),p5(0:3)

#include "invariants.h"

      double precision dot
      double complex epsfun
      external dot,epsfun
! for mz2..
#include "couplingandmasses.h"

      p5 = p1+p2+p3+p4

      p1p2 = dot(p1,p2) 
      p1p3 = dot(p1,p3)
      p1p4 = dot(p1,p4) 
      p2p3 = dot(p2,p3)
      p2p4 = dot(p2,p4)
      p3p4 = dot(p3,p4)
      
* with *p5* needed for LoopTools, where all momenta must be ingoing
      p1p5 = -dot(p1,p5)
      p2p5 = -dot(p2,p5)
      p3p5 = -dot(p3,p5)
      p4p5 = -dot(p4,p5)

      p1p22 = p1p2*p1p2
      p1p32 = p1p3*p1p3 
      p1p42 = p1p4*p1p4
      p2p32 = p2p3*p2p3
      p2p42 = p2p4*p2p4
      p3p42 = p3p4*p3p4

      p1p2s = dot(p1+p2,p1+p2)
      p1p3s = dot(p1+p3,p1+p3)
      p1p4s = dot(p1+p4,p1+p4)
      p2p3s = dot(p2+p3,p2+p3)
      p2p4s = dot(p2+p4,p2+p4)
      p3p4s = dot(p3+p4,p3+p4)

      p1p5s = dot(-p1+p5,-p1+p5)
      p2p5s = dot(-p2+p5,-p2+p5)
      p3p5s = dot(-p3+p5,-p3+p5)
      p4p5s = dot(-p4+p5,-p4+p5)

      p1p2p3s = dot(p1+p2+p3,p1+p2+p3)
      p1p2p4s = dot(p1+p2+p4,p1+p2+p4)
      p1p3p4s = dot(p1+p3+p4,p1+p3+p4)
      p2p3p4s = dot(p2+p3+p4,p2+p3+p4)
c      p1p2p3p4s = masshiggs * masshiggs !dot(p1+p2+p3+p4,p1+p2+p3+p4)
      p1p2p3p4s = dot(p1+p2+p3+p4,p1+p2+p3+p4)
cc      print*,'invariants',p1p2p3p4s,masshiggs*masshiggs

      P12g = 1.d0/p1p2s
      P34g = 1.d0/p3p4s
      P14g = 1.d0/p1p4s
      P23g = 1.d0/p2p3s

      P12  = 1.d0/(p1p2s - mz2)
      P34  = 1.d0/(p3p4s - mz2)
      P14  = 1.d0/(p1p4s - mz2)
      P23  =  1.d0/(p2p3s - mz2)
      P12s = conjg(P12)
      P34s = conjg(P34)
      P14s = conjg(P14)
      P23s = conjg(P23)

      ep1p2p3p4  = epsfun(p1,p2,p3,p4)

      return
      end
****
      subroutine flip
** flips 2 <-> 4 for identical particles MEs
      implicit none
      double precision tmp
      double complex   ctmp

#include "invariants.h"

      tmp  = p1p2
      p1p2 = p1p4
      p1p4 = tmp
c not needed      p1p3
      tmp  = p2p3
      p2p3 = p3p4
      p3p4 = tmp
c not needed      p2p4

      p1p22 = p1p2*p1p2
c not needed      p1p32
      p1p42 = p1p4*p1p4
      p2p32 = p2p3*p2p3
c not needed      p2p42
      p3p42 = p3p4*p3p4

      tmp  = p2p5
      p2p5 = p4p5
      p4p5 = tmp

      tmp   = p1p2s
      p1p2s = p1p4s
      p1p4s = tmp
c not needed      p1p3s
      tmp   = p2p3s
      p2p3s = p3p4s
      p3p4s = tmp
c not needed      p2p4s

      tmp   = p2p5s
      p2p5s = p4p5s
      p4p5s = tmp
      
      tmp     = p1p2p3s
      p1p2p3s = p1p3p4s
      p1p3p4s = tmp
c not needed      p1p2p4s
c not needed      p2p3p4s
c not needed      p1p2p3p4s

      tmp  = P12g 
      P12g = P14g
      P14g = tmp

      tmp  = P34g
      P34g = P23g
      P23g = tmp

      ctmp = P12
      P12  = P14
      P14  = ctmp

      ctmp = P34
      P34  = P23
      P23  = ctmp

      P12s = conjg(P12)
      P34s = conjg(P34)
      P14s = conjg(P14)
      P23s = conjg(P23)

c since  ep1p2p3p4 = -ep1p2p4p3 = ep1p4p2p3 = - ep1p4p3p2
      ep1p2p3p4  = -ep1p2p3p4

      return
      end
************************************************************************
      function checknan(r)
      integer checknan
      double precision r
      checknan = 1
      if (isnan(r)) checknan = 0
      return
      end
*************************************************************************
      SUBROUTINE virtualplussoft(Q1,Q2,Q3,Q4,oneloop,BORN,BORNIBA)
      IMPLICIT NONE
      double precision q1(0:3), q2(0:3), q3(0:3), q4(0:3)     
      double precision ctsQED,born,vertex,oneloop,pentagons,bornIBA
      double precision ctsandselfen,cfrpro,sfnew,sfDD
      double precision extravertex,box,Hvertex
      double precision pent1234,box1234,vert1234,extravert1234
      double precision pent1432,box1432,vert1432,extravert1432
      integer ifirst,icount,ik
      common/ifirstcountvirtual/ifirst,icount
      data ifirst,icount/1,0/
      integer imode,i1_40
      common/imode/imode

      double precision charges(4),mudim,deltauv
      common/vcharges/charges
      data charges/-1.d0,-1.d0,-1.d0,-1.d0/

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double precision masshiggs
      common/paramhiggs/masshiggs

      double precision ck_mhiggs,mh2
      common/checkhiggsmass/ck_mhiggs
      data ck_mhiggs /0.d0/

      double precision phmass,egmin
      COMMON/INFRAR/phmass,egmin

      double precision sf,soft_integral,soft_integral_new
      double precision soft_integral_DD
      external soft_integral,soft_integral_new,soft_integral_DD

      double complex vZ,vW,vNA
      common/vertexdebug/vZ,vW,vNA

      integer idpart
      common/identicalparticles/idpart

      double precision toploop,neutralloop,chargedloop,chargedblob,
     .     neutralblob,quadriblob
      double precision toploop1234,neutralloop1234,chargedloop1234,
     .     chargedblob1234,
     .     neutralblob1234,quadriblob1234,
     .     toploop1432,neutralloop1432,chargedloop1432,chargedblob1432,
     .     neutralblob1432,quadriblob1432
      common/Hvertexresults/toploop,neutralloop,chargedloop,chargedblob,
     .     neutralblob,quadriblob,
     .     toploop1234,neutralloop1234,chargedloop1234,chargedblob1234,
     .     neutralblob1234,quadriblob1234,
     .     toploop1432,neutralloop1432,chargedloop1432,chargedblob1432,
     .     neutralblob1432,quadriblob1432

      integer checknan
      external checknan

#include "looptools.h"

** UV test
c      DO IK = 1,2
c      IF (IK.EQ.1) THEN
c         DELTAUV = 0.D0
c         MUDIM   = 1.D0
c      ELSE
c         DELTAUV = 10000.D0
c         MUDIM   = 0.001D0
c      ENDIF
c      PRINT*,'======= K = ',IK
c      CALL SETDELTA(DELTAUV)
c      CALL SETMUDIM(MUDIM)
****

      i1_40 = 0
      if (imode.eq.1.or.imode.eq.40) i1_40 = 1
      
      oneloop = 0.d0

c      open(10,file='getmomenta',status='unknown')
c      read(10,*) q1(0)
c      read(10,*) q1(1)
c      read(10,*) q1(2)
c      read(10,*) q1(3)
c      read(10,*) q2(0)
c      read(10,*) q2(1)
c      read(10,*) q2(2)
c      read(10,*) q2(3)
c      read(10,*) q3(0)
c      read(10,*) q3(1)
c      read(10,*) q3(2)
c      read(10,*) q3(3)
c      read(10,*) q4(0)
c      read(10,*) q4(1)
c      read(10,*) q4(2)
c      read(10,*) q4(3)
c      close(10)

      call newborn(q1,q2,q3,q4,born,bornIBA)
      call QEDcts(born,ctsQED)

c      sfDD = born * soft_integral_DD(phmass,egmin,q1,q2,q3,q4,charges)

c      sf   = born * soft_integral(phmass,egmin,q1,q2,q3,q4,charges)

      sfnew= born * soft_integral_new(phmass,egmin,q1,q2,q3,q4,charges)
      sf = sfnew


      oneloop = oneloop + ctsQED + sf

c      oneloop = oneloop - ctsQED
c      return
      
*********
      call setinvariants(q1,q2,q3,q4)
********

      call get_vertexes(vert1234)
      oneloop = oneloop + vert1234
      if (i1_40.eq.0) then
         call get_pentagons(pent1234)
         if (.not.isnan(pent1234)) oneloop = oneloop + pent1234
      endif
      if (idpart.eq.1) then
***
         call flip
***
         call get_vertexes(vert1432)
         oneloop = oneloop + vert1432
         if (i1_40.eq.0) then         
            call get_pentagons(pent1432)
            if (.not.isnan(pent1432)) oneloop = oneloop + pent1432
         endif
***
         call flip
***
      endif

*****************************************************
      if (i1_40.eq.1) return
****************************************************

      if (iweakcorr.eq.1) then

! remove "if" for UV test
         if (abs(ck_mhiggs-masshiggs).gt.1.d-3) then
            mh2 = masshiggs*masshiggs
            call modifyHMdependentcouplings(mh2)
            call get_counterterms(mh2)
            ck_mhiggs = masshiggs
         endif
         call CTSandSelf(ctsandselfen)
         oneloop = oneloop + ctsandselfen
         
         call get_boxes(box1234)
         if (.not.isnan(box1234)) oneloop = oneloop + box1234
         call get_extravertexes(extravert1234) ! correction to the H>ffbar (via loop) vertex
         oneloop = oneloop + extravert1234
* H vertex
         call get_Htoploop(toploop1234)
         oneloop = oneloop + toploop1234
         call get_Hneutralloop(neutralloop1234)
         oneloop = oneloop + neutralloop1234
         call get_Hneutralblobs(neutralblob1234)
         oneloop = oneloop + neutralblob1234
         call get_Hchargedloop(chargedloop1234)
         oneloop = oneloop + chargedloop1234
         call get_Hchargedblobs(chargedblob1234)
         oneloop = oneloop + chargedblob1234
         call get_Hblobsquadrilinear(quadriblob1234)
         oneloop = oneloop + quadriblob1234
         
c$$$         print*,'sf =       ',sf
c$$$         print*,'ctsqed =   ',ctsQED
c$$$         print*,'vert=      ',vert1234
c$$$         print*,'pent=      ',pent1234
c$$$         print*,'ctsself=   ',ctsandselfen
c$$$         print*,'box =      ',box1234!*checknan(box1234)
c$$$         print*,'extravert= ',extravert1234
c$$$         print*,'toploop=   ',toploop1234
c$$$         print*,'nl =       ',neutralloop1234
c$$$         print*,'nb =       ',neutralblob1234
c$$$         print*,'cl =       ',chargedloop1234
c$$$         print*,'cb =       ',chargedblob1234
c$$$         print*,'qb =       ',quadriblob1234
c$$$         call debugboxes
c$$$         stop

         if (idpart.eq.1) then
***
            call flip            
***
            call get_boxes(box1432)
            if (.not.isnan(box1432)) oneloop = oneloop + box1432
            call get_extravertexes(extravert1432) ! correction to the H>ffbar (via loop) vertex
            oneloop = oneloop + extravert1432
* Hvertex
            call get_Htoploop(toploop1432)
            oneloop = oneloop + toploop1432
            call get_Hneutralloop(neutralloop1432)
            oneloop = oneloop + neutralloop1432
            call get_Hneutralblobs(neutralblob1432)
            oneloop = oneloop + neutralblob1432
            call get_Hchargedloop(chargedloop1432)
            oneloop = oneloop + chargedloop1432
            call get_Hchargedblobs(chargedblob1432)
            oneloop = oneloop + chargedblob1432
            call get_Hblobsquadrilinear(quadriblob1432)
            oneloop = oneloop + quadriblob1432
***
            call flip
***
         endif

      endif

c      print*,box1234
c      print*,box1432
c      print*,'stop in virtual.F'
c      stop

c      print*,'TOPBOTTOM LOOP',toploop
c      stop
c      cfrpro = neutralloop1234 + neutralblob1234 + chargedloop1234 
c     .         + chargedblob1234 + quadriblob1234
c     .         + neutralloop1432 + neutralblob1432 + chargedloop1432
c     .         + chargedblob1432 + quadriblob1432


c      cfrpro = oneloop  !-sf!extravert1234 + idpart * extravert1432
c      print*,born
c      print*,cfrpro
c      stop

** UV test
c      ENDDO
c      STOP
***
c      print*,'virtual.F --- stop'
c      print*,oneloop - sf
c      stop
c      print*,'vert=      ',vert1234+idpart*vert1432
c      print*,'pent=      ',pent1234+idpart*pent1432
c      print*,'1L =       ',oneloop
c      call debug5p
c      stop

      return
      end
