C-- Input parameters from MG5 
c$$$      gW = MG5GW
c$$$      CW = MG5CW
c$$$      SW = MG5SW
c$$$      MZ = MDL_MZ
C=================
c$$$      gZ = gW/CW
c$$$      g1 = gZ*SW
c$$$      gE = gW*SW
c$$$      COUPLSM = (gZ**3*MZ)**2
c$$$
c$$$      SWSQ = SW**2
c$$$      CV = (SWSQ -1.D0/4.D0)
c$$$      CA = (+1.D0/4.D0)
c$$$      CVA = CV*CA
c$$$      CVSQ = CV**2
c$$$      CASQ = CA**2
c$$$
c$$$      MZSQ = MZ**2

      s12 = dot(k1,k2)
      s13 = dot(k1,k3)
      s14 = dot(k1,k4)
      s23 = dot(k2,k3)
      s24 = dot(k2,k4)
      s34 = dot(k3,k4)

      PROPZ12 = 1d0/(dot(k1+k2,k1+k2)-MZSQ)
      PROPZ34 = 1d0/(dot(k3+k4,k3+k4)-MZSQ)


C-- SM
      MSQSM =
     &  + CASQ**2*couplsm * ( 32*s14*s23*PropZ12**2*PropZ34**2 + 32*s13
     &    *s24*PropZ12**2*PropZ34**2 )
      MSQSM = MSQSM + CVSQ*CASQ*couplsm * (  - 64*s14*s23*PropZ12**2*
     &    PropZ34**2 + 192*s13*s24*PropZ12**2*PropZ34**2 )
      MSQSM = MSQSM + CVSQ**2*couplsm * ( 32*s14*s23*PropZ12**2*
     &    PropZ34**2 + 32*s13*s24*PropZ12**2*PropZ34**2 )

C-- BSM
c$$$         NP   = 1D0
c$$$         NPSQ = 1D0
c$$$
c$$$         dGl1L = 0d0 
c$$$         dGl1R = 0d0
c$$$
c$$$         dCz  = 0d0
c$$$         Caa  = 0d0
c$$$         Cza  = 0d0
c$$$         Czz  = 0d0
c$$$         Czbx = 0d0
c$$$
c$$$         Cabx = (2d0*gW**2*Czbx+(gW**2+g1**2)*Czz-
c$$$     &        gE**2*Caa-(gW**2-g1**2)*Cza)/(gW**2-g1**2)

      MSQBSM =
     &  + mzsq**(-2)*couplsm*NPSQ*Caa**2 * ( s12**(-2)*s14**2*s23**2*
     &    s34**(-2)*cw**4*sw**8 - 2*s12**(-2)*s13*s14*s23*s24*s34**(-2)
     &    *cw**4*sw**8 + s12**(-2)*s13**2*s24**2*s34**(-2)*cw**4*sw**8
     &     + 1./2.*s12**(-1)*s24**2*s34**(-1)*cw**4*sw**8 + 1./2.*
     &    s12**(-1)*s23**2*s34**(-1)*cw**4*sw**8 - s12**(-1)*s14*s23*
     &    s34**(-1)*cw**4*sw**8 + 1./2.*s12**(-1)*s14**2*s34**(-1)*
     &    cw**4*sw**8 - s12**(-1)*s13*s24*s34**(-1)*cw**4*sw**8 + 1./2.
     &    *s12**(-1)*s13**2*s34**(-1)*cw**4*sw**8 + cw**4*sw**8 )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*dGl1L**2 * ( 32*s14
     &    *s23*PropZ34**2 + 32*s14*s23*PropZ12**2 - 32*s13*s24*
     &    PropZ34**2 - 64*s13*s24*PropZ12*PropZ34 - 32*s13*s24*
     &    PropZ12**2 )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*dGl1R**2 * (  - 32*
     &    s14*s23*PropZ34**2 - 32*s14*s23*PropZ12**2 + 32*s13*s24*
     &    PropZ34**2 + 64*s13*s24*PropZ12*PropZ34 + 32*s13*s24*
     &    PropZ12**2 )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * ( 8*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ34**2 + 8*s12**(-1)*s14*s23*
     &    s24*sw**2*PropZ12*PropZ34 + 8*s12**(-1)*s14*s23**2*sw**2*
     &    PropZ34**2 + 8*s12**(-1)*s14**2*s23*sw**2*PropZ34**2 - 8*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34**2 - 8*s12**(-1)*s13*
     &    s24**2*sw**2*PropZ12*PropZ34 - 8*s12**(-1)*s13*s23*s24*sw**2*
     &    PropZ34**2 - 8*s12**(-1)*s13*s14*s24*sw**2*PropZ34**2 + 8*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34**2 + 8*s12**(-1)*s13*s14*
     &    s23*sw**2*PropZ12*PropZ34 - 8*s12**(-1)*s13**2*s24*sw**2*
     &    PropZ34**2 - 8*s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34 - 8
     &    *s24*s34*sw**2*PropZ34**2 - 8*s24*s34*sw**2*PropZ12*PropZ34
     &     + 8*s23*s34*sw**2*PropZ34**2 + 8*s14*s34*sw**2*PropZ34**2 + 
     &    8*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34 + 8*s14*s23*s24
     &    *s34**(-1)*sw**2*PropZ12**2 + 8*s14*s23**2*s34**(-1)*sw**2*
     &    PropZ12**2 + 8*s14**2*s23*s34**(-1)*sw**2*PropZ12**2 - 8*s13*
     &    s34*sw**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * (  - 8*
     &    s13*s34*sw**2*PropZ12*PropZ34 - 8*s13*s24**2*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 - 8*s13*s24**2*s34**(-1)*sw**2*PropZ12**2 - 8
     &    *s13*s23*s24*s34**(-1)*sw**2*PropZ12**2 - 8*s13*s14*s24*
     &    s34**(-1)*sw**2*PropZ12**2 + 8*s13*s14*s23*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 8*s13*s14*s23*s34**(-1)*sw**2*PropZ12**2 - 
     &    8*s13**2*s24*s34**(-1)*sw**2*PropZ12*PropZ34 - 8*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12**2 - 8*s12*s24*sw**2*PropZ12*PropZ34
     &     - 8*s12*s24*sw**2*PropZ12**2 + 8*s12*s23*sw**2*PropZ12**2 + 
     &    8*s12*s14*sw**2*PropZ12**2 - 8*s12*s13*sw**2*PropZ12*PropZ34
     &     - 8*s12*s13*sw**2*PropZ12**2 )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * (  - 8*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ34**2 - 8*s12**(-1)*s14*s23*
     &    s24*sw**2*PropZ12*PropZ34 - 8*s12**(-1)*s14*s23**2*sw**2*
     &    PropZ34**2 - 8*s12**(-1)*s14**2*s23*sw**2*PropZ34**2 + 8*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34**2 + 8*s12**(-1)*s13*
     &    s24**2*sw**2*PropZ12*PropZ34 + 8*s12**(-1)*s13*s23*s24*sw**2*
     &    PropZ34**2 + 8*s12**(-1)*s13*s14*s24*sw**2*PropZ34**2 - 8*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34**2 - 8*s12**(-1)*s13*s14*
     &    s23*sw**2*PropZ12*PropZ34 + 8*s12**(-1)*s13**2*s24*sw**2*
     &    PropZ34**2 + 8*s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34 + 8
     &    *s24*s34*sw**2*PropZ34**2 + 8*s24*s34*sw**2*PropZ12*PropZ34
     &     - 8*s23*s34*sw**2*PropZ34**2 - 8*s14*s34*sw**2*PropZ34**2 - 
     &    8*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34 - 8*s14*s23*s24
     &    *s34**(-1)*sw**2*PropZ12**2 - 8*s14*s23**2*s34**(-1)*sw**2*
     &    PropZ12**2 - 8*s14**2*s23*s34**(-1)*sw**2*PropZ12**2 + 8*s13*
     &    s34*sw**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * ( 8*s13
     &    *s34*sw**2*PropZ12*PropZ34 + 8*s13*s24**2*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 8*s13*s24**2*s34**(-1)*sw**2*PropZ12**2 + 8
     &    *s13*s23*s24*s34**(-1)*sw**2*PropZ12**2 + 8*s13*s14*s24*
     &    s34**(-1)*sw**2*PropZ12**2 - 8*s13*s14*s23*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 - 8*s13*s14*s23*s34**(-1)*sw**2*PropZ12**2 + 
     &    8*s13**2*s24*s34**(-1)*sw**2*PropZ12*PropZ34 + 8*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12**2 + 8*s12*s24*sw**2*PropZ12*PropZ34
     &     + 8*s12*s24*sw**2*PropZ12**2 - 8*s12*s23*sw**2*PropZ12**2 - 
     &    8*s12*s14*sw**2*PropZ12**2 + 8*s12*s13*sw**2*PropZ12*PropZ34
     &     + 8*s12*s13*sw**2*PropZ12**2 )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cabx*dGl1L * (  - 
     &    32*s14*s23*sw**2*PropZ34**2 - 32*s14*s23*sw**2*PropZ12**2 + 
     &    32*s13*s24*sw**2*PropZ34**2 + 64*s13*s24*sw**2*PropZ12*
     &    PropZ34 + 32*s13*s24*sw**2*PropZ12**2 )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cabx*dGl1R * ( 32*
     &    s14*s23*sw**2*PropZ34**2 + 32*s14*s23*sw**2*PropZ12**2 - 32*
     &    s13*s24*sw**2*PropZ34**2 - 64*s13*s24*sw**2*PropZ12*PropZ34
     &     - 32*s13*s24*sw**2*PropZ12**2 )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*dGl1L**2 * ( 64*s14
     &    *s23*PropZ12*PropZ34**2 + 64*s14*s23*PropZ12**2*PropZ34 - 128
     &    *s13*s24*PropZ12*PropZ34**2 - 128*s13*s24*PropZ12**2*PropZ34
     &     )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*dGl1R**2 * (  - 64*
     &    s14*s23*PropZ12*PropZ34**2 - 64*s14*s23*PropZ12**2*PropZ34 + 
     &    128*s13*s24*PropZ12*PropZ34**2 + 128*s13*s24*PropZ12**2*
     &    PropZ34 )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * ( 16*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*
     &    s14*s23**2*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*s14**2*s23*
     &    sw**2*PropZ12*PropZ34**2 - 16*s12**(-1)*s13*s24**2*sw**2*
     &    PropZ12*PropZ34**2 - 8*s12**(-1)*s13*s23*s24*sw**2*PropZ12*
     &    PropZ34**2 - 8*s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34**2
     &     + 16*s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34**2 - 16*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34**2 - 16*s24*s34*
     &    sw**2*PropZ12*PropZ34**2 + 8*s23*s34*sw**2*PropZ12*PropZ34**2
     &     + 8*s14*s34*sw**2*PropZ12*PropZ34**2 + 16*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s14*s23**2*s34**(-1)*
     &    sw**2*PropZ12**2*PropZ34 + 8*s14**2*s23*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 - 16*s13*s34*sw**2*PropZ12*PropZ34**2 - 16
     &    *s13*s24**2*s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s13*s23*
     &    s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s13*s14*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * ( 16*
     &    s13*s14*s23*s34**(-1)*sw**2*PropZ12**2*PropZ34 - 16*s13**2*
     &    s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 - 16*s12*s24*sw**2*
     &    PropZ12**2*PropZ34 + 8*s12*s23*sw**2*PropZ12**2*PropZ34 + 8*
     &    s12*s14*sw**2*PropZ12**2*PropZ34 - 16*s12*s13*sw**2*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * (  - 16
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34**2 - 8*s12**(-1)
     &    *s14*s23**2*sw**2*PropZ12*PropZ34**2 - 8*s12**(-1)*s14**2*s23
     &    *sw**2*PropZ12*PropZ34**2 + 16*s12**(-1)*s13*s24**2*sw**2*
     &    PropZ12*PropZ34**2 + 8*s12**(-1)*s13*s23*s24*sw**2*PropZ12*
     &    PropZ34**2 + 8*s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34**2
     &     - 16*s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34**2 + 16*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34**2 + 16*s24*s34*
     &    sw**2*PropZ12*PropZ34**2 - 8*s23*s34*sw**2*PropZ12*PropZ34**2
     &     - 8*s14*s34*sw**2*PropZ12*PropZ34**2 - 16*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s14*s23**2*s34**(-1)*
     &    sw**2*PropZ12**2*PropZ34 - 8*s14**2*s23*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 + 16*s13*s34*sw**2*PropZ12*PropZ34**2 + 16
     &    *s13*s24**2*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s13*s23*
     &    s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s13*s14*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * (  - 16
     &    *s13*s14*s23*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 16*s13**2*
     &    s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 16*s12*s24*sw**2*
     &    PropZ12**2*PropZ34 - 8*s12*s23*sw**2*PropZ12**2*PropZ34 - 8*
     &    s12*s14*sw**2*PropZ12**2*PropZ34 + 16*s12*s13*sw**2*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cabx*dGl1L * (  - 
     &    32*s14*s23*sw**2*PropZ12*PropZ34**2 - 32*s14*s23*sw**2*
     &    PropZ12**2*PropZ34 + 64*s13*s24*sw**2*PropZ12*PropZ34**2 + 64
     &    *s13*s24*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cabx*dGl1R * ( 32*
     &    s14*s23*sw**2*PropZ12*PropZ34**2 + 32*s14*s23*sw**2*
     &    PropZ12**2*PropZ34 - 64*s13*s24*sw**2*PropZ12*PropZ34**2 - 64
     &    *s13*s24*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CVA*couplsm*NPSQ*dGl1L**2 * ( 64*s14*s23*
     &    PropZ12**2*PropZ34**2 - 128*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVA*couplsm*NPSQ*dGl1R**2 * (  - 64*s14*s23*
     &    PropZ12**2*PropZ34**2 + 128*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L**2 * ( 16*
     &    s14*s23*PropZ34**2 + 16*s14*s23*PropZ12**2 + 16*s13*s24*
     &    PropZ34**2 + 32*s13*s24*PropZ12*PropZ34 + 16*s13*s24*
     &    PropZ12**2 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*dGl1L * ( 
     &     - 64*s14*s23*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R**2 * ( 16*
     &    s14*s23*PropZ34**2 + 16*s14*s23*PropZ12**2 + 16*s13*s24*
     &    PropZ34**2 + 32*s13*s24*PropZ12*PropZ34 + 16*s13*s24*
     &    PropZ12**2 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * (  - 4
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ34**2 - 4*s12**(-1)*s14*s23
     &    *s24*sw**2*PropZ12*PropZ34 + 4*s12**(-1)*s14*s23**2*sw**2*
     &    PropZ34**2 - 4*s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34 + 4
     &    *s12**(-1)*s14**2*s23*sw**2*PropZ34**2 - 4*s12**(-1)*s14**2*
     &    s23*sw**2*PropZ12*PropZ34 + 4*s12**(-1)*s13*s24**2*sw**2*
     &    PropZ34**2 + 4*s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34 - 4
     &    *s12**(-1)*s13*s23*s24*sw**2*PropZ34**2 + 4*s12**(-1)*s13*s23
     &    *s24*sw**2*PropZ12*PropZ34 - 4*s12**(-1)*s13*s14*s24*sw**2*
     &    PropZ34**2 + 4*s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34 - 
     &    4*s12**(-1)*s13*s14*s23*sw**2*PropZ34**2 - 4*s12**(-1)*s13*
     &    s14*s23*sw**2*PropZ12*PropZ34 + 4*s12**(-1)*s13**2*s24*sw**2*
     &    PropZ34**2 + 4*s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34 + 4
     &    *s24*s34*sw**2*PropZ34**2 + 4*s24*s34*sw**2*PropZ12*PropZ34
     &     + 4*s23*s34*sw**2*PropZ34**2 - 4*s23*s34*sw**2*PropZ12*
     &    PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * ( 4*
     &    s14*s34*sw**2*PropZ34**2 - 4*s14*s34*sw**2*PropZ12*PropZ34 - 
     &    4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34 - 4*s14*s23*s24
     &    *s34**(-1)*sw**2*PropZ12**2 - 4*s14*s23**2*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12**2 - 4
     &    *s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34 + 4*s14**2*s23*
     &    s34**(-1)*sw**2*PropZ12**2 + 4*s13*s34*sw**2*PropZ34**2 + 4*
     &    s13*s34*sw**2*PropZ12*PropZ34 + 4*s13*s24**2*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 4*s13*s24**2*s34**(-1)*sw**2*PropZ12**2 + 4
     &    *s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34 - 4*s13*s23*s24*
     &    s34**(-1)*sw**2*PropZ12**2 + 4*s13*s14*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 - 4*s13*s14*s24*s34**(-1)*sw**2*PropZ12**2 - 
     &    4*s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ34 - 4*s13*s14*s23
     &    *s34**(-1)*sw**2*PropZ12**2 + 4*s13**2*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 4*s13**2*s24*s34**(-1)*sw**2*PropZ12**2 + 4
     &    *s12*s24*sw**2*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * ( 4*
     &    s12*s24*sw**2*PropZ12**2 - 4*s12*s23*sw**2*PropZ12*PropZ34 + 
     &    4*s12*s23*sw**2*PropZ12**2 - 4*s12*s14*sw**2*PropZ12*PropZ34
     &     + 4*s12*s14*sw**2*PropZ12**2 + 4*s12*s13*sw**2*PropZ12*
     &    PropZ34 + 4*s12*s13*sw**2*PropZ12**2 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * (  - 4
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ34**2 - 4*s12**(-1)*s14*s23
     &    *s24*sw**2*PropZ12*PropZ34 + 4*s12**(-1)*s14*s23**2*sw**2*
     &    PropZ34**2 - 4*s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34 + 4
     &    *s12**(-1)*s14**2*s23*sw**2*PropZ34**2 - 4*s12**(-1)*s14**2*
     &    s23*sw**2*PropZ12*PropZ34 + 4*s12**(-1)*s13*s24**2*sw**2*
     &    PropZ34**2 + 4*s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34 - 4
     &    *s12**(-1)*s13*s23*s24*sw**2*PropZ34**2 + 4*s12**(-1)*s13*s23
     &    *s24*sw**2*PropZ12*PropZ34 - 4*s12**(-1)*s13*s14*s24*sw**2*
     &    PropZ34**2 + 4*s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34 - 
     &    4*s12**(-1)*s13*s14*s23*sw**2*PropZ34**2 - 4*s12**(-1)*s13*
     &    s14*s23*sw**2*PropZ12*PropZ34 + 4*s12**(-1)*s13**2*s24*sw**2*
     &    PropZ34**2 + 4*s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34 + 4
     &    *s24*s34*sw**2*PropZ34**2 + 4*s24*s34*sw**2*PropZ12*PropZ34
     &     + 4*s23*s34*sw**2*PropZ34**2 - 4*s23*s34*sw**2*PropZ12*
     &    PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * ( 4*
     &    s14*s34*sw**2*PropZ34**2 - 4*s14*s34*sw**2*PropZ12*PropZ34 - 
     &    4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34 - 4*s14*s23*s24
     &    *s34**(-1)*sw**2*PropZ12**2 - 4*s14*s23**2*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12**2 - 4
     &    *s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34 + 4*s14**2*s23*
     &    s34**(-1)*sw**2*PropZ12**2 + 4*s13*s34*sw**2*PropZ34**2 + 4*
     &    s13*s34*sw**2*PropZ12*PropZ34 + 4*s13*s24**2*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 4*s13*s24**2*s34**(-1)*sw**2*PropZ12**2 + 4
     &    *s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34 - 4*s13*s23*s24*
     &    s34**(-1)*sw**2*PropZ12**2 + 4*s13*s14*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 - 4*s13*s14*s24*s34**(-1)*sw**2*PropZ12**2 - 
     &    4*s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ34 - 4*s13*s14*s23
     &    *s34**(-1)*sw**2*PropZ12**2 + 4*s13**2*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 4*s13**2*s24*s34**(-1)*sw**2*PropZ12**2 + 4
     &    *s12*s24*sw**2*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * ( 4*
     &    s12*s24*sw**2*PropZ12**2 - 4*s12*s23*sw**2*PropZ12*PropZ34 + 
     &    4*s12*s23*sw**2*PropZ12**2 - 4*s12*s14*sw**2*PropZ12*PropZ34
     &     + 4*s12*s14*sw**2*PropZ12**2 + 4*s12*s13*sw**2*PropZ12*
     &    PropZ34 + 4*s12*s13*sw**2*PropZ12**2 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza**2 * ( 4*
     &    s12**(-2)*s14**2*s23**2*sw**4*PropZ34**2 - 8*s12**(-2)*s13*
     &    s14*s23*s24*sw**4*PropZ34**2 + 4*s12**(-2)*s13**2*s24**2*
     &    sw**4*PropZ34**2 + 2*s12**(-1)*s24**2*s34*sw**4*PropZ34**2 + 
     &    2*s12**(-1)*s23**2*s34*sw**4*PropZ34**2 - 4*s12**(-1)*s14*s23
     &    *s34*sw**4*PropZ34**2 + 2*s12**(-1)*s14**2*s34*sw**4*
     &    PropZ34**2 - 4*s12**(-1)*s13*s24*s34*sw**4*PropZ34**2 + 2*
     &    s12**(-1)*s13**2*s34*sw**4*PropZ34**2 + 4*s34**2*sw**4*
     &    PropZ34**2 + 4*s24**2*sw**4*PropZ12*PropZ34 - 4*s23**2*sw**4*
     &    PropZ12*PropZ34 - 8*s14*s23*sw**4*PropZ12*PropZ34 - 4*s14**2*
     &    sw**4*PropZ12*PropZ34 + 4*s14**2*s23**2*s34**(-2)*sw**4*
     &    PropZ12**2 + 8*s13*s24*sw**4*PropZ12*PropZ34 - 8*s13*s14*s23*
     &    s24*s34**(-2)*sw**4*PropZ12**2 + 4*s13**2*sw**4*PropZ12*
     &    PropZ34 + 4*s13**2*s24**2*s34**(-2)*sw**4*PropZ12**2 + 2*s12*
     &    s24**2*s34**(-1)*sw**4*PropZ12**2 + 2*s12*s23**2*s34**(-1)*
     &    sw**4*PropZ12**2 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza**2 * (  - 4*
     &    s12*s14*s23*s34**(-1)*sw**4*PropZ12**2 + 2*s12*s14**2*
     &    s34**(-1)*sw**4*PropZ12**2 - 4*s12*s13*s24*s34**(-1)*sw**4*
     &    PropZ12**2 + 2*s12*s13**2*s34**(-1)*sw**4*PropZ12**2 + 4*
     &    s12**2*sw**4*PropZ12**2 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*dGl1L * (  - 
     &    16*s14*s23*sw**2*PropZ34**2 + 32*s14*s23*sw**2*PropZ12*
     &    PropZ34 - 16*s14*s23*sw**2*PropZ12**2 - 16*s13*s24*sw**2*
     &    PropZ34**2 - 32*s13*s24*sw**2*PropZ12*PropZ34 - 16*s13*s24*
     &    sw**2*PropZ12**2 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*dGl1R * (  - 
     &    16*s14*s23*sw**2*PropZ34**2 + 32*s14*s23*sw**2*PropZ12*
     &    PropZ34 - 16*s14*s23*sw**2*PropZ12**2 - 16*s13*s24*sw**2*
     &    PropZ34**2 - 32*s13*s24*sw**2*PropZ12*PropZ34 - 16*s13*s24*
     &    sw**2*PropZ12**2 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * ( 4*
     &    s12**(-1)*s14*s23*s24*sw**4*PropZ34**2 + 4*s12**(-1)*s14*s23*
     &    s24*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s14*s23**2*sw**4*
     &    PropZ34**2 + 4*s12**(-1)*s14*s23**2*sw**4*PropZ12*PropZ34 - 4
     &    *s12**(-1)*s14**2*s23*sw**4*PropZ34**2 + 4*s12**(-1)*s14**2*
     &    s23*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13*s24**2*sw**4*
     &    PropZ34**2 - 4*s12**(-1)*s13*s24**2*sw**4*PropZ12*PropZ34 + 4
     &    *s12**(-1)*s13*s23*s24*sw**4*PropZ34**2 - 4*s12**(-1)*s13*s23
     &    *s24*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*s24*sw**4*
     &    PropZ34**2 - 4*s12**(-1)*s13*s14*s24*sw**4*PropZ12*PropZ34 + 
     &    4*s12**(-1)*s13*s14*s23*sw**4*PropZ34**2 + 4*s12**(-1)*s13*
     &    s14*s23*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13**2*s24*sw**4*
     &    PropZ34**2 - 4*s12**(-1)*s13**2*s24*sw**4*PropZ12*PropZ34 - 4
     &    *s24*s34*sw**4*PropZ34**2 - 4*s24*s34*sw**4*PropZ12*PropZ34
     &     - 4*s23*s34*sw**4*PropZ34**2 + 4*s23*s34*sw**4*PropZ12*
     &    PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * (  - 4*
     &    s14*s34*sw**4*PropZ34**2 + 4*s14*s34*sw**4*PropZ12*PropZ34 + 
     &    4*s14*s23*s24*s34**(-1)*sw**4*PropZ12*PropZ34 + 4*s14*s23*s24
     &    *s34**(-1)*sw**4*PropZ12**2 + 4*s14*s23**2*s34**(-1)*sw**4*
     &    PropZ12*PropZ34 - 4*s14*s23**2*s34**(-1)*sw**4*PropZ12**2 + 4
     &    *s14**2*s23*s34**(-1)*sw**4*PropZ12*PropZ34 - 4*s14**2*s23*
     &    s34**(-1)*sw**4*PropZ12**2 - 4*s13*s34*sw**4*PropZ34**2 - 4*
     &    s13*s34*sw**4*PropZ12*PropZ34 - 4*s13*s24**2*s34**(-1)*sw**4*
     &    PropZ12*PropZ34 - 4*s13*s24**2*s34**(-1)*sw**4*PropZ12**2 - 4
     &    *s13*s23*s24*s34**(-1)*sw**4*PropZ12*PropZ34 + 4*s13*s23*s24*
     &    s34**(-1)*sw**4*PropZ12**2 - 4*s13*s14*s24*s34**(-1)*sw**4*
     &    PropZ12*PropZ34 + 4*s13*s14*s24*s34**(-1)*sw**4*PropZ12**2 + 
     &    4*s13*s14*s23*s34**(-1)*sw**4*PropZ12*PropZ34 + 4*s13*s14*s23
     &    *s34**(-1)*sw**4*PropZ12**2 - 4*s13**2*s24*s34**(-1)*sw**4*
     &    PropZ12*PropZ34 - 4*s13**2*s24*s34**(-1)*sw**4*PropZ12**2 - 4
     &    *s12*s24*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * (  - 4*
     &    s12*s24*sw**4*PropZ12**2 + 4*s12*s23*sw**4*PropZ12*PropZ34 - 
     &    4*s12*s23*sw**4*PropZ12**2 + 4*s12*s14*sw**4*PropZ12*PropZ34
     &     - 4*s12*s14*sw**4*PropZ12**2 - 4*s12*s13*sw**4*PropZ12*
     &    PropZ34 - 4*s12*s13*sw**4*PropZ12**2 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx**2 * ( 8*s14*
     &    s23*sw**4*PropZ34**2 - 16*s14*s23*sw**4*PropZ12*PropZ34 + 8*
     &    s14*s23*sw**4*PropZ12**2 + 8*s13*s24*sw**4*PropZ34**2 + 16*
     &    s13*s24*sw**4*PropZ12*PropZ34 + 8*s13*s24*sw**4*PropZ12**2 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czz * ( 4*
     &    s24**2*cw**2*sw**4*PropZ12*PropZ34 - 4*s23**2*cw**2*sw**4*
     &    PropZ12*PropZ34 - 8*s14*s23*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s14**2*cw**2*sw**4*PropZ12*PropZ34 + 8*s13*s24*cw**2*sw**4*
     &    PropZ12*PropZ34 + 4*s13**2*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czbx * ( 4*
     &    s12**(-1)*s14*s23*s24*cw**2*sw**4*PropZ12*PropZ34 + 4*
     &    s12**(-1)*s14*s23**2*cw**2*sw**4*PropZ12*PropZ34 + 4*
     &    s12**(-1)*s14**2*s23*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s12**(-1)*s13*s24**2*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s12**(-1)*s13*s23*s24*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s12**(-1)*s13*s14*s24*cw**2*sw**4*PropZ12*PropZ34 + 4*
     &    s12**(-1)*s13*s14*s23*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s12**(-1)*s13**2*s24*cw**2*sw**4*PropZ12*PropZ34 - 4*s24*s34*
     &    cw**2*sw**4*PropZ12*PropZ34 + 4*s23*s34*cw**2*sw**4*PropZ12*
     &    PropZ34 + 4*s14*s34*cw**2*sw**4*PropZ12*PropZ34 + 4*s14*s23*
     &    s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s14*s23**2*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s14**2*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s13*s34*cw**2*sw**4
     &    *PropZ12*PropZ34 - 4*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12
     &    *PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czbx * (  - 4*
     &    s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s13*s14
     &    *s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s13*s14*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s13**2*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s12*s24*cw**2*sw**4
     &    *PropZ12*PropZ34 + 4*s12*s23*cw**2*sw**4*PropZ12*PropZ34 + 4*
     &    s12*s14*cw**2*sw**4*PropZ12*PropZ34 - 4*s12*s13*cw**2*sw**4*
     &    PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L**2 * ( 32*
     &    s14*s23*PropZ12*PropZ34**2 + 32*s14*s23*PropZ12**2*PropZ34 + 
     &    64*s13*s24*PropZ12*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34
     &     )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*dGl1L * ( 
     &     - 64*s14*s23*PropZ12*PropZ34**2 - 64*s14*s23*PropZ12**2*
     &    PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R**2 * ( 32*
     &    s14*s23*PropZ12*PropZ34**2 + 32*s14*s23*PropZ12**2*PropZ34 + 
     &    64*s13*s24*PropZ12*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34
     &     )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * (  - 8
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)
     &    *s13*s24**2*sw**2*PropZ12*PropZ34**2 - 8*s12**(-1)*s13*s14*
     &    s23*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*s13**2*s24*sw**2*
     &    PropZ12*PropZ34**2 + 8*s24*s34*sw**2*PropZ12*PropZ34**2 - 8*
     &    s14*s23*s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s13*s34*
     &    sw**2*PropZ12*PropZ34**2 + 8*s13*s24**2*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 - 8*s13*s14*s23*s34**(-1)*sw**2*PropZ12**2
     &    *PropZ34 + 8*s13**2*s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 
     &    8*s12*s24*sw**2*PropZ12**2*PropZ34 + 8*s12*s13*sw**2*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * (  - 8
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)
     &    *s13*s24**2*sw**2*PropZ12*PropZ34**2 - 8*s12**(-1)*s13*s14*
     &    s23*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*s13**2*s24*sw**2*
     &    PropZ12*PropZ34**2 + 8*s24*s34*sw**2*PropZ12*PropZ34**2 - 8*
     &    s14*s23*s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s13*s34*
     &    sw**2*PropZ12*PropZ34**2 + 8*s13*s24**2*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 - 8*s13*s14*s23*s34**(-1)*sw**2*PropZ12**2
     &    *PropZ34 + 8*s13**2*s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 
     &    8*s12*s24*sw**2*PropZ12**2*PropZ34 + 8*s12*s13*sw**2*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Cabx*dGl1L * (  - 
     &    32*s13*s24*sw**2*PropZ12*PropZ34**2 - 32*s13*s24*sw**2*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Cabx*dGl1R * (  - 
     &    32*s13*s24*sw**2*PropZ12*PropZ34**2 - 32*s13*s24*sw**2*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Caa*dCz * ( 4*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     + 4*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 + 4*s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 4*s12**(-1)*s13*s24**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13*s23*s24*s34**(-1)*
     &    cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13*s14*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*
     &    s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*
     &    s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s24*
     &    cw**2*sw**4*PropZ12*PropZ34 + 4*s23*cw**2*sw**4*PropZ12*
     &    PropZ34 + 4*s14*cw**2*sw**4*PropZ12*PropZ34 - 4*s13*cw**2*
     &    sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NP*Caa * ( 4*s12**(-1)*
     &    s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 
     &    4*s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 4*s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 4*s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 4*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13**2*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s24*cw**2*sw**4*
     &    PropZ12*PropZ34 + 4*s23*cw**2*sw**4*PropZ12*PropZ34 + 4*s14*
     &    cw**2*sw**4*PropZ12*PropZ34 - 4*s13*cw**2*sw**4*PropZ12*
     &    PropZ34 )
      MSQBSM = MSQBSM + CASQ*couplsm*NPSQ*dGl1L**2 * ( 32*s14*s23*
     &    PropZ12**2*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ*couplsm*NPSQ*dGl1R*dGl1L * (  - 64*s14*s23
     &    *PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ*couplsm*NPSQ*dGl1R**2 * ( 32*s14*s23*
     &    PropZ12**2*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-2)*couplsm*NPSQ*Czz**2 * ( 16*
     &    s14**2*s23**2*PropZ12**2*PropZ34**2 - 32*s13*s14*s23*s24*
     &    PropZ12**2*PropZ34**2 + 16*s13**2*s24**2*PropZ12**2*
     &    PropZ34**2 + 8*s12*s24**2*s34*PropZ12**2*PropZ34**2 + 8*s12*
     &    s23**2*s34*PropZ12**2*PropZ34**2 - 16*s12*s14*s23*s34*
     &    PropZ12**2*PropZ34**2 + 8*s12*s14**2*s34*PropZ12**2*
     &    PropZ34**2 - 16*s12*s13*s24*s34*PropZ12**2*PropZ34**2 + 8*s12
     &    *s13**2*s34*PropZ12**2*PropZ34**2 + 16*s12**2*s34**2*
     &    PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-2)*couplsm*NPSQ*Czbx*Czz * ( 16
     &    *s14*s23*s24*s34*PropZ12**2*PropZ34**2 - 16*s14*s23**2*s34*
     &    PropZ12**2*PropZ34**2 - 16*s14**2*s23*s34*PropZ12**2*
     &    PropZ34**2 - 16*s13*s24**2*s34*PropZ12**2*PropZ34**2 + 16*s13
     &    *s23*s24*s34*PropZ12**2*PropZ34**2 + 16*s13*s14*s24*s34*
     &    PropZ12**2*PropZ34**2 + 16*s13*s14*s23*s34*PropZ12**2*
     &    PropZ34**2 - 16*s13**2*s24*s34*PropZ12**2*PropZ34**2 - 16*s12
     &    *s24*s34**2*PropZ12**2*PropZ34**2 - 16*s12*s23*s34**2*
     &    PropZ12**2*PropZ34**2 - 16*s12*s14*s34**2*PropZ12**2*
     &    PropZ34**2 + 16*s12*s14*s23*s24*PropZ12**2*PropZ34**2 - 16*
     &    s12*s14*s23**2*PropZ12**2*PropZ34**2 - 16*s12*s14**2*s23*
     &    PropZ12**2*PropZ34**2 - 16*s12*s13*s34**2*PropZ12**2*
     &    PropZ34**2 - 16*s12*s13*s24**2*PropZ12**2*PropZ34**2 + 16*s12
     &    *s13*s23*s24*PropZ12**2*PropZ34**2 + 16*s12*s13*s14*s24*
     &    PropZ12**2*PropZ34**2 + 16*s12*s13*s14*s23*PropZ12**2*
     &    PropZ34**2 )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-2)*couplsm*NPSQ*Czbx*Czz * ( 
     &     - 16*s12*s13**2*s24*PropZ12**2*PropZ34**2 - 16*s12**2*s24*
     &    s34*PropZ12**2*PropZ34**2 - 16*s12**2*s23*s34*PropZ12**2*
     &    PropZ34**2 - 16*s12**2*s14*s34*PropZ12**2*PropZ34**2 - 16*
     &    s12**2*s13*s34*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-2)*couplsm*NPSQ*Czbx**2 * ( 32*
     &    s14*s23*s34**2*PropZ12**2*PropZ34**2 + 32*s13*s24*s34**2*
     &    PropZ12**2*PropZ34**2 + 64*s12*s14*s23*s34*PropZ12**2*
     &    PropZ34**2 + 64*s12*s13*s24*s34*PropZ12**2*PropZ34**2 + 32*
     &    s12**2*s14*s23*PropZ12**2*PropZ34**2 + 32*s12**2*s13*s24*
     &    PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-1)*couplsm*NPSQ*Czz*dCz * ( 16*
     &    s14*s23*s24*PropZ12**2*PropZ34**2 - 16*s14*s23**2*PropZ12**2*
     &    PropZ34**2 - 16*s14**2*s23*PropZ12**2*PropZ34**2 - 16*s13*
     &    s24**2*PropZ12**2*PropZ34**2 + 16*s13*s23*s24*PropZ12**2*
     &    PropZ34**2 + 16*s13*s14*s24*PropZ12**2*PropZ34**2 + 16*s13*
     &    s14*s23*PropZ12**2*PropZ34**2 - 16*s13**2*s24*PropZ12**2*
     &    PropZ34**2 - 16*s12*s24*s34*PropZ12**2*PropZ34**2 - 16*s12*
     &    s23*s34*PropZ12**2*PropZ34**2 - 16*s12*s14*s34*PropZ12**2*
     &    PropZ34**2 - 16*s12*s13*s34*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-1)*couplsm*NPSQ*Czbx*dCz * ( 64
     &    *s14*s23*s34*PropZ12**2*PropZ34**2 + 64*s13*s24*s34*
     &    PropZ12**2*PropZ34**2 + 64*s12*s14*s23*PropZ12**2*PropZ34**2
     &     + 64*s12*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-1)*couplsm*NP*Czz * ( 16*s14*
     &    s23*s24*PropZ12**2*PropZ34**2 - 16*s14*s23**2*PropZ12**2*
     &    PropZ34**2 - 16*s14**2*s23*PropZ12**2*PropZ34**2 - 16*s13*
     &    s24**2*PropZ12**2*PropZ34**2 + 16*s13*s23*s24*PropZ12**2*
     &    PropZ34**2 + 16*s13*s14*s24*PropZ12**2*PropZ34**2 + 16*s13*
     &    s14*s23*PropZ12**2*PropZ34**2 - 16*s13**2*s24*PropZ12**2*
     &    PropZ34**2 - 16*s12*s24*s34*PropZ12**2*PropZ34**2 - 16*s12*
     &    s23*s34*PropZ12**2*PropZ34**2 - 16*s12*s14*s34*PropZ12**2*
     &    PropZ34**2 - 16*s12*s13*s34*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-1)*couplsm*NP*Czbx * ( 64*s14*
     &    s23*s34*PropZ12**2*PropZ34**2 + 64*s13*s24*s34*PropZ12**2*
     &    PropZ34**2 + 64*s12*s14*s23*PropZ12**2*PropZ34**2 + 64*s12*
     &    s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ**2*couplsm * ( 32*s14*s23*PropZ12**2*
     &    PropZ34**2 + 32*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ**2*couplsm*NPSQ*dCz**2 * ( 32*s14*s23*
     &    PropZ12**2*PropZ34**2 + 32*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CASQ**2*couplsm*NP*dCz * ( 64*s14*s23*
     &    PropZ12**2*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L**2 * ( 16*
     &    s14*s23*PropZ34**2 + 16*s14*s23*PropZ12**2 + 16*s13*s24*
     &    PropZ34**2 + 32*s13*s24*PropZ12*PropZ34 + 16*s13*s24*
     &    PropZ12**2 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*dGl1L * ( 64
     &    *s14*s23*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R**2 * ( 16*
     &    s14*s23*PropZ34**2 + 16*s14*s23*PropZ12**2 + 16*s13*s24*
     &    PropZ34**2 + 32*s13*s24*PropZ12*PropZ34 + 16*s13*s24*
     &    PropZ12**2 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * (  - 4
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ34**2 - 4*s12**(-1)*s14*s23
     &    *s24*sw**2*PropZ12*PropZ34 + 4*s12**(-1)*s14*s23**2*sw**2*
     &    PropZ34**2 + 4*s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34 + 4
     &    *s12**(-1)*s14**2*s23*sw**2*PropZ34**2 + 4*s12**(-1)*s14**2*
     &    s23*sw**2*PropZ12*PropZ34 + 4*s12**(-1)*s13*s24**2*sw**2*
     &    PropZ34**2 + 4*s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34 - 4
     &    *s12**(-1)*s13*s23*s24*sw**2*PropZ34**2 - 4*s12**(-1)*s13*s23
     &    *s24*sw**2*PropZ12*PropZ34 - 4*s12**(-1)*s13*s14*s24*sw**2*
     &    PropZ34**2 - 4*s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34 - 
     &    4*s12**(-1)*s13*s14*s23*sw**2*PropZ34**2 - 4*s12**(-1)*s13*
     &    s14*s23*sw**2*PropZ12*PropZ34 + 4*s12**(-1)*s13**2*s24*sw**2*
     &    PropZ34**2 + 4*s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34 + 4
     &    *s24*s34*sw**2*PropZ34**2 + 4*s24*s34*sw**2*PropZ12*PropZ34
     &     + 4*s23*s34*sw**2*PropZ34**2 + 4*s23*s34*sw**2*PropZ12*
     &    PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * ( 4*
     &    s14*s34*sw**2*PropZ34**2 + 4*s14*s34*sw**2*PropZ12*PropZ34 - 
     &    4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34 - 4*s14*s23*s24
     &    *s34**(-1)*sw**2*PropZ12**2 + 4*s14*s23**2*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12**2 + 4
     &    *s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34 + 4*s14**2*s23*
     &    s34**(-1)*sw**2*PropZ12**2 + 4*s13*s34*sw**2*PropZ34**2 + 4*
     &    s13*s34*sw**2*PropZ12*PropZ34 + 4*s13*s24**2*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 4*s13*s24**2*s34**(-1)*sw**2*PropZ12**2 - 4
     &    *s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34 - 4*s13*s23*s24*
     &    s34**(-1)*sw**2*PropZ12**2 - 4*s13*s14*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 - 4*s13*s14*s24*s34**(-1)*sw**2*PropZ12**2 - 
     &    4*s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ34 - 4*s13*s14*s23
     &    *s34**(-1)*sw**2*PropZ12**2 + 4*s13**2*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 4*s13**2*s24*s34**(-1)*sw**2*PropZ12**2 + 4
     &    *s12*s24*sw**2*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * ( 4*
     &    s12*s24*sw**2*PropZ12**2 + 4*s12*s23*sw**2*PropZ12*PropZ34 + 
     &    4*s12*s23*sw**2*PropZ12**2 + 4*s12*s14*sw**2*PropZ12*PropZ34
     &     + 4*s12*s14*sw**2*PropZ12**2 + 4*s12*s13*sw**2*PropZ12*
     &    PropZ34 + 4*s12*s13*sw**2*PropZ12**2 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * (  - 4
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ34**2 - 4*s12**(-1)*s14*s23
     &    *s24*sw**2*PropZ12*PropZ34 + 4*s12**(-1)*s14*s23**2*sw**2*
     &    PropZ34**2 + 4*s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34 + 4
     &    *s12**(-1)*s14**2*s23*sw**2*PropZ34**2 + 4*s12**(-1)*s14**2*
     &    s23*sw**2*PropZ12*PropZ34 + 4*s12**(-1)*s13*s24**2*sw**2*
     &    PropZ34**2 + 4*s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34 - 4
     &    *s12**(-1)*s13*s23*s24*sw**2*PropZ34**2 - 4*s12**(-1)*s13*s23
     &    *s24*sw**2*PropZ12*PropZ34 - 4*s12**(-1)*s13*s14*s24*sw**2*
     &    PropZ34**2 - 4*s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34 - 
     &    4*s12**(-1)*s13*s14*s23*sw**2*PropZ34**2 - 4*s12**(-1)*s13*
     &    s14*s23*sw**2*PropZ12*PropZ34 + 4*s12**(-1)*s13**2*s24*sw**2*
     &    PropZ34**2 + 4*s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34 + 4
     &    *s24*s34*sw**2*PropZ34**2 + 4*s24*s34*sw**2*PropZ12*PropZ34
     &     + 4*s23*s34*sw**2*PropZ34**2 + 4*s23*s34*sw**2*PropZ12*
     &    PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * ( 4*
     &    s14*s34*sw**2*PropZ34**2 + 4*s14*s34*sw**2*PropZ12*PropZ34 - 
     &    4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34 - 4*s14*s23*s24
     &    *s34**(-1)*sw**2*PropZ12**2 + 4*s14*s23**2*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12**2 + 4
     &    *s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34 + 4*s14**2*s23*
     &    s34**(-1)*sw**2*PropZ12**2 + 4*s13*s34*sw**2*PropZ34**2 + 4*
     &    s13*s34*sw**2*PropZ12*PropZ34 + 4*s13*s24**2*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 4*s13*s24**2*s34**(-1)*sw**2*PropZ12**2 - 4
     &    *s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34 - 4*s13*s23*s24*
     &    s34**(-1)*sw**2*PropZ12**2 - 4*s13*s14*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 - 4*s13*s14*s24*s34**(-1)*sw**2*PropZ12**2 - 
     &    4*s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ34 - 4*s13*s14*s23
     &    *s34**(-1)*sw**2*PropZ12**2 + 4*s13**2*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ34 + 4*s13**2*s24*s34**(-1)*sw**2*PropZ12**2 + 4
     &    *s12*s24*sw**2*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * ( 4*
     &    s12*s24*sw**2*PropZ12**2 + 4*s12*s23*sw**2*PropZ12*PropZ34 + 
     &    4*s12*s23*sw**2*PropZ12**2 + 4*s12*s14*sw**2*PropZ12*PropZ34
     &     + 4*s12*s14*sw**2*PropZ12**2 + 4*s12*s13*sw**2*PropZ12*
     &    PropZ34 + 4*s12*s13*sw**2*PropZ12**2 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza**2 * ( 4*
     &    s12**(-2)*s14**2*s23**2*sw**4*PropZ34**2 - 8*s12**(-2)*s13*
     &    s14*s23*s24*sw**4*PropZ34**2 + 4*s12**(-2)*s13**2*s24**2*
     &    sw**4*PropZ34**2 + 2*s12**(-1)*s24**2*s34*sw**4*PropZ34**2 + 
     &    2*s12**(-1)*s23**2*s34*sw**4*PropZ34**2 - 4*s12**(-1)*s14*s23
     &    *s34*sw**4*PropZ34**2 + 2*s12**(-1)*s14**2*s34*sw**4*
     &    PropZ34**2 + 8*s12**(-1)*s14**2*s23**2*s34**(-1)*sw**4*
     &    PropZ12*PropZ34 - 4*s12**(-1)*s13*s24*s34*sw**4*PropZ34**2 - 
     &    16*s12**(-1)*s13*s14*s23*s24*s34**(-1)*sw**4*PropZ12*PropZ34
     &     + 2*s12**(-1)*s13**2*s34*sw**4*PropZ34**2 + 8*s12**(-1)*
     &    s13**2*s24**2*s34**(-1)*sw**4*PropZ12*PropZ34 + 4*s34**2*
     &    sw**4*PropZ34**2 + 4*s24**2*sw**4*PropZ12*PropZ34 + 4*s23**2*
     &    sw**4*PropZ12*PropZ34 - 8*s14*s23*sw**4*PropZ12*PropZ34 + 4*
     &    s14**2*sw**4*PropZ12*PropZ34 + 4*s14**2*s23**2*s34**(-2)*
     &    sw**4*PropZ12**2 - 8*s13*s24*sw**4*PropZ12*PropZ34 - 8*s13*
     &    s14*s23*s24*s34**(-2)*sw**4*PropZ12**2 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza**2 * ( 4*
     &    s13**2*sw**4*PropZ12*PropZ34 + 4*s13**2*s24**2*s34**(-2)*
     &    sw**4*PropZ12**2 + 8*s12*s34*sw**4*PropZ12*PropZ34 + 2*s12*
     &    s24**2*s34**(-1)*sw**4*PropZ12**2 + 2*s12*s23**2*s34**(-1)*
     &    sw**4*PropZ12**2 - 4*s12*s14*s23*s34**(-1)*sw**4*PropZ12**2
     &     + 2*s12*s14**2*s34**(-1)*sw**4*PropZ12**2 - 4*s12*s13*s24*
     &    s34**(-1)*sw**4*PropZ12**2 + 2*s12*s13**2*s34**(-1)*sw**4*
     &    PropZ12**2 + 4*s12**2*sw**4*PropZ12**2 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*dGl1L * (  - 
     &    16*s14*s23*sw**2*PropZ34**2 - 32*s14*s23*sw**2*PropZ12*
     &    PropZ34 - 16*s14*s23*sw**2*PropZ12**2 - 16*s13*s24*sw**2*
     &    PropZ34**2 - 32*s13*s24*sw**2*PropZ12*PropZ34 - 16*s13*s24*
     &    sw**2*PropZ12**2 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*dGl1R * (  - 
     &    16*s14*s23*sw**2*PropZ34**2 - 32*s14*s23*sw**2*PropZ12*
     &    PropZ34 - 16*s14*s23*sw**2*PropZ12**2 - 16*s13*s24*sw**2*
     &    PropZ34**2 - 32*s13*s24*sw**2*PropZ12*PropZ34 - 16*s13*s24*
     &    sw**2*PropZ12**2 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * ( 4*
     &    s12**(-1)*s14*s23*s24*sw**4*PropZ34**2 + 4*s12**(-1)*s14*s23*
     &    s24*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s14*s23**2*sw**4*
     &    PropZ34**2 - 4*s12**(-1)*s14*s23**2*sw**4*PropZ12*PropZ34 - 4
     &    *s12**(-1)*s14**2*s23*sw**4*PropZ34**2 - 4*s12**(-1)*s14**2*
     &    s23*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13*s24**2*sw**4*
     &    PropZ34**2 - 4*s12**(-1)*s13*s24**2*sw**4*PropZ12*PropZ34 + 4
     &    *s12**(-1)*s13*s23*s24*sw**4*PropZ34**2 + 4*s12**(-1)*s13*s23
     &    *s24*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*s24*sw**4*
     &    PropZ34**2 + 4*s12**(-1)*s13*s14*s24*sw**4*PropZ12*PropZ34 + 
     &    4*s12**(-1)*s13*s14*s23*sw**4*PropZ34**2 + 4*s12**(-1)*s13*
     &    s14*s23*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13**2*s24*sw**4*
     &    PropZ34**2 - 4*s12**(-1)*s13**2*s24*sw**4*PropZ12*PropZ34 - 4
     &    *s24*s34*sw**4*PropZ34**2 - 4*s24*s34*sw**4*PropZ12*PropZ34
     &     - 4*s23*s34*sw**4*PropZ34**2 - 4*s23*s34*sw**4*PropZ12*
     &    PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * (  - 4*
     &    s14*s34*sw**4*PropZ34**2 - 4*s14*s34*sw**4*PropZ12*PropZ34 + 
     &    4*s14*s23*s24*s34**(-1)*sw**4*PropZ12*PropZ34 + 4*s14*s23*s24
     &    *s34**(-1)*sw**4*PropZ12**2 - 4*s14*s23**2*s34**(-1)*sw**4*
     &    PropZ12*PropZ34 - 4*s14*s23**2*s34**(-1)*sw**4*PropZ12**2 - 4
     &    *s14**2*s23*s34**(-1)*sw**4*PropZ12*PropZ34 - 4*s14**2*s23*
     &    s34**(-1)*sw**4*PropZ12**2 - 4*s13*s34*sw**4*PropZ34**2 - 4*
     &    s13*s34*sw**4*PropZ12*PropZ34 - 4*s13*s24**2*s34**(-1)*sw**4*
     &    PropZ12*PropZ34 - 4*s13*s24**2*s34**(-1)*sw**4*PropZ12**2 + 4
     &    *s13*s23*s24*s34**(-1)*sw**4*PropZ12*PropZ34 + 4*s13*s23*s24*
     &    s34**(-1)*sw**4*PropZ12**2 + 4*s13*s14*s24*s34**(-1)*sw**4*
     &    PropZ12*PropZ34 + 4*s13*s14*s24*s34**(-1)*sw**4*PropZ12**2 + 
     &    4*s13*s14*s23*s34**(-1)*sw**4*PropZ12*PropZ34 + 4*s13*s14*s23
     &    *s34**(-1)*sw**4*PropZ12**2 - 4*s13**2*s24*s34**(-1)*sw**4*
     &    PropZ12*PropZ34 - 4*s13**2*s24*s34**(-1)*sw**4*PropZ12**2 - 4
     &    *s12*s24*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * (  - 4*
     &    s12*s24*sw**4*PropZ12**2 - 4*s12*s23*sw**4*PropZ12*PropZ34 - 
     &    4*s12*s23*sw**4*PropZ12**2 - 4*s12*s14*sw**4*PropZ12*PropZ34
     &     - 4*s12*s14*sw**4*PropZ12**2 - 4*s12*s13*sw**4*PropZ12*
     &    PropZ34 - 4*s12*s13*sw**4*PropZ12**2 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx**2 * ( 8*s14*
     &    s23*sw**4*PropZ34**2 + 16*s14*s23*sw**4*PropZ12*PropZ34 + 8*
     &    s14*s23*sw**4*PropZ12**2 + 8*s13*s24*sw**4*PropZ34**2 + 16*
     &    s13*s24*sw**4*PropZ12*PropZ34 + 8*s13*s24*sw**4*PropZ12**2 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czz * ( 8*
     &    s12**(-1)*s14**2*s23**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 16*s12**(-1)*s13*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12
     &    *PropZ34 + 8*s12**(-1)*s13**2*s24**2*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 + 4*s24**2*cw**2*sw**4*PropZ12*PropZ34 + 4*
     &    s23**2*cw**2*sw**4*PropZ12*PropZ34 - 8*s14*s23*cw**2*sw**4*
     &    PropZ12*PropZ34 + 4*s14**2*cw**2*sw**4*PropZ12*PropZ34 - 8*
     &    s13*s24*cw**2*sw**4*PropZ12*PropZ34 + 4*s13**2*cw**2*sw**4*
     &    PropZ12*PropZ34 + 8*s12*s34*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czbx * ( 4*
     &    s12**(-1)*s14*s23*s24*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s12**(-1)*s14*s23**2*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s12**(-1)*s14**2*s23*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s12**(-1)*s13*s24**2*cw**2*sw**4*PropZ12*PropZ34 + 4*
     &    s12**(-1)*s13*s23*s24*cw**2*sw**4*PropZ12*PropZ34 + 4*
     &    s12**(-1)*s13*s14*s24*cw**2*sw**4*PropZ12*PropZ34 + 4*
     &    s12**(-1)*s13*s14*s23*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s12**(-1)*s13**2*s24*cw**2*sw**4*PropZ12*PropZ34 - 4*s24*s34*
     &    cw**2*sw**4*PropZ12*PropZ34 - 4*s23*s34*cw**2*sw**4*PropZ12*
     &    PropZ34 - 4*s14*s34*cw**2*sw**4*PropZ12*PropZ34 + 4*s14*s23*
     &    s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s14*s23**2*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s14**2*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s13*s34*cw**2*sw**4
     &    *PropZ12*PropZ34 - 4*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12
     &    *PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czbx * ( 4*s13
     &    *s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s13*s14*
     &    s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s13*s14*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s13**2*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s12*s24*cw**2*sw**4
     &    *PropZ12*PropZ34 - 4*s12*s23*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s12*s14*cw**2*sw**4*PropZ12*PropZ34 - 4*s12*s13*cw**2*sw**4*
     &    PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L**2 * ( 32*
     &    s14*s23*PropZ12*PropZ34**2 + 32*s14*s23*PropZ12**2*PropZ34 + 
     &    64*s13*s24*PropZ12*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34
     &     )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*dGl1L * ( 64
     &    *s14*s23*PropZ12*PropZ34**2 + 64*s14*s23*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R**2 * ( 32*
     &    s14*s23*PropZ12*PropZ34**2 + 32*s14*s23*PropZ12**2*PropZ34 + 
     &    64*s13*s24*PropZ12*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34
     &     )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * (  - 8
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)
     &    *s14*s23**2*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*s14**2*s23
     &    *sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*s13*s24**2*sw**2*
     &    PropZ12*PropZ34**2 - 8*s12**(-1)*s13*s23*s24*sw**2*PropZ12*
     &    PropZ34**2 - 8*s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34**2
     &     - 8*s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34**2 + 8*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34**2 + 8*s24*s34*
     &    sw**2*PropZ12*PropZ34**2 + 8*s23*s34*sw**2*PropZ12*PropZ34**2
     &     + 8*s14*s34*sw**2*PropZ12*PropZ34**2 - 8*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s14*s23**2*s34**(-1)*
     &    sw**2*PropZ12**2*PropZ34 + 8*s14**2*s23*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 + 8*s13*s34*sw**2*PropZ12*PropZ34**2 + 8*
     &    s13*s24**2*s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s13*s23*s24
     &    *s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s13*s14*s24*s34**(-1)
     &    *sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * (  - 8
     &    *s13*s14*s23*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s13**2*
     &    s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s12*s24*sw**2*
     &    PropZ12**2*PropZ34 + 8*s12*s23*sw**2*PropZ12**2*PropZ34 + 8*
     &    s12*s14*sw**2*PropZ12**2*PropZ34 + 8*s12*s13*sw**2*PropZ12**2
     &    *PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * (  - 8
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)
     &    *s14*s23**2*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*s14**2*s23
     &    *sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*s13*s24**2*sw**2*
     &    PropZ12*PropZ34**2 - 8*s12**(-1)*s13*s23*s24*sw**2*PropZ12*
     &    PropZ34**2 - 8*s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34**2
     &     - 8*s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34**2 + 8*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34**2 + 8*s24*s34*
     &    sw**2*PropZ12*PropZ34**2 + 8*s23*s34*sw**2*PropZ12*PropZ34**2
     &     + 8*s14*s34*sw**2*PropZ12*PropZ34**2 - 8*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s14*s23**2*s34**(-1)*
     &    sw**2*PropZ12**2*PropZ34 + 8*s14**2*s23*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 + 8*s13*s34*sw**2*PropZ12*PropZ34**2 + 8*
     &    s13*s24**2*s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s13*s23*s24
     &    *s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s13*s14*s24*s34**(-1)
     &    *sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * (  - 8
     &    *s13*s14*s23*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s13**2*
     &    s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s12*s24*sw**2*
     &    PropZ12**2*PropZ34 + 8*s12*s23*sw**2*PropZ12**2*PropZ34 + 8*
     &    s12*s14*sw**2*PropZ12**2*PropZ34 + 8*s12*s13*sw**2*PropZ12**2
     &    *PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cabx*dGl1L * (  - 
     &    32*s14*s23*sw**2*PropZ12*PropZ34**2 - 32*s14*s23*sw**2*
     &    PropZ12**2*PropZ34 - 32*s13*s24*sw**2*PropZ12*PropZ34**2 - 32
     &    *s13*s24*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cabx*dGl1R * (  - 
     &    32*s14*s23*sw**2*PropZ12*PropZ34**2 - 32*s14*s23*sw**2*
     &    PropZ12**2*PropZ34 - 32*s13*s24*sw**2*PropZ12*PropZ34**2 - 32
     &    *s13*s24*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Caa*dCz * ( 4*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 4*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 4*s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 4*s12**(-1)*s13*s24**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s23*s24*s34**(-1)*
     &    cw**2*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*
     &    s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*
     &    s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s24*
     &    cw**2*sw**4*PropZ12*PropZ34 - 4*s23*cw**2*sw**4*PropZ12*
     &    PropZ34 - 4*s14*cw**2*sw**4*PropZ12*PropZ34 - 4*s13*cw**2*
     &    sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NP*Caa * ( 4*s12**(-1)*
     &    s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 
     &    4*s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 4*s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 + 4*s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13**2*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s24*cw**2*sw**4*
     &    PropZ12*PropZ34 - 4*s23*cw**2*sw**4*PropZ12*PropZ34 - 4*s14*
     &    cw**2*sw**4*PropZ12*PropZ34 - 4*s13*cw**2*sw**4*PropZ12*
     &    PropZ34 )
      MSQBSM = MSQBSM + CVSQ*couplsm*NPSQ*dGl1L**2 * ( 32*s14*s23*
     &    PropZ12**2*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*couplsm*NPSQ*dGl1R*dGl1L * ( 64*s14*s23*
     &    PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*couplsm*NPSQ*dGl1R**2 * ( 32*s14*s23*
     &    PropZ12**2*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-2)*couplsm*NPSQ*Czz**2 * ( 32
     &    *s14**2*s23**2*PropZ12**2*PropZ34**2 - 64*s13*s14*s23*s24*
     &    PropZ12**2*PropZ34**2 + 32*s13**2*s24**2*PropZ12**2*
     &    PropZ34**2 + 48*s12*s24**2*s34*PropZ12**2*PropZ34**2 - 16*s12
     &    *s23**2*s34*PropZ12**2*PropZ34**2 - 96*s12*s14*s23*s34*
     &    PropZ12**2*PropZ34**2 - 16*s12*s14**2*s34*PropZ12**2*
     &    PropZ34**2 + 32*s12*s13*s24*s34*PropZ12**2*PropZ34**2 + 48*
     &    s12*s13**2*s34*PropZ12**2*PropZ34**2 + 32*s12**2*s34**2*
     &    PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-2)*couplsm*NPSQ*Czbx*Czz * ( 
     &    96*s14*s23*s24*s34*PropZ12**2*PropZ34**2 + 32*s14*s23**2*s34*
     &    PropZ12**2*PropZ34**2 + 32*s14**2*s23*s34*PropZ12**2*
     &    PropZ34**2 - 96*s13*s24**2*s34*PropZ12**2*PropZ34**2 - 32*s13
     &    *s23*s24*s34*PropZ12**2*PropZ34**2 - 32*s13*s14*s24*s34*
     &    PropZ12**2*PropZ34**2 + 96*s13*s14*s23*s34*PropZ12**2*
     &    PropZ34**2 - 96*s13**2*s24*s34*PropZ12**2*PropZ34**2 - 96*s12
     &    *s24*s34**2*PropZ12**2*PropZ34**2 + 32*s12*s23*s34**2*
     &    PropZ12**2*PropZ34**2 + 32*s12*s14*s34**2*PropZ12**2*
     &    PropZ34**2 + 96*s12*s14*s23*s24*PropZ12**2*PropZ34**2 + 32*
     &    s12*s14*s23**2*PropZ12**2*PropZ34**2 + 32*s12*s14**2*s23*
     &    PropZ12**2*PropZ34**2 - 96*s12*s13*s34**2*PropZ12**2*
     &    PropZ34**2 - 96*s12*s13*s24**2*PropZ12**2*PropZ34**2 - 32*s12
     &    *s13*s23*s24*PropZ12**2*PropZ34**2 - 32*s12*s13*s14*s24*
     &    PropZ12**2*PropZ34**2 + 96*s12*s13*s14*s23*PropZ12**2*
     &    PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-2)*couplsm*NPSQ*Czbx*Czz * ( 
     &     - 96*s12*s13**2*s24*PropZ12**2*PropZ34**2 - 96*s12**2*s24*
     &    s34*PropZ12**2*PropZ34**2 + 32*s12**2*s23*s34*PropZ12**2*
     &    PropZ34**2 + 32*s12**2*s14*s34*PropZ12**2*PropZ34**2 - 96*
     &    s12**2*s13*s34*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-2)*couplsm*NPSQ*Czbx**2 * ( 
     &     - 64*s14*s23*s34**2*PropZ12**2*PropZ34**2 + 192*s13*s24*
     &    s34**2*PropZ12**2*PropZ34**2 - 128*s12*s14*s23*s34*PropZ12**2
     &    *PropZ34**2 + 384*s12*s13*s24*s34*PropZ12**2*PropZ34**2 - 64*
     &    s12**2*s14*s23*PropZ12**2*PropZ34**2 + 192*s12**2*s13*s24*
     &    PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-1)*couplsm*NPSQ*Czz*dCz * ( 
     &    96*s14*s23*s24*PropZ12**2*PropZ34**2 + 32*s14*s23**2*
     &    PropZ12**2*PropZ34**2 + 32*s14**2*s23*PropZ12**2*PropZ34**2
     &     - 96*s13*s24**2*PropZ12**2*PropZ34**2 - 32*s13*s23*s24*
     &    PropZ12**2*PropZ34**2 - 32*s13*s14*s24*PropZ12**2*PropZ34**2
     &     + 96*s13*s14*s23*PropZ12**2*PropZ34**2 - 96*s13**2*s24*
     &    PropZ12**2*PropZ34**2 - 96*s12*s24*s34*PropZ12**2*PropZ34**2
     &     + 32*s12*s23*s34*PropZ12**2*PropZ34**2 + 32*s12*s14*s34*
     &    PropZ12**2*PropZ34**2 - 96*s12*s13*s34*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-1)*couplsm*NPSQ*Czbx*dCz * ( 
     &     - 128*s14*s23*s34*PropZ12**2*PropZ34**2 + 384*s13*s24*s34*
     &    PropZ12**2*PropZ34**2 - 128*s12*s14*s23*PropZ12**2*PropZ34**2
     &     + 384*s12*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-1)*couplsm*NP*Czz * ( 96*s14*
     &    s23*s24*PropZ12**2*PropZ34**2 + 32*s14*s23**2*PropZ12**2*
     &    PropZ34**2 + 32*s14**2*s23*PropZ12**2*PropZ34**2 - 96*s13*
     &    s24**2*PropZ12**2*PropZ34**2 - 32*s13*s23*s24*PropZ12**2*
     &    PropZ34**2 - 32*s13*s14*s24*PropZ12**2*PropZ34**2 + 96*s13*
     &    s14*s23*PropZ12**2*PropZ34**2 - 96*s13**2*s24*PropZ12**2*
     &    PropZ34**2 - 96*s12*s24*s34*PropZ12**2*PropZ34**2 + 32*s12*
     &    s23*s34*PropZ12**2*PropZ34**2 + 32*s12*s14*s34*PropZ12**2*
     &    PropZ34**2 - 96*s12*s13*s34*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-1)*couplsm*NP*Czbx * (  - 128
     &    *s14*s23*s34*PropZ12**2*PropZ34**2 + 384*s13*s24*s34*
     &    PropZ12**2*PropZ34**2 - 128*s12*s14*s23*PropZ12**2*PropZ34**2
     &     + 384*s12*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*CASQ*couplsm * (  - 64*s14*s23*PropZ12**2*
     &    PropZ34**2 + 192*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*CASQ*couplsm*NPSQ*dCz**2 * (  - 64*s14*s23
     &    *PropZ12**2*PropZ34**2 + 192*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ*CASQ*couplsm*NP*dCz * (  - 128*s14*s23*
     &    PropZ12**2*PropZ34**2 + 384*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-2)*couplsm*NPSQ*Czz**2 * ( 16*
     &    s14**2*s23**2*PropZ12**2*PropZ34**2 - 32*s13*s14*s23*s24*
     &    PropZ12**2*PropZ34**2 + 16*s13**2*s24**2*PropZ12**2*
     &    PropZ34**2 + 8*s12*s24**2*s34*PropZ12**2*PropZ34**2 + 8*s12*
     &    s23**2*s34*PropZ12**2*PropZ34**2 - 16*s12*s14*s23*s34*
     &    PropZ12**2*PropZ34**2 + 8*s12*s14**2*s34*PropZ12**2*
     &    PropZ34**2 - 16*s12*s13*s24*s34*PropZ12**2*PropZ34**2 + 8*s12
     &    *s13**2*s34*PropZ12**2*PropZ34**2 + 16*s12**2*s34**2*
     &    PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-2)*couplsm*NPSQ*Czbx*Czz * ( 16
     &    *s14*s23*s24*s34*PropZ12**2*PropZ34**2 - 16*s14*s23**2*s34*
     &    PropZ12**2*PropZ34**2 - 16*s14**2*s23*s34*PropZ12**2*
     &    PropZ34**2 - 16*s13*s24**2*s34*PropZ12**2*PropZ34**2 + 16*s13
     &    *s23*s24*s34*PropZ12**2*PropZ34**2 + 16*s13*s14*s24*s34*
     &    PropZ12**2*PropZ34**2 + 16*s13*s14*s23*s34*PropZ12**2*
     &    PropZ34**2 - 16*s13**2*s24*s34*PropZ12**2*PropZ34**2 - 16*s12
     &    *s24*s34**2*PropZ12**2*PropZ34**2 - 16*s12*s23*s34**2*
     &    PropZ12**2*PropZ34**2 - 16*s12*s14*s34**2*PropZ12**2*
     &    PropZ34**2 + 16*s12*s14*s23*s24*PropZ12**2*PropZ34**2 - 16*
     &    s12*s14*s23**2*PropZ12**2*PropZ34**2 - 16*s12*s14**2*s23*
     &    PropZ12**2*PropZ34**2 - 16*s12*s13*s34**2*PropZ12**2*
     &    PropZ34**2 - 16*s12*s13*s24**2*PropZ12**2*PropZ34**2 + 16*s12
     &    *s13*s23*s24*PropZ12**2*PropZ34**2 + 16*s12*s13*s14*s24*
     &    PropZ12**2*PropZ34**2 + 16*s12*s13*s14*s23*PropZ12**2*
     &    PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-2)*couplsm*NPSQ*Czbx*Czz * ( 
     &     - 16*s12*s13**2*s24*PropZ12**2*PropZ34**2 - 16*s12**2*s24*
     &    s34*PropZ12**2*PropZ34**2 - 16*s12**2*s23*s34*PropZ12**2*
     &    PropZ34**2 - 16*s12**2*s14*s34*PropZ12**2*PropZ34**2 - 16*
     &    s12**2*s13*s34*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-2)*couplsm*NPSQ*Czbx**2 * ( 32*
     &    s14*s23*s34**2*PropZ12**2*PropZ34**2 + 32*s13*s24*s34**2*
     &    PropZ12**2*PropZ34**2 + 64*s12*s14*s23*s34*PropZ12**2*
     &    PropZ34**2 + 64*s12*s13*s24*s34*PropZ12**2*PropZ34**2 + 32*
     &    s12**2*s14*s23*PropZ12**2*PropZ34**2 + 32*s12**2*s13*s24*
     &    PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-1)*couplsm*NPSQ*Czz*dCz * ( 16*
     &    s14*s23*s24*PropZ12**2*PropZ34**2 - 16*s14*s23**2*PropZ12**2*
     &    PropZ34**2 - 16*s14**2*s23*PropZ12**2*PropZ34**2 - 16*s13*
     &    s24**2*PropZ12**2*PropZ34**2 + 16*s13*s23*s24*PropZ12**2*
     &    PropZ34**2 + 16*s13*s14*s24*PropZ12**2*PropZ34**2 + 16*s13*
     &    s14*s23*PropZ12**2*PropZ34**2 - 16*s13**2*s24*PropZ12**2*
     &    PropZ34**2 - 16*s12*s24*s34*PropZ12**2*PropZ34**2 - 16*s12*
     &    s23*s34*PropZ12**2*PropZ34**2 - 16*s12*s14*s34*PropZ12**2*
     &    PropZ34**2 - 16*s12*s13*s34*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-1)*couplsm*NPSQ*Czbx*dCz * ( 64
     &    *s14*s23*s34*PropZ12**2*PropZ34**2 + 64*s13*s24*s34*
     &    PropZ12**2*PropZ34**2 + 64*s12*s14*s23*PropZ12**2*PropZ34**2
     &     + 64*s12*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-1)*couplsm*NP*Czz * ( 16*s14*
     &    s23*s24*PropZ12**2*PropZ34**2 - 16*s14*s23**2*PropZ12**2*
     &    PropZ34**2 - 16*s14**2*s23*PropZ12**2*PropZ34**2 - 16*s13*
     &    s24**2*PropZ12**2*PropZ34**2 + 16*s13*s23*s24*PropZ12**2*
     &    PropZ34**2 + 16*s13*s14*s24*PropZ12**2*PropZ34**2 + 16*s13*
     &    s14*s23*PropZ12**2*PropZ34**2 - 16*s13**2*s24*PropZ12**2*
     &    PropZ34**2 - 16*s12*s24*s34*PropZ12**2*PropZ34**2 - 16*s12*
     &    s23*s34*PropZ12**2*PropZ34**2 - 16*s12*s14*s34*PropZ12**2*
     &    PropZ34**2 - 16*s12*s13*s34*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-1)*couplsm*NP*Czbx * ( 64*s14*
     &    s23*s34*PropZ12**2*PropZ34**2 + 64*s13*s24*s34*PropZ12**2*
     &    PropZ34**2 + 64*s12*s14*s23*PropZ12**2*PropZ34**2 + 64*s12*
     &    s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ**2*couplsm * ( 32*s14*s23*PropZ12**2*
     &    PropZ34**2 + 32*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ**2*couplsm*NPSQ*dCz**2 * ( 32*s14*s23*
     &    PropZ12**2*PropZ34**2 + 32*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CVSQ**2*couplsm*NP*dCz * ( 64*s14*s23*
     &    PropZ12**2*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1L * (  - 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ34 )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1L * ( 2*
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 2*s24*
     &    cw**2*sw**4*PropZ34 + 2*s24*cw**2*sw**4*PropZ12 - 2*s23*cw**2
     &    *sw**4*PropZ34 - 2*s23*cw**2*sw**4*PropZ12 - 2*s14*cw**2*
     &    sw**4*PropZ34 - 2*s14*cw**2*sw**4*PropZ12 + 2*s13*cw**2*sw**4
     &    *PropZ34 + 2*s13*cw**2*sw**4*PropZ12 )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1R * ( 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ34 )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1R * (  - 2*
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 2*s24*
     &    cw**2*sw**4*PropZ34 - 2*s24*cw**2*sw**4*PropZ12 + 2*s23*cw**2
     &    *sw**4*PropZ34 + 2*s23*cw**2*sw**4*PropZ12 + 2*s14*cw**2*
     &    sw**4*PropZ34 + 2*s14*cw**2*sw**4*PropZ12 - 2*s13*cw**2*sw**4
     &    *PropZ34 - 2*s13*cw**2*sw**4*PropZ12 )
      MSQBSM = MSQBSM + CA*mzsq**(-1)*couplsm*NPSQ*Caa*dGl1L * (  - 4*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 4*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 4*s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 + 4*s12**(-1)*s13*s24**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s23*s24*s34**(-1)*
     &    cw**2*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13*s14*
     &    s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*
     &    s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s24*
     &    cw**2*sw**4*PropZ12*PropZ34 - 4*s23*cw**2*sw**4*PropZ12*
     &    PropZ34 - 4*s14*cw**2*sw**4*PropZ12*PropZ34 + 4*s13*cw**2*
     &    sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CA*mzsq**(-1)*couplsm*NPSQ*Caa*dGl1R * ( 4*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     + 4*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 + 4*s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 4*s12**(-1)*s13*s24**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13*s23*s24*s34**(-1)*
     &    cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13*s14*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*
     &    s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*
     &    s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s24*
     &    cw**2*sw**4*PropZ12*PropZ34 + 4*s23*cw**2*sw**4*PropZ12*
     &    PropZ34 + 4*s14*cw**2*sw**4*PropZ12*PropZ34 - 4*s13*cw**2*
     &    sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 
     &     - 8*s14*s23*s24*PropZ12*PropZ34**2 - 8*s14*s23*s24*
     &    PropZ12**2*PropZ34 + 8*s14*s23**2*PropZ12*PropZ34**2 + 8*s14*
     &    s23**2*PropZ12**2*PropZ34 + 8*s14**2*s23*PropZ12*PropZ34**2
     &     + 8*s14**2*s23*PropZ12**2*PropZ34 + 8*s13*s24**2*PropZ12*
     &    PropZ34**2 + 8*s13*s24**2*PropZ12**2*PropZ34 - 8*s13*s23*s24*
     &    PropZ12*PropZ34**2 - 8*s13*s23*s24*PropZ12**2*PropZ34 - 8*s13
     &    *s14*s24*PropZ12*PropZ34**2 - 8*s13*s14*s24*PropZ12**2*
     &    PropZ34 - 8*s13*s14*s23*PropZ12*PropZ34**2 - 8*s13*s14*s23*
     &    PropZ12**2*PropZ34 + 8*s13**2*s24*PropZ12*PropZ34**2 + 8*
     &    s13**2*s24*PropZ12**2*PropZ34 + 8*s12*s24*s34*PropZ12*
     &    PropZ34**2 + 8*s12*s24*s34*PropZ12**2*PropZ34 + 8*s12*s23*s34
     &    *PropZ12*PropZ34**2 + 8*s12*s23*s34*PropZ12**2*PropZ34 + 8*
     &    s12*s14*s34*PropZ12*PropZ34**2 + 8*s12*s14*s34*PropZ12**2*
     &    PropZ34 + 8*s12*s13*s34*PropZ12*PropZ34**2 + 8*s12*s13*s34*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &     - 32*s14*s23*s34*PropZ12*PropZ34**2 - 32*s14*s23*s34*
     &    PropZ12**2*PropZ34 - 32*s13*s24*s34*PropZ12*PropZ34**2 - 32*
     &    s13*s24*s34*PropZ12**2*PropZ34 - 32*s12*s14*s23*PropZ12*
     &    PropZ34**2 - 32*s12*s14*s23*PropZ12**2*PropZ34 - 32*s12*s13*
     &    s24*PropZ12*PropZ34**2 - 32*s12*s13*s24*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 8
     &    *s14*s23*s24*PropZ12*PropZ34**2 + 8*s14*s23*s24*PropZ12**2*
     &    PropZ34 - 8*s14*s23**2*PropZ12*PropZ34**2 - 8*s14*s23**2*
     &    PropZ12**2*PropZ34 - 8*s14**2*s23*PropZ12*PropZ34**2 - 8*
     &    s14**2*s23*PropZ12**2*PropZ34 - 8*s13*s24**2*PropZ12*
     &    PropZ34**2 - 8*s13*s24**2*PropZ12**2*PropZ34 + 8*s13*s23*s24*
     &    PropZ12*PropZ34**2 + 8*s13*s23*s24*PropZ12**2*PropZ34 + 8*s13
     &    *s14*s24*PropZ12*PropZ34**2 + 8*s13*s14*s24*PropZ12**2*
     &    PropZ34 + 8*s13*s14*s23*PropZ12*PropZ34**2 + 8*s13*s14*s23*
     &    PropZ12**2*PropZ34 - 8*s13**2*s24*PropZ12*PropZ34**2 - 8*
     &    s13**2*s24*PropZ12**2*PropZ34 - 8*s12*s24*s34*PropZ12*
     &    PropZ34**2 - 8*s12*s24*s34*PropZ12**2*PropZ34 - 8*s12*s23*s34
     &    *PropZ12*PropZ34**2 - 8*s12*s23*s34*PropZ12**2*PropZ34 - 8*
     &    s12*s14*s34*PropZ12*PropZ34**2 - 8*s12*s14*s34*PropZ12**2*
     &    PropZ34 - 8*s12*s13*s34*PropZ12*PropZ34**2 - 8*s12*s13*s34*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &    32*s14*s23*s34*PropZ12*PropZ34**2 + 32*s14*s23*s34*PropZ12**2
     &    *PropZ34 + 32*s13*s24*s34*PropZ12*PropZ34**2 + 32*s13*s24*s34
     &    *PropZ12**2*PropZ34 + 32*s12*s14*s23*PropZ12*PropZ34**2 + 32*
     &    s12*s14*s23*PropZ12**2*PropZ34 + 32*s12*s13*s24*PropZ12*
     &    PropZ34**2 + 32*s12*s13*s24*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*dCz * ( 
     &     - 32*s14*s23*PropZ12*PropZ34**2 - 32*s14*s23*PropZ12**2*
     &    PropZ34 - 32*s13*s24*PropZ12*PropZ34**2 - 32*s13*s24*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czz * ( 
     &     - 16*s14*s23*s24*PropZ12**2*PropZ34**2 + 16*s14*s23**2*
     &    PropZ12**2*PropZ34**2 + 16*s14**2*s23*PropZ12**2*PropZ34**2
     &     + 16*s13*s24**2*PropZ12**2*PropZ34**2 - 16*s13*s23*s24*
     &    PropZ12**2*PropZ34**2 - 16*s13*s14*s24*PropZ12**2*PropZ34**2
     &     - 16*s13*s14*s23*PropZ12**2*PropZ34**2 + 16*s13**2*s24*
     &    PropZ12**2*PropZ34**2 + 16*s12*s24*s34*PropZ12**2*PropZ34**2
     &     + 16*s12*s23*s34*PropZ12**2*PropZ34**2 + 16*s12*s14*s34*
     &    PropZ12**2*PropZ34**2 + 16*s12*s13*s34*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &     - 64*s14*s23*s34*PropZ12**2*PropZ34**2 - 64*s13*s24*s34*
     &    PropZ12**2*PropZ34**2 - 64*s12*s14*s23*PropZ12**2*PropZ34**2
     &     - 64*s12*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*dCz * ( 
     &    32*s14*s23*PropZ12*PropZ34**2 + 32*s14*s23*PropZ12**2*PropZ34
     &     + 32*s13*s24*PropZ12*PropZ34**2 + 32*s13*s24*PropZ12**2*
     &    PropZ34 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czz * ( 
     &    16*s14*s23*s24*PropZ12**2*PropZ34**2 - 16*s14*s23**2*
     &    PropZ12**2*PropZ34**2 - 16*s14**2*s23*PropZ12**2*PropZ34**2
     &     - 16*s13*s24**2*PropZ12**2*PropZ34**2 + 16*s13*s23*s24*
     &    PropZ12**2*PropZ34**2 + 16*s13*s14*s24*PropZ12**2*PropZ34**2
     &     + 16*s13*s14*s23*PropZ12**2*PropZ34**2 - 16*s13**2*s24*
     &    PropZ12**2*PropZ34**2 - 16*s12*s24*s34*PropZ12**2*PropZ34**2
     &     - 16*s12*s23*s34*PropZ12**2*PropZ34**2 - 16*s12*s14*s34*
     &    PropZ12**2*PropZ34**2 - 16*s12*s13*s34*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &    64*s14*s23*s34*PropZ12**2*PropZ34**2 + 64*s13*s24*s34*
     &    PropZ12**2*PropZ34**2 + 64*s12*s14*s23*PropZ12**2*PropZ34**2
     &     + 64*s12*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NP*dGl1L * (  - 32*
     &    s14*s23*PropZ12*PropZ34**2 - 32*s14*s23*PropZ12**2*PropZ34 - 
     &    32*s13*s24*PropZ12*PropZ34**2 - 32*s13*s24*PropZ12**2*PropZ34
     &     )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NP*dGl1R * ( 32*s14*
     &    s23*PropZ12*PropZ34**2 + 32*s14*s23*PropZ12**2*PropZ34 + 32*
     &    s13*s24*PropZ12*PropZ34**2 + 32*s13*s24*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CA*CASQ*couplsm*NPSQ*dGl1L*dCz * (  - 64*s14*
     &    s23*PropZ12**2*PropZ34**2 - 64*s13*s24*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CA*CASQ*couplsm*NPSQ*dGl1R*dCz * ( 64*s14*s23*
     &    PropZ12**2*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CA*CASQ*couplsm*NP*dGl1L * (  - 64*s14*s23*
     &    PropZ12**2*PropZ34**2 - 64*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CA*CASQ*couplsm*NP*dGl1R * ( 64*s14*s23*
     &    PropZ12**2*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 
     &     - 24*s14*s23*s24*PropZ12*PropZ34**2 - 24*s14*s23*s24*
     &    PropZ12**2*PropZ34 - 8*s14*s23**2*PropZ12*PropZ34**2 - 8*s14*
     &    s23**2*PropZ12**2*PropZ34 - 8*s14**2*s23*PropZ12*PropZ34**2
     &     - 8*s14**2*s23*PropZ12**2*PropZ34 + 24*s13*s24**2*PropZ12*
     &    PropZ34**2 + 24*s13*s24**2*PropZ12**2*PropZ34 + 8*s13*s23*s24
     &    *PropZ12*PropZ34**2 + 8*s13*s23*s24*PropZ12**2*PropZ34 + 8*
     &    s13*s14*s24*PropZ12*PropZ34**2 + 8*s13*s14*s24*PropZ12**2*
     &    PropZ34 - 24*s13*s14*s23*PropZ12*PropZ34**2 - 24*s13*s14*s23*
     &    PropZ12**2*PropZ34 + 24*s13**2*s24*PropZ12*PropZ34**2 + 24*
     &    s13**2*s24*PropZ12**2*PropZ34 + 24*s12*s24*s34*PropZ12*
     &    PropZ34**2 + 24*s12*s24*s34*PropZ12**2*PropZ34 - 8*s12*s23*
     &    s34*PropZ12*PropZ34**2 - 8*s12*s23*s34*PropZ12**2*PropZ34 - 8
     &    *s12*s14*s34*PropZ12*PropZ34**2 - 8*s12*s14*s34*PropZ12**2*
     &    PropZ34 + 24*s12*s13*s34*PropZ12*PropZ34**2 + 24*s12*s13*s34*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &    32*s14*s23*s34*PropZ12*PropZ34**2 + 32*s14*s23*s34*PropZ12**2
     &    *PropZ34 - 96*s13*s24*s34*PropZ12*PropZ34**2 - 96*s13*s24*s34
     &    *PropZ12**2*PropZ34 + 32*s12*s14*s23*PropZ12*PropZ34**2 + 32*
     &    s12*s14*s23*PropZ12**2*PropZ34 - 96*s12*s13*s24*PropZ12*
     &    PropZ34**2 - 96*s12*s13*s24*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 
     &    24*s14*s23*s24*PropZ12*PropZ34**2 + 24*s14*s23*s24*PropZ12**2
     &    *PropZ34 + 8*s14*s23**2*PropZ12*PropZ34**2 + 8*s14*s23**2*
     &    PropZ12**2*PropZ34 + 8*s14**2*s23*PropZ12*PropZ34**2 + 8*
     &    s14**2*s23*PropZ12**2*PropZ34 - 24*s13*s24**2*PropZ12*
     &    PropZ34**2 - 24*s13*s24**2*PropZ12**2*PropZ34 - 8*s13*s23*s24
     &    *PropZ12*PropZ34**2 - 8*s13*s23*s24*PropZ12**2*PropZ34 - 8*
     &    s13*s14*s24*PropZ12*PropZ34**2 - 8*s13*s14*s24*PropZ12**2*
     &    PropZ34 + 24*s13*s14*s23*PropZ12*PropZ34**2 + 24*s13*s14*s23*
     &    PropZ12**2*PropZ34 - 24*s13**2*s24*PropZ12*PropZ34**2 - 24*
     &    s13**2*s24*PropZ12**2*PropZ34 - 24*s12*s24*s34*PropZ12*
     &    PropZ34**2 - 24*s12*s24*s34*PropZ12**2*PropZ34 + 8*s12*s23*
     &    s34*PropZ12*PropZ34**2 + 8*s12*s23*s34*PropZ12**2*PropZ34 + 8
     &    *s12*s14*s34*PropZ12*PropZ34**2 + 8*s12*s14*s34*PropZ12**2*
     &    PropZ34 - 24*s12*s13*s34*PropZ12*PropZ34**2 - 24*s12*s13*s34*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &     - 32*s14*s23*s34*PropZ12*PropZ34**2 - 32*s14*s23*s34*
     &    PropZ12**2*PropZ34 + 96*s13*s24*s34*PropZ12*PropZ34**2 + 96*
     &    s13*s24*s34*PropZ12**2*PropZ34 - 32*s12*s14*s23*PropZ12*
     &    PropZ34**2 - 32*s12*s14*s23*PropZ12**2*PropZ34 + 96*s12*s13*
     &    s24*PropZ12*PropZ34**2 + 96*s12*s13*s24*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*dCz * ( 
     &    32*s14*s23*PropZ12*PropZ34**2 + 32*s14*s23*PropZ12**2*PropZ34
     &     - 96*s13*s24*PropZ12*PropZ34**2 - 96*s13*s24*PropZ12**2*
     &    PropZ34 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czz * ( 
     &     - 48*s14*s23*s24*PropZ12**2*PropZ34**2 - 16*s14*s23**2*
     &    PropZ12**2*PropZ34**2 - 16*s14**2*s23*PropZ12**2*PropZ34**2
     &     + 48*s13*s24**2*PropZ12**2*PropZ34**2 + 16*s13*s23*s24*
     &    PropZ12**2*PropZ34**2 + 16*s13*s14*s24*PropZ12**2*PropZ34**2
     &     - 48*s13*s14*s23*PropZ12**2*PropZ34**2 + 48*s13**2*s24*
     &    PropZ12**2*PropZ34**2 + 48*s12*s24*s34*PropZ12**2*PropZ34**2
     &     - 16*s12*s23*s34*PropZ12**2*PropZ34**2 - 16*s12*s14*s34*
     &    PropZ12**2*PropZ34**2 + 48*s12*s13*s34*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &    64*s14*s23*s34*PropZ12**2*PropZ34**2 - 192*s13*s24*s34*
     &    PropZ12**2*PropZ34**2 + 64*s12*s14*s23*PropZ12**2*PropZ34**2
     &     - 192*s12*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*dCz * ( 
     &     - 32*s14*s23*PropZ12*PropZ34**2 - 32*s14*s23*PropZ12**2*
     &    PropZ34 + 96*s13*s24*PropZ12*PropZ34**2 + 96*s13*s24*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czz * ( 
     &    48*s14*s23*s24*PropZ12**2*PropZ34**2 + 16*s14*s23**2*
     &    PropZ12**2*PropZ34**2 + 16*s14**2*s23*PropZ12**2*PropZ34**2
     &     - 48*s13*s24**2*PropZ12**2*PropZ34**2 - 16*s13*s23*s24*
     &    PropZ12**2*PropZ34**2 - 16*s13*s14*s24*PropZ12**2*PropZ34**2
     &     + 48*s13*s14*s23*PropZ12**2*PropZ34**2 - 48*s13**2*s24*
     &    PropZ12**2*PropZ34**2 - 48*s12*s24*s34*PropZ12**2*PropZ34**2
     &     + 16*s12*s23*s34*PropZ12**2*PropZ34**2 + 16*s12*s14*s34*
     &    PropZ12**2*PropZ34**2 - 48*s12*s13*s34*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &     - 64*s14*s23*s34*PropZ12**2*PropZ34**2 + 192*s13*s24*s34*
     &    PropZ12**2*PropZ34**2 - 64*s12*s14*s23*PropZ12**2*PropZ34**2
     &     + 192*s12*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NP*dGl1L * ( 32*s14*
     &    s23*PropZ12*PropZ34**2 + 32*s14*s23*PropZ12**2*PropZ34 - 96*
     &    s13*s24*PropZ12*PropZ34**2 - 96*s13*s24*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NP*dGl1R * (  - 32*
     &    s14*s23*PropZ12*PropZ34**2 - 32*s14*s23*PropZ12**2*PropZ34 + 
     &    96*s13*s24*PropZ12*PropZ34**2 + 96*s13*s24*PropZ12**2*PropZ34
     &     )
      MSQBSM = MSQBSM + CA*CVSQ*couplsm*NPSQ*dGl1L*dCz * ( 64*s14*s23*
     &    PropZ12**2*PropZ34**2 - 192*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CA*CVSQ*couplsm*NPSQ*dGl1R*dCz * (  - 64*s14*
     &    s23*PropZ12**2*PropZ34**2 + 192*s13*s24*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CA*CVSQ*couplsm*NP*dGl1L * ( 64*s14*s23*
     &    PropZ12**2*PropZ34**2 - 192*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CA*CVSQ*couplsm*NP*dGl1R * (  - 64*s14*s23*
     &    PropZ12**2*PropZ34**2 + 192*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1L * ( 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ34 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1L * (  - 2*
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 2*s24*
     &    cw**2*sw**4*PropZ34 - 2*s24*cw**2*sw**4*PropZ12 - 2*s23*cw**2
     &    *sw**4*PropZ34 - 2*s23*cw**2*sw**4*PropZ12 - 2*s14*cw**2*
     &    sw**4*PropZ34 - 2*s14*cw**2*sw**4*PropZ12 - 2*s13*cw**2*sw**4
     &    *PropZ34 - 2*s13*cw**2*sw**4*PropZ12 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1R * ( 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ34 - 2*
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ34 + 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12 - 2*
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ34 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1R * (  - 2*
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 2*s24*
     &    cw**2*sw**4*PropZ34 - 2*s24*cw**2*sw**4*PropZ12 - 2*s23*cw**2
     &    *sw**4*PropZ34 - 2*s23*cw**2*sw**4*PropZ12 - 2*s14*cw**2*
     &    sw**4*PropZ34 - 2*s14*cw**2*sw**4*PropZ12 - 2*s13*cw**2*sw**4
     &    *PropZ34 - 2*s13*cw**2*sw**4*PropZ12 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*Cza * (  - 4*
     &    s12**(-2)*s14**2*s23**2*s34**(-1)*cw**2*sw**6*PropZ34 + 8*
     &    s12**(-2)*s13*s14*s23*s24*s34**(-1)*cw**2*sw**6*PropZ34 - 4*
     &    s12**(-2)*s13**2*s24**2*s34**(-1)*cw**2*sw**6*PropZ34 - 2*
     &    s12**(-1)*s24**2*cw**2*sw**6*PropZ34 - 2*s12**(-1)*s23**2*
     &    cw**2*sw**6*PropZ34 + 4*s12**(-1)*s14*s23*cw**2*sw**6*PropZ34
     &     - 2*s12**(-1)*s14**2*cw**2*sw**6*PropZ34 - 4*s12**(-1)*
     &    s14**2*s23**2*s34**(-2)*cw**2*sw**6*PropZ12 + 4*s12**(-1)*s13
     &    *s24*cw**2*sw**6*PropZ34 + 8*s12**(-1)*s13*s14*s23*s24*
     &    s34**(-2)*cw**2*sw**6*PropZ12 - 2*s12**(-1)*s13**2*cw**2*
     &    sw**6*PropZ34 - 4*s12**(-1)*s13**2*s24**2*s34**(-2)*cw**2*
     &    sw**6*PropZ12 - 4*s34*cw**2*sw**6*PropZ34 - 2*s24**2*
     &    s34**(-1)*cw**2*sw**6*PropZ12 - 2*s23**2*s34**(-1)*cw**2*
     &    sw**6*PropZ12 + 4*s14*s23*s34**(-1)*cw**2*sw**6*PropZ12 - 2*
     &    s14**2*s34**(-1)*cw**2*sw**6*PropZ12 + 4*s13*s24*s34**(-1)*
     &    cw**2*sw**6*PropZ12 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*Cza * (  - 2*
     &    s13**2*s34**(-1)*cw**2*sw**6*PropZ12 - 4*s12*cw**2*sw**6*
     &    PropZ12 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*Cabx * (  - 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**6*PropZ34 - 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**6*PropZ12 + 2*
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**6*PropZ34 + 2*
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**6*PropZ12 + 2*
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**6*PropZ34 + 2*
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**6*PropZ12 + 2*
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**6*PropZ34 + 2*
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**6*PropZ12 - 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**6*PropZ34 - 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**6*PropZ12 - 2*
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**6*PropZ34 - 2*
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**6*PropZ12 - 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**6*PropZ34 - 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**6*PropZ12 + 2*
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**6*PropZ34 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*Cabx * ( 2*
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**6*PropZ12 + 2*s24*
     &    cw**2*sw**6*PropZ34 + 2*s24*cw**2*sw**6*PropZ12 + 2*s23*cw**2
     &    *sw**6*PropZ34 + 2*s23*cw**2*sw**6*PropZ12 + 2*s14*cw**2*
     &    sw**6*PropZ34 + 2*s14*cw**2*sw**6*PropZ12 + 2*s13*cw**2*sw**6
     &    *PropZ34 + 2*s13*cw**2*sw**6*PropZ12 )
      MSQBSM = MSQBSM + CV*mzsq**(-1)*couplsm*NPSQ*Caa*dGl1L * ( 4*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 4*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 4*s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 4*s12**(-1)*s13*s24**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s23*s24*s34**(-1)*
     &    cw**2*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*
     &    s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*
     &    s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s24*
     &    cw**2*sw**4*PropZ12*PropZ34 - 4*s23*cw**2*sw**4*PropZ12*
     &    PropZ34 - 4*s14*cw**2*sw**4*PropZ12*PropZ34 - 4*s13*cw**2*
     &    sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CV*mzsq**(-1)*couplsm*NPSQ*Caa*dGl1R * ( 4*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 4*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 4*s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 4*s12**(-1)*s13*s24**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s23*s24*s34**(-1)*
     &    cw**2*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*
     &    s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*
     &    s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s24*
     &    cw**2*sw**4*PropZ12*PropZ34 - 4*s23*cw**2*sw**4*PropZ12*
     &    PropZ34 - 4*s14*cw**2*sw**4*PropZ12*PropZ34 - 4*s13*cw**2*
     &    sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 
     &    24*s14*s23*s24*PropZ12*PropZ34**2 + 24*s14*s23*s24*PropZ12**2
     &    *PropZ34 + 8*s14*s23**2*PropZ12*PropZ34**2 + 8*s14*s23**2*
     &    PropZ12**2*PropZ34 + 8*s14**2*s23*PropZ12*PropZ34**2 + 8*
     &    s14**2*s23*PropZ12**2*PropZ34 - 24*s13*s24**2*PropZ12*
     &    PropZ34**2 - 24*s13*s24**2*PropZ12**2*PropZ34 - 8*s13*s23*s24
     &    *PropZ12*PropZ34**2 - 8*s13*s23*s24*PropZ12**2*PropZ34 - 8*
     &    s13*s14*s24*PropZ12*PropZ34**2 - 8*s13*s14*s24*PropZ12**2*
     &    PropZ34 + 24*s13*s14*s23*PropZ12*PropZ34**2 + 24*s13*s14*s23*
     &    PropZ12**2*PropZ34 - 24*s13**2*s24*PropZ12*PropZ34**2 - 24*
     &    s13**2*s24*PropZ12**2*PropZ34 - 24*s12*s24*s34*PropZ12*
     &    PropZ34**2 - 24*s12*s24*s34*PropZ12**2*PropZ34 + 8*s12*s23*
     &    s34*PropZ12*PropZ34**2 + 8*s12*s23*s34*PropZ12**2*PropZ34 + 8
     &    *s12*s14*s34*PropZ12*PropZ34**2 + 8*s12*s14*s34*PropZ12**2*
     &    PropZ34 - 24*s12*s13*s34*PropZ12*PropZ34**2 - 24*s12*s13*s34*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &     - 32*s14*s23*s34*PropZ12*PropZ34**2 - 32*s14*s23*s34*
     &    PropZ12**2*PropZ34 + 96*s13*s24*s34*PropZ12*PropZ34**2 + 96*
     &    s13*s24*s34*PropZ12**2*PropZ34 - 32*s12*s14*s23*PropZ12*
     &    PropZ34**2 - 32*s12*s14*s23*PropZ12**2*PropZ34 + 96*s12*s13*
     &    s24*PropZ12*PropZ34**2 + 96*s12*s13*s24*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 
     &    24*s14*s23*s24*PropZ12*PropZ34**2 + 24*s14*s23*s24*PropZ12**2
     &    *PropZ34 + 8*s14*s23**2*PropZ12*PropZ34**2 + 8*s14*s23**2*
     &    PropZ12**2*PropZ34 + 8*s14**2*s23*PropZ12*PropZ34**2 + 8*
     &    s14**2*s23*PropZ12**2*PropZ34 - 24*s13*s24**2*PropZ12*
     &    PropZ34**2 - 24*s13*s24**2*PropZ12**2*PropZ34 - 8*s13*s23*s24
     &    *PropZ12*PropZ34**2 - 8*s13*s23*s24*PropZ12**2*PropZ34 - 8*
     &    s13*s14*s24*PropZ12*PropZ34**2 - 8*s13*s14*s24*PropZ12**2*
     &    PropZ34 + 24*s13*s14*s23*PropZ12*PropZ34**2 + 24*s13*s14*s23*
     &    PropZ12**2*PropZ34 - 24*s13**2*s24*PropZ12*PropZ34**2 - 24*
     &    s13**2*s24*PropZ12**2*PropZ34 - 24*s12*s24*s34*PropZ12*
     &    PropZ34**2 - 24*s12*s24*s34*PropZ12**2*PropZ34 + 8*s12*s23*
     &    s34*PropZ12*PropZ34**2 + 8*s12*s23*s34*PropZ12**2*PropZ34 + 8
     &    *s12*s14*s34*PropZ12*PropZ34**2 + 8*s12*s14*s34*PropZ12**2*
     &    PropZ34 - 24*s12*s13*s34*PropZ12*PropZ34**2 - 24*s12*s13*s34*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &     - 32*s14*s23*s34*PropZ12*PropZ34**2 - 32*s14*s23*s34*
     &    PropZ12**2*PropZ34 + 96*s13*s24*s34*PropZ12*PropZ34**2 + 96*
     &    s13*s24*s34*PropZ12**2*PropZ34 - 32*s12*s14*s23*PropZ12*
     &    PropZ34**2 - 32*s12*s14*s23*PropZ12**2*PropZ34 + 96*s12*s13*
     &    s24*PropZ12*PropZ34**2 + 96*s12*s13*s24*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czz * (  - 
     &    16*s12**(-1)*s14**2*s23**2*sw**2*PropZ12*PropZ34**2 + 32*
     &    s12**(-1)*s13*s14*s23*s24*sw**2*PropZ12*PropZ34**2 - 16*
     &    s12**(-1)*s13**2*s24**2*sw**2*PropZ12*PropZ34**2 - 24*s24**2*
     &    s34*sw**2*PropZ12*PropZ34**2 + 8*s23**2*s34*sw**2*PropZ12*
     &    PropZ34**2 + 48*s14*s23*s34*sw**2*PropZ12*PropZ34**2 + 8*
     &    s14**2*s34*sw**2*PropZ12*PropZ34**2 - 16*s14**2*s23**2*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 - 16*s13*s24*s34*sw**2*
     &    PropZ12*PropZ34**2 + 32*s13*s14*s23*s24*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 - 24*s13**2*s34*sw**2*PropZ12*PropZ34**2
     &     - 16*s13**2*s24**2*s34**(-1)*sw**2*PropZ12**2*PropZ34 - 16*
     &    s12*s34**2*sw**2*PropZ12*PropZ34**2 - 24*s12*s24**2*sw**2*
     &    PropZ12**2*PropZ34 + 8*s12*s23**2*sw**2*PropZ12**2*PropZ34 + 
     &    48*s12*s14*s23*sw**2*PropZ12**2*PropZ34 + 8*s12*s14**2*sw**2*
     &    PropZ12**2*PropZ34 - 16*s12*s13*s24*sw**2*PropZ12**2*PropZ34
     &     - 24*s12*s13**2*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czz * (  - 
     &    16*s12**2*s34*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 
     &     - 24*s12**(-1)*s14*s23*s24*s34*sw**2*PropZ12*PropZ34**2 - 8*
     &    s12**(-1)*s14*s23**2*s34*sw**2*PropZ12*PropZ34**2 - 8*
     &    s12**(-1)*s14**2*s23*s34*sw**2*PropZ12*PropZ34**2 + 24*
     &    s12**(-1)*s13*s24**2*s34*sw**2*PropZ12*PropZ34**2 + 8*
     &    s12**(-1)*s13*s23*s24*s34*sw**2*PropZ12*PropZ34**2 + 8*
     &    s12**(-1)*s13*s14*s24*s34*sw**2*PropZ12*PropZ34**2 - 24*
     &    s12**(-1)*s13*s14*s23*s34*sw**2*PropZ12*PropZ34**2 + 24*
     &    s12**(-1)*s13**2*s24*s34*sw**2*PropZ12*PropZ34**2 + 24*s24*
     &    s34**2*sw**2*PropZ12*PropZ34**2 - 8*s23*s34**2*sw**2*PropZ12*
     &    PropZ34**2 - 8*s14*s34**2*sw**2*PropZ12*PropZ34**2 - 24*s14*
     &    s23*s24*sw**2*PropZ12*PropZ34**2 - 24*s14*s23*s24*sw**2*
     &    PropZ12**2*PropZ34 - 8*s14*s23**2*sw**2*PropZ12*PropZ34**2 - 
     &    8*s14*s23**2*sw**2*PropZ12**2*PropZ34 - 8*s14**2*s23*sw**2*
     &    PropZ12*PropZ34**2 - 8*s14**2*s23*sw**2*PropZ12**2*PropZ34 + 
     &    24*s13*s34**2*sw**2*PropZ12*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 24
     &    *s13*s24**2*sw**2*PropZ12*PropZ34**2 + 24*s13*s24**2*sw**2*
     &    PropZ12**2*PropZ34 + 8*s13*s23*s24*sw**2*PropZ12*PropZ34**2
     &     + 8*s13*s23*s24*sw**2*PropZ12**2*PropZ34 + 8*s13*s14*s24*
     &    sw**2*PropZ12*PropZ34**2 + 8*s13*s14*s24*sw**2*PropZ12**2*
     &    PropZ34 - 24*s13*s14*s23*sw**2*PropZ12*PropZ34**2 - 24*s13*
     &    s14*s23*sw**2*PropZ12**2*PropZ34 + 24*s13**2*s24*sw**2*
     &    PropZ12*PropZ34**2 + 24*s13**2*s24*sw**2*PropZ12**2*PropZ34
     &     + 24*s12*s24*s34*sw**2*PropZ12*PropZ34**2 + 24*s12*s24*s34*
     &    sw**2*PropZ12**2*PropZ34 - 8*s12*s23*s34*sw**2*PropZ12*
     &    PropZ34**2 - 8*s12*s23*s34*sw**2*PropZ12**2*PropZ34 - 8*s12*
     &    s14*s34*sw**2*PropZ12*PropZ34**2 - 8*s12*s14*s34*sw**2*
     &    PropZ12**2*PropZ34 - 24*s12*s14*s23*s24*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 - 8*s12*s14*s23**2*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 - 8*s12*s14**2*s23*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 24
     &    *s12*s13*s34*sw**2*PropZ12*PropZ34**2 + 24*s12*s13*s34*sw**2*
     &    PropZ12**2*PropZ34 + 24*s12*s13*s24**2*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 + 8*s12*s13*s23*s24*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 + 8*s12*s13*s14*s24*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 - 24*s12*s13*s14*s23*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 + 24*s12*s13**2*s24*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 + 24*s12**2*s24*sw**2*PropZ12**2*PropZ34
     &     - 8*s12**2*s23*sw**2*PropZ12**2*PropZ34 - 8*s12**2*s14*sw**2
     &    *PropZ12**2*PropZ34 + 24*s12**2*s13*sw**2*PropZ12**2*PropZ34
     &     )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czz * ( 
     &     - 24*s14*s23*s24*sw**2*PropZ12*PropZ34**2 - 24*s14*s23*s24*
     &    sw**2*PropZ12**2*PropZ34 - 8*s14*s23**2*sw**2*PropZ12*
     &    PropZ34**2 - 8*s14*s23**2*sw**2*PropZ12**2*PropZ34 - 8*s14**2
     &    *s23*sw**2*PropZ12*PropZ34**2 - 8*s14**2*s23*sw**2*PropZ12**2
     &    *PropZ34 + 24*s13*s24**2*sw**2*PropZ12*PropZ34**2 + 24*s13*
     &    s24**2*sw**2*PropZ12**2*PropZ34 + 8*s13*s23*s24*sw**2*PropZ12
     &    *PropZ34**2 + 8*s13*s23*s24*sw**2*PropZ12**2*PropZ34 + 8*s13*
     &    s14*s24*sw**2*PropZ12*PropZ34**2 + 8*s13*s14*s24*sw**2*
     &    PropZ12**2*PropZ34 - 24*s13*s14*s23*sw**2*PropZ12*PropZ34**2
     &     - 24*s13*s14*s23*sw**2*PropZ12**2*PropZ34 + 24*s13**2*s24*
     &    sw**2*PropZ12*PropZ34**2 + 24*s13**2*s24*sw**2*PropZ12**2*
     &    PropZ34 + 24*s12*s24*s34*sw**2*PropZ12*PropZ34**2 + 24*s12*
     &    s24*s34*sw**2*PropZ12**2*PropZ34 - 8*s12*s23*s34*sw**2*
     &    PropZ12*PropZ34**2 - 8*s12*s23*s34*sw**2*PropZ12**2*PropZ34
     &     - 8*s12*s14*s34*sw**2*PropZ12*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czz * ( 
     &     - 8*s12*s14*s34*sw**2*PropZ12**2*PropZ34 + 24*s12*s13*s34*
     &    sw**2*PropZ12*PropZ34**2 + 24*s12*s13*s34*sw**2*PropZ12**2*
     &    PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czbx * ( 
     &    32*s14*s23*s34*sw**2*PropZ12*PropZ34**2 + 32*s14*s23*s34*
     &    sw**2*PropZ12**2*PropZ34 - 96*s13*s24*s34*sw**2*PropZ12*
     &    PropZ34**2 - 96*s13*s24*s34*sw**2*PropZ12**2*PropZ34 + 32*s12
     &    *s14*s23*sw**2*PropZ12*PropZ34**2 + 32*s12*s14*s23*sw**2*
     &    PropZ12**2*PropZ34 - 96*s12*s13*s24*sw**2*PropZ12*PropZ34**2
     &     - 96*s12*s13*s24*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*dCz * ( 
     &     - 32*s14*s23*PropZ12*PropZ34**2 - 32*s14*s23*PropZ12**2*
     &    PropZ34 + 96*s13*s24*PropZ12*PropZ34**2 + 96*s13*s24*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czz * ( 
     &    48*s14*s23*s24*PropZ12**2*PropZ34**2 + 16*s14*s23**2*
     &    PropZ12**2*PropZ34**2 + 16*s14**2*s23*PropZ12**2*PropZ34**2
     &     - 48*s13*s24**2*PropZ12**2*PropZ34**2 - 16*s13*s23*s24*
     &    PropZ12**2*PropZ34**2 - 16*s13*s14*s24*PropZ12**2*PropZ34**2
     &     + 48*s13*s14*s23*PropZ12**2*PropZ34**2 - 48*s13**2*s24*
     &    PropZ12**2*PropZ34**2 - 48*s12*s24*s34*PropZ12**2*PropZ34**2
     &     + 16*s12*s23*s34*PropZ12**2*PropZ34**2 + 16*s12*s14*s34*
     &    PropZ12**2*PropZ34**2 - 48*s12*s13*s34*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &     - 64*s14*s23*s34*PropZ12**2*PropZ34**2 + 192*s13*s24*s34*
     &    PropZ12**2*PropZ34**2 - 64*s12*s14*s23*PropZ12**2*PropZ34**2
     &     + 192*s12*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*dCz * ( 
     &     - 32*s14*s23*PropZ12*PropZ34**2 - 32*s14*s23*PropZ12**2*
     &    PropZ34 + 96*s13*s24*PropZ12*PropZ34**2 + 96*s13*s24*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czz * ( 
     &    48*s14*s23*s24*PropZ12**2*PropZ34**2 + 16*s14*s23**2*
     &    PropZ12**2*PropZ34**2 + 16*s14**2*s23*PropZ12**2*PropZ34**2
     &     - 48*s13*s24**2*PropZ12**2*PropZ34**2 - 16*s13*s23*s24*
     &    PropZ12**2*PropZ34**2 - 16*s13*s14*s24*PropZ12**2*PropZ34**2
     &     + 48*s13*s14*s23*PropZ12**2*PropZ34**2 - 48*s13**2*s24*
     &    PropZ12**2*PropZ34**2 - 48*s12*s24*s34*PropZ12**2*PropZ34**2
     &     + 16*s12*s23*s34*PropZ12**2*PropZ34**2 + 16*s12*s14*s34*
     &    PropZ12**2*PropZ34**2 - 48*s12*s13*s34*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &     - 64*s14*s23*s34*PropZ12**2*PropZ34**2 + 192*s13*s24*s34*
     &    PropZ12**2*PropZ34**2 - 64*s12*s14*s23*PropZ12**2*PropZ34**2
     &     + 192*s12*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*Cza*dCz * (  - 
     &    24*s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34**2 - 8*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34**2 - 8*s12**(-1)*
     &    s14**2*s23*sw**2*PropZ12*PropZ34**2 + 24*s12**(-1)*s13*s24**2
     &    *sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*s13*s23*s24*sw**2*
     &    PropZ12*PropZ34**2 + 8*s12**(-1)*s13*s14*s24*sw**2*PropZ12*
     &    PropZ34**2 - 24*s12**(-1)*s13*s14*s23*sw**2*PropZ12*
     &    PropZ34**2 + 24*s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34**2
     &     + 24*s24*s34*sw**2*PropZ12*PropZ34**2 - 8*s23*s34*sw**2*
     &    PropZ12*PropZ34**2 - 8*s14*s34*sw**2*PropZ12*PropZ34**2 - 24*
     &    s14*s23*s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s14*s23**2
     &    *s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s14**2*s23*s34**(-1)*
     &    sw**2*PropZ12**2*PropZ34 + 24*s13*s34*sw**2*PropZ12*
     &    PropZ34**2 + 24*s13*s24**2*s34**(-1)*sw**2*PropZ12**2*PropZ34
     &     + 8*s13*s23*s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s13*
     &    s14*s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*Cza*dCz * (  - 
     &    24*s13*s14*s23*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 24*s13**2
     &    *s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 24*s12*s24*sw**2*
     &    PropZ12**2*PropZ34 - 8*s12*s23*sw**2*PropZ12**2*PropZ34 - 8*
     &    s12*s14*sw**2*PropZ12**2*PropZ34 + 24*s12*s13*sw**2*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*Cabx*dCz * ( 32
     &    *s14*s23*sw**2*PropZ12*PropZ34**2 + 32*s14*s23*sw**2*
     &    PropZ12**2*PropZ34 - 96*s13*s24*sw**2*PropZ12*PropZ34**2 - 96
     &    *s13*s24*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NP*dGl1L * (  - 32*
     &    s14*s23*PropZ12*PropZ34**2 - 32*s14*s23*PropZ12**2*PropZ34 + 
     &    96*s13*s24*PropZ12*PropZ34**2 + 96*s13*s24*PropZ12**2*PropZ34
     &     )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NP*dGl1R * (  - 32*
     &    s14*s23*PropZ12*PropZ34**2 - 32*s14*s23*PropZ12**2*PropZ34 + 
     &    96*s13*s24*PropZ12*PropZ34**2 + 96*s13*s24*PropZ12**2*PropZ34
     &     )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NP*Cza * (  - 24*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34**2 - 8*s12**(-1)*
     &    s14*s23**2*sw**2*PropZ12*PropZ34**2 - 8*s12**(-1)*s14**2*s23*
     &    sw**2*PropZ12*PropZ34**2 + 24*s12**(-1)*s13*s24**2*sw**2*
     &    PropZ12*PropZ34**2 + 8*s12**(-1)*s13*s23*s24*sw**2*PropZ12*
     &    PropZ34**2 + 8*s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34**2
     &     - 24*s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34**2 + 24*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34**2 + 24*s24*s34*
     &    sw**2*PropZ12*PropZ34**2 - 8*s23*s34*sw**2*PropZ12*PropZ34**2
     &     - 8*s14*s34*sw**2*PropZ12*PropZ34**2 - 24*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s14*s23**2*s34**(-1)*
     &    sw**2*PropZ12**2*PropZ34 - 8*s14**2*s23*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 + 24*s13*s34*sw**2*PropZ12*PropZ34**2 + 24
     &    *s13*s24**2*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s13*s23*
     &    s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s13*s14*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NP*Cza * (  - 24*s13
     &    *s14*s23*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 24*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 + 24*s12*s24*sw**2*
     &    PropZ12**2*PropZ34 - 8*s12*s23*sw**2*PropZ12**2*PropZ34 - 8*
     &    s12*s14*sw**2*PropZ12**2*PropZ34 + 24*s12*s13*sw**2*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NP*Cabx * ( 32*s14*
     &    s23*sw**2*PropZ12*PropZ34**2 + 32*s14*s23*sw**2*PropZ12**2*
     &    PropZ34 - 96*s13*s24*sw**2*PropZ12*PropZ34**2 - 96*s13*s24*
     &    sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*couplsm*NPSQ*dGl1L*dCz * (  - 64*s14*
     &    s23*PropZ12**2*PropZ34**2 + 192*s13*s24*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CV*CASQ*couplsm*NPSQ*dGl1R*dCz * (  - 64*s14*
     &    s23*PropZ12**2*PropZ34**2 + 192*s13*s24*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CV*CASQ*couplsm*NP*dGl1L * (  - 64*s14*s23*
     &    PropZ12**2*PropZ34**2 + 192*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CASQ*couplsm*NP*dGl1R * (  - 64*s14*s23*
     &    PropZ12**2*PropZ34**2 + 192*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 8
     &    *s14*s23*s24*PropZ12*PropZ34**2 + 8*s14*s23*s24*PropZ12**2*
     &    PropZ34 - 8*s14*s23**2*PropZ12*PropZ34**2 - 8*s14*s23**2*
     &    PropZ12**2*PropZ34 - 8*s14**2*s23*PropZ12*PropZ34**2 - 8*
     &    s14**2*s23*PropZ12**2*PropZ34 - 8*s13*s24**2*PropZ12*
     &    PropZ34**2 - 8*s13*s24**2*PropZ12**2*PropZ34 + 8*s13*s23*s24*
     &    PropZ12*PropZ34**2 + 8*s13*s23*s24*PropZ12**2*PropZ34 + 8*s13
     &    *s14*s24*PropZ12*PropZ34**2 + 8*s13*s14*s24*PropZ12**2*
     &    PropZ34 + 8*s13*s14*s23*PropZ12*PropZ34**2 + 8*s13*s14*s23*
     &    PropZ12**2*PropZ34 - 8*s13**2*s24*PropZ12*PropZ34**2 - 8*
     &    s13**2*s24*PropZ12**2*PropZ34 - 8*s12*s24*s34*PropZ12*
     &    PropZ34**2 - 8*s12*s24*s34*PropZ12**2*PropZ34 - 8*s12*s23*s34
     &    *PropZ12*PropZ34**2 - 8*s12*s23*s34*PropZ12**2*PropZ34 - 8*
     &    s12*s14*s34*PropZ12*PropZ34**2 - 8*s12*s14*s34*PropZ12**2*
     &    PropZ34 - 8*s12*s13*s34*PropZ12*PropZ34**2 - 8*s12*s13*s34*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &    32*s14*s23*s34*PropZ12*PropZ34**2 + 32*s14*s23*s34*PropZ12**2
     &    *PropZ34 + 32*s13*s24*s34*PropZ12*PropZ34**2 + 32*s13*s24*s34
     &    *PropZ12**2*PropZ34 + 32*s12*s14*s23*PropZ12*PropZ34**2 + 32*
     &    s12*s14*s23*PropZ12**2*PropZ34 + 32*s12*s13*s24*PropZ12*
     &    PropZ34**2 + 32*s12*s13*s24*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 8
     &    *s14*s23*s24*PropZ12*PropZ34**2 + 8*s14*s23*s24*PropZ12**2*
     &    PropZ34 - 8*s14*s23**2*PropZ12*PropZ34**2 - 8*s14*s23**2*
     &    PropZ12**2*PropZ34 - 8*s14**2*s23*PropZ12*PropZ34**2 - 8*
     &    s14**2*s23*PropZ12**2*PropZ34 - 8*s13*s24**2*PropZ12*
     &    PropZ34**2 - 8*s13*s24**2*PropZ12**2*PropZ34 + 8*s13*s23*s24*
     &    PropZ12*PropZ34**2 + 8*s13*s23*s24*PropZ12**2*PropZ34 + 8*s13
     &    *s14*s24*PropZ12*PropZ34**2 + 8*s13*s14*s24*PropZ12**2*
     &    PropZ34 + 8*s13*s14*s23*PropZ12*PropZ34**2 + 8*s13*s14*s23*
     &    PropZ12**2*PropZ34 - 8*s13**2*s24*PropZ12*PropZ34**2 - 8*
     &    s13**2*s24*PropZ12**2*PropZ34 - 8*s12*s24*s34*PropZ12*
     &    PropZ34**2 - 8*s12*s24*s34*PropZ12**2*PropZ34 - 8*s12*s23*s34
     &    *PropZ12*PropZ34**2 - 8*s12*s23*s34*PropZ12**2*PropZ34 - 8*
     &    s12*s14*s34*PropZ12*PropZ34**2 - 8*s12*s14*s34*PropZ12**2*
     &    PropZ34 - 8*s12*s13*s34*PropZ12*PropZ34**2 - 8*s12*s13*s34*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &    32*s14*s23*s34*PropZ12*PropZ34**2 + 32*s14*s23*s34*PropZ12**2
     &    *PropZ34 + 32*s13*s24*s34*PropZ12*PropZ34**2 + 32*s13*s24*s34
     &    *PropZ12**2*PropZ34 + 32*s12*s14*s23*PropZ12*PropZ34**2 + 32*
     &    s12*s14*s23*PropZ12**2*PropZ34 + 32*s12*s13*s24*PropZ12*
     &    PropZ34**2 + 32*s12*s13*s24*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czz * (  - 
     &    16*s12**(-1)*s14**2*s23**2*sw**2*PropZ12*PropZ34**2 + 32*
     &    s12**(-1)*s13*s14*s23*s24*sw**2*PropZ12*PropZ34**2 - 16*
     &    s12**(-1)*s13**2*s24**2*sw**2*PropZ12*PropZ34**2 - 8*s24**2*
     &    s34*sw**2*PropZ12*PropZ34**2 - 8*s23**2*s34*sw**2*PropZ12*
     &    PropZ34**2 + 16*s14*s23*s34*sw**2*PropZ12*PropZ34**2 - 8*
     &    s14**2*s34*sw**2*PropZ12*PropZ34**2 - 16*s14**2*s23**2*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 + 16*s13*s24*s34*sw**2*
     &    PropZ12*PropZ34**2 + 32*s13*s14*s23*s24*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 - 8*s13**2*s34*sw**2*PropZ12*PropZ34**2 - 
     &    16*s13**2*s24**2*s34**(-1)*sw**2*PropZ12**2*PropZ34 - 16*s12*
     &    s34**2*sw**2*PropZ12*PropZ34**2 - 8*s12*s24**2*sw**2*
     &    PropZ12**2*PropZ34 - 8*s12*s23**2*sw**2*PropZ12**2*PropZ34 + 
     &    16*s12*s14*s23*sw**2*PropZ12**2*PropZ34 - 8*s12*s14**2*sw**2*
     &    PropZ12**2*PropZ34 + 16*s12*s13*s24*sw**2*PropZ12**2*PropZ34
     &     - 8*s12*s13**2*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czz * (  - 
     &    16*s12**2*s34*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 
     &     - 8*s12**(-1)*s14*s23*s24*s34*sw**2*PropZ12*PropZ34**2 + 8*
     &    s12**(-1)*s14*s23**2*s34*sw**2*PropZ12*PropZ34**2 + 8*
     &    s12**(-1)*s14**2*s23*s34*sw**2*PropZ12*PropZ34**2 + 8*
     &    s12**(-1)*s13*s24**2*s34*sw**2*PropZ12*PropZ34**2 - 8*
     &    s12**(-1)*s13*s23*s24*s34*sw**2*PropZ12*PropZ34**2 - 8*
     &    s12**(-1)*s13*s14*s24*s34*sw**2*PropZ12*PropZ34**2 - 8*
     &    s12**(-1)*s13*s14*s23*s34*sw**2*PropZ12*PropZ34**2 + 8*
     &    s12**(-1)*s13**2*s24*s34*sw**2*PropZ12*PropZ34**2 + 8*s24*
     &    s34**2*sw**2*PropZ12*PropZ34**2 + 8*s23*s34**2*sw**2*PropZ12*
     &    PropZ34**2 + 8*s14*s34**2*sw**2*PropZ12*PropZ34**2 - 8*s14*
     &    s23*s24*sw**2*PropZ12*PropZ34**2 - 8*s14*s23*s24*sw**2*
     &    PropZ12**2*PropZ34 + 8*s14*s23**2*sw**2*PropZ12*PropZ34**2 + 
     &    8*s14*s23**2*sw**2*PropZ12**2*PropZ34 + 8*s14**2*s23*sw**2*
     &    PropZ12*PropZ34**2 + 8*s14**2*s23*sw**2*PropZ12**2*PropZ34 + 
     &    8*s13*s34**2*sw**2*PropZ12*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 8*
     &    s13*s24**2*sw**2*PropZ12*PropZ34**2 + 8*s13*s24**2*sw**2*
     &    PropZ12**2*PropZ34 - 8*s13*s23*s24*sw**2*PropZ12*PropZ34**2
     &     - 8*s13*s23*s24*sw**2*PropZ12**2*PropZ34 - 8*s13*s14*s24*
     &    sw**2*PropZ12*PropZ34**2 - 8*s13*s14*s24*sw**2*PropZ12**2*
     &    PropZ34 - 8*s13*s14*s23*sw**2*PropZ12*PropZ34**2 - 8*s13*s14*
     &    s23*sw**2*PropZ12**2*PropZ34 + 8*s13**2*s24*sw**2*PropZ12*
     &    PropZ34**2 + 8*s13**2*s24*sw**2*PropZ12**2*PropZ34 + 8*s12*
     &    s24*s34*sw**2*PropZ12*PropZ34**2 + 8*s12*s24*s34*sw**2*
     &    PropZ12**2*PropZ34 + 8*s12*s23*s34*sw**2*PropZ12*PropZ34**2
     &     + 8*s12*s23*s34*sw**2*PropZ12**2*PropZ34 + 8*s12*s14*s34*
     &    sw**2*PropZ12*PropZ34**2 + 8*s12*s14*s34*sw**2*PropZ12**2*
     &    PropZ34 - 8*s12*s14*s23*s24*s34**(-1)*sw**2*PropZ12**2*
     &    PropZ34 + 8*s12*s14*s23**2*s34**(-1)*sw**2*PropZ12**2*PropZ34
     &     + 8*s12*s14**2*s23*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*
     &    s12*s13*s34*sw**2*PropZ12*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 8*
     &    s12*s13*s34*sw**2*PropZ12**2*PropZ34 + 8*s12*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s12*s13*s23*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s12*s13*s14*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s12*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s12*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s12**2*s24*sw**2*
     &    PropZ12**2*PropZ34 + 8*s12**2*s23*sw**2*PropZ12**2*PropZ34 + 
     &    8*s12**2*s14*sw**2*PropZ12**2*PropZ34 + 8*s12**2*s13*sw**2*
     &    PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czz * ( 
     &     - 8*s14*s23*s24*sw**2*PropZ12*PropZ34**2 - 8*s14*s23*s24*
     &    sw**2*PropZ12**2*PropZ34 + 8*s14*s23**2*sw**2*PropZ12*
     &    PropZ34**2 + 8*s14*s23**2*sw**2*PropZ12**2*PropZ34 + 8*s14**2
     &    *s23*sw**2*PropZ12*PropZ34**2 + 8*s14**2*s23*sw**2*PropZ12**2
     &    *PropZ34 + 8*s13*s24**2*sw**2*PropZ12*PropZ34**2 + 8*s13*
     &    s24**2*sw**2*PropZ12**2*PropZ34 - 8*s13*s23*s24*sw**2*PropZ12
     &    *PropZ34**2 - 8*s13*s23*s24*sw**2*PropZ12**2*PropZ34 - 8*s13*
     &    s14*s24*sw**2*PropZ12*PropZ34**2 - 8*s13*s14*s24*sw**2*
     &    PropZ12**2*PropZ34 - 8*s13*s14*s23*sw**2*PropZ12*PropZ34**2
     &     - 8*s13*s14*s23*sw**2*PropZ12**2*PropZ34 + 8*s13**2*s24*
     &    sw**2*PropZ12*PropZ34**2 + 8*s13**2*s24*sw**2*PropZ12**2*
     &    PropZ34 + 8*s12*s24*s34*sw**2*PropZ12*PropZ34**2 + 8*s12*s24*
     &    s34*sw**2*PropZ12**2*PropZ34 + 8*s12*s23*s34*sw**2*PropZ12*
     &    PropZ34**2 + 8*s12*s23*s34*sw**2*PropZ12**2*PropZ34 + 8*s12*
     &    s14*s34*sw**2*PropZ12*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czz * ( 8*
     &    s12*s14*s34*sw**2*PropZ12**2*PropZ34 + 8*s12*s13*s34*sw**2*
     &    PropZ12*PropZ34**2 + 8*s12*s13*s34*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czbx * ( 
     &     - 32*s14*s23*s34*sw**2*PropZ12*PropZ34**2 - 32*s14*s23*s34*
     &    sw**2*PropZ12**2*PropZ34 - 32*s13*s24*s34*sw**2*PropZ12*
     &    PropZ34**2 - 32*s13*s24*s34*sw**2*PropZ12**2*PropZ34 - 32*s12
     &    *s14*s23*sw**2*PropZ12*PropZ34**2 - 32*s12*s14*s23*sw**2*
     &    PropZ12**2*PropZ34 - 32*s12*s13*s24*sw**2*PropZ12*PropZ34**2
     &     - 32*s12*s13*s24*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*dCz * ( 
     &    32*s14*s23*PropZ12*PropZ34**2 + 32*s14*s23*PropZ12**2*PropZ34
     &     + 32*s13*s24*PropZ12*PropZ34**2 + 32*s13*s24*PropZ12**2*
     &    PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czz * ( 
     &    16*s14*s23*s24*PropZ12**2*PropZ34**2 - 16*s14*s23**2*
     &    PropZ12**2*PropZ34**2 - 16*s14**2*s23*PropZ12**2*PropZ34**2
     &     - 16*s13*s24**2*PropZ12**2*PropZ34**2 + 16*s13*s23*s24*
     &    PropZ12**2*PropZ34**2 + 16*s13*s14*s24*PropZ12**2*PropZ34**2
     &     + 16*s13*s14*s23*PropZ12**2*PropZ34**2 - 16*s13**2*s24*
     &    PropZ12**2*PropZ34**2 - 16*s12*s24*s34*PropZ12**2*PropZ34**2
     &     - 16*s12*s23*s34*PropZ12**2*PropZ34**2 - 16*s12*s14*s34*
     &    PropZ12**2*PropZ34**2 - 16*s12*s13*s34*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &    64*s14*s23*s34*PropZ12**2*PropZ34**2 + 64*s13*s24*s34*
     &    PropZ12**2*PropZ34**2 + 64*s12*s14*s23*PropZ12**2*PropZ34**2
     &     + 64*s12*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*dCz * ( 
     &    32*s14*s23*PropZ12*PropZ34**2 + 32*s14*s23*PropZ12**2*PropZ34
     &     + 32*s13*s24*PropZ12*PropZ34**2 + 32*s13*s24*PropZ12**2*
     &    PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czz * ( 
     &    16*s14*s23*s24*PropZ12**2*PropZ34**2 - 16*s14*s23**2*
     &    PropZ12**2*PropZ34**2 - 16*s14**2*s23*PropZ12**2*PropZ34**2
     &     - 16*s13*s24**2*PropZ12**2*PropZ34**2 + 16*s13*s23*s24*
     &    PropZ12**2*PropZ34**2 + 16*s13*s14*s24*PropZ12**2*PropZ34**2
     &     + 16*s13*s14*s23*PropZ12**2*PropZ34**2 - 16*s13**2*s24*
     &    PropZ12**2*PropZ34**2 - 16*s12*s24*s34*PropZ12**2*PropZ34**2
     &     - 16*s12*s23*s34*PropZ12**2*PropZ34**2 - 16*s12*s14*s34*
     &    PropZ12**2*PropZ34**2 - 16*s12*s13*s34*PropZ12**2*PropZ34**2
     &     )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &    64*s14*s23*s34*PropZ12**2*PropZ34**2 + 64*s13*s24*s34*
     &    PropZ12**2*PropZ34**2 + 64*s12*s14*s23*PropZ12**2*PropZ34**2
     &     + 64*s12*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dCz * (  - 
     &    8*s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34**2 + 8*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*
     &    s14**2*s23*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*s13*s24**2*
     &    sw**2*PropZ12*PropZ34**2 - 8*s12**(-1)*s13*s23*s24*sw**2*
     &    PropZ12*PropZ34**2 - 8*s12**(-1)*s13*s14*s24*sw**2*PropZ12*
     &    PropZ34**2 - 8*s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34**2
     &     + 8*s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34**2 + 8*s24*
     &    s34*sw**2*PropZ12*PropZ34**2 + 8*s23*s34*sw**2*PropZ12*
     &    PropZ34**2 + 8*s14*s34*sw**2*PropZ12*PropZ34**2 - 8*s14*s23*
     &    s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s14*s23**2*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s14**2*s23*s34**(-1)*
     &    sw**2*PropZ12**2*PropZ34 + 8*s13*s34*sw**2*PropZ12*PropZ34**2
     &     + 8*s13*s24**2*s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s13*
     &    s23*s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s13*s14*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dCz * (  - 
     &    8*s13*s14*s23*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s13**2*
     &    s24*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s12*s24*sw**2*
     &    PropZ12**2*PropZ34 + 8*s12*s23*sw**2*PropZ12**2*PropZ34 + 8*
     &    s12*s14*sw**2*PropZ12**2*PropZ34 + 8*s12*s13*sw**2*PropZ12**2
     &    *PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*Cabx*dCz * ( 
     &     - 32*s14*s23*sw**2*PropZ12*PropZ34**2 - 32*s14*s23*sw**2*
     &    PropZ12**2*PropZ34 - 32*s13*s24*sw**2*PropZ12*PropZ34**2 - 32
     &    *s13*s24*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NP*dGl1L * ( 32*s14*
     &    s23*PropZ12*PropZ34**2 + 32*s14*s23*PropZ12**2*PropZ34 + 32*
     &    s13*s24*PropZ12*PropZ34**2 + 32*s13*s24*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NP*dGl1R * ( 32*s14*
     &    s23*PropZ12*PropZ34**2 + 32*s14*s23*PropZ12**2*PropZ34 + 32*
     &    s13*s24*PropZ12*PropZ34**2 + 32*s13*s24*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NP*Cza * (  - 8*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*
     &    s14*s23**2*sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*s14**2*s23*
     &    sw**2*PropZ12*PropZ34**2 + 8*s12**(-1)*s13*s24**2*sw**2*
     &    PropZ12*PropZ34**2 - 8*s12**(-1)*s13*s23*s24*sw**2*PropZ12*
     &    PropZ34**2 - 8*s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34**2
     &     - 8*s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34**2 + 8*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34**2 + 8*s24*s34*
     &    sw**2*PropZ12*PropZ34**2 + 8*s23*s34*sw**2*PropZ12*PropZ34**2
     &     + 8*s14*s34*sw**2*PropZ12*PropZ34**2 - 8*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s14*s23**2*s34**(-1)*
     &    sw**2*PropZ12**2*PropZ34 + 8*s14**2*s23*s34**(-1)*sw**2*
     &    PropZ12**2*PropZ34 + 8*s13*s34*sw**2*PropZ12*PropZ34**2 + 8*
     &    s13*s24**2*s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s13*s23*s24
     &    *s34**(-1)*sw**2*PropZ12**2*PropZ34 - 8*s13*s14*s24*s34**(-1)
     &    *sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NP*Cza * (  - 8*s13*
     &    s14*s23*s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12**2*PropZ34 + 8*s12*s24*sw**2*
     &    PropZ12**2*PropZ34 + 8*s12*s23*sw**2*PropZ12**2*PropZ34 + 8*
     &    s12*s14*sw**2*PropZ12**2*PropZ34 + 8*s12*s13*sw**2*PropZ12**2
     &    *PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NP*Cabx * (  - 32*
     &    s14*s23*sw**2*PropZ12*PropZ34**2 - 32*s14*s23*sw**2*
     &    PropZ12**2*PropZ34 - 32*s13*s24*sw**2*PropZ12*PropZ34**2 - 32
     &    *s13*s24*sw**2*PropZ12**2*PropZ34 )
      MSQBSM = MSQBSM + CV*CVSQ*couplsm*NPSQ*dGl1L*dCz * ( 64*s14*s23*
     &    PropZ12**2*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CVSQ*couplsm*NPSQ*dGl1R*dCz * ( 64*s14*s23*
     &    PropZ12**2*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CVSQ*couplsm*NP*dGl1L * ( 64*s14*s23*
     &    PropZ12**2*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34**2 )
      MSQBSM = MSQBSM + CV*CVSQ*couplsm*NP*dGl1R * ( 64*s14*s23*
     &    PropZ12**2*PropZ34**2 + 64*s13*s24*PropZ12**2*PropZ34**2 )

