C-- Input parameters from MG5 
c$$$      gW = MG5GW
c$$$      CW = MG5CW
c$$$      SW = MG5SW
c$$$      MZ = MDL_MZ
c$$$      WZ = MDL_WZ 
C=================
c$$$      gZ = gW/CW
c$$$      g1 = gZ*SW
c$$$      gE = gW*SW
c$$$      COUPLSM = (gZ**3*MZ)**2
c$$$
c$$$      SWSQ = SW**2
c$$$      CV   = (SWSQ -1.D0/4.D0)
c$$$      CA   = (+1.D0/4.D0)
c$$$      CVA  = CV*CA
c$$$      CVSQ = CV**2
c$$$      CASQ = CA**2
c$$$
c$$$      MZSQ = MZ**2

      s12 = dot(k1,k2)
      s13 = dot(k1,k3)
      s14 = dot(k1,k4)
      s23 = dot(k2,k3)
      s24 = dot(k2,k4)
      s34 = dot(k3,k4)

c$$$      CI = (0D0, 1D0)
      PROPZ12 = 1d0/(dot(k1+k2,k1+k2)-MZSQ+CI*WZ*MZ)
      PROPZ34 = 1d0/(dot(k3+k4,k3+k4)-MZSQ+CI*WZ*MZ)

      PROPZ12C= 1d0/(dot(k1+k2,k1+k2)-MZSQ-CI*WZ*MZ)
      PROPZ34C= 1d0/(dot(k3+k4,k3+k4)-MZSQ-CI*WZ*MZ)

C-- NOTE: FORM does not include the factor of (-I) while  
C--       taking trace with Gamma5.
      eps1234 = epsfun(k1,k2,k3,k4)

C-- SM
      MSQSM =
     &  + CASQ**2*couplsm * ( 32*s14*s23*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 32*s13*s24*PropZ12*PropZ34*PropZ12C*PropZ34C )
      MSQSM = MSQSM + CVSQ*CASQ*couplsm * (  - 64*s14*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 192*s13*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQSM = MSQSM + CVSQ**2*couplsm * ( 32*s14*s23*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 32*s13*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )

C-- BSM

c$$$         Cabx = (2d0*gW**2*Czbx+(gW**2+g1**2)*Czz-gE**2*Caa-
c$$$     >          (gW**2-g1**2)*Cza)/(gW**2-g1**2)

      MSQBSM =
     &  + mzsq**(-2)*couplsm*NPSQ*Caa**2 * ( s12**(-2)*s14**2*s23**2*
     &    s34**(-2)*cw**4*sw**8 - 2*s12**(-2)*s13*s14*s23*s24*s34**(-2)
     &    *cw**4*sw**8 + s12**(-2)*s13**2*s24**2*s34**(-2)*cw**4*sw**8
     &     + 1./2.*s12**(-1)*s24**2*s34**(-1)*cw**4*sw**8 + 1./2.*
     &    s12**(-1)*s23**2*s34**(-1)*cw**4*sw**8 - s12**(-1)*s14*s23*
     &    s34**(-1)*cw**4*sw**8 + 1./2.*s12**(-1)*s14**2*s34**(-1)*
     &    cw**4*sw**8 - s12**(-1)*s13*s24*s34**(-1)*cw**4*sw**8 + 1./2.
     &    *s12**(-1)*s13**2*s34**(-1)*cw**4*sw**8 + cw**4*sw**8 )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*dGl1L**2 * ( 32*s14
     &    *s23*PropZ34*PropZ34C + 32*s14*s23*PropZ12*PropZ12C - 32*s13*
     &    s24*PropZ34*PropZ34C - 32*s13*s24*PropZ34*PropZ12C - 32*s13*
     &    s24*PropZ12*PropZ34C - 32*s13*s24*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*dGl1R**2 * (  - 32*
     &    s14*s23*PropZ34*PropZ34C - 32*s14*s23*PropZ12*PropZ12C + 32*
     &    s13*s24*PropZ34*PropZ34C + 32*s13*s24*PropZ34*PropZ12C + 32*
     &    s13*s24*PropZ12*PropZ34C + 32*s13*s24*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * ( 8*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ34C + 4*s12**(-1)*
     &    s14*s23*s24*sw**2*PropZ34*PropZ12C + 4*s12**(-1)*s14*s23*s24*
     &    sw**2*PropZ12*PropZ34C + 8*s12**(-1)*s14*s23**2*sw**2*PropZ34
     &    *PropZ34C + 8*s12**(-1)*s14**2*s23*sw**2*PropZ34*PropZ34C - 8
     &    *s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ34C - 4*s12**(-1)*
     &    s13*s24**2*sw**2*PropZ34*PropZ12C - 4*s12**(-1)*s13*s24**2*
     &    sw**2*PropZ12*PropZ34C - 8*s12**(-1)*s13*s23*s24*sw**2*
     &    PropZ34*PropZ34C - 8*s12**(-1)*s13*s14*s24*sw**2*PropZ34*
     &    PropZ34C + 8*s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ34C + 4
     &    *s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C + 4*s12**(-1)*
     &    s13*s14*s23*sw**2*PropZ12*PropZ34C - 8*s12**(-1)*s13**2*s24*
     &    sw**2*PropZ34*PropZ34C - 4*s12**(-1)*s13**2*s24*sw**2*PropZ34
     &    *PropZ12C - 4*s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34C - 8
     &    *s24*s34*sw**2*PropZ34*PropZ34C - 4*s24*s34*sw**2*PropZ34*
     &    PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * (  - 4*
     &    s24*s34*sw**2*PropZ12*PropZ34C + 8*s23*s34*sw**2*PropZ34*
     &    PropZ34C + 8*s14*s34*sw**2*PropZ34*PropZ34C + 4*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C + 4*s14*s23*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C + 8*s14*s23*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ12C + 8*s14*s23**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C + 8*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ12C - 8*
     &    s13*s34*sw**2*PropZ34*PropZ34C - 4*s13*s34*sw**2*PropZ34*
     &    PropZ12C - 4*s13*s34*sw**2*PropZ12*PropZ34C - 4*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C - 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C - 8*s13*s24**2*s34**(-1)*sw**2*PropZ12
     &    *PropZ12C - 8*s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C - 
     &    8*s13*s14*s24*s34**(-1)*sw**2*PropZ12*PropZ12C + 4*s13*s14*
     &    s23*s34**(-1)*sw**2*PropZ34*PropZ12C + 4*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ34C + 8*s13*s14*s23*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * (  - 4*
     &    s13**2*s24*s34**(-1)*sw**2*PropZ34*PropZ12C - 4*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34C - 8*s13**2*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C - 4*s12*s24*sw**2*PropZ34*PropZ12C - 4
     &    *s12*s24*sw**2*PropZ12*PropZ34C - 8*s12*s24*sw**2*PropZ12*
     &    PropZ12C + 8*s12*s23*sw**2*PropZ12*PropZ12C + 8*s12*s14*sw**2
     &    *PropZ12*PropZ12C - 4*s12*s13*sw**2*PropZ34*PropZ12C - 4*s12*
     &    s13*sw**2*PropZ12*PropZ34C - 8*s12*s13*sw**2*PropZ12*PropZ12C
     &     )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * (  - 8*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ34C - 4*s12**(-1)*
     &    s14*s23*s24*sw**2*PropZ34*PropZ12C - 4*s12**(-1)*s14*s23*s24*
     &    sw**2*PropZ12*PropZ34C - 8*s12**(-1)*s14*s23**2*sw**2*PropZ34
     &    *PropZ34C - 8*s12**(-1)*s14**2*s23*sw**2*PropZ34*PropZ34C + 8
     &    *s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ34C + 4*s12**(-1)*
     &    s13*s24**2*sw**2*PropZ34*PropZ12C + 4*s12**(-1)*s13*s24**2*
     &    sw**2*PropZ12*PropZ34C + 8*s12**(-1)*s13*s23*s24*sw**2*
     &    PropZ34*PropZ34C + 8*s12**(-1)*s13*s14*s24*sw**2*PropZ34*
     &    PropZ34C - 8*s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ34C - 4
     &    *s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C - 4*s12**(-1)*
     &    s13*s14*s23*sw**2*PropZ12*PropZ34C + 8*s12**(-1)*s13**2*s24*
     &    sw**2*PropZ34*PropZ34C + 4*s12**(-1)*s13**2*s24*sw**2*PropZ34
     &    *PropZ12C + 4*s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34C + 8
     &    *s24*s34*sw**2*PropZ34*PropZ34C + 4*s24*s34*sw**2*PropZ34*
     &    PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * ( 4*s24
     &    *s34*sw**2*PropZ12*PropZ34C - 8*s23*s34*sw**2*PropZ34*
     &    PropZ34C - 8*s14*s34*sw**2*PropZ34*PropZ34C - 4*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C - 4*s14*s23*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C - 8*s14*s23*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ12C - 8*s14*s23**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C - 8*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ12C + 8*
     &    s13*s34*sw**2*PropZ34*PropZ34C + 4*s13*s34*sw**2*PropZ34*
     &    PropZ12C + 4*s13*s34*sw**2*PropZ12*PropZ34C + 4*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C + 8*s13*s24**2*s34**(-1)*sw**2*PropZ12
     &    *PropZ12C + 8*s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C + 
     &    8*s13*s14*s24*s34**(-1)*sw**2*PropZ12*PropZ12C - 4*s13*s14*
     &    s23*s34**(-1)*sw**2*PropZ34*PropZ12C - 4*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ34C - 8*s13*s14*s23*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * ( 4*
     &    s13**2*s24*s34**(-1)*sw**2*PropZ34*PropZ12C + 4*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34C + 8*s13**2*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C + 4*s12*s24*sw**2*PropZ34*PropZ12C + 4
     &    *s12*s24*sw**2*PropZ12*PropZ34C + 8*s12*s24*sw**2*PropZ12*
     &    PropZ12C - 8*s12*s23*sw**2*PropZ12*PropZ12C - 8*s12*s14*sw**2
     &    *PropZ12*PropZ12C + 4*s12*s13*sw**2*PropZ34*PropZ12C + 4*s12*
     &    s13*sw**2*PropZ12*PropZ34C + 8*s12*s13*sw**2*PropZ12*PropZ12C
     &     )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cabx*dGl1L * (  - 
     &    32*s14*s23*sw**2*PropZ34*PropZ34C - 32*s14*s23*sw**2*PropZ12*
     &    PropZ12C + 32*s13*s24*sw**2*PropZ34*PropZ34C + 32*s13*s24*
     &    sw**2*PropZ34*PropZ12C + 32*s13*s24*sw**2*PropZ12*PropZ34C + 
     &    32*s13*s24*sw**2*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*couplsm*NPSQ*Cabx*dGl1R * ( 32*
     &    s14*s23*sw**2*PropZ34*PropZ34C + 32*s14*s23*sw**2*PropZ12*
     &    PropZ12C - 32*s13*s24*sw**2*PropZ34*PropZ34C - 32*s13*s24*
     &    sw**2*PropZ34*PropZ12C - 32*s13*s24*sw**2*PropZ12*PropZ34C - 
     &    32*s13*s24*sw**2*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*eps1234*couplsm*NPSQ*Cza*dGl1L
     &  * (  - 4*s12**(-1)*s24*sw**2*PropZ34*PropZ12C + 4*s12**(-1)*s24
     &    *sw**2*PropZ12*PropZ34C + 4*s12**(-1)*s13*sw**2*PropZ34*
     &    PropZ12C - 4*s12**(-1)*s13*sw**2*PropZ12*PropZ34C + 4*s24*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C - 4*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ34C - 4*s13*s34**(-1)*sw**2*PropZ34*PropZ12C + 4
     &    *s13*s34**(-1)*sw**2*PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*eps1234*couplsm*NPSQ*Cza*dGl1R
     &  * (  - 4*s12**(-1)*s24*sw**2*PropZ34*PropZ12C + 4*s12**(-1)*s24
     &    *sw**2*PropZ12*PropZ34C + 4*s12**(-1)*s13*sw**2*PropZ34*
     &    PropZ12C - 4*s12**(-1)*s13*sw**2*PropZ12*PropZ34C + 4*s24*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C - 4*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ34C - 4*s13*s34**(-1)*sw**2*PropZ34*PropZ12C + 4
     &    *s13*s34**(-1)*sw**2*PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*eps1234*couplsm*NPSQ*Cabx*Cza
     &  * ( 4*s12**(-1)*s24*sw**4*PropZ34*PropZ12C - 4*s12**(-1)*s24*
     &    sw**4*PropZ12*PropZ34C - 4*s12**(-1)*s13*sw**4*PropZ34*
     &    PropZ12C + 4*s12**(-1)*s13*sw**4*PropZ12*PropZ34C - 4*s24*
     &    s34**(-1)*sw**4*PropZ34*PropZ12C + 4*s24*s34**(-1)*sw**4*
     &    PropZ12*PropZ34C + 4*s13*s34**(-1)*sw**4*PropZ34*PropZ12C - 4
     &    *s13*s34**(-1)*sw**4*PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CVA*mzsq**(-2)*eps1234*couplsm*NPSQ*Caa*Czbx
     &  * ( 4*s12**(-1)*s24*cw**2*sw**4*PropZ12C*PropZ34C - 4*s12**(-1)
     &    *s24*cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13*cw**2*
     &    sw**4*PropZ12C*PropZ34C + 4*s12**(-1)*s13*cw**2*sw**4*PropZ12
     &    *PropZ34 + 4*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 4*
     &    s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s13*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C + 4*s13*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*dGl1L**2 * ( 32*s14
     &    *s23*PropZ34*PropZ12C*PropZ34C + 32*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C + 32*s14*s23*PropZ12*PropZ34*PropZ34C + 32*s14*s23*
     &    PropZ12*PropZ34*PropZ12C - 64*s13*s24*PropZ34*PropZ12C*
     &    PropZ34C - 64*s13*s24*PropZ12*PropZ12C*PropZ34C - 64*s13*s24*
     &    PropZ12*PropZ34*PropZ34C - 64*s13*s24*PropZ12*PropZ34*
     &    PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*dGl1R**2 * (  - 32*
     &    s14*s23*PropZ34*PropZ12C*PropZ34C - 32*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C - 32*s14*s23*PropZ12*PropZ34*PropZ34C - 32*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 64*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 64*s13*s24*PropZ12*PropZ12C*PropZ34C + 64
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 64*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * ( 8*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 8*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C - 8*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C - 8*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C + 8*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C + 8*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C - 8*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * (  - 8*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C - 8*s24*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C - 8*s24*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C + 4*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 4*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s14*s34*sw**2
     &    *PropZ34*PropZ12C*PropZ34C + 4*s14*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 8*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 8*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 8*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 8*s13*
     &    s34*sw**2*PropZ12*PropZ34*PropZ34C - 8*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C*PropZ34C - 8*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * (  - 4*
     &    s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13
     &    *s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*s14
     &    *s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*
     &    s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 8*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 8*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 8*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 8*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 8*s12*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 8*s12*s24*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s23*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*
     &    s23*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s14*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s12*s14*sw**2*PropZ12*PropZ34*PropZ12C
     &     - 8*s12*s13*sw**2*PropZ12*PropZ12C*PropZ34C - 8*s12*s13*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * (  - 8*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 8*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C + 8*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 8*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C - 8*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 8*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C + 8*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * ( 8*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C + 8*s24*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C + 8*s24*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C - 4*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     - 4*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*s14*s34*sw**2
     &    *PropZ34*PropZ12C*PropZ34C - 4*s14*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 8*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 8*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 8*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 8*s13*
     &    s34*sw**2*PropZ12*PropZ34*PropZ34C + 8*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 8*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * ( 4*s13
     &    *s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*
     &    s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s13*s14*
     &    s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s14*s24
     &    *s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 8*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 8*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 8*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 8*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 8*s12*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 8*s12*s24*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s12*s23*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*
     &    s23*sw**2*PropZ12*PropZ34*PropZ12C - 4*s12*s14*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s12*s14*sw**2*PropZ12*PropZ34*PropZ12C
     &     + 8*s12*s13*sw**2*PropZ12*PropZ12C*PropZ34C + 8*s12*s13*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cabx*dGl1L * (  - 
     &    16*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*sw**2
     &    *PropZ12*PropZ12C*PropZ34C - 16*s14*s23*sw**2*PropZ12*PropZ34
     &    *PropZ34C - 16*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C + 32*
     &    s13*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 32*s13*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 32*s13*s24*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 32*s13*s24*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NPSQ*Cabx*dGl1R * ( 16*
     &    s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 16*s14*s23*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 16*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C - 32*s13
     &    *s24*sw**2*PropZ34*PropZ12C*PropZ34C - 32*s13*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 32*s13*s24*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 32*s13*s24*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*eps1234*couplsm*NPSQ*Cza*dGl1L
     &  * (  - 8*s12**(-1)*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 8*
     &    s12**(-1)*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*s12**(-1)*
     &    s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s12**(-1)*s23*sw**2*
     &    PropZ12*PropZ34*PropZ34C + 4*s12**(-1)*s14*sw**2*PropZ34*
     &    PropZ12C*PropZ34C - 4*s12**(-1)*s14*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 8*s12**(-1)*s13*sw**2*PropZ34*PropZ12C*PropZ34C - 
     &    8*s12**(-1)*s13*sw**2*PropZ12*PropZ34*PropZ34C - 8*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 8*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 4*s23*s34**(-1)*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 4*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s14*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 8
     &    *s13*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 8*s13*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*eps1234*couplsm*NPSQ*Cza*dGl1R
     &  * (  - 8*s12**(-1)*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 8*
     &    s12**(-1)*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*s12**(-1)*
     &    s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s12**(-1)*s23*sw**2*
     &    PropZ12*PropZ34*PropZ34C + 4*s12**(-1)*s14*sw**2*PropZ34*
     &    PropZ12C*PropZ34C - 4*s12**(-1)*s14*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 8*s12**(-1)*s13*sw**2*PropZ34*PropZ12C*PropZ34C - 
     &    8*s12**(-1)*s13*sw**2*PropZ12*PropZ34*PropZ34C - 8*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 8*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 4*s23*s34**(-1)*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 4*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s14*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 8
     &    *s13*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 8*s13*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*eps1234*couplsm*NPSQ*Caa*dCz
     &  * ( 4*s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 4
     &    *s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*eps1234*couplsm*NP*Caa * ( 4*
     &    s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVA*couplsm*NPSQ*dGl1L**2 * ( 64*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 128*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVA*couplsm*NPSQ*dGl1R**2 * (  - 64*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 128*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L**2 * ( 16*
     &    s14*s23*PropZ34*PropZ34C + 16*s14*s23*PropZ12*PropZ12C + 16*
     &    s13*s24*PropZ34*PropZ34C + 16*s13*s24*PropZ34*PropZ12C + 16*
     &    s13*s24*PropZ12*PropZ34C + 16*s13*s24*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*dGl1L * ( 
     &     - 32*s14*s23*PropZ34*PropZ12C - 32*s14*s23*PropZ12*PropZ34C
     &     )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R**2 * ( 16*
     &    s14*s23*PropZ34*PropZ34C + 16*s14*s23*PropZ12*PropZ12C + 16*
     &    s13*s24*PropZ34*PropZ34C + 16*s13*s24*PropZ34*PropZ12C + 16*
     &    s13*s24*PropZ12*PropZ34C + 16*s13*s24*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * (  - 4
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ34C - 2*s12**(-1)*
     &    s14*s23*s24*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s14*s23*s24*
     &    sw**2*PropZ12*PropZ34C + 4*s12**(-1)*s14*s23**2*sw**2*PropZ34
     &    *PropZ34C - 2*s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C - 2
     &    *s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34C + 4*s12**(-1)*
     &    s14**2*s23*sw**2*PropZ34*PropZ34C - 2*s12**(-1)*s14**2*s23*
     &    sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s14**2*s23*sw**2*PropZ12
     &    *PropZ34C + 4*s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ34C + 2
     &    *s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C + 2*s12**(-1)*
     &    s13*s24**2*sw**2*PropZ12*PropZ34C - 4*s12**(-1)*s13*s23*s24*
     &    sw**2*PropZ34*PropZ34C + 2*s12**(-1)*s13*s23*s24*sw**2*
     &    PropZ34*PropZ12C + 2*s12**(-1)*s13*s23*s24*sw**2*PropZ12*
     &    PropZ34C - 4*s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ34C + 2
     &    *s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C + 2*s12**(-1)*
     &    s13*s14*s24*sw**2*PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * (  - 4
     &    *s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ34C - 2*s12**(-1)*
     &    s13*s14*s23*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s13*s14*s23*
     &    sw**2*PropZ12*PropZ34C + 4*s12**(-1)*s13**2*s24*sw**2*PropZ34
     &    *PropZ34C + 2*s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C + 2
     &    *s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34C + 4*s24*s34*
     &    sw**2*PropZ34*PropZ34C + 2*s24*s34*sw**2*PropZ34*PropZ12C + 2
     &    *s24*s34*sw**2*PropZ12*PropZ34C + 4*s23*s34*sw**2*PropZ34*
     &    PropZ34C - 2*s23*s34*sw**2*PropZ34*PropZ12C - 2*s23*s34*sw**2
     &    *PropZ12*PropZ34C + 4*s14*s34*sw**2*PropZ34*PropZ34C - 2*s14*
     &    s34*sw**2*PropZ34*PropZ12C - 2*s14*s34*sw**2*PropZ12*PropZ34C
     &     - 2*s14*s23*s24*s34**(-1)*sw**2*PropZ34*PropZ12C - 2*s14*s23
     &    *s24*s34**(-1)*sw**2*PropZ12*PropZ34C - 4*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C - 2*s14*s23**2*s34**(-1)*
     &    sw**2*PropZ34*PropZ12C - 2*s14*s23**2*s34**(-1)*sw**2*PropZ12
     &    *PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * ( 4*
     &    s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C - 2*s14**2*s23*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C - 2*s14**2*s23*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12
     &    *PropZ12C + 4*s13*s34*sw**2*PropZ34*PropZ34C + 2*s13*s34*
     &    sw**2*PropZ34*PropZ12C + 2*s13*s34*sw**2*PropZ12*PropZ34C + 2
     &    *s13*s24**2*s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C + 2*s13*s23*s24*s34**(-1)*sw**2*
     &    PropZ34*PropZ12C + 2*s13*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ34C - 4*s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C + 2
     &    *s13*s14*s24*s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s13*s14*s24
     &    *s34**(-1)*sw**2*PropZ12*PropZ34C - 4*s13*s14*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C - 2*s13*s14*s23*s34**(-1)*sw**2*
     &    PropZ34*PropZ12C - 2*s13*s14*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * (  - 4
     &    *s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ12C + 2*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s13**2*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C + 4*s13**2*s24*s34**(-1)*sw**2*PropZ12
     &    *PropZ12C + 2*s12*s24*sw**2*PropZ34*PropZ12C + 2*s12*s24*
     &    sw**2*PropZ12*PropZ34C + 4*s12*s24*sw**2*PropZ12*PropZ12C - 2
     &    *s12*s23*sw**2*PropZ34*PropZ12C - 2*s12*s23*sw**2*PropZ12*
     &    PropZ34C + 4*s12*s23*sw**2*PropZ12*PropZ12C - 2*s12*s14*sw**2
     &    *PropZ34*PropZ12C - 2*s12*s14*sw**2*PropZ12*PropZ34C + 4*s12*
     &    s14*sw**2*PropZ12*PropZ12C + 2*s12*s13*sw**2*PropZ34*PropZ12C
     &     + 2*s12*s13*sw**2*PropZ12*PropZ34C + 4*s12*s13*sw**2*PropZ12
     &    *PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * (  - 4
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ34C - 2*s12**(-1)*
     &    s14*s23*s24*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s14*s23*s24*
     &    sw**2*PropZ12*PropZ34C + 4*s12**(-1)*s14*s23**2*sw**2*PropZ34
     &    *PropZ34C - 2*s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C - 2
     &    *s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34C + 4*s12**(-1)*
     &    s14**2*s23*sw**2*PropZ34*PropZ34C - 2*s12**(-1)*s14**2*s23*
     &    sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s14**2*s23*sw**2*PropZ12
     &    *PropZ34C + 4*s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ34C + 2
     &    *s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C + 2*s12**(-1)*
     &    s13*s24**2*sw**2*PropZ12*PropZ34C - 4*s12**(-1)*s13*s23*s24*
     &    sw**2*PropZ34*PropZ34C + 2*s12**(-1)*s13*s23*s24*sw**2*
     &    PropZ34*PropZ12C + 2*s12**(-1)*s13*s23*s24*sw**2*PropZ12*
     &    PropZ34C - 4*s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ34C + 2
     &    *s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C + 2*s12**(-1)*
     &    s13*s14*s24*sw**2*PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * (  - 4
     &    *s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ34C - 2*s12**(-1)*
     &    s13*s14*s23*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s13*s14*s23*
     &    sw**2*PropZ12*PropZ34C + 4*s12**(-1)*s13**2*s24*sw**2*PropZ34
     &    *PropZ34C + 2*s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C + 2
     &    *s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34C + 4*s24*s34*
     &    sw**2*PropZ34*PropZ34C + 2*s24*s34*sw**2*PropZ34*PropZ12C + 2
     &    *s24*s34*sw**2*PropZ12*PropZ34C + 4*s23*s34*sw**2*PropZ34*
     &    PropZ34C - 2*s23*s34*sw**2*PropZ34*PropZ12C - 2*s23*s34*sw**2
     &    *PropZ12*PropZ34C + 4*s14*s34*sw**2*PropZ34*PropZ34C - 2*s14*
     &    s34*sw**2*PropZ34*PropZ12C - 2*s14*s34*sw**2*PropZ12*PropZ34C
     &     - 2*s14*s23*s24*s34**(-1)*sw**2*PropZ34*PropZ12C - 2*s14*s23
     &    *s24*s34**(-1)*sw**2*PropZ12*PropZ34C - 4*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C - 2*s14*s23**2*s34**(-1)*
     &    sw**2*PropZ34*PropZ12C - 2*s14*s23**2*s34**(-1)*sw**2*PropZ12
     &    *PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * ( 4*
     &    s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C - 2*s14**2*s23*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C - 2*s14**2*s23*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12
     &    *PropZ12C + 4*s13*s34*sw**2*PropZ34*PropZ34C + 2*s13*s34*
     &    sw**2*PropZ34*PropZ12C + 2*s13*s34*sw**2*PropZ12*PropZ34C + 2
     &    *s13*s24**2*s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C + 2*s13*s23*s24*s34**(-1)*sw**2*
     &    PropZ34*PropZ12C + 2*s13*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ34C - 4*s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C + 2
     &    *s13*s14*s24*s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s13*s14*s24
     &    *s34**(-1)*sw**2*PropZ12*PropZ34C - 4*s13*s14*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C - 2*s13*s14*s23*s34**(-1)*sw**2*
     &    PropZ34*PropZ12C - 2*s13*s14*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * (  - 4
     &    *s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ12C + 2*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s13**2*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C + 4*s13**2*s24*s34**(-1)*sw**2*PropZ12
     &    *PropZ12C + 2*s12*s24*sw**2*PropZ34*PropZ12C + 2*s12*s24*
     &    sw**2*PropZ12*PropZ34C + 4*s12*s24*sw**2*PropZ12*PropZ12C - 2
     &    *s12*s23*sw**2*PropZ34*PropZ12C - 2*s12*s23*sw**2*PropZ12*
     &    PropZ34C + 4*s12*s23*sw**2*PropZ12*PropZ12C - 2*s12*s14*sw**2
     &    *PropZ34*PropZ12C - 2*s12*s14*sw**2*PropZ12*PropZ34C + 4*s12*
     &    s14*sw**2*PropZ12*PropZ12C + 2*s12*s13*sw**2*PropZ34*PropZ12C
     &     + 2*s12*s13*sw**2*PropZ12*PropZ34C + 4*s12*s13*sw**2*PropZ12
     &    *PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza**2 * ( 4*
     &    s12**(-2)*s14**2*s23**2*sw**4*PropZ34*PropZ34C - 8*s12**(-2)*
     &    s13*s14*s23*s24*sw**4*PropZ34*PropZ34C + 4*s12**(-2)*s13**2*
     &    s24**2*sw**4*PropZ34*PropZ34C + 2*s12**(-1)*s24**2*s34*sw**4*
     &    PropZ34*PropZ34C + 2*s12**(-1)*s23**2*s34*sw**4*PropZ34*
     &    PropZ34C - 4*s12**(-1)*s14*s23*s34*sw**4*PropZ34*PropZ34C + 2
     &    *s12**(-1)*s14**2*s34*sw**4*PropZ34*PropZ34C - 4*s12**(-1)*
     &    s13*s24*s34*sw**4*PropZ34*PropZ34C + 2*s12**(-1)*s13**2*s34*
     &    sw**4*PropZ34*PropZ34C + 4*s34**2*sw**4*PropZ34*PropZ34C + 2*
     &    s24**2*sw**4*PropZ34*PropZ12C + 2*s24**2*sw**4*PropZ12*
     &    PropZ34C - 2*s23**2*sw**4*PropZ34*PropZ12C - 2*s23**2*sw**4*
     &    PropZ12*PropZ34C - 4*s14*s23*sw**4*PropZ34*PropZ12C - 4*s14*
     &    s23*sw**4*PropZ12*PropZ34C - 2*s14**2*sw**4*PropZ34*PropZ12C
     &     - 2*s14**2*sw**4*PropZ12*PropZ34C + 4*s14**2*s23**2*
     &    s34**(-2)*sw**4*PropZ12*PropZ12C + 4*s13*s24*sw**4*PropZ34*
     &    PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cza**2 * ( 4*s13*
     &    s24*sw**4*PropZ12*PropZ34C - 8*s13*s14*s23*s24*s34**(-2)*
     &    sw**4*PropZ12*PropZ12C + 2*s13**2*sw**4*PropZ34*PropZ12C + 2*
     &    s13**2*sw**4*PropZ12*PropZ34C + 4*s13**2*s24**2*s34**(-2)*
     &    sw**4*PropZ12*PropZ12C + 2*s12*s24**2*s34**(-1)*sw**4*PropZ12
     &    *PropZ12C + 2*s12*s23**2*s34**(-1)*sw**4*PropZ12*PropZ12C - 4
     &    *s12*s14*s23*s34**(-1)*sw**4*PropZ12*PropZ12C + 2*s12*s14**2*
     &    s34**(-1)*sw**4*PropZ12*PropZ12C - 4*s12*s13*s24*s34**(-1)*
     &    sw**4*PropZ12*PropZ12C + 2*s12*s13**2*s34**(-1)*sw**4*PropZ12
     &    *PropZ12C + 4*s12**2*sw**4*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*dGl1L * (  - 
     &    16*s14*s23*sw**2*PropZ34*PropZ34C + 16*s14*s23*sw**2*PropZ34*
     &    PropZ12C + 16*s14*s23*sw**2*PropZ12*PropZ34C - 16*s14*s23*
     &    sw**2*PropZ12*PropZ12C - 16*s13*s24*sw**2*PropZ34*PropZ34C - 
     &    16*s13*s24*sw**2*PropZ34*PropZ12C - 16*s13*s24*sw**2*PropZ12*
     &    PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*dGl1R * (  - 
     &    16*s14*s23*sw**2*PropZ34*PropZ34C + 16*s14*s23*sw**2*PropZ34*
     &    PropZ12C + 16*s14*s23*sw**2*PropZ12*PropZ34C - 16*s14*s23*
     &    sw**2*PropZ12*PropZ12C - 16*s13*s24*sw**2*PropZ34*PropZ34C - 
     &    16*s13*s24*sw**2*PropZ34*PropZ12C - 16*s13*s24*sw**2*PropZ12*
     &    PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * ( 4*
     &    s12**(-1)*s14*s23*s24*sw**4*PropZ34*PropZ34C + 2*s12**(-1)*
     &    s14*s23*s24*sw**4*PropZ34*PropZ12C + 2*s12**(-1)*s14*s23*s24*
     &    sw**4*PropZ12*PropZ34C - 4*s12**(-1)*s14*s23**2*sw**4*PropZ34
     &    *PropZ34C + 2*s12**(-1)*s14*s23**2*sw**4*PropZ34*PropZ12C + 2
     &    *s12**(-1)*s14*s23**2*sw**4*PropZ12*PropZ34C - 4*s12**(-1)*
     &    s14**2*s23*sw**4*PropZ34*PropZ34C + 2*s12**(-1)*s14**2*s23*
     &    sw**4*PropZ34*PropZ12C + 2*s12**(-1)*s14**2*s23*sw**4*PropZ12
     &    *PropZ34C - 4*s12**(-1)*s13*s24**2*sw**4*PropZ34*PropZ34C - 2
     &    *s12**(-1)*s13*s24**2*sw**4*PropZ34*PropZ12C - 2*s12**(-1)*
     &    s13*s24**2*sw**4*PropZ12*PropZ34C + 4*s12**(-1)*s13*s23*s24*
     &    sw**4*PropZ34*PropZ34C - 2*s12**(-1)*s13*s23*s24*sw**4*
     &    PropZ34*PropZ12C - 2*s12**(-1)*s13*s23*s24*sw**4*PropZ12*
     &    PropZ34C + 4*s12**(-1)*s13*s14*s24*sw**4*PropZ34*PropZ34C - 2
     &    *s12**(-1)*s13*s14*s24*sw**4*PropZ34*PropZ12C - 2*s12**(-1)*
     &    s13*s14*s24*sw**4*PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * ( 4*
     &    s12**(-1)*s13*s14*s23*sw**4*PropZ34*PropZ34C + 2*s12**(-1)*
     &    s13*s14*s23*sw**4*PropZ34*PropZ12C + 2*s12**(-1)*s13*s14*s23*
     &    sw**4*PropZ12*PropZ34C - 4*s12**(-1)*s13**2*s24*sw**4*PropZ34
     &    *PropZ34C - 2*s12**(-1)*s13**2*s24*sw**4*PropZ34*PropZ12C - 2
     &    *s12**(-1)*s13**2*s24*sw**4*PropZ12*PropZ34C - 4*s24*s34*
     &    sw**4*PropZ34*PropZ34C - 2*s24*s34*sw**4*PropZ34*PropZ12C - 2
     &    *s24*s34*sw**4*PropZ12*PropZ34C - 4*s23*s34*sw**4*PropZ34*
     &    PropZ34C + 2*s23*s34*sw**4*PropZ34*PropZ12C + 2*s23*s34*sw**4
     &    *PropZ12*PropZ34C - 4*s14*s34*sw**4*PropZ34*PropZ34C + 2*s14*
     &    s34*sw**4*PropZ34*PropZ12C + 2*s14*s34*sw**4*PropZ12*PropZ34C
     &     + 2*s14*s23*s24*s34**(-1)*sw**4*PropZ34*PropZ12C + 2*s14*s23
     &    *s24*s34**(-1)*sw**4*PropZ12*PropZ34C + 4*s14*s23*s24*
     &    s34**(-1)*sw**4*PropZ12*PropZ12C + 2*s14*s23**2*s34**(-1)*
     &    sw**4*PropZ34*PropZ12C + 2*s14*s23**2*s34**(-1)*sw**4*PropZ12
     &    *PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * (  - 4*
     &    s14*s23**2*s34**(-1)*sw**4*PropZ12*PropZ12C + 2*s14**2*s23*
     &    s34**(-1)*sw**4*PropZ34*PropZ12C + 2*s14**2*s23*s34**(-1)*
     &    sw**4*PropZ12*PropZ34C - 4*s14**2*s23*s34**(-1)*sw**4*PropZ12
     &    *PropZ12C - 4*s13*s34*sw**4*PropZ34*PropZ34C - 2*s13*s34*
     &    sw**4*PropZ34*PropZ12C - 2*s13*s34*sw**4*PropZ12*PropZ34C - 2
     &    *s13*s24**2*s34**(-1)*sw**4*PropZ34*PropZ12C - 2*s13*s24**2*
     &    s34**(-1)*sw**4*PropZ12*PropZ34C - 4*s13*s24**2*s34**(-1)*
     &    sw**4*PropZ12*PropZ12C - 2*s13*s23*s24*s34**(-1)*sw**4*
     &    PropZ34*PropZ12C - 2*s13*s23*s24*s34**(-1)*sw**4*PropZ12*
     &    PropZ34C + 4*s13*s23*s24*s34**(-1)*sw**4*PropZ12*PropZ12C - 2
     &    *s13*s14*s24*s34**(-1)*sw**4*PropZ34*PropZ12C - 2*s13*s14*s24
     &    *s34**(-1)*sw**4*PropZ12*PropZ34C + 4*s13*s14*s24*s34**(-1)*
     &    sw**4*PropZ12*PropZ12C + 2*s13*s14*s23*s34**(-1)*sw**4*
     &    PropZ34*PropZ12C + 2*s13*s14*s23*s34**(-1)*sw**4*PropZ12*
     &    PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * ( 4*s13
     &    *s14*s23*s34**(-1)*sw**4*PropZ12*PropZ12C - 2*s13**2*s24*
     &    s34**(-1)*sw**4*PropZ34*PropZ12C - 2*s13**2*s24*s34**(-1)*
     &    sw**4*PropZ12*PropZ34C - 4*s13**2*s24*s34**(-1)*sw**4*PropZ12
     &    *PropZ12C - 2*s12*s24*sw**4*PropZ34*PropZ12C - 2*s12*s24*
     &    sw**4*PropZ12*PropZ34C - 4*s12*s24*sw**4*PropZ12*PropZ12C + 2
     &    *s12*s23*sw**4*PropZ34*PropZ12C + 2*s12*s23*sw**4*PropZ12*
     &    PropZ34C - 4*s12*s23*sw**4*PropZ12*PropZ12C + 2*s12*s14*sw**4
     &    *PropZ34*PropZ12C + 2*s12*s14*sw**4*PropZ12*PropZ34C - 4*s12*
     &    s14*sw**4*PropZ12*PropZ12C - 2*s12*s13*sw**4*PropZ34*PropZ12C
     &     - 2*s12*s13*sw**4*PropZ12*PropZ34C - 4*s12*s13*sw**4*PropZ12
     &    *PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx**2 * ( 8*s14*
     &    s23*sw**4*PropZ34*PropZ34C - 8*s14*s23*sw**4*PropZ34*PropZ12C
     &     - 8*s14*s23*sw**4*PropZ12*PropZ34C + 8*s14*s23*sw**4*PropZ12
     &    *PropZ12C + 8*s13*s24*sw**4*PropZ34*PropZ34C + 8*s13*s24*
     &    sw**4*PropZ34*PropZ12C + 8*s13*s24*sw**4*PropZ12*PropZ34C + 8
     &    *s13*s24*sw**4*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czz * ( 2*
     &    s24**2*cw**2*sw**4*PropZ12C*PropZ34C + 2*s24**2*cw**2*sw**4*
     &    PropZ12*PropZ34 - 2*s23**2*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s23**2*cw**2*sw**4*PropZ12*PropZ34 - 4*s14*s23*cw**2*sw**4*
     &    PropZ12C*PropZ34C - 4*s14*s23*cw**2*sw**4*PropZ12*PropZ34 - 2
     &    *s14**2*cw**2*sw**4*PropZ12C*PropZ34C - 2*s14**2*cw**2*sw**4*
     &    PropZ12*PropZ34 + 4*s13*s24*cw**2*sw**4*PropZ12C*PropZ34C + 4
     &    *s13*s24*cw**2*sw**4*PropZ12*PropZ34 + 2*s13**2*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 2*s13**2*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czbx * ( 2*
     &    s12**(-1)*s14*s23*s24*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s14*s23*s24*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s14*s23**2*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s14*s23**2*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s14**2*s23*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s14**2*s23*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13*s24**2*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s13*s24**2*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13*s23*s24*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s13*s23*s24*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13*s14*s24*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s13*s14*s24*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s13*s14*s23*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s13*s14*s23*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13**2*s24*cw**2*sw**4*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czbx * (  - 2*
     &    s12**(-1)*s13**2*s24*cw**2*sw**4*PropZ12*PropZ34 - 2*s24*s34*
     &    cw**2*sw**4*PropZ12C*PropZ34C - 2*s24*s34*cw**2*sw**4*PropZ12
     &    *PropZ34 + 2*s23*s34*cw**2*sw**4*PropZ12C*PropZ34C + 2*s23*
     &    s34*cw**2*sw**4*PropZ12*PropZ34 + 2*s14*s34*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 2*s14*s34*cw**2*sw**4*PropZ12*PropZ34 + 2
     &    *s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*s14*
     &    s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*s14*s23**2*
     &    s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*s14*s23**2*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*s14**2*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*s14**2*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s13*s34*cw**2*sw**4
     &    *PropZ12C*PropZ34C - 2*s13*s34*cw**2*sw**4*PropZ12*PropZ34 - 
     &    2*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s13*
     &    s24**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s13*s23*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czbx * (  - 2*
     &    s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s13*s14
     &    *s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s13*s14*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*s13*s14*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*s13*s14*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s13**2*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s13**2*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s12*s24*cw**2*sw**4
     &    *PropZ12C*PropZ34C - 2*s12*s24*cw**2*sw**4*PropZ12*PropZ34 + 
     &    2*s12*s23*cw**2*sw**4*PropZ12C*PropZ34C + 2*s12*s23*cw**2*
     &    sw**4*PropZ12*PropZ34 + 2*s12*s14*cw**2*sw**4*PropZ12C*
     &    PropZ34C + 2*s12*s14*cw**2*sw**4*PropZ12*PropZ34 - 2*s12*s13*
     &    cw**2*sw**4*PropZ12C*PropZ34C - 2*s12*s13*cw**2*sw**4*PropZ12
     &    *PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*eps1234*couplsm*NPSQ*Cza*dGl1L
     &  * ( 2*s12**(-1)*s24*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s24*
     &    sw**2*PropZ12*PropZ34C - 2*s12**(-1)*s23*sw**2*PropZ34*
     &    PropZ12C + 2*s12**(-1)*s23*sw**2*PropZ12*PropZ34C + 2*
     &    s12**(-1)*s14*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s14*sw**2*
     &    PropZ12*PropZ34C - 2*s12**(-1)*s13*sw**2*PropZ34*PropZ12C + 2
     &    *s12**(-1)*s13*sw**2*PropZ12*PropZ34C - 2*s24*s34**(-1)*sw**2
     &    *PropZ34*PropZ12C + 2*s24*s34**(-1)*sw**2*PropZ12*PropZ34C - 
     &    2*s23*s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s23*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C + 2*s14*s34**(-1)*sw**2*PropZ34*
     &    PropZ12C - 2*s14*s34**(-1)*sw**2*PropZ12*PropZ34C + 2*s13*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C - 2*s13*s34**(-1)*sw**2*
     &    PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*eps1234*couplsm*NPSQ*Cza*dGl1R
     &  * (  - 2*s12**(-1)*s24*sw**2*PropZ34*PropZ12C + 2*s12**(-1)*s24
     &    *sw**2*PropZ12*PropZ34C + 2*s12**(-1)*s23*sw**2*PropZ34*
     &    PropZ12C - 2*s12**(-1)*s23*sw**2*PropZ12*PropZ34C - 2*
     &    s12**(-1)*s14*sw**2*PropZ34*PropZ12C + 2*s12**(-1)*s14*sw**2*
     &    PropZ12*PropZ34C + 2*s12**(-1)*s13*sw**2*PropZ34*PropZ12C - 2
     &    *s12**(-1)*s13*sw**2*PropZ12*PropZ34C + 2*s24*s34**(-1)*sw**2
     &    *PropZ34*PropZ12C - 2*s24*s34**(-1)*sw**2*PropZ12*PropZ34C + 
     &    2*s23*s34**(-1)*sw**2*PropZ34*PropZ12C - 2*s23*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C - 2*s14*s34**(-1)*sw**2*PropZ34*
     &    PropZ12C + 2*s14*s34**(-1)*sw**2*PropZ12*PropZ34C - 2*s13*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s13*s34**(-1)*sw**2*
     &    PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L**2 * ( 16*
     &    s14*s23*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C + 16*s14*s23*PropZ12*PropZ34*PropZ34C + 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 32*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 32*s13*s24*PropZ12*PropZ12C*PropZ34C + 32
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 32*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*dGl1L * ( 
     &     - 32*s14*s23*PropZ34*PropZ12C*PropZ34C - 32*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C - 32*s14*s23*PropZ12*PropZ34*PropZ34C - 32*
     &    s14*s23*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R**2 * ( 16*
     &    s14*s23*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C + 16*s14*s23*PropZ12*PropZ34*PropZ34C + 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 32*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 32*s13*s24*PropZ12*PropZ12C*PropZ34C + 32
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 32*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * (  - 4
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s24*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s24*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 4*s13*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * (  - 4
     &    *s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*
     &    s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*
     &    s13**2*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*
     &    s13**2*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*
     &    s24*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*s24*sw**2*PropZ12
     &    *PropZ34*PropZ12C + 4*s12*s13*sw**2*PropZ12*PropZ12C*PropZ34C
     &     + 4*s12*s13*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * (  - 4
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s24*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s24*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 4*s13*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * (  - 4
     &    *s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*
     &    s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*
     &    s13**2*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*
     &    s13**2*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*
     &    s24*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*s24*sw**2*PropZ12
     &    *PropZ34*PropZ12C + 4*s12*s13*sw**2*PropZ12*PropZ12C*PropZ34C
     &     + 4*s12*s13*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Cabx*dGl1L * (  - 
     &    16*s13*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s13*s24*sw**2
     &    *PropZ12*PropZ12C*PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ34
     &    *PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Cabx*dGl1R * (  - 
     &    16*s13*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s13*s24*sw**2
     &    *PropZ12*PropZ12C*PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ34
     &    *PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Caa*dCz * ( 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     + 2*s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 + 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 2*s12**(-1)*s14**2*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C + 2*s12**(-1)*s14**2*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s12**(-1)*s13*
     &    s24**2*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s12**(-1)*
     &    s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     - 2*s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C - 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 2*s12**(-1)*s13*s14*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NPSQ*Caa*dCz * ( 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 2*s24*cw**2*sw**4*PropZ12C*PropZ34C - 2*s24
     &    *cw**2*sw**4*PropZ12*PropZ34 + 2*s23*cw**2*sw**4*PropZ12C*
     &    PropZ34C + 2*s23*cw**2*sw**4*PropZ12*PropZ34 + 2*s14*cw**2*
     &    sw**4*PropZ12C*PropZ34C + 2*s14*cw**2*sw**4*PropZ12*PropZ34
     &     - 2*s13*cw**2*sw**4*PropZ12C*PropZ34C - 2*s13*cw**2*sw**4*
     &    PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NP*Caa * ( 2*s12**(-1)*
     &    s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     + 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12C*
     &    PropZ34C + 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 + 2*s12**(-1)*s14**2*s23*s34**(-1)*cw**2*
     &    sw**4*PropZ12C*PropZ34C + 2*s12**(-1)*s14**2*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12*PropZ34 - 2*s12**(-1)*s13*s24**2*
     &    s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s12**(-1)*s13*
     &    s24**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s12**(-1)*
     &    s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 + 2*s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*
     &    sw**4*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*couplsm*NP*Caa * ( 2*s12**(-1)*
     &    s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     - 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 2*s24*cw**2*sw**4*PropZ12C*PropZ34C - 2*s24*cw**2*
     &    sw**4*PropZ12*PropZ34 + 2*s23*cw**2*sw**4*PropZ12C*PropZ34C
     &     + 2*s23*cw**2*sw**4*PropZ12*PropZ34 + 2*s14*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 2*s14*cw**2*sw**4*PropZ12*PropZ34 - 2*s13
     &    *cw**2*sw**4*PropZ12C*PropZ34C - 2*s13*cw**2*sw**4*PropZ12*
     &    PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*eps1234*couplsm*NPSQ*Cza*dGl1L
     &  * ( 4*s12**(-1)*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*s12**(-1)*
     &    s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s12**(-1)*s23*sw**2*
     &    PropZ12*PropZ34*PropZ34C + 4*s12**(-1)*s14*sw**2*PropZ34*
     &    PropZ12C*PropZ34C - 4*s12**(-1)*s14*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 4*s12**(-1)*s13*sw**2*PropZ34*PropZ12C*PropZ34C + 
     &    4*s12**(-1)*s13*sw**2*PropZ12*PropZ34*PropZ34C + 4*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 4*s23*s34**(-1)*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 4*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s14*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4
     &    *s13*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*eps1234*couplsm*NPSQ*Cza*dGl1R
     &  * (  - 4*s12**(-1)*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s12**(-1)*
     &    s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s12**(-1)*s23*sw**2*
     &    PropZ12*PropZ34*PropZ34C - 4*s12**(-1)*s14*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 4*s12**(-1)*s14*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 4*s12**(-1)*s13*sw**2*PropZ34*PropZ12C*PropZ34C - 
     &    4*s12**(-1)*s13*sw**2*PropZ12*PropZ34*PropZ34C - 4*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C - 4*s23*s34**(-1)*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 4*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s14*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s14*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4
     &    *s13*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CASQ*couplsm*NPSQ*dGl1L**2 * ( 32*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ*couplsm*NPSQ*dGl1R*dGl1L * (  - 64*s14*s23
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ*couplsm*NPSQ*dGl1R**2 * ( 32*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-2)*couplsm*NPSQ*Czz**2 * ( 16*
     &    s14**2*s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C - 32*s13*s14*
     &    s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s13**2*s24**2*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 8*s12*s24**2*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 8*s12*s23**2*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s14*s23*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 8*s12*s14**2*s34*PropZ12*PropZ34*PropZ12C
     &    *PropZ34C - 16*s12*s13*s24*s34*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 8*s12*s13**2*s34*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     + 16*s12**2*s34**2*PropZ12*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-2)*couplsm*NPSQ*Czbx*Czz * ( 16
     &    *s14*s23*s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14*
     &    s23**2*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14**2*s23*
     &    s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s13*s24**2*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s13*s23*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s13*s14*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s13*s14*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s13**2*s24*s34*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C - 16*s12*s24*s34**2*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s23*s34**2*PropZ12*PropZ34
     &    *PropZ12C*PropZ34C - 16*s12*s14*s34**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 16*s12*s14*s23*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s14*s23**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s14**2*s23*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s13*s34**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-2)*couplsm*NPSQ*Czbx*Czz * ( 
     &     - 16*s12*s13*s24**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*
     &    s12*s13*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*
     &    s13*s14*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*s13*
     &    s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s13**2*s24
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12**2*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12**2*s23*s34*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C - 16*s12**2*s14*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12**2*s13*s34*PropZ12*PropZ34
     &    *PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-2)*couplsm*NPSQ*Czbx**2 * ( 32*
     &    s14*s23*s34**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s13*s24
     &    *s34**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s14*s23*
     &    s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s13*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s12**2*s14*s23*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C + 32*s12**2*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-1)*couplsm*NPSQ*Czz*dCz * ( 16*
     &    s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14*s23**2
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s13*s24**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 16*s13*s23*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 16*s13*s14*s24*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     + 16*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*
     &    s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s24*s34
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s23*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s13*s34*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-1)*couplsm*NPSQ*Czbx*dCz * ( 64
     &    *s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24*
     &    s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-1)*couplsm*NP*Czz * ( 16*s14*
     &    s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14*s23**2*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s13*s24**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 16*s13*s23*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 16*s13*s14*s24*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     + 16*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*
     &    s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s24*s34
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s23*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s13*s34*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-1)*couplsm*NP*Czbx * ( 64*s14*
     &    s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s14*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 64*s12*s13*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*couplsm * ( 32*s14*s23*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 32*s13*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*couplsm*NPSQ*dCz**2 * ( 32*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*couplsm*NP*dCz * ( 64*s14*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 64*s13*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L**2 * ( 16*
     &    s14*s23*PropZ34*PropZ34C + 16*s14*s23*PropZ12*PropZ12C + 16*
     &    s13*s24*PropZ34*PropZ34C + 16*s13*s24*PropZ34*PropZ12C + 16*
     &    s13*s24*PropZ12*PropZ34C + 16*s13*s24*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*dGl1L * ( 32
     &    *s14*s23*PropZ34*PropZ12C + 32*s14*s23*PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R**2 * ( 16*
     &    s14*s23*PropZ34*PropZ34C + 16*s14*s23*PropZ12*PropZ12C + 16*
     &    s13*s24*PropZ34*PropZ34C + 16*s13*s24*PropZ34*PropZ12C + 16*
     &    s13*s24*PropZ12*PropZ34C + 16*s13*s24*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * (  - 4
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ34C - 2*s12**(-1)*
     &    s14*s23*s24*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s14*s23*s24*
     &    sw**2*PropZ12*PropZ34C + 4*s12**(-1)*s14*s23**2*sw**2*PropZ34
     &    *PropZ34C + 2*s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C + 2
     &    *s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34C + 4*s12**(-1)*
     &    s14**2*s23*sw**2*PropZ34*PropZ34C + 2*s12**(-1)*s14**2*s23*
     &    sw**2*PropZ34*PropZ12C + 2*s12**(-1)*s14**2*s23*sw**2*PropZ12
     &    *PropZ34C + 4*s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ34C + 2
     &    *s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C + 2*s12**(-1)*
     &    s13*s24**2*sw**2*PropZ12*PropZ34C - 4*s12**(-1)*s13*s23*s24*
     &    sw**2*PropZ34*PropZ34C - 2*s12**(-1)*s13*s23*s24*sw**2*
     &    PropZ34*PropZ12C - 2*s12**(-1)*s13*s23*s24*sw**2*PropZ12*
     &    PropZ34C - 4*s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ34C - 2
     &    *s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*
     &    s13*s14*s24*sw**2*PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * (  - 4
     &    *s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ34C - 2*s12**(-1)*
     &    s13*s14*s23*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s13*s14*s23*
     &    sw**2*PropZ12*PropZ34C + 4*s12**(-1)*s13**2*s24*sw**2*PropZ34
     &    *PropZ34C + 2*s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C + 2
     &    *s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34C + 4*s24*s34*
     &    sw**2*PropZ34*PropZ34C + 2*s24*s34*sw**2*PropZ34*PropZ12C + 2
     &    *s24*s34*sw**2*PropZ12*PropZ34C + 4*s23*s34*sw**2*PropZ34*
     &    PropZ34C + 2*s23*s34*sw**2*PropZ34*PropZ12C + 2*s23*s34*sw**2
     &    *PropZ12*PropZ34C + 4*s14*s34*sw**2*PropZ34*PropZ34C + 2*s14*
     &    s34*sw**2*PropZ34*PropZ12C + 2*s14*s34*sw**2*PropZ12*PropZ34C
     &     - 2*s14*s23*s24*s34**(-1)*sw**2*PropZ34*PropZ12C - 2*s14*s23
     &    *s24*s34**(-1)*sw**2*PropZ12*PropZ34C - 4*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C + 2*s14*s23**2*s34**(-1)*
     &    sw**2*PropZ34*PropZ12C + 2*s14*s23**2*s34**(-1)*sw**2*PropZ12
     &    *PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * ( 4*
     &    s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C + 2*s14**2*s23*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s14**2*s23*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12
     &    *PropZ12C + 4*s13*s34*sw**2*PropZ34*PropZ34C + 2*s13*s34*
     &    sw**2*PropZ34*PropZ12C + 2*s13*s34*sw**2*PropZ12*PropZ34C + 2
     &    *s13*s24**2*s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C - 2*s13*s23*s24*s34**(-1)*sw**2*
     &    PropZ34*PropZ12C - 2*s13*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ34C - 4*s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C - 2
     &    *s13*s14*s24*s34**(-1)*sw**2*PropZ34*PropZ12C - 2*s13*s14*s24
     &    *s34**(-1)*sw**2*PropZ12*PropZ34C - 4*s13*s14*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C - 2*s13*s14*s23*s34**(-1)*sw**2*
     &    PropZ34*PropZ12C - 2*s13*s14*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1L * (  - 4
     &    *s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ12C + 2*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s13**2*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C + 4*s13**2*s24*s34**(-1)*sw**2*PropZ12
     &    *PropZ12C + 2*s12*s24*sw**2*PropZ34*PropZ12C + 2*s12*s24*
     &    sw**2*PropZ12*PropZ34C + 4*s12*s24*sw**2*PropZ12*PropZ12C + 2
     &    *s12*s23*sw**2*PropZ34*PropZ12C + 2*s12*s23*sw**2*PropZ12*
     &    PropZ34C + 4*s12*s23*sw**2*PropZ12*PropZ12C + 2*s12*s14*sw**2
     &    *PropZ34*PropZ12C + 2*s12*s14*sw**2*PropZ12*PropZ34C + 4*s12*
     &    s14*sw**2*PropZ12*PropZ12C + 2*s12*s13*sw**2*PropZ34*PropZ12C
     &     + 2*s12*s13*sw**2*PropZ12*PropZ34C + 4*s12*s13*sw**2*PropZ12
     &    *PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * (  - 4
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ34C - 2*s12**(-1)*
     &    s14*s23*s24*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s14*s23*s24*
     &    sw**2*PropZ12*PropZ34C + 4*s12**(-1)*s14*s23**2*sw**2*PropZ34
     &    *PropZ34C + 2*s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C + 2
     &    *s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34C + 4*s12**(-1)*
     &    s14**2*s23*sw**2*PropZ34*PropZ34C + 2*s12**(-1)*s14**2*s23*
     &    sw**2*PropZ34*PropZ12C + 2*s12**(-1)*s14**2*s23*sw**2*PropZ12
     &    *PropZ34C + 4*s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ34C + 2
     &    *s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C + 2*s12**(-1)*
     &    s13*s24**2*sw**2*PropZ12*PropZ34C - 4*s12**(-1)*s13*s23*s24*
     &    sw**2*PropZ34*PropZ34C - 2*s12**(-1)*s13*s23*s24*sw**2*
     &    PropZ34*PropZ12C - 2*s12**(-1)*s13*s23*s24*sw**2*PropZ12*
     &    PropZ34C - 4*s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ34C - 2
     &    *s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*
     &    s13*s14*s24*sw**2*PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * (  - 4
     &    *s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ34C - 2*s12**(-1)*
     &    s13*s14*s23*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s13*s14*s23*
     &    sw**2*PropZ12*PropZ34C + 4*s12**(-1)*s13**2*s24*sw**2*PropZ34
     &    *PropZ34C + 2*s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C + 2
     &    *s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34C + 4*s24*s34*
     &    sw**2*PropZ34*PropZ34C + 2*s24*s34*sw**2*PropZ34*PropZ12C + 2
     &    *s24*s34*sw**2*PropZ12*PropZ34C + 4*s23*s34*sw**2*PropZ34*
     &    PropZ34C + 2*s23*s34*sw**2*PropZ34*PropZ12C + 2*s23*s34*sw**2
     &    *PropZ12*PropZ34C + 4*s14*s34*sw**2*PropZ34*PropZ34C + 2*s14*
     &    s34*sw**2*PropZ34*PropZ12C + 2*s14*s34*sw**2*PropZ12*PropZ34C
     &     - 2*s14*s23*s24*s34**(-1)*sw**2*PropZ34*PropZ12C - 2*s14*s23
     &    *s24*s34**(-1)*sw**2*PropZ12*PropZ34C - 4*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C + 2*s14*s23**2*s34**(-1)*
     &    sw**2*PropZ34*PropZ12C + 2*s14*s23**2*s34**(-1)*sw**2*PropZ12
     &    *PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * ( 4*
     &    s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C + 2*s14**2*s23*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s14**2*s23*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12
     &    *PropZ12C + 4*s13*s34*sw**2*PropZ34*PropZ34C + 2*s13*s34*
     &    sw**2*PropZ34*PropZ12C + 2*s13*s34*sw**2*PropZ12*PropZ34C + 2
     &    *s13*s24**2*s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C - 2*s13*s23*s24*s34**(-1)*sw**2*
     &    PropZ34*PropZ12C - 2*s13*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ34C - 4*s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C - 2
     &    *s13*s14*s24*s34**(-1)*sw**2*PropZ34*PropZ12C - 2*s13*s14*s24
     &    *s34**(-1)*sw**2*PropZ12*PropZ34C - 4*s13*s14*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C - 2*s13*s14*s23*s34**(-1)*sw**2*
     &    PropZ34*PropZ12C - 2*s13*s14*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*dGl1R * (  - 4
     &    *s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ12C + 2*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s13**2*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C + 4*s13**2*s24*s34**(-1)*sw**2*PropZ12
     &    *PropZ12C + 2*s12*s24*sw**2*PropZ34*PropZ12C + 2*s12*s24*
     &    sw**2*PropZ12*PropZ34C + 4*s12*s24*sw**2*PropZ12*PropZ12C + 2
     &    *s12*s23*sw**2*PropZ34*PropZ12C + 2*s12*s23*sw**2*PropZ12*
     &    PropZ34C + 4*s12*s23*sw**2*PropZ12*PropZ12C + 2*s12*s14*sw**2
     &    *PropZ34*PropZ12C + 2*s12*s14*sw**2*PropZ12*PropZ34C + 4*s12*
     &    s14*sw**2*PropZ12*PropZ12C + 2*s12*s13*sw**2*PropZ34*PropZ12C
     &     + 2*s12*s13*sw**2*PropZ12*PropZ34C + 4*s12*s13*sw**2*PropZ12
     &    *PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza**2 * ( 4*
     &    s12**(-2)*s14**2*s23**2*sw**4*PropZ34*PropZ34C - 8*s12**(-2)*
     &    s13*s14*s23*s24*sw**4*PropZ34*PropZ34C + 4*s12**(-2)*s13**2*
     &    s24**2*sw**4*PropZ34*PropZ34C + 2*s12**(-1)*s24**2*s34*sw**4*
     &    PropZ34*PropZ34C + 2*s12**(-1)*s23**2*s34*sw**4*PropZ34*
     &    PropZ34C - 4*s12**(-1)*s14*s23*s34*sw**4*PropZ34*PropZ34C + 2
     &    *s12**(-1)*s14**2*s34*sw**4*PropZ34*PropZ34C + 4*s12**(-1)*
     &    s14**2*s23**2*s34**(-1)*sw**4*PropZ34*PropZ12C + 4*s12**(-1)*
     &    s14**2*s23**2*s34**(-1)*sw**4*PropZ12*PropZ34C - 4*s12**(-1)*
     &    s13*s24*s34*sw**4*PropZ34*PropZ34C - 8*s12**(-1)*s13*s14*s23*
     &    s24*s34**(-1)*sw**4*PropZ34*PropZ12C - 8*s12**(-1)*s13*s14*
     &    s23*s24*s34**(-1)*sw**4*PropZ12*PropZ34C + 2*s12**(-1)*s13**2
     &    *s34*sw**4*PropZ34*PropZ34C + 4*s12**(-1)*s13**2*s24**2*
     &    s34**(-1)*sw**4*PropZ34*PropZ12C + 4*s12**(-1)*s13**2*s24**2*
     &    s34**(-1)*sw**4*PropZ12*PropZ34C + 4*s34**2*sw**4*PropZ34*
     &    PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza**2 * ( 2*
     &    s24**2*sw**4*PropZ34*PropZ12C + 2*s24**2*sw**4*PropZ12*
     &    PropZ34C + 2*s23**2*sw**4*PropZ34*PropZ12C + 2*s23**2*sw**4*
     &    PropZ12*PropZ34C - 4*s14*s23*sw**4*PropZ34*PropZ12C - 4*s14*
     &    s23*sw**4*PropZ12*PropZ34C + 2*s14**2*sw**4*PropZ34*PropZ12C
     &     + 2*s14**2*sw**4*PropZ12*PropZ34C + 4*s14**2*s23**2*
     &    s34**(-2)*sw**4*PropZ12*PropZ12C - 4*s13*s24*sw**4*PropZ34*
     &    PropZ12C - 4*s13*s24*sw**4*PropZ12*PropZ34C - 8*s13*s14*s23*
     &    s24*s34**(-2)*sw**4*PropZ12*PropZ12C + 2*s13**2*sw**4*PropZ34
     &    *PropZ12C + 2*s13**2*sw**4*PropZ12*PropZ34C + 4*s13**2*s24**2
     &    *s34**(-2)*sw**4*PropZ12*PropZ12C + 4*s12*s34*sw**4*PropZ34*
     &    PropZ12C + 4*s12*s34*sw**4*PropZ12*PropZ34C + 2*s12*s24**2*
     &    s34**(-1)*sw**4*PropZ12*PropZ12C + 2*s12*s23**2*s34**(-1)*
     &    sw**4*PropZ12*PropZ12C - 4*s12*s14*s23*s34**(-1)*sw**4*
     &    PropZ12*PropZ12C + 2*s12*s14**2*s34**(-1)*sw**4*PropZ12*
     &    PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza**2 * (  - 4*
     &    s12*s13*s24*s34**(-1)*sw**4*PropZ12*PropZ12C + 2*s12*s13**2*
     &    s34**(-1)*sw**4*PropZ12*PropZ12C + 4*s12**2*sw**4*PropZ12*
     &    PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*dGl1L * (  - 
     &    16*s14*s23*sw**2*PropZ34*PropZ34C - 16*s14*s23*sw**2*PropZ34*
     &    PropZ12C - 16*s14*s23*sw**2*PropZ12*PropZ34C - 16*s14*s23*
     &    sw**2*PropZ12*PropZ12C - 16*s13*s24*sw**2*PropZ34*PropZ34C - 
     &    16*s13*s24*sw**2*PropZ34*PropZ12C - 16*s13*s24*sw**2*PropZ12*
     &    PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*dGl1R * (  - 
     &    16*s14*s23*sw**2*PropZ34*PropZ34C - 16*s14*s23*sw**2*PropZ34*
     &    PropZ12C - 16*s14*s23*sw**2*PropZ12*PropZ34C - 16*s14*s23*
     &    sw**2*PropZ12*PropZ12C - 16*s13*s24*sw**2*PropZ34*PropZ34C - 
     &    16*s13*s24*sw**2*PropZ34*PropZ12C - 16*s13*s24*sw**2*PropZ12*
     &    PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * ( 4*
     &    s12**(-1)*s14*s23*s24*sw**4*PropZ34*PropZ34C + 2*s12**(-1)*
     &    s14*s23*s24*sw**4*PropZ34*PropZ12C + 2*s12**(-1)*s14*s23*s24*
     &    sw**4*PropZ12*PropZ34C - 4*s12**(-1)*s14*s23**2*sw**4*PropZ34
     &    *PropZ34C - 2*s12**(-1)*s14*s23**2*sw**4*PropZ34*PropZ12C - 2
     &    *s12**(-1)*s14*s23**2*sw**4*PropZ12*PropZ34C - 4*s12**(-1)*
     &    s14**2*s23*sw**4*PropZ34*PropZ34C - 2*s12**(-1)*s14**2*s23*
     &    sw**4*PropZ34*PropZ12C - 2*s12**(-1)*s14**2*s23*sw**4*PropZ12
     &    *PropZ34C - 4*s12**(-1)*s13*s24**2*sw**4*PropZ34*PropZ34C - 2
     &    *s12**(-1)*s13*s24**2*sw**4*PropZ34*PropZ12C - 2*s12**(-1)*
     &    s13*s24**2*sw**4*PropZ12*PropZ34C + 4*s12**(-1)*s13*s23*s24*
     &    sw**4*PropZ34*PropZ34C + 2*s12**(-1)*s13*s23*s24*sw**4*
     &    PropZ34*PropZ12C + 2*s12**(-1)*s13*s23*s24*sw**4*PropZ12*
     &    PropZ34C + 4*s12**(-1)*s13*s14*s24*sw**4*PropZ34*PropZ34C + 2
     &    *s12**(-1)*s13*s14*s24*sw**4*PropZ34*PropZ12C + 2*s12**(-1)*
     &    s13*s14*s24*sw**4*PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * ( 4*
     &    s12**(-1)*s13*s14*s23*sw**4*PropZ34*PropZ34C + 2*s12**(-1)*
     &    s13*s14*s23*sw**4*PropZ34*PropZ12C + 2*s12**(-1)*s13*s14*s23*
     &    sw**4*PropZ12*PropZ34C - 4*s12**(-1)*s13**2*s24*sw**4*PropZ34
     &    *PropZ34C - 2*s12**(-1)*s13**2*s24*sw**4*PropZ34*PropZ12C - 2
     &    *s12**(-1)*s13**2*s24*sw**4*PropZ12*PropZ34C - 4*s24*s34*
     &    sw**4*PropZ34*PropZ34C - 2*s24*s34*sw**4*PropZ34*PropZ12C - 2
     &    *s24*s34*sw**4*PropZ12*PropZ34C - 4*s23*s34*sw**4*PropZ34*
     &    PropZ34C - 2*s23*s34*sw**4*PropZ34*PropZ12C - 2*s23*s34*sw**4
     &    *PropZ12*PropZ34C - 4*s14*s34*sw**4*PropZ34*PropZ34C - 2*s14*
     &    s34*sw**4*PropZ34*PropZ12C - 2*s14*s34*sw**4*PropZ12*PropZ34C
     &     + 2*s14*s23*s24*s34**(-1)*sw**4*PropZ34*PropZ12C + 2*s14*s23
     &    *s24*s34**(-1)*sw**4*PropZ12*PropZ34C + 4*s14*s23*s24*
     &    s34**(-1)*sw**4*PropZ12*PropZ12C - 2*s14*s23**2*s34**(-1)*
     &    sw**4*PropZ34*PropZ12C - 2*s14*s23**2*s34**(-1)*sw**4*PropZ12
     &    *PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * (  - 4*
     &    s14*s23**2*s34**(-1)*sw**4*PropZ12*PropZ12C - 2*s14**2*s23*
     &    s34**(-1)*sw**4*PropZ34*PropZ12C - 2*s14**2*s23*s34**(-1)*
     &    sw**4*PropZ12*PropZ34C - 4*s14**2*s23*s34**(-1)*sw**4*PropZ12
     &    *PropZ12C - 4*s13*s34*sw**4*PropZ34*PropZ34C - 2*s13*s34*
     &    sw**4*PropZ34*PropZ12C - 2*s13*s34*sw**4*PropZ12*PropZ34C - 2
     &    *s13*s24**2*s34**(-1)*sw**4*PropZ34*PropZ12C - 2*s13*s24**2*
     &    s34**(-1)*sw**4*PropZ12*PropZ34C - 4*s13*s24**2*s34**(-1)*
     &    sw**4*PropZ12*PropZ12C + 2*s13*s23*s24*s34**(-1)*sw**4*
     &    PropZ34*PropZ12C + 2*s13*s23*s24*s34**(-1)*sw**4*PropZ12*
     &    PropZ34C + 4*s13*s23*s24*s34**(-1)*sw**4*PropZ12*PropZ12C + 2
     &    *s13*s14*s24*s34**(-1)*sw**4*PropZ34*PropZ12C + 2*s13*s14*s24
     &    *s34**(-1)*sw**4*PropZ12*PropZ34C + 4*s13*s14*s24*s34**(-1)*
     &    sw**4*PropZ12*PropZ12C + 2*s13*s14*s23*s34**(-1)*sw**4*
     &    PropZ34*PropZ12C + 2*s13*s14*s23*s34**(-1)*sw**4*PropZ12*
     &    PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Cza * ( 4*s13
     &    *s14*s23*s34**(-1)*sw**4*PropZ12*PropZ12C - 2*s13**2*s24*
     &    s34**(-1)*sw**4*PropZ34*PropZ12C - 2*s13**2*s24*s34**(-1)*
     &    sw**4*PropZ12*PropZ34C - 4*s13**2*s24*s34**(-1)*sw**4*PropZ12
     &    *PropZ12C - 2*s12*s24*sw**4*PropZ34*PropZ12C - 2*s12*s24*
     &    sw**4*PropZ12*PropZ34C - 4*s12*s24*sw**4*PropZ12*PropZ12C - 2
     &    *s12*s23*sw**4*PropZ34*PropZ12C - 2*s12*s23*sw**4*PropZ12*
     &    PropZ34C - 4*s12*s23*sw**4*PropZ12*PropZ12C - 2*s12*s14*sw**4
     &    *PropZ34*PropZ12C - 2*s12*s14*sw**4*PropZ12*PropZ34C - 4*s12*
     &    s14*sw**4*PropZ12*PropZ12C - 2*s12*s13*sw**4*PropZ34*PropZ12C
     &     - 2*s12*s13*sw**4*PropZ12*PropZ34C - 4*s12*s13*sw**4*PropZ12
     &    *PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx**2 * ( 8*s14*
     &    s23*sw**4*PropZ34*PropZ34C + 8*s14*s23*sw**4*PropZ34*PropZ12C
     &     + 8*s14*s23*sw**4*PropZ12*PropZ34C + 8*s14*s23*sw**4*PropZ12
     &    *PropZ12C + 8*s13*s24*sw**4*PropZ34*PropZ34C + 8*s13*s24*
     &    sw**4*PropZ34*PropZ12C + 8*s13*s24*sw**4*PropZ12*PropZ34C + 8
     &    *s13*s24*sw**4*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czz * ( 4*
     &    s12**(-1)*s14**2*s23**2*s34**(-1)*cw**2*sw**4*PropZ12C*
     &    PropZ34C + 4*s12**(-1)*s14**2*s23**2*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 8*s12**(-1)*s13*s14*s23*s24*s34**(-1)*cw**2
     &    *sw**4*PropZ12C*PropZ34C - 8*s12**(-1)*s13*s14*s23*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13**2*
     &    s24**2*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 4*s12**(-1)*
     &    s13**2*s24**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s24**2*cw**2*sw**4*PropZ12C*PropZ34C + 2*s24**2*cw**2*sw**4*
     &    PropZ12*PropZ34 + 2*s23**2*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s23**2*cw**2*sw**4*PropZ12*PropZ34 - 4*s14*s23*cw**2*sw**4*
     &    PropZ12C*PropZ34C - 4*s14*s23*cw**2*sw**4*PropZ12*PropZ34 + 2
     &    *s14**2*cw**2*sw**4*PropZ12C*PropZ34C + 2*s14**2*cw**2*sw**4*
     &    PropZ12*PropZ34 - 4*s13*s24*cw**2*sw**4*PropZ12C*PropZ34C - 4
     &    *s13*s24*cw**2*sw**4*PropZ12*PropZ34 + 2*s13**2*cw**2*sw**4*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czz * ( 2*
     &    s13**2*cw**2*sw**4*PropZ12*PropZ34 + 4*s12*s34*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 4*s12*s34*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czbx * ( 2*
     &    s12**(-1)*s14*s23*s24*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s14*s23*s24*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s14*s23**2*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s14*s23**2*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s14**2*s23*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s14**2*s23*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13*s24**2*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s13*s24**2*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s13*s23*s24*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s13*s23*s24*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s13*s14*s24*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s13*s14*s24*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s13*s14*s23*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s13*s14*s23*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13**2*s24*cw**2*sw**4*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czbx * (  - 2*
     &    s12**(-1)*s13**2*s24*cw**2*sw**4*PropZ12*PropZ34 - 2*s24*s34*
     &    cw**2*sw**4*PropZ12C*PropZ34C - 2*s24*s34*cw**2*sw**4*PropZ12
     &    *PropZ34 - 2*s23*s34*cw**2*sw**4*PropZ12C*PropZ34C - 2*s23*
     &    s34*cw**2*sw**4*PropZ12*PropZ34 - 2*s14*s34*cw**2*sw**4*
     &    PropZ12C*PropZ34C - 2*s14*s34*cw**2*sw**4*PropZ12*PropZ34 + 2
     &    *s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*s14*
     &    s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s14*s23**2*
     &    s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s14*s23**2*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s14**2*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s14**2*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s13*s34*cw**2*sw**4
     &    *PropZ12C*PropZ34C - 2*s13*s34*cw**2*sw**4*PropZ12*PropZ34 - 
     &    2*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s13*
     &    s24**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*s13*s23*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*Caa*Czbx * ( 2*s13
     &    *s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*s13*s14*
     &    s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*s13*s14*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*s13*s14*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*s13*s14*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s13**2*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s13**2*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s12*s24*cw**2*sw**4
     &    *PropZ12C*PropZ34C - 2*s12*s24*cw**2*sw**4*PropZ12*PropZ34 - 
     &    2*s12*s23*cw**2*sw**4*PropZ12C*PropZ34C - 2*s12*s23*cw**2*
     &    sw**4*PropZ12*PropZ34 - 2*s12*s14*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 2*s12*s14*cw**2*sw**4*PropZ12*PropZ34 - 2*s12*s13*
     &    cw**2*sw**4*PropZ12C*PropZ34C - 2*s12*s13*cw**2*sw**4*PropZ12
     &    *PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*eps1234*couplsm*NPSQ*Cza*dGl1L
     &  * ( 2*s12**(-1)*s24*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s24*
     &    sw**2*PropZ12*PropZ34C + 2*s12**(-1)*s23*sw**2*PropZ34*
     &    PropZ12C - 2*s12**(-1)*s23*sw**2*PropZ12*PropZ34C - 2*
     &    s12**(-1)*s14*sw**2*PropZ34*PropZ12C + 2*s12**(-1)*s14*sw**2*
     &    PropZ12*PropZ34C - 2*s12**(-1)*s13*sw**2*PropZ34*PropZ12C + 2
     &    *s12**(-1)*s13*sw**2*PropZ12*PropZ34C - 2*s24*s34**(-1)*sw**2
     &    *PropZ34*PropZ12C + 2*s24*s34**(-1)*sw**2*PropZ12*PropZ34C + 
     &    2*s23*s34**(-1)*sw**2*PropZ34*PropZ12C - 2*s23*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C - 2*s14*s34**(-1)*sw**2*PropZ34*
     &    PropZ12C + 2*s14*s34**(-1)*sw**2*PropZ12*PropZ34C + 2*s13*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C - 2*s13*s34**(-1)*sw**2*
     &    PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*eps1234*couplsm*NPSQ*Cza*dGl1R
     &  * (  - 2*s12**(-1)*s24*sw**2*PropZ34*PropZ12C + 2*s12**(-1)*s24
     &    *sw**2*PropZ12*PropZ34C - 2*s12**(-1)*s23*sw**2*PropZ34*
     &    PropZ12C + 2*s12**(-1)*s23*sw**2*PropZ12*PropZ34C + 2*
     &    s12**(-1)*s14*sw**2*PropZ34*PropZ12C - 2*s12**(-1)*s14*sw**2*
     &    PropZ12*PropZ34C + 2*s12**(-1)*s13*sw**2*PropZ34*PropZ12C - 2
     &    *s12**(-1)*s13*sw**2*PropZ12*PropZ34C + 2*s24*s34**(-1)*sw**2
     &    *PropZ34*PropZ12C - 2*s24*s34**(-1)*sw**2*PropZ12*PropZ34C - 
     &    2*s23*s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s23*s34**(-1)*
     &    sw**2*PropZ12*PropZ34C + 2*s14*s34**(-1)*sw**2*PropZ34*
     &    PropZ12C - 2*s14*s34**(-1)*sw**2*PropZ12*PropZ34C - 2*s13*
     &    s34**(-1)*sw**2*PropZ34*PropZ12C + 2*s13*s34**(-1)*sw**2*
     &    PropZ12*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L**2 * ( 16*
     &    s14*s23*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C + 16*s14*s23*PropZ12*PropZ34*PropZ34C + 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 32*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 32*s13*s24*PropZ12*PropZ12C*PropZ34C + 32
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 32*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*dGl1L * ( 32
     &    *s14*s23*PropZ34*PropZ12C*PropZ34C + 32*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C + 32*s14*s23*PropZ12*PropZ34*PropZ34C + 32*
     &    s14*s23*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R**2 * ( 16*
     &    s14*s23*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C + 16*s14*s23*PropZ12*PropZ34*PropZ34C + 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 32*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 32*s13*s24*PropZ12*PropZ12C*PropZ34C + 32
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 32*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * (  - 4
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * ( 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s24*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s24*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C + 4*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 4*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s14*s34*sw**2
     &    *PropZ34*PropZ12C*PropZ34C + 4*s14*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s13*
     &    s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1L * (  - 4
     &    *s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*
     &    s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*
     &    s14*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s14
     &    *s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*s14*s23
     &    *s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 4*s12*s24*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s23*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*
     &    s23*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s14*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s12*s14*sw**2*PropZ12*PropZ34*PropZ12C
     &     + 4*s12*s13*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*s13*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * (  - 4
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * ( 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s24*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s24*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C + 4*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 4*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s14*s34*sw**2
     &    *PropZ34*PropZ12C*PropZ34C + 4*s14*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s13*
     &    s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dGl1R * (  - 4
     &    *s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*
     &    s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*
     &    s14*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s14
     &    *s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*s14*s23
     &    *s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 4*s12*s24*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s23*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*
     &    s23*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s14*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s12*s14*sw**2*PropZ12*PropZ34*PropZ12C
     &     + 4*s12*s13*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*s13*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cabx*dGl1L * (  - 
     &    16*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*sw**2
     &    *PropZ12*PropZ12C*PropZ34C - 16*s14*s23*sw**2*PropZ12*PropZ34
     &    *PropZ34C - 16*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C - 16*
     &    s13*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s13*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Cabx*dGl1R * (  - 
     &    16*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*sw**2
     &    *PropZ12*PropZ12C*PropZ34C - 16*s14*s23*sw**2*PropZ12*PropZ34
     &    *PropZ34C - 16*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C - 16*
     &    s13*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s13*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Caa*dCz * ( 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     + 2*s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C - 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 - 2*s12**(-1)*s14**2*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C - 2*s12**(-1)*s14**2*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s12**(-1)*s13*
     &    s24**2*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s12**(-1)*
     &    s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     + 2*s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 + 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 2*s12**(-1)*s13*s14*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NPSQ*Caa*dCz * ( 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 2*s24*cw**2*sw**4*PropZ12C*PropZ34C - 2*s24
     &    *cw**2*sw**4*PropZ12*PropZ34 - 2*s23*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 2*s23*cw**2*sw**4*PropZ12*PropZ34 - 2*s14*cw**2*
     &    sw**4*PropZ12C*PropZ34C - 2*s14*cw**2*sw**4*PropZ12*PropZ34
     &     - 2*s13*cw**2*sw**4*PropZ12C*PropZ34C - 2*s13*cw**2*sw**4*
     &    PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NP*Caa * ( 2*s12**(-1)*
     &    s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 2*s12**(-1)*s14**2*s23*s34**(-1)*cw**2*
     &    sw**4*PropZ12C*PropZ34C - 2*s12**(-1)*s14**2*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12*PropZ34 - 2*s12**(-1)*s13*s24**2*
     &    s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s12**(-1)*s13*
     &    s24**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*s12**(-1)*
     &    s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     + 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12C*
     &    PropZ34C + 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 + 2*s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*
     &    sw**4*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*couplsm*NP*Caa * ( 2*s12**(-1)*
     &    s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     - 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 2*s24*cw**2*sw**4*PropZ12C*PropZ34C - 2*s24*cw**2*
     &    sw**4*PropZ12*PropZ34 - 2*s23*cw**2*sw**4*PropZ12C*PropZ34C
     &     - 2*s23*cw**2*sw**4*PropZ12*PropZ34 - 2*s14*cw**2*sw**4*
     &    PropZ12C*PropZ34C - 2*s14*cw**2*sw**4*PropZ12*PropZ34 - 2*s13
     &    *cw**2*sw**4*PropZ12C*PropZ34C - 2*s13*cw**2*sw**4*PropZ12*
     &    PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*eps1234*couplsm*NPSQ*Cza*dGl1L
     &  * ( 4*s12**(-1)*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*s12**(-1)*
     &    s13*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s12**(-1)*s13*sw**2*
     &    PropZ12*PropZ34*PropZ34C + 4*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s24*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s13*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 
     &    4*s13*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*eps1234*couplsm*NPSQ*Cza*dGl1R
     &  * (  - 4*s12**(-1)*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s12**(-1)*
     &    s13*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s12**(-1)*s13*sw**2*
     &    PropZ12*PropZ34*PropZ34C - 4*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s24*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s13*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 
     &    4*s13*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CVSQ*couplsm*NPSQ*dGl1L**2 * ( 32*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*couplsm*NPSQ*dGl1R*dGl1L * ( 64*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*couplsm*NPSQ*dGl1R**2 * ( 32*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-2)*couplsm*NPSQ*Czz**2 * ( 32
     &    *s14**2*s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C - 64*s13*s14
     &    *s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s13**2*s24**2
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C + 48*s12*s24**2*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s23**2*s34*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C - 96*s12*s14*s23*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s14**2*s34*PropZ12*PropZ34
     &    *PropZ12C*PropZ34C + 32*s12*s13*s24*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 48*s12*s13**2*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 32*s12**2*s34**2*PropZ12*PropZ34*PropZ12C
     &    *PropZ34C )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-2)*couplsm*NPSQ*Czbx*Czz * ( 
     &    96*s14*s23*s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s14
     &    *s23**2*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s14**2*s23
     &    *s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 96*s13*s24**2*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 32*s13*s23*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 32*s13*s14*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 96*s13*s14*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 96*s13**2*s24*s34*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C - 96*s12*s24*s34**2*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 32*s12*s23*s34**2*PropZ12*PropZ34
     &    *PropZ12C*PropZ34C + 32*s12*s14*s34**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 96*s12*s14*s23*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 32*s12*s14*s23**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 32*s12*s14**2*s23*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 96*s12*s13*s34**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-2)*couplsm*NPSQ*Czbx*Czz * ( 
     &     - 96*s12*s13*s24**2*PropZ12*PropZ34*PropZ12C*PropZ34C - 32*
     &    s12*s13*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 32*s12*
     &    s13*s14*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 96*s12*s13*
     &    s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C - 96*s12*s13**2*s24
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C - 96*s12**2*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s12**2*s23*s34*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C + 32*s12**2*s14*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 96*s12**2*s13*s34*PropZ12*PropZ34
     &    *PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-2)*couplsm*NPSQ*Czbx**2 * ( 
     &     - 64*s14*s23*s34**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 192*
     &    s13*s24*s34**2*PropZ12*PropZ34*PropZ12C*PropZ34C - 128*s12*
     &    s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 384*s12*s13*
     &    s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 64*s12**2*s14*s23
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s12**2*s13*s24*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-1)*couplsm*NPSQ*Czz*dCz * ( 
     &    96*s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s14*
     &    s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s14**2*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 96*s13*s24**2*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 32*s13*s23*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 32*s13*s14*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 96*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     - 96*s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 96*s12*
     &    s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s12*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s12*s14*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 96*s12*s13*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-1)*couplsm*NPSQ*Czbx*dCz * ( 
     &     - 128*s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 384*
     &    s13*s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 128*s12*s14*
     &    s23*PropZ12*PropZ34*PropZ12C*PropZ34C + 384*s12*s13*s24*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-1)*couplsm*NP*Czz * ( 96*s14*
     &    s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s14*s23**2*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 96*s13*s24**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 32*s13*s23*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C - 32*s13*s14*s24*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     + 96*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C - 96*
     &    s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 96*s12*s24*s34
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s12*s23*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 32*s12*s14*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 96*s12*s13*s34*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-1)*couplsm*NP*Czbx * (  - 128
     &    *s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 384*s13*s24*
     &    s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 128*s12*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 384*s12*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*CASQ*couplsm * (  - 64*s14*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 192*s13*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*CASQ*couplsm*NPSQ*dCz**2 * (  - 64*s14*s23
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*CASQ*couplsm*NP*dCz * (  - 128*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 384*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-2)*couplsm*NPSQ*Czz**2 * ( 16*
     &    s14**2*s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C - 32*s13*s14*
     &    s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s13**2*s24**2*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 8*s12*s24**2*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 8*s12*s23**2*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s14*s23*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 8*s12*s14**2*s34*PropZ12*PropZ34*PropZ12C
     &    *PropZ34C - 16*s12*s13*s24*s34*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 8*s12*s13**2*s34*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     + 16*s12**2*s34**2*PropZ12*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-2)*couplsm*NPSQ*Czbx*Czz * ( 16
     &    *s14*s23*s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14*
     &    s23**2*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14**2*s23*
     &    s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s13*s24**2*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s13*s23*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s13*s14*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s13*s14*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s13**2*s24*s34*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C - 16*s12*s24*s34**2*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s23*s34**2*PropZ12*PropZ34
     &    *PropZ12C*PropZ34C - 16*s12*s14*s34**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 16*s12*s14*s23*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s14*s23**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s14**2*s23*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s13*s34**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-2)*couplsm*NPSQ*Czbx*Czz * ( 
     &     - 16*s12*s13*s24**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*
     &    s12*s13*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*
     &    s13*s14*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*s13*
     &    s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s13**2*s24
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12**2*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12**2*s23*s34*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C - 16*s12**2*s14*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12**2*s13*s34*PropZ12*PropZ34
     &    *PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-2)*couplsm*NPSQ*Czbx**2 * ( 32*
     &    s14*s23*s34**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s13*s24
     &    *s34**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s14*s23*
     &    s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s13*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s12**2*s14*s23*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C + 32*s12**2*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-1)*couplsm*NPSQ*Czz*dCz * ( 16*
     &    s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14*s23**2
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s13*s24**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 16*s13*s23*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 16*s13*s14*s24*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     + 16*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*
     &    s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s24*s34
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s23*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s13*s34*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-1)*couplsm*NPSQ*Czbx*dCz * ( 64
     &    *s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24*
     &    s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-1)*couplsm*NP*Czz * ( 16*s14*
     &    s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14*s23**2*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s13*s24**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 16*s13*s23*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 16*s13*s14*s24*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     + 16*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*
     &    s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s24*s34
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s23*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s13*s34*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-1)*couplsm*NP*Czbx * ( 64*s14*
     &    s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s14*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 64*s12*s13*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*couplsm * ( 32*s14*s23*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 32*s13*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*couplsm*NPSQ*dCz**2 * ( 32*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*couplsm*NP*dCz * ( 64*s14*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 64*s13*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1L * (  - 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ34 )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1L * ( 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12C )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1L * ( 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12 + s24*
     &    cw**2*sw**4*PropZ34C + s24*cw**2*sw**4*PropZ12C + s24*cw**2*
     &    sw**4*PropZ34 + s24*cw**2*sw**4*PropZ12 - s23*cw**2*sw**4*
     &    PropZ34C - s23*cw**2*sw**4*PropZ12C - s23*cw**2*sw**4*PropZ34
     &     - s23*cw**2*sw**4*PropZ12 - s14*cw**2*sw**4*PropZ34C - s14*
     &    cw**2*sw**4*PropZ12C - s14*cw**2*sw**4*PropZ34 - s14*cw**2*
     &    sw**4*PropZ12 + s13*cw**2*sw**4*PropZ34C + s13*cw**2*sw**4*
     &    PropZ12C + s13*cw**2*sw**4*PropZ34 + s13*cw**2*sw**4*PropZ12
     &     )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1R * ( 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ34 )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1R * (  - 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12C )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1R * (  - 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12 - s24*
     &    cw**2*sw**4*PropZ34C - s24*cw**2*sw**4*PropZ12C - s24*cw**2*
     &    sw**4*PropZ34 - s24*cw**2*sw**4*PropZ12 + s23*cw**2*sw**4*
     &    PropZ34C + s23*cw**2*sw**4*PropZ12C + s23*cw**2*sw**4*PropZ34
     &     + s23*cw**2*sw**4*PropZ12 + s14*cw**2*sw**4*PropZ34C + s14*
     &    cw**2*sw**4*PropZ12C + s14*cw**2*sw**4*PropZ34 + s14*cw**2*
     &    sw**4*PropZ12 - s13*cw**2*sw**4*PropZ34C - s13*cw**2*sw**4*
     &    PropZ12C - s13*cw**2*sw**4*PropZ34 - s13*cw**2*sw**4*PropZ12
     &     )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*eps1234*couplsm*NPSQ*Caa*dGl1L
     &  * ( s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ34C + s12**(-1)*
     &    s24*s34**(-1)*cw**2*sw**4*PropZ12C - s12**(-1)*s24*s34**(-1)*
     &    cw**2*sw**4*PropZ34 - s12**(-1)*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12 + s12**(-1)*s23*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s23*s34**(-1)*cw**2*sw**4*PropZ12C - s12**(-1)*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ34 + s12**(-1)*s23*s34**(-1)*cw**2
     &    *sw**4*PropZ12 - s12**(-1)*s14*s34**(-1)*cw**2*sw**4*PropZ34C
     &     + s12**(-1)*s14*s34**(-1)*cw**2*sw**4*PropZ12C + s12**(-1)*
     &    s14*s34**(-1)*cw**2*sw**4*PropZ34 - s12**(-1)*s14*s34**(-1)*
     &    cw**2*sw**4*PropZ12 - s12**(-1)*s13*s34**(-1)*cw**2*sw**4*
     &    PropZ34C - s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ34 + s12**(-1)*s13*
     &    s34**(-1)*cw**2*sw**4*PropZ12 )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*eps1234*couplsm*NPSQ*Caa*dGl1R
     &  * ( s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ34C + s12**(-1)*
     &    s24*s34**(-1)*cw**2*sw**4*PropZ12C - s12**(-1)*s24*s34**(-1)*
     &    cw**2*sw**4*PropZ34 - s12**(-1)*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12 + s12**(-1)*s23*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s23*s34**(-1)*cw**2*sw**4*PropZ12C - s12**(-1)*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ34 + s12**(-1)*s23*s34**(-1)*cw**2
     &    *sw**4*PropZ12 - s12**(-1)*s14*s34**(-1)*cw**2*sw**4*PropZ34C
     &     + s12**(-1)*s14*s34**(-1)*cw**2*sw**4*PropZ12C + s12**(-1)*
     &    s14*s34**(-1)*cw**2*sw**4*PropZ34 - s12**(-1)*s14*s34**(-1)*
     &    cw**2*sw**4*PropZ12 - s12**(-1)*s13*s34**(-1)*cw**2*sw**4*
     &    PropZ34C - s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ34 + s12**(-1)*s13*
     &    s34**(-1)*cw**2*sw**4*PropZ12 )
      MSQBSM = MSQBSM + CA*mzsq**(-2)*eps1234*couplsm*NPSQ*Caa*Cabx
     &  * (  - s12**(-1)*s24*s34**(-1)*cw**2*sw**6*PropZ34C - s12**(-1)
     &    *s24*s34**(-1)*cw**2*sw**6*PropZ12C + s12**(-1)*s24*s34**(-1)
     &    *cw**2*sw**6*PropZ34 + s12**(-1)*s24*s34**(-1)*cw**2*sw**6*
     &    PropZ12 - s12**(-1)*s23*s34**(-1)*cw**2*sw**6*PropZ34C + 
     &    s12**(-1)*s23*s34**(-1)*cw**2*sw**6*PropZ12C + s12**(-1)*s23*
     &    s34**(-1)*cw**2*sw**6*PropZ34 - s12**(-1)*s23*s34**(-1)*cw**2
     &    *sw**6*PropZ12 + s12**(-1)*s14*s34**(-1)*cw**2*sw**6*PropZ34C
     &     - s12**(-1)*s14*s34**(-1)*cw**2*sw**6*PropZ12C - s12**(-1)*
     &    s14*s34**(-1)*cw**2*sw**6*PropZ34 + s12**(-1)*s14*s34**(-1)*
     &    cw**2*sw**6*PropZ12 + s12**(-1)*s13*s34**(-1)*cw**2*sw**6*
     &    PropZ34C + s12**(-1)*s13*s34**(-1)*cw**2*sw**6*PropZ12C - 
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**6*PropZ34 - s12**(-1)*s13*
     &    s34**(-1)*cw**2*sw**6*PropZ12 )
      MSQBSM = MSQBSM + CA*mzsq**(-1)*couplsm*NPSQ*Caa*dGl1L * (  - 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     - 2*s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C - 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 - 2*s12**(-1)*s14**2*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C - 2*s12**(-1)*s14**2*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*s12**(-1)*s13*
     &    s24**2*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*s12**(-1)*
     &    s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     + 2*s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 + 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 - 2*s12**(-1)*s13*s14*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*mzsq**(-1)*couplsm*NPSQ*Caa*dGl1L * (  - 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     + 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12C*
     &    PropZ34C + 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 + 2*s24*cw**2*sw**4*PropZ12C*PropZ34C + 2*s24
     &    *cw**2*sw**4*PropZ12*PropZ34 - 2*s23*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 2*s23*cw**2*sw**4*PropZ12*PropZ34 - 2*s14*cw**2*
     &    sw**4*PropZ12C*PropZ34C - 2*s14*cw**2*sw**4*PropZ12*PropZ34
     &     + 2*s13*cw**2*sw**4*PropZ12C*PropZ34C + 2*s13*cw**2*sw**4*
     &    PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CA*mzsq**(-1)*couplsm*NPSQ*Caa*dGl1R * ( 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     + 2*s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 + 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 2*s12**(-1)*s14**2*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C + 2*s12**(-1)*s14**2*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s12**(-1)*s13*
     &    s24**2*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s12**(-1)*
     &    s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     - 2*s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C - 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 2*s12**(-1)*s13*s14*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*mzsq**(-1)*couplsm*NPSQ*Caa*dGl1R * ( 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 2*s24*cw**2*sw**4*PropZ12C*PropZ34C - 2*s24
     &    *cw**2*sw**4*PropZ12*PropZ34 + 2*s23*cw**2*sw**4*PropZ12C*
     &    PropZ34C + 2*s23*cw**2*sw**4*PropZ12*PropZ34 + 2*s14*cw**2*
     &    sw**4*PropZ12C*PropZ34C + 2*s14*cw**2*sw**4*PropZ12*PropZ34
     &     - 2*s13*cw**2*sw**4*PropZ12C*PropZ34C - 2*s13*cw**2*sw**4*
     &    PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CA*mzsq**(-1)*eps1234*couplsm*NPSQ*Caa*dGl1L
     &  * ( 2*s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2
     &    *s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CA*mzsq**(-1)*eps1234*couplsm*NPSQ*Caa*dGl1R
     &  * ( 2*s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2
     &    *s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 
     &     - 4*s14*s23*s24*PropZ34*PropZ12C*PropZ34C - 4*s14*s23*s24*
     &    PropZ12*PropZ12C*PropZ34C - 4*s14*s23*s24*PropZ12*PropZ34*
     &    PropZ34C - 4*s14*s23*s24*PropZ12*PropZ34*PropZ12C + 4*s14*
     &    s23**2*PropZ34*PropZ12C*PropZ34C + 4*s14*s23**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s14*s23**2*PropZ12*PropZ34*PropZ34C + 4
     &    *s14*s23**2*PropZ12*PropZ34*PropZ12C + 4*s14**2*s23*PropZ34*
     &    PropZ12C*PropZ34C + 4*s14**2*s23*PropZ12*PropZ12C*PropZ34C + 
     &    4*s14**2*s23*PropZ12*PropZ34*PropZ34C + 4*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C + 4*s13*s24**2*PropZ34*PropZ12C*PropZ34C + 4
     &    *s13*s24**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s24**2*PropZ12*
     &    PropZ34*PropZ34C + 4*s13*s24**2*PropZ12*PropZ34*PropZ12C - 4*
     &    s13*s23*s24*PropZ34*PropZ12C*PropZ34C - 4*s13*s23*s24*PropZ12
     &    *PropZ12C*PropZ34C - 4*s13*s23*s24*PropZ12*PropZ34*PropZ34C
     &     - 4*s13*s23*s24*PropZ12*PropZ34*PropZ12C - 4*s13*s14*s24*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 
     &     - 4*s13*s14*s24*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*s24*
     &    PropZ12*PropZ34*PropZ34C - 4*s13*s14*s24*PropZ12*PropZ34*
     &    PropZ12C - 4*s13*s14*s23*PropZ34*PropZ12C*PropZ34C - 4*s13*
     &    s14*s23*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*s23*PropZ12*
     &    PropZ34*PropZ34C - 4*s13*s14*s23*PropZ12*PropZ34*PropZ12C + 4
     &    *s13**2*s24*PropZ34*PropZ12C*PropZ34C + 4*s13**2*s24*PropZ12*
     &    PropZ12C*PropZ34C + 4*s13**2*s24*PropZ12*PropZ34*PropZ34C + 4
     &    *s13**2*s24*PropZ12*PropZ34*PropZ12C + 4*s12*s24*s34*PropZ34*
     &    PropZ12C*PropZ34C + 4*s12*s24*s34*PropZ12*PropZ12C*PropZ34C
     &     + 4*s12*s24*s34*PropZ12*PropZ34*PropZ34C + 4*s12*s24*s34*
     &    PropZ12*PropZ34*PropZ12C + 4*s12*s23*s34*PropZ34*PropZ12C*
     &    PropZ34C + 4*s12*s23*s34*PropZ12*PropZ12C*PropZ34C + 4*s12*
     &    s23*s34*PropZ12*PropZ34*PropZ34C + 4*s12*s23*s34*PropZ12*
     &    PropZ34*PropZ12C + 4*s12*s14*s34*PropZ34*PropZ12C*PropZ34C + 
     &    4*s12*s14*s34*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 4
     &    *s12*s14*s34*PropZ12*PropZ34*PropZ34C + 4*s12*s14*s34*PropZ12
     &    *PropZ34*PropZ12C + 4*s12*s13*s34*PropZ34*PropZ12C*PropZ34C
     &     + 4*s12*s13*s34*PropZ12*PropZ12C*PropZ34C + 4*s12*s13*s34*
     &    PropZ12*PropZ34*PropZ34C + 4*s12*s13*s34*PropZ12*PropZ34*
     &    PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &     - 16*s14*s23*s34*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*s34*
     &    PropZ12*PropZ12C*PropZ34C - 16*s14*s23*s34*PropZ12*PropZ34*
     &    PropZ34C - 16*s14*s23*s34*PropZ12*PropZ34*PropZ12C - 16*s13*
     &    s24*s34*PropZ34*PropZ12C*PropZ34C - 16*s13*s24*s34*PropZ12*
     &    PropZ12C*PropZ34C - 16*s13*s24*s34*PropZ12*PropZ34*PropZ34C
     &     - 16*s13*s24*s34*PropZ12*PropZ34*PropZ12C - 16*s12*s14*s23*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C - 16*s12*s14*s23*PropZ12*PropZ34*PropZ34C - 16*s12*
     &    s14*s23*PropZ12*PropZ34*PropZ12C - 16*s12*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C - 16*s12*s13*s24*PropZ12*PropZ12C*PropZ34C
     &     - 16*s12*s13*s24*PropZ12*PropZ34*PropZ34C - 16*s12*s13*s24*
     &    PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 4
     &    *s14*s23*s24*PropZ34*PropZ12C*PropZ34C + 4*s14*s23*s24*
     &    PropZ12*PropZ12C*PropZ34C + 4*s14*s23*s24*PropZ12*PropZ34*
     &    PropZ34C + 4*s14*s23*s24*PropZ12*PropZ34*PropZ12C - 4*s14*
     &    s23**2*PropZ34*PropZ12C*PropZ34C - 4*s14*s23**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s14*s23**2*PropZ12*PropZ34*PropZ34C - 4
     &    *s14*s23**2*PropZ12*PropZ34*PropZ12C - 4*s14**2*s23*PropZ34*
     &    PropZ12C*PropZ34C - 4*s14**2*s23*PropZ12*PropZ12C*PropZ34C - 
     &    4*s14**2*s23*PropZ12*PropZ34*PropZ34C - 4*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C - 4*s13*s24**2*PropZ34*PropZ12C*PropZ34C - 4
     &    *s13*s24**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s24**2*PropZ12*
     &    PropZ34*PropZ34C - 4*s13*s24**2*PropZ12*PropZ34*PropZ12C + 4*
     &    s13*s23*s24*PropZ34*PropZ12C*PropZ34C + 4*s13*s23*s24*PropZ12
     &    *PropZ12C*PropZ34C + 4*s13*s23*s24*PropZ12*PropZ34*PropZ34C
     &     + 4*s13*s23*s24*PropZ12*PropZ34*PropZ12C + 4*s13*s14*s24*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 4
     &    *s13*s14*s24*PropZ12*PropZ12C*PropZ34C + 4*s13*s14*s24*
     &    PropZ12*PropZ34*PropZ34C + 4*s13*s14*s24*PropZ12*PropZ34*
     &    PropZ12C + 4*s13*s14*s23*PropZ34*PropZ12C*PropZ34C + 4*s13*
     &    s14*s23*PropZ12*PropZ12C*PropZ34C + 4*s13*s14*s23*PropZ12*
     &    PropZ34*PropZ34C + 4*s13*s14*s23*PropZ12*PropZ34*PropZ12C - 4
     &    *s13**2*s24*PropZ34*PropZ12C*PropZ34C - 4*s13**2*s24*PropZ12*
     &    PropZ12C*PropZ34C - 4*s13**2*s24*PropZ12*PropZ34*PropZ34C - 4
     &    *s13**2*s24*PropZ12*PropZ34*PropZ12C - 4*s12*s24*s34*PropZ34*
     &    PropZ12C*PropZ34C - 4*s12*s24*s34*PropZ12*PropZ12C*PropZ34C
     &     - 4*s12*s24*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s24*s34*
     &    PropZ12*PropZ34*PropZ12C - 4*s12*s23*s34*PropZ34*PropZ12C*
     &    PropZ34C - 4*s12*s23*s34*PropZ12*PropZ12C*PropZ34C - 4*s12*
     &    s23*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s23*s34*PropZ12*
     &    PropZ34*PropZ12C - 4*s12*s14*s34*PropZ34*PropZ12C*PropZ34C - 
     &    4*s12*s14*s34*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 
     &     - 4*s12*s14*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s14*s34*
     &    PropZ12*PropZ34*PropZ12C - 4*s12*s13*s34*PropZ34*PropZ12C*
     &    PropZ34C - 4*s12*s13*s34*PropZ12*PropZ12C*PropZ34C - 4*s12*
     &    s13*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s13*s34*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &    16*s14*s23*s34*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*s34*
     &    PropZ12*PropZ12C*PropZ34C + 16*s14*s23*s34*PropZ12*PropZ34*
     &    PropZ34C + 16*s14*s23*s34*PropZ12*PropZ34*PropZ12C + 16*s13*
     &    s24*s34*PropZ34*PropZ12C*PropZ34C + 16*s13*s24*s34*PropZ12*
     &    PropZ12C*PropZ34C + 16*s13*s24*s34*PropZ12*PropZ34*PropZ34C
     &     + 16*s13*s24*s34*PropZ12*PropZ34*PropZ12C + 16*s12*s14*s23*
     &    PropZ34*PropZ12C*PropZ34C + 16*s12*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C + 16*s12*s14*s23*PropZ12*PropZ34*PropZ34C + 16*s12*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 16*s12*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 16*s12*s13*s24*PropZ12*PropZ12C*PropZ34C
     &     + 16*s12*s13*s24*PropZ12*PropZ34*PropZ34C + 16*s12*s13*s24*
     &    PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*eps1234*couplsm*NPSQ*dGl1L*
     & Czz * (  - 4*s24*PropZ34*PropZ12C*PropZ34C - 4*s24*PropZ12*
     &    PropZ12C*PropZ34C + 4*s24*PropZ12*PropZ34*PropZ34C + 4*s24*
     &    PropZ12*PropZ34*PropZ12C + 4*s23*PropZ34*PropZ12C*PropZ34C - 
     &    4*s23*PropZ12*PropZ12C*PropZ34C - 4*s23*PropZ12*PropZ34*
     &    PropZ34C + 4*s23*PropZ12*PropZ34*PropZ12C - 4*s14*PropZ34*
     &    PropZ12C*PropZ34C + 4*s14*PropZ12*PropZ12C*PropZ34C + 4*s14*
     &    PropZ12*PropZ34*PropZ34C - 4*s14*PropZ12*PropZ34*PropZ12C + 4
     &    *s13*PropZ34*PropZ12C*PropZ34C + 4*s13*PropZ12*PropZ12C*
     &    PropZ34C - 4*s13*PropZ12*PropZ34*PropZ34C - 4*s13*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*eps1234*couplsm*NPSQ*dGl1R*
     & Czz * (  - 4*s24*PropZ34*PropZ12C*PropZ34C - 4*s24*PropZ12*
     &    PropZ12C*PropZ34C + 4*s24*PropZ12*PropZ34*PropZ34C + 4*s24*
     &    PropZ12*PropZ34*PropZ12C + 4*s23*PropZ34*PropZ12C*PropZ34C - 
     &    4*s23*PropZ12*PropZ12C*PropZ34C - 4*s23*PropZ12*PropZ34*
     &    PropZ34C + 4*s23*PropZ12*PropZ34*PropZ12C - 4*s14*PropZ34*
     &    PropZ12C*PropZ34C + 4*s14*PropZ12*PropZ12C*PropZ34C + 4*s14*
     &    PropZ12*PropZ34*PropZ34C - 4*s14*PropZ12*PropZ34*PropZ12C + 4
     &    *s13*PropZ34*PropZ12C*PropZ34C + 4*s13*PropZ12*PropZ12C*
     &    PropZ34C - 4*s13*PropZ12*PropZ34*PropZ34C - 4*s13*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*eps1234*couplsm*NPSQ*Cza*
     & Czbx * (  - 4*s12**(-1)*s24*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 4*s12**(-1)*s24*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s14*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*s24*
     &    sw**2*PropZ34*PropZ12C*PropZ34C - 4*s24*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s24*sw**2*PropZ12*PropZ34*PropZ12C + 4*s23*sw**2*PropZ34*
     &    PropZ12C*PropZ34C - 4*s23*sw**2*PropZ12*PropZ12C*PropZ34C - 4
     &    *s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*s23*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s14*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s14*sw**2*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*eps1234*couplsm*NPSQ*Cza*
     & Czbx * ( 4*s14*sw**2*PropZ12*PropZ34*PropZ34C - 4*s14*sw**2*
     &    PropZ12*PropZ34*PropZ12C + 4*s13*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 4*s13*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*
     &    sw**2*PropZ12*PropZ34*PropZ34C - 4*s13*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s12*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s12*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C
     &     - 4*s12*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*
     &    s12*s23*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s14*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*s14*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s13*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*s13*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-2)*eps1234*couplsm*NPSQ*Cabx*
     & Czz * ( 4*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 4*s24*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 4*s24*sw**2*PropZ12*PropZ34*PropZ12C - 4*s23*sw**2
     &    *PropZ34*PropZ12C*PropZ34C + 4*s23*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s23*sw**2*PropZ12*PropZ34*PropZ34C - 4*s23*sw**2
     &    *PropZ12*PropZ34*PropZ12C + 4*s14*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 4*s14*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s14*
     &    sw**2*PropZ12*PropZ34*PropZ34C + 4*s14*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s13*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s13*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*sw**2*PropZ12*PropZ34
     &    *PropZ34C + 4*s13*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*dCz * ( 
     &     - 16*s14*s23*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C - 16*s14*s23*PropZ12*PropZ34*PropZ34C - 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C - 16*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C - 16*s13*s24*PropZ12*PropZ12C*PropZ34C - 16
     &    *s13*s24*PropZ12*PropZ34*PropZ34C - 16*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czz * ( 
     &     - 16*s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s14*
     &    s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s14**2*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s13*s24**2*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s13*s23*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s13*s14*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C - 16*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     + 16*s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*
     &    s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*s14*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 16*s12*s13*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &     - 64*s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 64*s13*
     &    s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 64*s12*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 64*s12*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*dCz * ( 
     &    16*s14*s23*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C + 16*s14*s23*PropZ12*PropZ34*PropZ34C + 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 16*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 16*s13*s24*PropZ12*PropZ12C*PropZ34C + 16
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 16*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czz * ( 
     &    16*s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14*
     &    s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14**2*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s13*s24**2*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 16*s13*s23*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 16*s13*s14*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 16*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     - 16*s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*
     &    s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s13*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &    64*s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24
     &    *s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NP*dGl1L * (  - 16*
     &    s14*s23*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C - 16*s14*s23*PropZ12*PropZ34*PropZ34C - 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C - 16*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C - 16*s13*s24*PropZ12*PropZ12C*PropZ34C - 16
     &    *s13*s24*PropZ12*PropZ34*PropZ34C - 16*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NP*dGl1R * ( 16*s14*
     &    s23*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C + 16*s14*s23*PropZ12*PropZ34*PropZ34C + 16*s14*s23*
     &    PropZ12*PropZ34*PropZ12C + 16*s13*s24*PropZ34*PropZ12C*
     &    PropZ34C + 16*s13*s24*PropZ12*PropZ12C*PropZ34C + 16*s13*s24*
     &    PropZ12*PropZ34*PropZ34C + 16*s13*s24*PropZ12*PropZ34*
     &    PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*eps1234*couplsm*NPSQ*Cza*dCz
     &  * (  - 4*s12**(-1)*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s12**(-1)*
     &    s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s12**(-1)*s23*sw**2*
     &    PropZ12*PropZ34*PropZ34C - 4*s12**(-1)*s14*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 4*s12**(-1)*s14*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 4*s12**(-1)*s13*sw**2*PropZ34*PropZ12C*PropZ34C - 
     &    4*s12**(-1)*s13*sw**2*PropZ12*PropZ34*PropZ34C - 4*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C - 4*s23*s34**(-1)*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 4*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s14*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s14*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4
     &    *s13*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*eps1234*couplsm*NP*Cza * ( 
     &     - 4*s12**(-1)*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s12**(-1)*
     &    s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s12**(-1)*s23*sw**2*
     &    PropZ12*PropZ34*PropZ34C - 4*s12**(-1)*s14*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 4*s12**(-1)*s14*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 4*s12**(-1)*s13*sw**2*PropZ34*PropZ12C*PropZ34C - 
     &    4*s12**(-1)*s13*sw**2*PropZ12*PropZ34*PropZ34C - 4*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C - 4*s23*s34**(-1)*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 4*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s14*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s14*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4
     &    *s13*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*couplsm*NPSQ*dGl1L*dCz * (  - 64*s14*
     &    s23*PropZ12*PropZ34*PropZ12C*PropZ34C - 64*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*couplsm*NPSQ*dGl1R*dCz * ( 64*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*couplsm*NP*dGl1L * (  - 64*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 64*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*couplsm*NP*dGl1R * ( 64*s14*s23*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C + 64*s13*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 
     &     - 12*s14*s23*s24*PropZ34*PropZ12C*PropZ34C - 12*s14*s23*s24*
     &    PropZ12*PropZ12C*PropZ34C - 12*s14*s23*s24*PropZ12*PropZ34*
     &    PropZ34C - 12*s14*s23*s24*PropZ12*PropZ34*PropZ12C - 4*s14*
     &    s23**2*PropZ34*PropZ12C*PropZ34C - 4*s14*s23**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s14*s23**2*PropZ12*PropZ34*PropZ34C - 4
     &    *s14*s23**2*PropZ12*PropZ34*PropZ12C - 4*s14**2*s23*PropZ34*
     &    PropZ12C*PropZ34C - 4*s14**2*s23*PropZ12*PropZ12C*PropZ34C - 
     &    4*s14**2*s23*PropZ12*PropZ34*PropZ34C - 4*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C + 12*s13*s24**2*PropZ34*PropZ12C*PropZ34C + 
     &    12*s13*s24**2*PropZ12*PropZ12C*PropZ34C + 12*s13*s24**2*
     &    PropZ12*PropZ34*PropZ34C + 12*s13*s24**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s13*s23*s24*PropZ34*PropZ12C*PropZ34C + 4*s13*
     &    s23*s24*PropZ12*PropZ12C*PropZ34C + 4*s13*s23*s24*PropZ12*
     &    PropZ34*PropZ34C + 4*s13*s23*s24*PropZ12*PropZ34*PropZ12C + 4
     &    *s13*s14*s24*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 4
     &    *s13*s14*s24*PropZ12*PropZ12C*PropZ34C + 4*s13*s14*s24*
     &    PropZ12*PropZ34*PropZ34C + 4*s13*s14*s24*PropZ12*PropZ34*
     &    PropZ12C - 12*s13*s14*s23*PropZ34*PropZ12C*PropZ34C - 12*s13*
     &    s14*s23*PropZ12*PropZ12C*PropZ34C - 12*s13*s14*s23*PropZ12*
     &    PropZ34*PropZ34C - 12*s13*s14*s23*PropZ12*PropZ34*PropZ12C + 
     &    12*s13**2*s24*PropZ34*PropZ12C*PropZ34C + 12*s13**2*s24*
     &    PropZ12*PropZ12C*PropZ34C + 12*s13**2*s24*PropZ12*PropZ34*
     &    PropZ34C + 12*s13**2*s24*PropZ12*PropZ34*PropZ12C + 12*s12*
     &    s24*s34*PropZ34*PropZ12C*PropZ34C + 12*s12*s24*s34*PropZ12*
     &    PropZ12C*PropZ34C + 12*s12*s24*s34*PropZ12*PropZ34*PropZ34C
     &     + 12*s12*s24*s34*PropZ12*PropZ34*PropZ12C - 4*s12*s23*s34*
     &    PropZ34*PropZ12C*PropZ34C - 4*s12*s23*s34*PropZ12*PropZ12C*
     &    PropZ34C - 4*s12*s23*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s23
     &    *s34*PropZ12*PropZ34*PropZ12C - 4*s12*s14*s34*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 
     &     - 4*s12*s14*s34*PropZ12*PropZ12C*PropZ34C - 4*s12*s14*s34*
     &    PropZ12*PropZ34*PropZ34C - 4*s12*s14*s34*PropZ12*PropZ34*
     &    PropZ12C + 12*s12*s13*s34*PropZ34*PropZ12C*PropZ34C + 12*s12*
     &    s13*s34*PropZ12*PropZ12C*PropZ34C + 12*s12*s13*s34*PropZ12*
     &    PropZ34*PropZ34C + 12*s12*s13*s34*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &    16*s14*s23*s34*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*s34*
     &    PropZ12*PropZ12C*PropZ34C + 16*s14*s23*s34*PropZ12*PropZ34*
     &    PropZ34C + 16*s14*s23*s34*PropZ12*PropZ34*PropZ12C - 48*s13*
     &    s24*s34*PropZ34*PropZ12C*PropZ34C - 48*s13*s24*s34*PropZ12*
     &    PropZ12C*PropZ34C - 48*s13*s24*s34*PropZ12*PropZ34*PropZ34C
     &     - 48*s13*s24*s34*PropZ12*PropZ34*PropZ12C + 16*s12*s14*s23*
     &    PropZ34*PropZ12C*PropZ34C + 16*s12*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C + 16*s12*s14*s23*PropZ12*PropZ34*PropZ34C + 16*s12*
     &    s14*s23*PropZ12*PropZ34*PropZ12C - 48*s12*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C - 48*s12*s13*s24*PropZ12*PropZ12C*PropZ34C
     &     - 48*s12*s13*s24*PropZ12*PropZ34*PropZ34C - 48*s12*s13*s24*
     &    PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 
     &    12*s14*s23*s24*PropZ34*PropZ12C*PropZ34C + 12*s14*s23*s24*
     &    PropZ12*PropZ12C*PropZ34C + 12*s14*s23*s24*PropZ12*PropZ34*
     &    PropZ34C + 12*s14*s23*s24*PropZ12*PropZ34*PropZ12C + 4*s14*
     &    s23**2*PropZ34*PropZ12C*PropZ34C + 4*s14*s23**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s14*s23**2*PropZ12*PropZ34*PropZ34C + 4
     &    *s14*s23**2*PropZ12*PropZ34*PropZ12C + 4*s14**2*s23*PropZ34*
     &    PropZ12C*PropZ34C + 4*s14**2*s23*PropZ12*PropZ12C*PropZ34C + 
     &    4*s14**2*s23*PropZ12*PropZ34*PropZ34C + 4*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C - 12*s13*s24**2*PropZ34*PropZ12C*PropZ34C - 
     &    12*s13*s24**2*PropZ12*PropZ12C*PropZ34C - 12*s13*s24**2*
     &    PropZ12*PropZ34*PropZ34C - 12*s13*s24**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s13*s23*s24*PropZ34*PropZ12C*PropZ34C - 4*s13*
     &    s23*s24*PropZ12*PropZ12C*PropZ34C - 4*s13*s23*s24*PropZ12*
     &    PropZ34*PropZ34C - 4*s13*s23*s24*PropZ12*PropZ34*PropZ12C - 4
     &    *s13*s14*s24*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 
     &     - 4*s13*s14*s24*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*s24*
     &    PropZ12*PropZ34*PropZ34C - 4*s13*s14*s24*PropZ12*PropZ34*
     &    PropZ12C + 12*s13*s14*s23*PropZ34*PropZ12C*PropZ34C + 12*s13*
     &    s14*s23*PropZ12*PropZ12C*PropZ34C + 12*s13*s14*s23*PropZ12*
     &    PropZ34*PropZ34C + 12*s13*s14*s23*PropZ12*PropZ34*PropZ12C - 
     &    12*s13**2*s24*PropZ34*PropZ12C*PropZ34C - 12*s13**2*s24*
     &    PropZ12*PropZ12C*PropZ34C - 12*s13**2*s24*PropZ12*PropZ34*
     &    PropZ34C - 12*s13**2*s24*PropZ12*PropZ34*PropZ12C - 12*s12*
     &    s24*s34*PropZ34*PropZ12C*PropZ34C - 12*s12*s24*s34*PropZ12*
     &    PropZ12C*PropZ34C - 12*s12*s24*s34*PropZ12*PropZ34*PropZ34C
     &     - 12*s12*s24*s34*PropZ12*PropZ34*PropZ12C + 4*s12*s23*s34*
     &    PropZ34*PropZ12C*PropZ34C + 4*s12*s23*s34*PropZ12*PropZ12C*
     &    PropZ34C + 4*s12*s23*s34*PropZ12*PropZ34*PropZ34C + 4*s12*s23
     &    *s34*PropZ12*PropZ34*PropZ12C + 4*s12*s14*s34*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 4
     &    *s12*s14*s34*PropZ12*PropZ12C*PropZ34C + 4*s12*s14*s34*
     &    PropZ12*PropZ34*PropZ34C + 4*s12*s14*s34*PropZ12*PropZ34*
     &    PropZ12C - 12*s12*s13*s34*PropZ34*PropZ12C*PropZ34C - 12*s12*
     &    s13*s34*PropZ12*PropZ12C*PropZ34C - 12*s12*s13*s34*PropZ12*
     &    PropZ34*PropZ34C - 12*s12*s13*s34*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &     - 16*s14*s23*s34*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*s34*
     &    PropZ12*PropZ12C*PropZ34C - 16*s14*s23*s34*PropZ12*PropZ34*
     &    PropZ34C - 16*s14*s23*s34*PropZ12*PropZ34*PropZ12C + 48*s13*
     &    s24*s34*PropZ34*PropZ12C*PropZ34C + 48*s13*s24*s34*PropZ12*
     &    PropZ12C*PropZ34C + 48*s13*s24*s34*PropZ12*PropZ34*PropZ34C
     &     + 48*s13*s24*s34*PropZ12*PropZ34*PropZ12C - 16*s12*s14*s23*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C - 16*s12*s14*s23*PropZ12*PropZ34*PropZ34C - 16*s12*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 48*s12*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 48*s12*s13*s24*PropZ12*PropZ12C*PropZ34C
     &     + 48*s12*s13*s24*PropZ12*PropZ34*PropZ34C + 48*s12*s13*s24*
     &    PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*eps1234*couplsm*NPSQ*dGl1L*
     & Czz * (  - 12*s24*PropZ34*PropZ12C*PropZ34C - 12*s24*PropZ12*
     &    PropZ12C*PropZ34C + 12*s24*PropZ12*PropZ34*PropZ34C + 12*s24*
     &    PropZ12*PropZ34*PropZ12C - 4*s23*PropZ34*PropZ12C*PropZ34C + 
     &    4*s23*PropZ12*PropZ12C*PropZ34C + 4*s23*PropZ12*PropZ34*
     &    PropZ34C - 4*s23*PropZ12*PropZ34*PropZ12C + 4*s14*PropZ34*
     &    PropZ12C*PropZ34C - 4*s14*PropZ12*PropZ12C*PropZ34C - 4*s14*
     &    PropZ12*PropZ34*PropZ34C + 4*s14*PropZ12*PropZ34*PropZ12C + 
     &    12*s13*PropZ34*PropZ12C*PropZ34C + 12*s13*PropZ12*PropZ12C*
     &    PropZ34C - 12*s13*PropZ12*PropZ34*PropZ34C - 12*s13*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*eps1234*couplsm*NPSQ*dGl1R*
     & Czz * (  - 12*s24*PropZ34*PropZ12C*PropZ34C - 12*s24*PropZ12*
     &    PropZ12C*PropZ34C + 12*s24*PropZ12*PropZ34*PropZ34C + 12*s24*
     &    PropZ12*PropZ34*PropZ12C - 4*s23*PropZ34*PropZ12C*PropZ34C + 
     &    4*s23*PropZ12*PropZ12C*PropZ34C + 4*s23*PropZ12*PropZ34*
     &    PropZ34C - 4*s23*PropZ12*PropZ34*PropZ12C + 4*s14*PropZ34*
     &    PropZ12C*PropZ34C - 4*s14*PropZ12*PropZ12C*PropZ34C - 4*s14*
     &    PropZ12*PropZ34*PropZ34C + 4*s14*PropZ12*PropZ34*PropZ12C + 
     &    12*s13*PropZ34*PropZ12C*PropZ34C + 12*s13*PropZ12*PropZ12C*
     &    PropZ34C - 12*s13*PropZ12*PropZ34*PropZ34C - 12*s13*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*eps1234*couplsm*NPSQ*Cza*
     & Czbx * (  - 12*s12**(-1)*s24*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 12*s12**(-1)*s24*s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14*s34*sw**2*PropZ12*PropZ34*PropZ34C + 12*
     &    s12**(-1)*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 12*
     &    s12**(-1)*s13*s34*sw**2*PropZ12*PropZ34*PropZ34C - 12*s24*
     &    sw**2*PropZ34*PropZ12C*PropZ34C - 12*s24*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 12*s24*sw**2*PropZ12*PropZ34*PropZ34C + 
     &    12*s24*sw**2*PropZ12*PropZ34*PropZ12C - 4*s23*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 4*s23*sw**2*PropZ12*PropZ12C*PropZ34C + 4
     &    *s23*sw**2*PropZ12*PropZ34*PropZ34C - 4*s23*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s14*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s14*sw**2*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*eps1234*couplsm*NPSQ*Cza*
     & Czbx * (  - 4*s14*sw**2*PropZ12*PropZ34*PropZ34C + 4*s14*sw**2*
     &    PropZ12*PropZ34*PropZ12C + 12*s13*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 12*s13*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s13*
     &    sw**2*PropZ12*PropZ34*PropZ34C - 12*s13*sw**2*PropZ12*PropZ34
     &    *PropZ12C - 12*s12*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 12*s12*s24*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s12*s23*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C
     &     - 4*s12*s14*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*
     &    s12*s14*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 12*s12*s13
     &    *s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s12*s13*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-2)*eps1234*couplsm*NPSQ*Cabx*
     & Czz * ( 12*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 12*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 12*s24*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 12*s24*sw**2*PropZ12*PropZ34*PropZ12C + 4*s23*
     &    sw**2*PropZ34*PropZ12C*PropZ34C - 4*s23*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s23*sw**2*PropZ12*PropZ34*PropZ12C - 4*s14*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 4*s14*sw**2*PropZ12*PropZ12C*PropZ34C + 4
     &    *s14*sw**2*PropZ12*PropZ34*PropZ34C - 4*s14*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 12*s13*sw**2*PropZ34*PropZ12C*PropZ34C - 
     &    12*s13*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s13*sw**2*PropZ12
     &    *PropZ34*PropZ34C + 12*s13*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*dCz * ( 
     &    16*s14*s23*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C + 16*s14*s23*PropZ12*PropZ34*PropZ34C + 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C - 48*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C - 48*s13*s24*PropZ12*PropZ12C*PropZ34C - 48
     &    *s13*s24*PropZ12*PropZ34*PropZ34C - 48*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czz * ( 
     &     - 48*s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14*
     &    s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14**2*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 48*s13*s24**2*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 16*s13*s23*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 16*s13*s14*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C - 48*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     + 48*s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 48*s12*
     &    s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 48*s12*s13*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &    64*s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 192*s13*
     &    s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 192*s12*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*dCz * ( 
     &     - 16*s14*s23*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C - 16*s14*s23*PropZ12*PropZ34*PropZ34C - 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 48*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 48*s13*s24*PropZ12*PropZ12C*PropZ34C + 48
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 48*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czz * ( 
     &    48*s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s14*
     &    s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s14**2*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 48*s13*s24**2*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s13*s23*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s13*s14*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 48*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     - 48*s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 48*s12*
     &    s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*s14*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 48*s12*s13*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &     - 64*s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s13
     &    *s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 64*s12*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s12*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NP*dGl1L * ( 16*s14*
     &    s23*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C + 16*s14*s23*PropZ12*PropZ34*PropZ34C + 16*s14*s23*
     &    PropZ12*PropZ34*PropZ12C - 48*s13*s24*PropZ34*PropZ12C*
     &    PropZ34C - 48*s13*s24*PropZ12*PropZ12C*PropZ34C - 48*s13*s24*
     &    PropZ12*PropZ34*PropZ34C - 48*s13*s24*PropZ12*PropZ34*
     &    PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NP*dGl1R * (  - 16*
     &    s14*s23*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C - 16*s14*s23*PropZ12*PropZ34*PropZ34C - 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 48*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 48*s13*s24*PropZ12*PropZ12C*PropZ34C + 48
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 48*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*eps1234*couplsm*NPSQ*Cza*dCz
     &  * (  - 12*s12**(-1)*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 12*
     &    s12**(-1)*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*s12**(-1)*
     &    s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s12**(-1)*s23*sw**2*
     &    PropZ12*PropZ34*PropZ34C + 4*s12**(-1)*s14*sw**2*PropZ34*
     &    PropZ12C*PropZ34C - 4*s12**(-1)*s14*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 12*s12**(-1)*s13*sw**2*PropZ34*PropZ12C*PropZ34C
     &     - 12*s12**(-1)*s13*sw**2*PropZ12*PropZ34*PropZ34C - 12*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 4*s23*s34**(-1)*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 4*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s14*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 
     &    12*s13*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s13*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*eps1234*couplsm*NP*Cza * ( 
     &     - 12*s12**(-1)*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 12*
     &    s12**(-1)*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*s12**(-1)*
     &    s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s12**(-1)*s23*sw**2*
     &    PropZ12*PropZ34*PropZ34C + 4*s12**(-1)*s14*sw**2*PropZ34*
     &    PropZ12C*PropZ34C - 4*s12**(-1)*s14*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 12*s12**(-1)*s13*sw**2*PropZ34*PropZ12C*PropZ34C
     &     - 12*s12**(-1)*s13*sw**2*PropZ12*PropZ34*PropZ34C - 12*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 4*s23*s34**(-1)*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 4*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s14*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 
     &    12*s13*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s13*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*couplsm*NPSQ*dGl1L*dCz * ( 64*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 192*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*couplsm*NPSQ*dGl1R*dCz * (  - 64*s14*
     &    s23*PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*couplsm*NP*dGl1L * ( 64*s14*s23*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C - 192*s13*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*couplsm*NP*dGl1R * (  - 64*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1L * ( 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ34 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1L * (  - 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12C )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1L * (  - 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12 - s24*
     &    cw**2*sw**4*PropZ34C - s24*cw**2*sw**4*PropZ12C - s24*cw**2*
     &    sw**4*PropZ34 - s24*cw**2*sw**4*PropZ12 - s23*cw**2*sw**4*
     &    PropZ34C - s23*cw**2*sw**4*PropZ12C - s23*cw**2*sw**4*PropZ34
     &     - s23*cw**2*sw**4*PropZ12 - s14*cw**2*sw**4*PropZ34C - s14*
     &    cw**2*sw**4*PropZ12C - s14*cw**2*sw**4*PropZ34 - s14*cw**2*
     &    sw**4*PropZ12 - s13*cw**2*sw**4*PropZ34C - s13*cw**2*sw**4*
     &    PropZ12C - s13*cw**2*sw**4*PropZ34 - s13*cw**2*sw**4*PropZ12
     &     )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1R * ( 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ34 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1R * (  - 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*PropZ12 + 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ34 + 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12 - 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12C )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*dGl1R * (  - 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ34 - 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12 - s24*
     &    cw**2*sw**4*PropZ34C - s24*cw**2*sw**4*PropZ12C - s24*cw**2*
     &    sw**4*PropZ34 - s24*cw**2*sw**4*PropZ12 - s23*cw**2*sw**4*
     &    PropZ34C - s23*cw**2*sw**4*PropZ12C - s23*cw**2*sw**4*PropZ34
     &     - s23*cw**2*sw**4*PropZ12 - s14*cw**2*sw**4*PropZ34C - s14*
     &    cw**2*sw**4*PropZ12C - s14*cw**2*sw**4*PropZ34 - s14*cw**2*
     &    sw**4*PropZ12 - s13*cw**2*sw**4*PropZ34C - s13*cw**2*sw**4*
     &    PropZ12C - s13*cw**2*sw**4*PropZ34 - s13*cw**2*sw**4*PropZ12
     &     )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*Cza * (  - 2*
     &    s12**(-2)*s14**2*s23**2*s34**(-1)*cw**2*sw**6*PropZ34C - 2*
     &    s12**(-2)*s14**2*s23**2*s34**(-1)*cw**2*sw**6*PropZ34 + 4*
     &    s12**(-2)*s13*s14*s23*s24*s34**(-1)*cw**2*sw**6*PropZ34C + 4*
     &    s12**(-2)*s13*s14*s23*s24*s34**(-1)*cw**2*sw**6*PropZ34 - 2*
     &    s12**(-2)*s13**2*s24**2*s34**(-1)*cw**2*sw**6*PropZ34C - 2*
     &    s12**(-2)*s13**2*s24**2*s34**(-1)*cw**2*sw**6*PropZ34 - 
     &    s12**(-1)*s24**2*cw**2*sw**6*PropZ34C - s12**(-1)*s24**2*
     &    cw**2*sw**6*PropZ34 - s12**(-1)*s23**2*cw**2*sw**6*PropZ34C
     &     - s12**(-1)*s23**2*cw**2*sw**6*PropZ34 + 2*s12**(-1)*s14*s23
     &    *cw**2*sw**6*PropZ34C + 2*s12**(-1)*s14*s23*cw**2*sw**6*
     &    PropZ34 - s12**(-1)*s14**2*cw**2*sw**6*PropZ34C - s12**(-1)*
     &    s14**2*cw**2*sw**6*PropZ34 - 2*s12**(-1)*s14**2*s23**2*
     &    s34**(-2)*cw**2*sw**6*PropZ12C - 2*s12**(-1)*s14**2*s23**2*
     &    s34**(-2)*cw**2*sw**6*PropZ12 + 2*s12**(-1)*s13*s24*cw**2*
     &    sw**6*PropZ34C )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*Cza * ( 2*
     &    s12**(-1)*s13*s24*cw**2*sw**6*PropZ34 + 4*s12**(-1)*s13*s14*
     &    s23*s24*s34**(-2)*cw**2*sw**6*PropZ12C + 4*s12**(-1)*s13*s14*
     &    s23*s24*s34**(-2)*cw**2*sw**6*PropZ12 - s12**(-1)*s13**2*
     &    cw**2*sw**6*PropZ34C - s12**(-1)*s13**2*cw**2*sw**6*PropZ34
     &     - 2*s12**(-1)*s13**2*s24**2*s34**(-2)*cw**2*sw**6*PropZ12C
     &     - 2*s12**(-1)*s13**2*s24**2*s34**(-2)*cw**2*sw**6*PropZ12 - 
     &    2*s34*cw**2*sw**6*PropZ34C - 2*s34*cw**2*sw**6*PropZ34 - 
     &    s24**2*s34**(-1)*cw**2*sw**6*PropZ12C - s24**2*s34**(-1)*
     &    cw**2*sw**6*PropZ12 - s23**2*s34**(-1)*cw**2*sw**6*PropZ12C
     &     - s23**2*s34**(-1)*cw**2*sw**6*PropZ12 + 2*s14*s23*s34**(-1)
     &    *cw**2*sw**6*PropZ12C + 2*s14*s23*s34**(-1)*cw**2*sw**6*
     &    PropZ12 - s14**2*s34**(-1)*cw**2*sw**6*PropZ12C - s14**2*
     &    s34**(-1)*cw**2*sw**6*PropZ12 + 2*s13*s24*s34**(-1)*cw**2*
     &    sw**6*PropZ12C + 2*s13*s24*s34**(-1)*cw**2*sw**6*PropZ12 - 
     &    s13**2*s34**(-1)*cw**2*sw**6*PropZ12C )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*Cza * (  - 
     &    s13**2*s34**(-1)*cw**2*sw**6*PropZ12 - 2*s12*cw**2*sw**6*
     &    PropZ12C - 2*s12*cw**2*sw**6*PropZ12 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*Cabx * (  - 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**6*PropZ34C - 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**6*PropZ12C - 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**6*PropZ34 - 
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**6*PropZ12 + 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**6*PropZ34C + 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**6*PropZ12C + 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**6*PropZ34 + 
     &    s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**6*PropZ12 + 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**6*PropZ34C + 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**6*PropZ12C + 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**6*PropZ34 + 
     &    s12**(-1)*s14**2*s23*s34**(-1)*cw**2*sw**6*PropZ12 + 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**6*PropZ34C + 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**6*PropZ12C + 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**6*PropZ34 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*Cabx * ( 
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**6*PropZ12 - 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**6*PropZ34C - 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**6*PropZ12C - 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**6*PropZ34 - 
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**6*PropZ12 - 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**6*PropZ34C - 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**6*PropZ12C - 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**6*PropZ34 - 
     &    s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**6*PropZ12 - 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**6*PropZ34C - 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**6*PropZ12C - 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**6*PropZ34 - 
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**6*PropZ12 + 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**6*PropZ34C + 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**6*PropZ12C )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*Caa*Cabx * ( 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**6*PropZ34 + 
     &    s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**6*PropZ12 + s24*
     &    cw**2*sw**6*PropZ34C + s24*cw**2*sw**6*PropZ12C + s24*cw**2*
     &    sw**6*PropZ34 + s24*cw**2*sw**6*PropZ12 + s23*cw**2*sw**6*
     &    PropZ34C + s23*cw**2*sw**6*PropZ12C + s23*cw**2*sw**6*PropZ34
     &     + s23*cw**2*sw**6*PropZ12 + s14*cw**2*sw**6*PropZ34C + s14*
     &    cw**2*sw**6*PropZ12C + s14*cw**2*sw**6*PropZ34 + s14*cw**2*
     &    sw**6*PropZ12 + s13*cw**2*sw**6*PropZ34C + s13*cw**2*sw**6*
     &    PropZ12C + s13*cw**2*sw**6*PropZ34 + s13*cw**2*sw**6*PropZ12
     &     )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*eps1234*couplsm*NPSQ*Caa*dGl1L
     &  * (  - s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ34C - s12**(-1)
     &    *s24*s34**(-1)*cw**2*sw**4*PropZ12C + s12**(-1)*s24*s34**(-1)
     &    *cw**2*sw**4*PropZ34 + s12**(-1)*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12 + s12**(-1)*s23*s34**(-1)*cw**2*sw**4*PropZ34C - 
     &    s12**(-1)*s23*s34**(-1)*cw**2*sw**4*PropZ12C - s12**(-1)*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ34 + s12**(-1)*s23*s34**(-1)*cw**2
     &    *sw**4*PropZ12 - s12**(-1)*s14*s34**(-1)*cw**2*sw**4*PropZ34C
     &     + s12**(-1)*s14*s34**(-1)*cw**2*sw**4*PropZ12C + s12**(-1)*
     &    s14*s34**(-1)*cw**2*sw**4*PropZ34 - s12**(-1)*s14*s34**(-1)*
     &    cw**2*sw**4*PropZ12 + s12**(-1)*s13*s34**(-1)*cw**2*sw**4*
     &    PropZ34C + s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12C - 
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ34 - s12**(-1)*s13*
     &    s34**(-1)*cw**2*sw**4*PropZ12 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*eps1234*couplsm*NPSQ*Caa*dGl1R
     &  * ( s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ34C + s12**(-1)*
     &    s24*s34**(-1)*cw**2*sw**4*PropZ12C - s12**(-1)*s24*s34**(-1)*
     &    cw**2*sw**4*PropZ34 - s12**(-1)*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12 - s12**(-1)*s23*s34**(-1)*cw**2*sw**4*PropZ34C + 
     &    s12**(-1)*s23*s34**(-1)*cw**2*sw**4*PropZ12C + s12**(-1)*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ34 - s12**(-1)*s23*s34**(-1)*cw**2
     &    *sw**4*PropZ12 + s12**(-1)*s14*s34**(-1)*cw**2*sw**4*PropZ34C
     &     - s12**(-1)*s14*s34**(-1)*cw**2*sw**4*PropZ12C - s12**(-1)*
     &    s14*s34**(-1)*cw**2*sw**4*PropZ34 + s12**(-1)*s14*s34**(-1)*
     &    cw**2*sw**4*PropZ12 - s12**(-1)*s13*s34**(-1)*cw**2*sw**4*
     &    PropZ34C - s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12C + 
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ34 + s12**(-1)*s13*
     &    s34**(-1)*cw**2*sw**4*PropZ12 )
      MSQBSM = MSQBSM + CV*mzsq**(-1)*couplsm*NPSQ*Caa*dGl1L * ( 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     + 2*s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C - 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 - 2*s12**(-1)*s14**2*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C - 2*s12**(-1)*s14**2*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s12**(-1)*s13*
     &    s24**2*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s12**(-1)*
     &    s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     + 2*s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 + 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 2*s12**(-1)*s13*s14*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*mzsq**(-1)*couplsm*NPSQ*Caa*dGl1L * ( 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 2*s24*cw**2*sw**4*PropZ12C*PropZ34C - 2*s24
     &    *cw**2*sw**4*PropZ12*PropZ34 - 2*s23*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 2*s23*cw**2*sw**4*PropZ12*PropZ34 - 2*s14*cw**2*
     &    sw**4*PropZ12C*PropZ34C - 2*s14*cw**2*sw**4*PropZ12*PropZ34
     &     - 2*s13*cw**2*sw**4*PropZ12C*PropZ34C - 2*s13*cw**2*sw**4*
     &    PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CV*mzsq**(-1)*couplsm*NPSQ*Caa*dGl1R * ( 2*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     + 2*s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 - 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C - 2*s12**(-1)*s14*s23**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 - 2*s12**(-1)*s14**2*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C - 2*s12**(-1)*s14**2*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*s12**(-1)*s13*
     &    s24**2*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*s12**(-1)*
     &    s13*s24**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     + 2*s12**(-1)*s13*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 + 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 2*s12**(-1)*s13*s14*s24*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 2*s12**(-1)*s13*s14*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*mzsq**(-1)*couplsm*NPSQ*Caa*dGl1R * ( 2*
     &    s12**(-1)*s13*s14*s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34
     &     - 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 2*s12**(-1)*s13**2*s24*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 - 2*s24*cw**2*sw**4*PropZ12C*PropZ34C - 2*s24
     &    *cw**2*sw**4*PropZ12*PropZ34 - 2*s23*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 2*s23*cw**2*sw**4*PropZ12*PropZ34 - 2*s14*cw**2*
     &    sw**4*PropZ12C*PropZ34C - 2*s14*cw**2*sw**4*PropZ12*PropZ34
     &     - 2*s13*cw**2*sw**4*PropZ12C*PropZ34C - 2*s13*cw**2*sw**4*
     &    PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CV*mzsq**(-1)*eps1234*couplsm*NPSQ*Caa*dGl1L
     &  * (  - 2*s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     + 2*s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CV*mzsq**(-1)*eps1234*couplsm*NPSQ*Caa*dGl1R
     &  * ( 2*s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2
     &    *s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 
     &    12*s14*s23*s24*PropZ34*PropZ12C*PropZ34C + 12*s14*s23*s24*
     &    PropZ12*PropZ12C*PropZ34C + 12*s14*s23*s24*PropZ12*PropZ34*
     &    PropZ34C + 12*s14*s23*s24*PropZ12*PropZ34*PropZ12C + 4*s14*
     &    s23**2*PropZ34*PropZ12C*PropZ34C + 4*s14*s23**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s14*s23**2*PropZ12*PropZ34*PropZ34C + 4
     &    *s14*s23**2*PropZ12*PropZ34*PropZ12C + 4*s14**2*s23*PropZ34*
     &    PropZ12C*PropZ34C + 4*s14**2*s23*PropZ12*PropZ12C*PropZ34C + 
     &    4*s14**2*s23*PropZ12*PropZ34*PropZ34C + 4*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C - 12*s13*s24**2*PropZ34*PropZ12C*PropZ34C - 
     &    12*s13*s24**2*PropZ12*PropZ12C*PropZ34C - 12*s13*s24**2*
     &    PropZ12*PropZ34*PropZ34C - 12*s13*s24**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s13*s23*s24*PropZ34*PropZ12C*PropZ34C - 4*s13*
     &    s23*s24*PropZ12*PropZ12C*PropZ34C - 4*s13*s23*s24*PropZ12*
     &    PropZ34*PropZ34C - 4*s13*s23*s24*PropZ12*PropZ34*PropZ12C - 4
     &    *s13*s14*s24*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 
     &     - 4*s13*s14*s24*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*s24*
     &    PropZ12*PropZ34*PropZ34C - 4*s13*s14*s24*PropZ12*PropZ34*
     &    PropZ12C + 12*s13*s14*s23*PropZ34*PropZ12C*PropZ34C + 12*s13*
     &    s14*s23*PropZ12*PropZ12C*PropZ34C + 12*s13*s14*s23*PropZ12*
     &    PropZ34*PropZ34C + 12*s13*s14*s23*PropZ12*PropZ34*PropZ12C - 
     &    12*s13**2*s24*PropZ34*PropZ12C*PropZ34C - 12*s13**2*s24*
     &    PropZ12*PropZ12C*PropZ34C - 12*s13**2*s24*PropZ12*PropZ34*
     &    PropZ34C - 12*s13**2*s24*PropZ12*PropZ34*PropZ12C - 12*s12*
     &    s24*s34*PropZ34*PropZ12C*PropZ34C - 12*s12*s24*s34*PropZ12*
     &    PropZ12C*PropZ34C - 12*s12*s24*s34*PropZ12*PropZ34*PropZ34C
     &     - 12*s12*s24*s34*PropZ12*PropZ34*PropZ12C + 4*s12*s23*s34*
     &    PropZ34*PropZ12C*PropZ34C + 4*s12*s23*s34*PropZ12*PropZ12C*
     &    PropZ34C + 4*s12*s23*s34*PropZ12*PropZ34*PropZ34C + 4*s12*s23
     &    *s34*PropZ12*PropZ34*PropZ12C + 4*s12*s14*s34*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 4
     &    *s12*s14*s34*PropZ12*PropZ12C*PropZ34C + 4*s12*s14*s34*
     &    PropZ12*PropZ34*PropZ34C + 4*s12*s14*s34*PropZ12*PropZ34*
     &    PropZ12C - 12*s12*s13*s34*PropZ34*PropZ12C*PropZ34C - 12*s12*
     &    s13*s34*PropZ12*PropZ12C*PropZ34C - 12*s12*s13*s34*PropZ12*
     &    PropZ34*PropZ34C - 12*s12*s13*s34*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &     - 16*s14*s23*s34*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*s34*
     &    PropZ12*PropZ12C*PropZ34C - 16*s14*s23*s34*PropZ12*PropZ34*
     &    PropZ34C - 16*s14*s23*s34*PropZ12*PropZ34*PropZ12C + 48*s13*
     &    s24*s34*PropZ34*PropZ12C*PropZ34C + 48*s13*s24*s34*PropZ12*
     &    PropZ12C*PropZ34C + 48*s13*s24*s34*PropZ12*PropZ34*PropZ34C
     &     + 48*s13*s24*s34*PropZ12*PropZ34*PropZ12C - 16*s12*s14*s23*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C - 16*s12*s14*s23*PropZ12*PropZ34*PropZ34C - 16*s12*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 48*s12*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 48*s12*s13*s24*PropZ12*PropZ12C*PropZ34C
     &     + 48*s12*s13*s24*PropZ12*PropZ34*PropZ34C + 48*s12*s13*s24*
     &    PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 
     &    12*s14*s23*s24*PropZ34*PropZ12C*PropZ34C + 12*s14*s23*s24*
     &    PropZ12*PropZ12C*PropZ34C + 12*s14*s23*s24*PropZ12*PropZ34*
     &    PropZ34C + 12*s14*s23*s24*PropZ12*PropZ34*PropZ12C + 4*s14*
     &    s23**2*PropZ34*PropZ12C*PropZ34C + 4*s14*s23**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s14*s23**2*PropZ12*PropZ34*PropZ34C + 4
     &    *s14*s23**2*PropZ12*PropZ34*PropZ12C + 4*s14**2*s23*PropZ34*
     &    PropZ12C*PropZ34C + 4*s14**2*s23*PropZ12*PropZ12C*PropZ34C + 
     &    4*s14**2*s23*PropZ12*PropZ34*PropZ34C + 4*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C - 12*s13*s24**2*PropZ34*PropZ12C*PropZ34C - 
     &    12*s13*s24**2*PropZ12*PropZ12C*PropZ34C - 12*s13*s24**2*
     &    PropZ12*PropZ34*PropZ34C - 12*s13*s24**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s13*s23*s24*PropZ34*PropZ12C*PropZ34C - 4*s13*
     &    s23*s24*PropZ12*PropZ12C*PropZ34C - 4*s13*s23*s24*PropZ12*
     &    PropZ34*PropZ34C - 4*s13*s23*s24*PropZ12*PropZ34*PropZ12C - 4
     &    *s13*s14*s24*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 
     &     - 4*s13*s14*s24*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*s24*
     &    PropZ12*PropZ34*PropZ34C - 4*s13*s14*s24*PropZ12*PropZ34*
     &    PropZ12C + 12*s13*s14*s23*PropZ34*PropZ12C*PropZ34C + 12*s13*
     &    s14*s23*PropZ12*PropZ12C*PropZ34C + 12*s13*s14*s23*PropZ12*
     &    PropZ34*PropZ34C + 12*s13*s14*s23*PropZ12*PropZ34*PropZ12C - 
     &    12*s13**2*s24*PropZ34*PropZ12C*PropZ34C - 12*s13**2*s24*
     &    PropZ12*PropZ12C*PropZ34C - 12*s13**2*s24*PropZ12*PropZ34*
     &    PropZ34C - 12*s13**2*s24*PropZ12*PropZ34*PropZ12C - 12*s12*
     &    s24*s34*PropZ34*PropZ12C*PropZ34C - 12*s12*s24*s34*PropZ12*
     &    PropZ12C*PropZ34C - 12*s12*s24*s34*PropZ12*PropZ34*PropZ34C
     &     - 12*s12*s24*s34*PropZ12*PropZ34*PropZ12C + 4*s12*s23*s34*
     &    PropZ34*PropZ12C*PropZ34C + 4*s12*s23*s34*PropZ12*PropZ12C*
     &    PropZ34C + 4*s12*s23*s34*PropZ12*PropZ34*PropZ34C + 4*s12*s23
     &    *s34*PropZ12*PropZ34*PropZ12C + 4*s12*s14*s34*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 4
     &    *s12*s14*s34*PropZ12*PropZ12C*PropZ34C + 4*s12*s14*s34*
     &    PropZ12*PropZ34*PropZ34C + 4*s12*s14*s34*PropZ12*PropZ34*
     &    PropZ12C - 12*s12*s13*s34*PropZ34*PropZ12C*PropZ34C - 12*s12*
     &    s13*s34*PropZ12*PropZ12C*PropZ34C - 12*s12*s13*s34*PropZ12*
     &    PropZ34*PropZ34C - 12*s12*s13*s34*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &     - 16*s14*s23*s34*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*s34*
     &    PropZ12*PropZ12C*PropZ34C - 16*s14*s23*s34*PropZ12*PropZ34*
     &    PropZ34C - 16*s14*s23*s34*PropZ12*PropZ34*PropZ12C + 48*s13*
     &    s24*s34*PropZ34*PropZ12C*PropZ34C + 48*s13*s24*s34*PropZ12*
     &    PropZ12C*PropZ34C + 48*s13*s24*s34*PropZ12*PropZ34*PropZ34C
     &     + 48*s13*s24*s34*PropZ12*PropZ34*PropZ12C - 16*s12*s14*s23*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C - 16*s12*s14*s23*PropZ12*PropZ34*PropZ34C - 16*s12*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 48*s12*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 48*s12*s13*s24*PropZ12*PropZ12C*PropZ34C
     &     + 48*s12*s13*s24*PropZ12*PropZ34*PropZ34C + 48*s12*s13*s24*
     &    PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czz * (  - 
     &    8*s12**(-1)*s14**2*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C - 8
     &    *s12**(-1)*s14**2*s23**2*sw**2*PropZ12*PropZ34*PropZ34C + 16*
     &    s12**(-1)*s13*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 
     &    16*s12**(-1)*s13*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C
     &     - 8*s12**(-1)*s13**2*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C
     &     - 8*s12**(-1)*s13**2*s24**2*sw**2*PropZ12*PropZ34*PropZ34C
     &     - 12*s24**2*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 12*s24**2*
     &    s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s23**2*s34*sw**2*
     &    PropZ34*PropZ12C*PropZ34C + 4*s23**2*s34*sw**2*PropZ12*
     &    PropZ34*PropZ34C + 24*s14*s23*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 24*s14*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s14**2*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s14**2*s34*
     &    sw**2*PropZ12*PropZ34*PropZ34C - 8*s14**2*s23**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C*PropZ34C - 8*s14**2*s23**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czz * (  - 
     &    8*s13*s24*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 8*s13*s24*s34
     &    *sw**2*PropZ12*PropZ34*PropZ34C + 16*s13*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 16*s13*s14*s23*
     &    s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 12*s13**2*s34*
     &    sw**2*PropZ34*PropZ12C*PropZ34C - 12*s13**2*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C - 8*s13**2*s24**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 8*s13**2*s24**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 8*s12*s34**2*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 8*s12*s34**2*sw**2*PropZ12*PropZ34*PropZ34C - 12*
     &    s12*s24**2*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s12*s24**2*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s23**2*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s12*s23**2*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 24*s12*s14*s23*sw**2*PropZ12*PropZ12C*PropZ34C + 
     &    24*s12*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s14**2*
     &    sw**2*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czz * ( 4*
     &    s12*s14**2*sw**2*PropZ12*PropZ34*PropZ12C - 8*s12*s13*s24*
     &    sw**2*PropZ12*PropZ12C*PropZ34C - 8*s12*s13*s24*sw**2*PropZ12
     &    *PropZ34*PropZ12C - 12*s12*s13**2*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 12*s12*s13**2*sw**2*PropZ12*PropZ34*PropZ12C - 8*
     &    s12**2*s34*sw**2*PropZ12*PropZ12C*PropZ34C - 8*s12**2*s34*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 
     &     - 12*s12**(-1)*s14*s23*s24*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 12*s12**(-1)*s14*s23*s24*s34*sw**2*PropZ12*PropZ34
     &    *PropZ34C - 4*s12**(-1)*s14*s23**2*s34*sw**2*PropZ34*PropZ12C
     &    *PropZ34C - 4*s12**(-1)*s14*s23**2*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 4*s12**(-1)*s14**2*s23*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 4*s12**(-1)*s14**2*s23*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 12*s12**(-1)*s13*s24**2*s34*sw**2*PropZ34*PropZ12C
     &    *PropZ34C + 12*s12**(-1)*s13*s24**2*s34*sw**2*PropZ12*PropZ34
     &    *PropZ34C + 4*s12**(-1)*s13*s23*s24*s34*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 4*s12**(-1)*s13*s23*s24*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C + 4*s12**(-1)*s13*s14*s24*s34*sw**2*PropZ34
     &    *PropZ12C*PropZ34C + 4*s12**(-1)*s13*s14*s24*s34*sw**2*
     &    PropZ12*PropZ34*PropZ34C - 12*s12**(-1)*s13*s14*s23*s34*sw**2
     &    *PropZ34*PropZ12C*PropZ34C - 12*s12**(-1)*s13*s14*s23*s34*
     &    sw**2*PropZ12*PropZ34*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 12
     &    *s12**(-1)*s13**2*s24*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 
     &    12*s12**(-1)*s13**2*s24*s34*sw**2*PropZ12*PropZ34*PropZ34C + 
     &    12*s24*s34**2*sw**2*PropZ34*PropZ12C*PropZ34C + 12*s24*s34**2
     &    *sw**2*PropZ12*PropZ34*PropZ34C - 4*s23*s34**2*sw**2*PropZ34*
     &    PropZ12C*PropZ34C - 4*s23*s34**2*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 4*s14*s34**2*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s14*s34**2*sw**2*PropZ12*PropZ34*PropZ34C - 12*s14*s23*s24*
     &    sw**2*PropZ34*PropZ12C*PropZ34C - 12*s14*s23*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 12*s14*s23*s24*sw**2*PropZ12*
     &    PropZ34*PropZ34C - 12*s14*s23*s24*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s14*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s14*s23**2*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s14*s23**2*
     &    sw**2*PropZ12*PropZ34*PropZ34C - 4*s14*s23**2*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s14**2*s23*sw**2*PropZ34*PropZ12C*
     &    PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 
     &     - 4*s14**2*s23*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s14**2*
     &    s23*sw**2*PropZ12*PropZ34*PropZ34C - 4*s14**2*s23*sw**2*
     &    PropZ12*PropZ34*PropZ12C + 12*s13*s34**2*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 12*s13*s34**2*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 12*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 12
     &    *s13*s24**2*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s13*s24**2*
     &    sw**2*PropZ12*PropZ34*PropZ34C + 12*s13*s24**2*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s13*s23*s24*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 4*s13*s23*s24*sw**2*PropZ12*PropZ12C*PropZ34C + 4*
     &    s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s13*s23*s24*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 4*s13*s14*s24*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 4*s13*s14*s24*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ12C - 12*s13*s14*s23*
     &    sw**2*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 
     &     - 12*s13*s14*s23*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s13*
     &    s14*s23*sw**2*PropZ12*PropZ34*PropZ34C - 12*s13*s14*s23*sw**2
     &    *PropZ12*PropZ34*PropZ12C + 12*s13**2*s24*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 12*s13**2*s24*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 12*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C + 12*
     &    s13**2*s24*sw**2*PropZ12*PropZ34*PropZ12C + 12*s12*s24*s34*
     &    sw**2*PropZ34*PropZ12C*PropZ34C + 12*s12*s24*s34*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 12*s12*s24*s34*sw**2*PropZ12*
     &    PropZ34*PropZ34C + 12*s12*s24*s34*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s12*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12*s23*s34*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*s23*s34*
     &    sw**2*PropZ12*PropZ34*PropZ34C - 4*s12*s23*s34*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s12*s14*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 4*s12*s14*s34*sw**2*PropZ12*PropZ12C*PropZ34C - 4*
     &    s12*s14*s34*sw**2*PropZ12*PropZ34*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 
     &     - 4*s12*s14*s34*sw**2*PropZ12*PropZ34*PropZ12C - 12*s12*s14*
     &    s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s12*
     &    s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s12*
     &    s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*
     &    s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s12*
     &    s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*
     &    s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 12*s12*
     &    s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 12*s12*s13*s34*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 12*s12*s13*s34*sw**2*
     &    PropZ12*PropZ34*PropZ34C + 12*s12*s13*s34*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 12*s12*s13*s24**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 12*s12*s13*s24**2*s34**(-1)*sw**2*PropZ12
     &    *PropZ34*PropZ12C + 4*s12*s13*s23*s24*s34**(-1)*sw**2*PropZ12
     &    *PropZ12C*PropZ34C + 4*s12*s13*s23*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 4*
     &    s12*s13*s14*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4
     &    *s12*s13*s14*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 
     &    12*s12*s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C
     &     - 12*s12*s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 12*s12*s13**2*s24*s34**(-1)*sw**2*PropZ12*PropZ12C
     &    *PropZ34C + 12*s12*s13**2*s24*s34**(-1)*sw**2*PropZ12*PropZ34
     &    *PropZ12C + 12*s12**2*s24*sw**2*PropZ12*PropZ12C*PropZ34C + 
     &    12*s12**2*s24*sw**2*PropZ12*PropZ34*PropZ12C - 4*s12**2*s23*
     &    sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12**2*s23*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s12**2*s14*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s12**2*s14*sw**2*PropZ12*PropZ34*PropZ12C + 12*
     &    s12**2*s13*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s12**2*s13*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czz * ( 
     &     - 12*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 12*s14*
     &    s23*s24*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s14*s23*s24*
     &    sw**2*PropZ12*PropZ34*PropZ34C - 12*s14*s23*s24*sw**2*PropZ12
     &    *PropZ34*PropZ12C - 4*s14*s23**2*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 4*s14*s23**2*sw**2*PropZ12*PropZ12C*PropZ34C - 4*
     &    s14*s23**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*s14*s23**2*
     &    sw**2*PropZ12*PropZ34*PropZ12C - 4*s14**2*s23*sw**2*PropZ34*
     &    PropZ12C*PropZ34C - 4*s14**2*s23*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s14**2*s23*sw**2*PropZ12*PropZ34*PropZ12C + 12*s13*s24**2*
     &    sw**2*PropZ34*PropZ12C*PropZ34C + 12*s13*s24**2*sw**2*PropZ12
     &    *PropZ12C*PropZ34C + 12*s13*s24**2*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 12*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ12C + 4*
     &    s13*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s13*s23*s24*
     &    sw**2*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czz * ( 4*
     &    s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s13*s23*s24*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 4*s13*s14*s24*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 4*s13*s14*s24*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ12C - 12*s13*s14*s23*
     &    sw**2*PropZ34*PropZ12C*PropZ34C - 12*s13*s14*s23*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 12*s13*s14*s23*sw**2*PropZ12*
     &    PropZ34*PropZ34C - 12*s13*s14*s23*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 12*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 12
     &    *s13**2*s24*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s13**2*s24*
     &    sw**2*PropZ12*PropZ34*PropZ34C + 12*s13**2*s24*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 12*s12*s24*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 12*s12*s24*s34*sw**2*PropZ12*PropZ12C*PropZ34C + 
     &    12*s12*s24*s34*sw**2*PropZ12*PropZ34*PropZ34C + 12*s12*s24*
     &    s34*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czz * ( 
     &     - 4*s12*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s12*s23*
     &    s34*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*s23*s34*sw**2*
     &    PropZ12*PropZ34*PropZ34C - 4*s12*s23*s34*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s12*s14*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 4*s12*s14*s34*sw**2*PropZ12*PropZ12C*PropZ34C - 4*
     &    s12*s14*s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*s12*s14*s34*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 12*s12*s13*s34*sw**2*PropZ34
     &    *PropZ12C*PropZ34C + 12*s12*s13*s34*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 12*s12*s13*s34*sw**2*PropZ12*PropZ34*PropZ34C + 12
     &    *s12*s13*s34*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czbx * ( 
     &    16*s14*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*
     &    s34*sw**2*PropZ12*PropZ12C*PropZ34C + 16*s14*s23*s34*sw**2*
     &    PropZ12*PropZ34*PropZ34C + 16*s14*s23*s34*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 48*s13*s24*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 48*s13*s24*s34*sw**2*PropZ12*PropZ12C*PropZ34C - 
     &    48*s13*s24*s34*sw**2*PropZ12*PropZ34*PropZ34C - 48*s13*s24*
     &    s34*sw**2*PropZ12*PropZ34*PropZ12C + 16*s12*s14*s23*sw**2*
     &    PropZ34*PropZ12C*PropZ34C + 16*s12*s14*s23*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 16*s12*s14*s23*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 16*s12*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C - 48
     &    *s12*s13*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 48*s12*s13*s24
     &    *sw**2*PropZ12*PropZ12C*PropZ34C - 48*s12*s13*s24*sw**2*
     &    PropZ12*PropZ34*PropZ34C - 48*s12*s13*s24*sw**2*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*eps1234*couplsm*NPSQ*dGl1L*
     & Czz * ( 12*s24*PropZ34*PropZ12C*PropZ34C + 12*s24*PropZ12*
     &    PropZ12C*PropZ34C - 12*s24*PropZ12*PropZ34*PropZ34C - 12*s24*
     &    PropZ12*PropZ34*PropZ12C + 4*s23*PropZ34*PropZ12C*PropZ34C - 
     &    4*s23*PropZ12*PropZ12C*PropZ34C - 4*s23*PropZ12*PropZ34*
     &    PropZ34C + 4*s23*PropZ12*PropZ34*PropZ12C - 4*s14*PropZ34*
     &    PropZ12C*PropZ34C + 4*s14*PropZ12*PropZ12C*PropZ34C + 4*s14*
     &    PropZ12*PropZ34*PropZ34C - 4*s14*PropZ12*PropZ34*PropZ12C - 
     &    12*s13*PropZ34*PropZ12C*PropZ34C - 12*s13*PropZ12*PropZ12C*
     &    PropZ34C + 12*s13*PropZ12*PropZ34*PropZ34C + 12*s13*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*eps1234*couplsm*NPSQ*dGl1R*
     & Czz * (  - 12*s24*PropZ34*PropZ12C*PropZ34C - 12*s24*PropZ12*
     &    PropZ12C*PropZ34C + 12*s24*PropZ12*PropZ34*PropZ34C + 12*s24*
     &    PropZ12*PropZ34*PropZ12C - 4*s23*PropZ34*PropZ12C*PropZ34C + 
     &    4*s23*PropZ12*PropZ12C*PropZ34C + 4*s23*PropZ12*PropZ34*
     &    PropZ34C - 4*s23*PropZ12*PropZ34*PropZ12C + 4*s14*PropZ34*
     &    PropZ12C*PropZ34C - 4*s14*PropZ12*PropZ12C*PropZ34C - 4*s14*
     &    PropZ12*PropZ34*PropZ34C + 4*s14*PropZ12*PropZ34*PropZ12C + 
     &    12*s13*PropZ34*PropZ12C*PropZ34C + 12*s13*PropZ12*PropZ12C*
     &    PropZ34C - 12*s13*PropZ12*PropZ34*PropZ34C - 12*s13*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*dCz * ( 
     &     - 16*s14*s23*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C - 16*s14*s23*PropZ12*PropZ34*PropZ34C - 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 48*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 48*s13*s24*PropZ12*PropZ12C*PropZ34C + 48
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 48*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czz * ( 
     &    48*s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s14*
     &    s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s14**2*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 48*s13*s24**2*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s13*s23*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s13*s14*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 48*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     - 48*s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 48*s12*
     &    s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*s14*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 48*s12*s13*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &     - 64*s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s13
     &    *s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 64*s12*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s12*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*dCz * ( 
     &     - 16*s14*s23*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C - 16*s14*s23*PropZ12*PropZ34*PropZ34C - 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 48*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 48*s13*s24*PropZ12*PropZ12C*PropZ34C + 48
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 48*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czz * ( 
     &    48*s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s14*
     &    s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s14**2*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 48*s13*s24**2*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s13*s23*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 16*s13*s14*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 48*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     - 48*s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 48*s12*
     &    s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s12*s14*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 48*s12*s13*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &     - 64*s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s13
     &    *s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 64*s12*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s12*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*Cza*dCz * (  - 
     &    12*s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 12
     &    *s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C + 12*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 12*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C - 12*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 12*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C + 12*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*Cza*dCz * ( 12*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C + 12*s24*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C + 12*s24*s34*sw**2*
     &    PropZ12*PropZ34*PropZ34C - 4*s23*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 4*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*s14*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s14*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C - 12*s14*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 12*s14*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 12*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 12*s13*s34*sw**2*PropZ12*PropZ34*PropZ34C + 12*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*Cza*dCz * ( 4*
     &    s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13
     &    *s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s13*s14
     &    *s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s14*
     &    s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 12*s13*s14*s23
     &    *s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 12*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 12*s12*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 12*s12*s24*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s12*s23*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*
     &    s23*sw**2*PropZ12*PropZ34*PropZ12C - 4*s12*s14*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s12*s14*sw**2*PropZ12*PropZ34*PropZ12C
     &     + 12*s12*s13*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s12*s13*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NPSQ*Cabx*dCz * ( 16
     &    *s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 16*s14*s23*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 16*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C - 48*s13
     &    *s24*sw**2*PropZ34*PropZ12C*PropZ34C - 48*s13*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 48*s13*s24*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 48*s13*s24*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NP*dGl1L * (  - 16*
     &    s14*s23*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C - 16*s14*s23*PropZ12*PropZ34*PropZ34C - 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 48*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 48*s13*s24*PropZ12*PropZ12C*PropZ34C + 48
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 48*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NP*dGl1R * (  - 16*
     &    s14*s23*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C - 16*s14*s23*PropZ12*PropZ34*PropZ34C - 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 48*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 48*s13*s24*PropZ12*PropZ12C*PropZ34C + 48
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 48*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NP*Cza * (  - 12*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 12*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C + 12*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 12*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C - 12*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 12*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C + 12*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NP*Cza * ( 12*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C + 12*s24*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C + 12*s24*s34*sw**2*
     &    PropZ12*PropZ34*PropZ34C - 4*s23*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 4*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*s14*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s14*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C - 12*s14*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 12*s14*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 12*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 12*s13*s34*sw**2*PropZ12*PropZ34*PropZ34C + 12*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NP*Cza * ( 4*s13*s23
     &    *s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s23*
     &    s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s13*s14*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s14*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 12*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 12*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 12*s12*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 12*s12*s24*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s12*s23*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*
     &    s23*sw**2*PropZ12*PropZ34*PropZ12C - 4*s12*s14*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s12*s14*sw**2*PropZ12*PropZ34*PropZ12C
     &     + 12*s12*s13*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s12*s13*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*couplsm*NP*Cabx * ( 16*s14*
     &    s23*sw**2*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 16*s14*s23*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 16*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C - 48*s13
     &    *s24*sw**2*PropZ34*PropZ12C*PropZ34C - 48*s13*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 48*s13*s24*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 48*s13*s24*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*couplsm*NPSQ*dGl1L*dCz * (  - 64*s14*
     &    s23*PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*couplsm*NPSQ*dGl1R*dCz * (  - 64*s14*
     &    s23*PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*couplsm*NP*dGl1L * (  - 64*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*couplsm*NP*dGl1R * (  - 64*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 192*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 4
     &    *s14*s23*s24*PropZ34*PropZ12C*PropZ34C + 4*s14*s23*s24*
     &    PropZ12*PropZ12C*PropZ34C + 4*s14*s23*s24*PropZ12*PropZ34*
     &    PropZ34C + 4*s14*s23*s24*PropZ12*PropZ34*PropZ12C - 4*s14*
     &    s23**2*PropZ34*PropZ12C*PropZ34C - 4*s14*s23**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s14*s23**2*PropZ12*PropZ34*PropZ34C - 4
     &    *s14*s23**2*PropZ12*PropZ34*PropZ12C - 4*s14**2*s23*PropZ34*
     &    PropZ12C*PropZ34C - 4*s14**2*s23*PropZ12*PropZ12C*PropZ34C - 
     &    4*s14**2*s23*PropZ12*PropZ34*PropZ34C - 4*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C - 4*s13*s24**2*PropZ34*PropZ12C*PropZ34C - 4
     &    *s13*s24**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s24**2*PropZ12*
     &    PropZ34*PropZ34C - 4*s13*s24**2*PropZ12*PropZ34*PropZ12C + 4*
     &    s13*s23*s24*PropZ34*PropZ12C*PropZ34C + 4*s13*s23*s24*PropZ12
     &    *PropZ12C*PropZ34C + 4*s13*s23*s24*PropZ12*PropZ34*PropZ34C
     &     + 4*s13*s23*s24*PropZ12*PropZ34*PropZ12C + 4*s13*s14*s24*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 4
     &    *s13*s14*s24*PropZ12*PropZ12C*PropZ34C + 4*s13*s14*s24*
     &    PropZ12*PropZ34*PropZ34C + 4*s13*s14*s24*PropZ12*PropZ34*
     &    PropZ12C + 4*s13*s14*s23*PropZ34*PropZ12C*PropZ34C + 4*s13*
     &    s14*s23*PropZ12*PropZ12C*PropZ34C + 4*s13*s14*s23*PropZ12*
     &    PropZ34*PropZ34C + 4*s13*s14*s23*PropZ12*PropZ34*PropZ12C - 4
     &    *s13**2*s24*PropZ34*PropZ12C*PropZ34C - 4*s13**2*s24*PropZ12*
     &    PropZ12C*PropZ34C - 4*s13**2*s24*PropZ12*PropZ34*PropZ34C - 4
     &    *s13**2*s24*PropZ12*PropZ34*PropZ12C - 4*s12*s24*s34*PropZ34*
     &    PropZ12C*PropZ34C - 4*s12*s24*s34*PropZ12*PropZ12C*PropZ34C
     &     - 4*s12*s24*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s24*s34*
     &    PropZ12*PropZ34*PropZ12C - 4*s12*s23*s34*PropZ34*PropZ12C*
     &    PropZ34C - 4*s12*s23*s34*PropZ12*PropZ12C*PropZ34C - 4*s12*
     &    s23*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s23*s34*PropZ12*
     &    PropZ34*PropZ12C - 4*s12*s14*s34*PropZ34*PropZ12C*PropZ34C - 
     &    4*s12*s14*s34*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czz * ( 
     &     - 4*s12*s14*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s14*s34*
     &    PropZ12*PropZ34*PropZ12C - 4*s12*s13*s34*PropZ34*PropZ12C*
     &    PropZ34C - 4*s12*s13*s34*PropZ12*PropZ12C*PropZ34C - 4*s12*
     &    s13*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s13*s34*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &    16*s14*s23*s34*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*s34*
     &    PropZ12*PropZ12C*PropZ34C + 16*s14*s23*s34*PropZ12*PropZ34*
     &    PropZ34C + 16*s14*s23*s34*PropZ12*PropZ34*PropZ12C + 16*s13*
     &    s24*s34*PropZ34*PropZ12C*PropZ34C + 16*s13*s24*s34*PropZ12*
     &    PropZ12C*PropZ34C + 16*s13*s24*s34*PropZ12*PropZ34*PropZ34C
     &     + 16*s13*s24*s34*PropZ12*PropZ34*PropZ12C + 16*s12*s14*s23*
     &    PropZ34*PropZ12C*PropZ34C + 16*s12*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C + 16*s12*s14*s23*PropZ12*PropZ34*PropZ34C + 16*s12*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 16*s12*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 16*s12*s13*s24*PropZ12*PropZ12C*PropZ34C
     &     + 16*s12*s13*s24*PropZ12*PropZ34*PropZ34C + 16*s12*s13*s24*
     &    PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 4
     &    *s14*s23*s24*PropZ34*PropZ12C*PropZ34C + 4*s14*s23*s24*
     &    PropZ12*PropZ12C*PropZ34C + 4*s14*s23*s24*PropZ12*PropZ34*
     &    PropZ34C + 4*s14*s23*s24*PropZ12*PropZ34*PropZ12C - 4*s14*
     &    s23**2*PropZ34*PropZ12C*PropZ34C - 4*s14*s23**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s14*s23**2*PropZ12*PropZ34*PropZ34C - 4
     &    *s14*s23**2*PropZ12*PropZ34*PropZ12C - 4*s14**2*s23*PropZ34*
     &    PropZ12C*PropZ34C - 4*s14**2*s23*PropZ12*PropZ12C*PropZ34C - 
     &    4*s14**2*s23*PropZ12*PropZ34*PropZ34C - 4*s14**2*s23*PropZ12*
     &    PropZ34*PropZ12C - 4*s13*s24**2*PropZ34*PropZ12C*PropZ34C - 4
     &    *s13*s24**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s24**2*PropZ12*
     &    PropZ34*PropZ34C - 4*s13*s24**2*PropZ12*PropZ34*PropZ12C + 4*
     &    s13*s23*s24*PropZ34*PropZ12C*PropZ34C + 4*s13*s23*s24*PropZ12
     &    *PropZ12C*PropZ34C + 4*s13*s23*s24*PropZ12*PropZ34*PropZ34C
     &     + 4*s13*s23*s24*PropZ12*PropZ34*PropZ12C + 4*s13*s14*s24*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 4
     &    *s13*s14*s24*PropZ12*PropZ12C*PropZ34C + 4*s13*s14*s24*
     &    PropZ12*PropZ34*PropZ34C + 4*s13*s14*s24*PropZ12*PropZ34*
     &    PropZ12C + 4*s13*s14*s23*PropZ34*PropZ12C*PropZ34C + 4*s13*
     &    s14*s23*PropZ12*PropZ12C*PropZ34C + 4*s13*s14*s23*PropZ12*
     &    PropZ34*PropZ34C + 4*s13*s14*s23*PropZ12*PropZ34*PropZ12C - 4
     &    *s13**2*s24*PropZ34*PropZ12C*PropZ34C - 4*s13**2*s24*PropZ12*
     &    PropZ12C*PropZ34C - 4*s13**2*s24*PropZ12*PropZ34*PropZ34C - 4
     &    *s13**2*s24*PropZ12*PropZ34*PropZ12C - 4*s12*s24*s34*PropZ34*
     &    PropZ12C*PropZ34C - 4*s12*s24*s34*PropZ12*PropZ12C*PropZ34C
     &     - 4*s12*s24*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s24*s34*
     &    PropZ12*PropZ34*PropZ12C - 4*s12*s23*s34*PropZ34*PropZ12C*
     &    PropZ34C - 4*s12*s23*s34*PropZ12*PropZ12C*PropZ34C - 4*s12*
     &    s23*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s23*s34*PropZ12*
     &    PropZ34*PropZ12C - 4*s12*s14*s34*PropZ34*PropZ12C*PropZ34C - 
     &    4*s12*s14*s34*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czz * ( 
     &     - 4*s12*s14*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s14*s34*
     &    PropZ12*PropZ34*PropZ12C - 4*s12*s13*s34*PropZ34*PropZ12C*
     &    PropZ34C - 4*s12*s13*s34*PropZ12*PropZ12C*PropZ34C - 4*s12*
     &    s13*s34*PropZ12*PropZ34*PropZ34C - 4*s12*s13*s34*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &    16*s14*s23*s34*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*s34*
     &    PropZ12*PropZ12C*PropZ34C + 16*s14*s23*s34*PropZ12*PropZ34*
     &    PropZ34C + 16*s14*s23*s34*PropZ12*PropZ34*PropZ12C + 16*s13*
     &    s24*s34*PropZ34*PropZ12C*PropZ34C + 16*s13*s24*s34*PropZ12*
     &    PropZ12C*PropZ34C + 16*s13*s24*s34*PropZ12*PropZ34*PropZ34C
     &     + 16*s13*s24*s34*PropZ12*PropZ34*PropZ12C + 16*s12*s14*s23*
     &    PropZ34*PropZ12C*PropZ34C + 16*s12*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C + 16*s12*s14*s23*PropZ12*PropZ34*PropZ34C + 16*s12*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 16*s12*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 16*s12*s13*s24*PropZ12*PropZ12C*PropZ34C
     &     + 16*s12*s13*s24*PropZ12*PropZ34*PropZ34C + 16*s12*s13*s24*
     &    PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czz * (  - 
     &    8*s12**(-1)*s14**2*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C - 8
     &    *s12**(-1)*s14**2*s23**2*sw**2*PropZ12*PropZ34*PropZ34C + 16*
     &    s12**(-1)*s13*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 
     &    16*s12**(-1)*s13*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C
     &     - 8*s12**(-1)*s13**2*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C
     &     - 8*s12**(-1)*s13**2*s24**2*sw**2*PropZ12*PropZ34*PropZ34C
     &     - 4*s24**2*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s24**2*
     &    s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*s23**2*s34*sw**2*
     &    PropZ34*PropZ12C*PropZ34C - 4*s23**2*s34*sw**2*PropZ12*
     &    PropZ34*PropZ34C + 8*s14*s23*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 8*s14*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s14**2*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s14**2*s34*
     &    sw**2*PropZ12*PropZ34*PropZ34C - 8*s14**2*s23**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C*PropZ34C - 8*s14**2*s23**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czz * ( 8*
     &    s13*s24*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 8*s13*s24*s34*
     &    sw**2*PropZ12*PropZ34*PropZ34C + 16*s13*s14*s23*s24*s34**(-1)
     &    *sw**2*PropZ12*PropZ12C*PropZ34C + 16*s13*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13**2*s34*sw**2
     &    *PropZ34*PropZ12C*PropZ34C - 4*s13**2*s34*sw**2*PropZ12*
     &    PropZ34*PropZ34C - 8*s13**2*s24**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 8*s13**2*s24**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 8*s12*s34**2*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 8*s12*s34**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12*s24**2*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*s24**2*
     &    sw**2*PropZ12*PropZ34*PropZ12C - 4*s12*s23**2*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s12*s23**2*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 8*s12*s14*s23*sw**2*PropZ12*PropZ12C*PropZ34C + 8*
     &    s12*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C - 4*s12*s14**2*
     &    sw**2*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czz * (  - 
     &    4*s12*s14**2*sw**2*PropZ12*PropZ34*PropZ12C + 8*s12*s13*s24*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 8*s12*s13*s24*sw**2*PropZ12
     &    *PropZ34*PropZ12C - 4*s12*s13**2*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s12*s13**2*sw**2*PropZ12*PropZ34*PropZ12C - 8*
     &    s12**2*s34*sw**2*PropZ12*PropZ12C*PropZ34C - 8*s12**2*s34*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 
     &     - 4*s12**(-1)*s14*s23*s24*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 4*s12**(-1)*s14*s23*s24*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 4*s12**(-1)*s14*s23**2*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 4*s12**(-1)*s14*s23**2*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 4*s12**(-1)*s14**2*s23*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 4*s12**(-1)*s14**2*s23*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 4*s12**(-1)*s13*s24**2*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 4*s12**(-1)*s13*s24**2*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 4*s12**(-1)*s13*s23*s24*s34*sw**2*PropZ34*PropZ12C
     &    *PropZ34C - 4*s12**(-1)*s13*s23*s24*s34*sw**2*PropZ12*PropZ34
     &    *PropZ34C - 4*s12**(-1)*s13*s14*s24*s34*sw**2*PropZ34*
     &    PropZ12C*PropZ34C - 4*s12**(-1)*s13*s14*s24*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C - 4*s12**(-1)*s13*s14*s23*s34*sw**2*PropZ34
     &    *PropZ12C*PropZ34C - 4*s12**(-1)*s13*s14*s23*s34*sw**2*
     &    PropZ12*PropZ34*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 4*
     &    s12**(-1)*s13**2*s24*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13**2*s24*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s24*s34**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s24*s34**2*
     &    sw**2*PropZ12*PropZ34*PropZ34C + 4*s23*s34**2*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 4*s23*s34**2*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 4*s14*s34**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s14*s34**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*s14*s23*s24*
     &    sw**2*PropZ34*PropZ12C*PropZ34C - 4*s14*s23*s24*sw**2*PropZ12
     &    *PropZ12C*PropZ34C - 4*s14*s23*s24*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 4*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ12C + 4*
     &    s14*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s14*s23**2*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 4*s14*s23**2*sw**2*PropZ12*
     &    PropZ34*PropZ34C + 4*s14*s23**2*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s14**2*s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s14**2*s23*sw**2*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 4*
     &    s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*s14**2*s23*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 4*s13*s34**2*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 4*s13*s34**2*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 4*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s13*s24**2*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s24**2*
     &    sw**2*PropZ12*PropZ34*PropZ34C + 4*s13*s24**2*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s13*s23*s24*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 4*s13*s23*s24*sw**2*PropZ12*PropZ12C*PropZ34C - 4*
     &    s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*s13*s23*s24*
     &    sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*s14*s24*sw**2*PropZ34*
     &    PropZ12C*PropZ34C - 4*s13*s14*s24*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*s14*s23*
     &    sw**2*PropZ34*PropZ12C*PropZ34C - 4*s13*s14*s23*sw**2*PropZ12
     &    *PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 
     &     - 4*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C - 4*s13*s14*
     &    s23*sw**2*PropZ12*PropZ34*PropZ12C + 4*s13**2*s24*sw**2*
     &    PropZ34*PropZ12C*PropZ34C + 4*s13**2*s24*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s13**2*s24*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 4*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ12C + 4*
     &    s12*s24*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s12*s24*s34*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*s24*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C + 4*s12*s24*s34*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12*s23*s34*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*s23*s34*
     &    sw**2*PropZ12*PropZ34*PropZ34C + 4*s12*s23*s34*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s12*s14*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 4*s12*s14*s34*sw**2*PropZ12*PropZ12C*PropZ34C + 4*
     &    s12*s14*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s12*s14*s34*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 
     &     - 4*s12*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s12*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s12*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s12*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12*s13*s34*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*s13*s34*
     &    sw**2*PropZ12*PropZ34*PropZ34C + 4*s12*s13*s34*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s12*s13*s24**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s12*s13*s24**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s12*s13*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s12*s13*s23*s24*s34**(-1)*sw**2*PropZ12
     &    *PropZ34*PropZ12C - 4*s12*s13*s14*s24*s34**(-1)*sw**2*PropZ12
     &    *PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cza*Czbx * ( 
     &     - 4*s12*s13*s14*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C
     &     - 4*s12*s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s12*s13*s14*s23*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s13**2*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s12*s13**2*s24*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12**2*s24*sw**2*PropZ12*PropZ12C*PropZ34C + 4*
     &    s12**2*s24*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12**2*s23*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12**2*s23*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s12**2*s14*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s12**2*s14*sw**2*PropZ12*PropZ34*PropZ12C + 4*
     &    s12**2*s13*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12**2*s13*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czz * ( 
     &     - 4*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s14*s23*
     &    s24*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s14*s23*s24*sw**2*
     &    PropZ12*PropZ34*PropZ34C - 4*s14*s23*s24*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s14*s23**2*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 4*s14*s23**2*sw**2*PropZ12*PropZ12C*PropZ34C + 4*
     &    s14*s23**2*sw**2*PropZ12*PropZ34*PropZ34C + 4*s14*s23**2*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 4*s14**2*s23*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 4*s14**2*s23*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s14**2*s23*sw**2*PropZ12*PropZ34*PropZ12C + 4*s13*s24**2*
     &    sw**2*PropZ34*PropZ12C*PropZ34C + 4*s13*s24**2*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s13*s24**2*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 4*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ12C - 4*
     &    s13*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s13*s23*s24*
     &    sw**2*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czz * ( 
     &     - 4*s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*s13*s23*
     &    s24*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*s14*s24*sw**2*
     &    PropZ34*PropZ12C*PropZ34C - 4*s13*s14*s24*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s13*s14*s24*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 4*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ12C - 4*
     &    s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s13*s14*s23*
     &    sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*s23*sw**2*PropZ12
     &    *PropZ34*PropZ34C - 4*s13*s14*s23*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s13**2*s24*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13**2*s24*
     &    sw**2*PropZ12*PropZ34*PropZ34C + 4*s13**2*s24*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s12*s24*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 4*s12*s24*s34*sw**2*PropZ12*PropZ12C*PropZ34C + 4*
     &    s12*s24*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s12*s24*s34*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czz * ( 4*
     &    s12*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s12*s23*s34*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*s23*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C + 4*s12*s23*s34*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s14*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12*s14*s34*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*s14*s34*
     &    sw**2*PropZ12*PropZ34*PropZ34C + 4*s12*s14*s34*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s12*s13*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 4*s12*s13*s34*sw**2*PropZ12*PropZ12C*PropZ34C + 4*
     &    s12*s13*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s12*s13*s34*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*Cabx*Czbx * ( 
     &     - 16*s14*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s14*
     &    s23*s34*sw**2*PropZ12*PropZ12C*PropZ34C - 16*s14*s23*s34*
     &    sw**2*PropZ12*PropZ34*PropZ34C - 16*s14*s23*s34*sw**2*PropZ12
     &    *PropZ34*PropZ12C - 16*s13*s24*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 16*s13*s24*s34*sw**2*PropZ12*PropZ12C*PropZ34C - 
     &    16*s13*s24*s34*sw**2*PropZ12*PropZ34*PropZ34C - 16*s13*s24*
     &    s34*sw**2*PropZ12*PropZ34*PropZ12C - 16*s12*s14*s23*sw**2*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s23*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 16*s12*s14*s23*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 16*s12*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C - 16
     &    *s12*s13*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s12*s13*s24
     &    *sw**2*PropZ12*PropZ12C*PropZ34C - 16*s12*s13*s24*sw**2*
     &    PropZ12*PropZ34*PropZ34C - 16*s12*s13*s24*sw**2*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*eps1234*couplsm*NPSQ*dGl1L*
     & Czz * ( 4*s24*PropZ34*PropZ12C*PropZ34C + 4*s24*PropZ12*PropZ12C
     &    *PropZ34C - 4*s24*PropZ12*PropZ34*PropZ34C - 4*s24*PropZ12*
     &    PropZ34*PropZ12C - 4*s23*PropZ34*PropZ12C*PropZ34C + 4*s23*
     &    PropZ12*PropZ12C*PropZ34C + 4*s23*PropZ12*PropZ34*PropZ34C - 
     &    4*s23*PropZ12*PropZ34*PropZ12C + 4*s14*PropZ34*PropZ12C*
     &    PropZ34C - 4*s14*PropZ12*PropZ12C*PropZ34C - 4*s14*PropZ12*
     &    PropZ34*PropZ34C + 4*s14*PropZ12*PropZ34*PropZ12C - 4*s13*
     &    PropZ34*PropZ12C*PropZ34C - 4*s13*PropZ12*PropZ12C*PropZ34C
     &     + 4*s13*PropZ12*PropZ34*PropZ34C + 4*s13*PropZ12*PropZ34*
     &    PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*eps1234*couplsm*NPSQ*dGl1R*
     & Czz * (  - 4*s24*PropZ34*PropZ12C*PropZ34C - 4*s24*PropZ12*
     &    PropZ12C*PropZ34C + 4*s24*PropZ12*PropZ34*PropZ34C + 4*s24*
     &    PropZ12*PropZ34*PropZ12C + 4*s23*PropZ34*PropZ12C*PropZ34C - 
     &    4*s23*PropZ12*PropZ12C*PropZ34C - 4*s23*PropZ12*PropZ34*
     &    PropZ34C + 4*s23*PropZ12*PropZ34*PropZ12C - 4*s14*PropZ34*
     &    PropZ12C*PropZ34C + 4*s14*PropZ12*PropZ12C*PropZ34C + 4*s14*
     &    PropZ12*PropZ34*PropZ34C - 4*s14*PropZ12*PropZ34*PropZ12C + 4
     &    *s13*PropZ34*PropZ12C*PropZ34C + 4*s13*PropZ12*PropZ12C*
     &    PropZ34C - 4*s13*PropZ12*PropZ34*PropZ34C - 4*s13*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*dCz * ( 
     &    16*s14*s23*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C + 16*s14*s23*PropZ12*PropZ34*PropZ34C + 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 16*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 16*s13*s24*PropZ12*PropZ12C*PropZ34C + 16
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 16*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czz * ( 
     &    16*s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14*
     &    s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14**2*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s13*s24**2*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 16*s13*s23*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 16*s13*s14*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 16*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     - 16*s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*
     &    s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s13*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1L*Czbx * ( 
     &    64*s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24
     &    *s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*dCz * ( 
     &    16*s14*s23*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*PropZ12*
     &    PropZ12C*PropZ34C + 16*s14*s23*PropZ12*PropZ34*PropZ34C + 16*
     &    s14*s23*PropZ12*PropZ34*PropZ12C + 16*s13*s24*PropZ34*
     &    PropZ12C*PropZ34C + 16*s13*s24*PropZ12*PropZ12C*PropZ34C + 16
     &    *s13*s24*PropZ12*PropZ34*PropZ34C + 16*s13*s24*PropZ12*
     &    PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czz * ( 
     &    16*s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14*
     &    s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s14**2*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s13*s24**2*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 16*s13*s23*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 16*s13*s14*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 16*s13*s14*s23*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     - 16*s13**2*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*
     &    s24*s34*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s14*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C - 16*s12*s13*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*dGl1R*Czbx * ( 
     &    64*s14*s23*s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24
     &    *s34*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s12*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dCz * (  - 
     &    4*s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dCz * ( 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s24*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s24*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C + 4*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 4*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s14*s34*sw**2
     &    *PropZ34*PropZ12C*PropZ34C + 4*s14*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s13*
     &    s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*Cza*dCz * (  - 
     &    4*s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*
     &    s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*
     &    s14*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s14
     &    *s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*s14*s23
     &    *s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 4*s12*s24*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s23*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*
     &    s23*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s14*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s12*s14*sw**2*PropZ12*PropZ34*PropZ12C
     &     + 4*s12*s13*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*s13*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NPSQ*Cabx*dCz * ( 
     &     - 16*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*
     &    sw**2*PropZ12*PropZ12C*PropZ34C - 16*s14*s23*sw**2*PropZ12*
     &    PropZ34*PropZ34C - 16*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C
     &     - 16*s13*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s13*s24*
     &    sw**2*PropZ12*PropZ12C*PropZ34C - 16*s13*s24*sw**2*PropZ12*
     &    PropZ34*PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ34*PropZ12C
     &     )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NP*dGl1L * ( 16*s14*
     &    s23*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C + 16*s14*s23*PropZ12*PropZ34*PropZ34C + 16*s14*s23*
     &    PropZ12*PropZ34*PropZ12C + 16*s13*s24*PropZ34*PropZ12C*
     &    PropZ34C + 16*s13*s24*PropZ12*PropZ12C*PropZ34C + 16*s13*s24*
     &    PropZ12*PropZ34*PropZ34C + 16*s13*s24*PropZ12*PropZ34*
     &    PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NP*dGl1R * ( 16*s14*
     &    s23*PropZ34*PropZ12C*PropZ34C + 16*s14*s23*PropZ12*PropZ12C*
     &    PropZ34C + 16*s14*s23*PropZ12*PropZ34*PropZ34C + 16*s14*s23*
     &    PropZ12*PropZ34*PropZ12C + 16*s13*s24*PropZ34*PropZ12C*
     &    PropZ34C + 16*s13*s24*PropZ12*PropZ12C*PropZ34C + 16*s13*s24*
     &    PropZ12*PropZ34*PropZ34C + 16*s13*s24*PropZ12*PropZ34*
     &    PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NP*Cza * (  - 4*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NP*Cza * ( 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s24*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s24*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C + 4*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 4*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s14*s34*sw**2
     &    *PropZ34*PropZ12C*PropZ34C + 4*s14*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s13*
     &    s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NP*Cza * (  - 4*s13*
     &    s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s23
     &    *s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*s14*s24
     &    *s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 4*s12*s24*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s23*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*
     &    s23*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s14*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s12*s14*sw**2*PropZ12*PropZ34*PropZ12C
     &     + 4*s12*s13*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*s13*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*couplsm*NP*Cabx * (  - 16*
     &    s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s14*s23*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 16*s14*s23*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 16*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C - 16*s13
     &    *s24*sw**2*PropZ34*PropZ12C*PropZ34C - 16*s13*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ34*
     &    PropZ34C - 16*s13*s24*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*couplsm*NPSQ*dGl1L*dCz * ( 64*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*couplsm*NPSQ*dGl1R*dCz * ( 64*s14*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 64*s13*s24*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*couplsm*NP*dGl1L * ( 64*s14*s23*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C + 64*s13*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*couplsm*NP*dGl1R * ( 64*s14*s23*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C + 64*s13*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )

